/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
(function(){
var e,t=["require","exports","vs/base/common/path","vs/base/common/lifecycle","vs/base/common/network","vs/base/common/event","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/nls","vs/nls!vs/server/remoteExtensionHostAgent","vs/base/common/strings","vs/base/common/types","vs/platform/log/common/log","vs/base/node/pfs","vs/base/common/async","vs/base/common/errors","vs/base/common/buffer","fs","vs/base/common/objects","vs/base/common/uuid","vs/base/common/arrays","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/cancellation","vs/platform/files/common/files","vs/platform/product/common/product","os","vs/platform/extensionManagement/common/extensionManagement","vs/platform/configuration/common/configuration","vs/base/common/extpath","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/map","child_process","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetry","vs/platform/extensions/common/extensions","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/server/remoteUriTransformer","vs/base/common/stream","util","vs/base/common/errorMessage","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/iterator","vs/base/common/json","vs/base/common/process","vs/base/common/glob","vs/base/common/uriIpc","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/instantiationService","semver-umd","vs/platform/files/common/fileService","crypto","vs/platform/configuration/common/configurationService","url","vs/platform/extensionManagement/common/extensionGalleryService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/functional","vs/base/common/normalization","vs/base/common/labels","vs/base/node/decoder","vs/base/node/id","net","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/localizations/common/localizations","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogService","vs/platform/environment/node/environmentService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/commonProperties","vs/server/remoteLanguagePacks","vs/platform/extensionManagement/node/extensionManagementUtil","vs/server/remoteExtensionManagement","vs/base/common/assert","vs/base/common/decorators","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/paths","vs/base/node/extpath","vs/base/node/ports","vs/base/node/watcher","vs/code/node/shellEnv","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/code/node/cliProcessMain","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/server/remoteAgentEnvironmentImpl","vs/nls!vs/workbench/services/extensions/node/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/downloadIpc","vs/platform/environment/node/argv","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/log/common/logIpc","vs/platform/notification/common/notification","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/storage/common/storage","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/node/errorTelemetry","vs/platform/telemetry/node/telemetry","vs/server/extensionHostConnection","vs/server/remoteAgentFileSystemImpl","vs/workbench/services/extensions/common/extensionPoints","vs/workbench/services/extensions/common/webWorkerIframe","vs/server/webClientServer","vs/workbench/services/extensions/node/extensionPoints","vs/server/remoteAgentEnvironmentImpl","vs/workbench/services/remote/common/remoteAgentFileSystemChannel","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionsScanner","vs/code/node/cliProcessMain","vs/server/remoteExtensionHostAgentServer","string_decoder","path","vs/base/common/performance","minimist","applicationinsights","cookie","yauzl","yazl","zlib","http","vs/server/remoteExtensionHostAgent"],n=function(e){
for(var n=[],i=0,r=e.length;i<r;i++)n[i]=t[e[i]];return n};function i(e){e.MonacoPerformanceMarks=e.MonacoPerformanceMarks||[];const t=2,n="function"==typeof console.timeStamp?console.timeStamp.bind(console):()=>{};return{mark:function(t){e.MonacoPerformanceMarks.push(t,Date.now()),n(t)},getEntries:function(){const n=[],i=e.MonacoPerformanceMarks;for(let e=0;e<i.length;e+=t)n.push({name:i[e],startTime:i[e+1]});return n},getDuration:function(n,i){const r=e.MonacoPerformanceMarks;let s=i,o=0;for(let e=r.length-t;e>=0;e-=t)if(r[e]===s){if(s!==i)return r[o+1]-r[e+1];o=e,s=n}return 0},importEntries:function(t){e.MonacoPerformanceMarks.splice(0,0,...t)},exportEntries:function(){return e.MonacoPerformanceMarks.slice(0)}}}function r(e,t,n,i){function r(e){return new Promise(t=>n.exists(e,t))}function s(e){return(i=e,new Promise((e,t)=>n.lstat(i,(n,i)=>n?t(n):e(i)))).then(i=>i.isDirectory()&&!i.isSymbolicLink()?function(e){return new Promise((t,i)=>n.readdir(e,(e,n)=>e?i(e):t(n)))
}(e).then(n=>Promise.all(n.map(n=>s(t.join(e,n))))).then(()=>(function(e){return new Promise((t,i)=>n.rmdir(e,e=>e?i(e):t(void 0)))})(e)):function(e){return new Promise((t,i)=>n.unlink(e,e=>e?i(e):t(void 0)))}(e),e=>{if("ENOENT"!==e.code)throw e});var i}function o(e){return new Promise((function(t,i){n.readFile(e,"utf8",(function(e,n){e?i(e):t(n)}))}))}function a(e,t){return new Promise((function(i,r){n.writeFile(e,t,"utf8",(function(e){e?r(e):i()}))}))}return{getNLSConfiguration:function(c,l,u,h){if("pseudo"===h)return Promise.resolve({locale:h,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:h,availableLanguages:{}});if(h&&("en"===h||"en-us"===h))return Promise.resolve({locale:h,availableLanguages:{}});const d=h;i.mark("nlsGeneration:start");const f=function(e){return i.mark("nlsGeneration:end"),Promise.resolve({locale:e,availableLanguages:{}})};try{if(!c)return f(d);const p=function(n){const i=t.join(n,"languagepacks.json");try{return e(i)}catch(e){}}(l)
;if(!p)return f(d);if(!(h=function(e,t){try{for(;t;){if(e[t])return t;{const e=t.lastIndexOf("-");if(!(e>0))return;t=t.substring(0,e)}}}catch(e){console.error("Resolving language pack configuration failed.",e)}}(p,h)))return f(d);const g=p[h];let m;return g&&"string"==typeof g.hash&&g.translations&&"string"==typeof(m=g.translations.vscode)?r(m).then(e=>{if(!e)return f(d);const p=g.hash+"."+h,v=t.join(l,"clp",p),y=t.join(v,c),w=t.join(v,"tcf.json"),E=t.join(v,"corrupted.info"),_={locale:d,availableLanguages:{"*":h},_languagePackId:p,_translationsConfigFile:w,_cacheRoot:v,_resolvedLanguagePackCoreLocation:y,_corruptedFile:E};return r(E).then(e=>{let c;return(c=e?s(v):Promise.resolve(void 0)).then(()=>r(y).then(e=>e?(function(e){return new Promise((t,i)=>{const r=new Date;n.utimes(e,r,r,e=>e?i(e):t())})}(y).catch(()=>{}),i.mark("nlsGeneration:end"),_):function(e){return new Promise((t,i)=>n.mkdir(e,{recursive:!0},n=>n&&"EEXIST"!==n.code?i(n):t(e)))}(y).then(()=>Promise.all([o(u),o(m)])).then(e=>{
const n=JSON.parse(e[0]),i=JSON.parse(e[1]).contents,r=Object.keys(n.bundles),s=[];for(const e of r){const r=n.bundles[e],o=Object.create(null);for(const e of r){const t=n.keys[e],r=n.messages[e],s=i[e];let a;if(s){a=[];for(let e=0;e<t.length;e++){const n=t[e];let i=s["string"==typeof n?n:n.key];void 0===i&&(i=r[e]),a.push(i)}}else a=r;o[e]=a}s.push(a(t.join(y,e.replace(/\//g,"!")+".nls.json"),JSON.stringify(o)))}return s.push(a(w,JSON.stringify(g.translations))),Promise.all(s)}).then(()=>(i.mark("nlsGeneration:end"),_)).catch(e=>(console.error("Generating translation files failed.",e),f(h)))))})}):f(d)}catch(e){return console.error("Generating translation files failed.",e),f(h)}}}}if(define(t[88],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0,t.ok=function(e,t){if(!e)throw new Error(t?`Assertion failed (${t})`:"Assertion Failed")}})),define(t[89],n([0,1]),(function(e,t){"use strict";function n(e){return(t,n,i)=>{let r=null,s=null
;if("function"==typeof i.value?(r="value",s=i.value):"function"==typeof i.get&&(r="get",s=i.get),!s)throw new Error("not supported");i[r]=e(s,n)}}Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createMemoizer=t.createDecorator=void 0,t.createDecorator=n;let i=0;function r(){const e=`$memoize${i++}`;let t=void 0;const n=function(n,i,r){let s=null,o=null;if("function"==typeof r.value?(s="value",0!==(o=r.value).length&&console.warn("Memoize should only be used in functions with zero parameters")):"function"==typeof r.get&&(s="get",o=r.get),!o)throw new Error("not supported");const a=`${e}:${i}`;r[s]=function(...e){return t=this,this.hasOwnProperty(a)||Object.defineProperty(this,a,{configurable:!0,enumerable:!1,writable:!0,value:o.apply(this,e)}),this[a]}};return n.clear=()=>{void 0!==t&&Object.getOwnPropertyNames(t).forEach(n=>{0===n.indexOf(e)&&delete t[n]})},n}t.createMemoizer=r,t.memoize=function(e,t,n){return r()(e,t,n)},t.debounce=function(e,t,i){return n((n,r)=>{
const s=`$debounce$${r}`,o=`$debounce$result$${r}`;return function(...r){this[o]||(this[o]=i?i():void 0),clearTimeout(this[s]),t&&(this[o]=t(this[o],...r),r=[this[o]]),this[s]=setTimeout(()=>{n.apply(this,r),this[o]=i?i():void 0},e)}})},t.throttle=function(e,t,i){return n((n,r)=>{const s=`$throttle$timer$${r}`,o=`$throttle$result$${r}`,a=`$throttle$lastRun$${r}`,c=`$throttle$pending$${r}`;return function(...r){if(this[o]||(this[o]=i?i():void 0),null!==this[a]&&void 0!==this[a]||(this[a]=-Number.MAX_VALUE),t&&(this[o]=t(this[o],...r)),this[c])return;const l=this[a]+e;l<=Date.now()?(this[a]=Date.now(),n.apply(this,[this[o]]),this[o]=i?i():void 0):(this[c]=!0,this[s]=setTimeout(()=>{this[c]=!1,this[a]=Date.now(),n.apply(this,[this[o]]),this[o]=i?i():void 0},l-Date.now()))}})}})),define(t[16],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class n{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(e){setTimeout(()=>{if(e.stack)throw new Error(e.message+"\n\n"+e.stack);throw e},0)}}addListener(e){return this.listeners.push(e),()=>{this._removeListener(e)}}emit(e){this.listeners.forEach(t=>{t(e)})}_removeListener(e){this.listeners.splice(this.listeners.indexOf(e),1)}setUnexpectedErrorHandler(e){this.unexpectedErrorHandler=e}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(e){this.unexpectedErrorHandler(e),this.emit(e)}onUnexpectedExternalError(e){this.unexpectedErrorHandler(e)}}t.ErrorHandler=n,t.errorHandler=new n,t.setUnexpectedErrorHandler=function(e){t.errorHandler.setUnexpectedErrorHandler(e)},
t.onUnexpectedError=function(e){r(e)||t.errorHandler.onUnexpectedError(e)},t.onUnexpectedExternalError=function(e){r(e)||t.errorHandler.onUnexpectedExternalError(e)},t.transformErrorForSerialization=function(e){if(e instanceof Error){let{name:t,message:n}=e;return{$isError:!0,name:t,message:n,stack:e.stacktrace||e.stack}}return e};const i="Canceled";function r(e){return e instanceof Error&&e.name===i&&e.message===i}t.isPromiseCanceledError=r,t.canceled=function(){const e=new Error(i);return e.name=e.message,e},t.illegalArgument=function(e){return e?new Error(`Illegal argument: ${e}`):new Error("Illegal argument")},t.illegalState=function(e){return e?new Error(`Illegal state: ${e}`):new Error("Illegal state")},t.readonly=function(e){return e?new Error(`readonly property '${e} cannot be changed'`):new Error("readonly property cannot be changed")},t.disposed=function(e){const t=new Error(`${e} has been disposed`);return t.name="DISPOSED",t},t.getErrorMessage=function(e){
return e?e.message?e.message:e.stack?e.stack.split("\n")[0]:String(e):"Error"};class s extends Error{constructor(e){super("NotImplemented"),e&&(this.message=e)}}t.NotImplementedError=s;class o extends Error{constructor(e){super("NotSupported"),e&&(this.message=e)}}t.NotSupportedError=o})),define(t[21],n([0,1,16]),(function(e,t,n){"use strict";function i(e,t){let n=0,i=e.length;if(0===i)return 0;for(;n<i;){const r=Math.floor((n+i)/2);t(e[r])?i=r:n=r+1}return n}function r(e,t){return function e(t,n,i,r,s){if(r<=i)return;const o=i+(r-i)/2|0;e(t,n,i,o,s);e(t,n,o+1,r,s);if(n(t[o],t[o+1])<=0)return;!function(e,t,n,i,r,s){let o=n,a=i+1;for(let t=n;t<=r;t++)s[t]=e[t];for(let c=n;c<=r;c++)o>i?e[c]=s[a++]:a>r?e[c]=s[o++]:t(s[a],s[o])<0?e[c]=s[a++]:e[c]=s[o++]}(t,n,i,o,r,s)}(e,t,0,e.length-1,[]),e}function s(e,t,n){const i=[];function r(e,t,n){if(0===t&&0===n.length)return;const r=i[i.length-1];r&&r.start+r.deleteCount===e?(r.deleteCount+=t,r.toInsert.push(...n)):i.push({start:e,deleteCount:t,toInsert:n})}let s=0,o=0
;for(;;){if(s===e.length){r(s,0,t.slice(o));break}if(o===t.length){r(s,e.length-s,[]);break}const i=e[s],a=t[o],c=n(i,a);0===c?(s+=1,o+=1):c<0?(r(s,1,[]),s+=1):c>0&&(r(s,0,[a]),o+=1)}return i}function o(e,t,n,r,s){for(const o=n.length;r<s;r++){const s=e[r];if(t(s,n[o-1])<0){n.pop();const e=i(n,e=>t(s,e)<0);n.splice(e,0,s)}}}function a(e,t){const n=e.indexOf(t);if(n>-1)return e.splice(n,1),t}Object.defineProperty(t,"__esModule",{value:!0}),t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.mergeSort=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0,t.tail=function(e,t=0){return e[e.length-(1+t)]},t.tail2=function(e){if(0===e.length)throw new Error("Invalid tail call")
;return[e.slice(0,e.length-1),e[e.length-1]]},t.equals=function(e,t,n=((e,t)=>e===t)){if(e===t)return!0;if(!e||!t)return!1;if(e.length!==t.length)return!1;for(let i=0,r=e.length;i<r;i++)if(!n(e[i],t[i]))return!1;return!0},t.binarySearch=function(e,t,n){let i=0,r=e.length-1;for(;i<=r;){const s=(i+r)/2|0,o=n(e[s],t);if(o<0)i=s+1;else{if(!(o>0))return s;r=s-1}}return-(i+1)},t.findFirstInSorted=i,t.mergeSort=r,t.groupBy=function(e,t){const n=[];let i=void 0;for(const s of r(e.slice(0),t))i&&0===t(i[0],s)?i.push(s):(i=[s],n.push(i));return n},t.sortedDiff=s,t.delta=function(e,t,n){const i=s(e,t,n),r=[],o=[];for(const t of i)r.push(...e.slice(t.start,t.start+t.deleteCount)),o.push(...t.toInsert);return{removed:r,added:o}},t.top=function(e,t,n){if(0===n)return[];const i=e.slice(0,n).sort(t);return o(e,t,i,n,e.length),i},t.topAsync=function(e,t,i,r,s){return 0===i?Promise.resolve([]):new Promise((a,c)=>{(async()=>{const a=e.length,c=e.slice(0,i).sort(t);for(let l=i,u=Math.min(i+r,a);l<a;l=u,u=Math.min(u+r,a)){
if(l>i&&await new Promise(e=>setTimeout(e)),s&&s.isCancellationRequested)throw n.canceled();o(e,t,c,l,u)}return c})().then(a,c)})},t.coalesce=function(e){return e.filter(e=>!!e)},t.coalesceInPlace=function(e){let t=0;for(let n=0;n<e.length;n++)e[n]&&(e[t]=e[n],t+=1);e.length=t},t.move=function(e,t,n){e.splice(n,0,e.splice(t,1)[0])},t.isFalsyOrEmpty=function(e){return!Array.isArray(e)||0===e.length},t.isNonEmptyArray=function(e){return Array.isArray(e)&&e.length>0},t.distinct=function(e,t){if(!t)return e.filter((t,n)=>e.indexOf(t)===n);const n=Object.create(null);return e.filter(e=>{const i=t(e);return!n[i]&&(n[i]=!0,!0)})},t.distinctES6=function(e){const t=new Set;return e.filter(e=>!t.has(e)&&(t.add(e),!0))},t.uniqueFilter=function(e){const t=Object.create(null);return n=>{const i=e(n);return!t[i]&&(t[i]=!0,!0)}},t.lastIndex=function(e,t){for(let n=e.length-1;n>=0;n--){if(t(e[n]))return n}return-1},t.firstOrDefault=function(e,t){return e.length>0?e[0]:t},t.commonPrefixLength=function(e,t,n=((e,t)=>e===t)){
let i=0;for(let r=0,s=Math.min(e.length,t.length);r<s&&n(e[r],t[r]);r++)i++;return i},t.flatten=function(e){return[].concat(...e)},t.range=function(e,t){let n="number"==typeof t?e:0;"number"==typeof t?n=e:(n=0,t=e);const i=[];if(n<=t)for(let e=n;e<t;e++)i.push(e);else for(let e=n;e>t;e--)i.push(e);return i},t.index=function(e,t,n){return e.reduce((e,i)=>(e[t(i)]=n?n(i):i,e),Object.create(null))},t.insert=function(e,t){return e.push(t),()=>a(e,t)},t.remove=a,t.arrayInsert=function(e,t,n){const i=e.slice(0,t),r=e.slice(t);return i.concat(n,r)},t.shuffle=function(e,t){let n;if("number"==typeof t){let e=t;n=()=>{const t=179426549*Math.sin(e++);return t-Math.floor(t)}}else n=Math.random;for(let t=e.length-1;t>0;t-=1){const i=Math.floor(n()*(t+1)),r=e[t];e[t]=e[i],e[i]=r}},t.pushToStart=function(e,t){const n=e.indexOf(t);n>-1&&(e.splice(n,1),e.unshift(t))},t.pushToEnd=function(e,t){const n=e.indexOf(t);n>-1&&(e.splice(n,1),e.push(t))},t.mapArrayOrNot=function(e,t){return Array.isArray(e)?e.map(t):t(e)},
t.asArray=function(e){return Array.isArray(e)?e:[e]},t.getRandomElement=function(e){return e[Math.floor(Math.random()*e.length)]}})),define(t[65],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0,t.once=function(e){const t=this;let n,i=!1;return function(){return i?n:(i=!0,n=e.apply(t,arguments))}}})),define(t[49],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0,function(e){e.is=function(e){return e&&"object"==typeof e&&"function"==typeof e[Symbol.iterator]};const t=Object.freeze([]);e.empty=function(){return t},e.single=function*(e){yield e},e.from=function(e){return e||t},e.first=function(e){return e[Symbol.iterator]().next().value},e.some=function(e,t){for(const n of e)if(t(n))return!0;return!1},e.filter=function*(e,t){for(const n of e)t(n)&&(yield n)},e.map=function*(e,t){for(const n of e)yield t(n)},e.concat=function*(...e){for(const t of e)for(const e of t)yield e},
e.consume=function(t,n=Number.POSITIVE_INFINITY){const i=[];if(0===n)return[i,t];const r=t[Symbol.iterator]();for(let t=0;t<n;t++){const t=r.next();if(t.done)return[i,e.empty()];i.push(t.value)}return[i,{[Symbol.iterator]:()=>r}]}}(t.Iterable||(t.Iterable={}))})),define(t[50],n([0,1]),(function(e,t){"use strict";var n,i;function r(e,t=!1){let n=0,i=e.length,r="",c=0,l=16,u=0;function h(t){let i=0,r=0;for(;i<t;){const t=e.charCodeAt(n);if(t>=48&&t<=57)r=16*r+t-48;else if(t>=65&&t<=70)r=16*r+t-65+10;else{if(!(t>=97&&t<=102))break;r=16*r+t-97+10}n++,i++}return i<t&&(r=-1),r}function d(){if(r="",u=0,c=n,n>=i)return c=i,l=17;let t=e.charCodeAt(n);if(s(t)){do{n++,r+=String.fromCharCode(t),t=e.charCodeAt(n)}while(s(t));return l=15}if(o(t))return n++,r+=String.fromCharCode(t),13===t&&10===e.charCodeAt(n)&&(n++,r+="\n"),l=14;switch(t){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,r=function(){let t="",r=n
;for(;;){if(n>=i){t+=e.substring(r,n),u=2;break}const s=e.charCodeAt(n);if(34===s){t+=e.substring(r,n),n++;break}if(92!==s){if(s>=0&&s<=31){if(o(s)){t+=e.substring(r,n),u=2;break}u=6}n++}else{if(t+=e.substring(r,n),++n>=i){u=2;break}switch(e.charCodeAt(n++)){case 34:t+='"';break;case 92:t+="\\";break;case 47:t+="/";break;case 98:t+="\b";break;case 102:t+="\f";break;case 110:t+="\n";break;case 114:t+="\r";break;case 116:t+="\t";break;case 117:const e=h(4);e>=0?t+=String.fromCharCode(e):u=4;break;default:u=5}r=n}}return t}(),l=10;case 47:const s=n-1;if(47===e.charCodeAt(n+1)){for(n+=2;n<i&&!o(e.charCodeAt(n));)n++;return r=e.substring(s,n),l=12}if(42===e.charCodeAt(n+1)){n+=2;const t=i-1;let o=!1;for(;n<t;){if(42===e.charCodeAt(n)&&47===e.charCodeAt(n+1)){n+=2,o=!0;break}n++}return o||(n++,u=1),r=e.substring(s,n),l=13}return r+=String.fromCharCode(t),n++,l=16;case 45:if(r+=String.fromCharCode(t),++n===i||!a(e.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:
case 57:return r+=function(){const t=n;if(48===e.charCodeAt(n))n++;else for(n++;n<e.length&&a(e.charCodeAt(n));)n++;if(n<e.length&&46===e.charCodeAt(n)){if(!(++n<e.length&&a(e.charCodeAt(n))))return u=3,e.substring(t,n);for(n++;n<e.length&&a(e.charCodeAt(n));)n++}let i=n;if(n<e.length&&(69===e.charCodeAt(n)||101===e.charCodeAt(n)))if((++n<e.length&&43===e.charCodeAt(n)||45===e.charCodeAt(n))&&n++,n<e.length&&a(e.charCodeAt(n))){for(n++;n<e.length&&a(e.charCodeAt(n));)n++;i=n}else u=3;return e.substring(t,i)}(),l=11;default:for(;n<i&&f(t);)n++,t=e.charCodeAt(n);if(c!==n){switch(r=e.substring(c,n)){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return r+=String.fromCharCode(t),n++,l=16}}function f(e){if(s(e)||o(e))return!1;switch(e){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}return{setPosition:function(e){n=e,r="",c=0,l=16,u=0},getPosition:()=>n,scan:t?function(){let e;do{e=d()}while(e>=12&&e<=15);return e}:d,getToken:()=>l,
getTokenValue:()=>r,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>u}}function s(e){return 32===e||9===e||11===e||12===e||160===e||5760===e||e>=8192&&e<=8203||8239===e||8287===e||12288===e||65279===e}function o(e){return 10===e||13===e||8232===e||8233===e}function a(e){return e>=48&&e<=57}function c(e,t,n=!1){return t>=e.offset&&t<e.offset+e.length||n&&t===e.offset+e.length}function l(e,t,i=n.DEFAULT){const s=r(e,!1);function o(e){return e?()=>e(s.getTokenOffset(),s.getTokenLength()):()=>!0}function a(e){return e?t=>e(t,s.getTokenOffset(),s.getTokenLength()):()=>!0}const c=o(t.onObjectBegin),l=a(t.onObjectProperty),u=o(t.onObjectEnd),h=o(t.onArrayBegin),d=o(t.onArrayEnd),f=a(t.onLiteralValue),p=a(t.onSeparator),g=o(t.onComment),m=a(t.onError),v=i&&i.disallowComments,y=i&&i.allowTrailingComma;function w(){for(;;){const e=s.scan();switch(s.getTokenError()){case 4:E(14);break;case 5:E(15);break;case 3:E(13);break;case 1:v||E(11);break;case 2:E(12);break;case 6:E(16)}switch(e){case 12:case 13:
v?E(10):g();break;case 16:E(1);break;case 15:case 14:break;default:return e}}}function E(e,t=[],n=[]){if(m(e),t.length+n.length>0){let e=s.getToken();for(;17!==e;){if(-1!==t.indexOf(e)){w();break}if(-1!==n.indexOf(e))break;e=w()}}}function _(e){const t=s.getTokenValue();return e?f(t):l(t),w(),!0}function S(){switch(s.getToken()){case 3:return function(){h(),w();let e=!1;for(;4!==s.getToken()&&17!==s.getToken();){if(5===s.getToken()){if(e||E(4,[],[]),p(","),w(),4===s.getToken()&&y)break}else e&&E(6,[],[]);S()||E(4,[],[4,5]),e=!0}return d(),4!==s.getToken()?E(8,[4],[]):w(),!0}();case 1:return function(){c(),w();let e=!1;for(;2!==s.getToken()&&17!==s.getToken();){if(5===s.getToken()){if(e||E(4,[],[]),p(","),w(),2===s.getToken()&&y)break}else e&&E(6,[],[]);(10!==s.getToken()?(E(3,[],[2,5]),0):(_(!1),6===s.getToken()?(p(":"),w(),S()||E(4,[],[2,5])):E(5,[],[2,5]),1))||E(4,[],[2,5]),e=!0}return u(),2!==s.getToken()?E(7,[2],[]):w(),!0}();case 10:return _(!0);default:return function(){switch(s.getToken()){case 11:
let e=0;try{"number"!=typeof(e=JSON.parse(s.getTokenValue()))&&(E(2),e=0)}catch(e){E(2)}f(e);break;case 7:f(null);break;case 8:f(!0);break;case 9:f(!1);break;default:return!1}return w(),!0}()}}return w(),17===s.getToken()?!!i.allowEmptyContent||(E(4,[],[]),!1):S()?(17!==s.getToken()&&E(9,[],[]),!0):(E(4,[],[]),!1)}function u(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":return e?Array.isArray(e)?"array":"object":"null";default:return"null"}}Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0,function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",
e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"}(t.ScanError||(t.ScanError={})),function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"}(t.SyntaxKind||(t.SyntaxKind={})),function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",
e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"}(t.ParseErrorCode||(t.ParseErrorCode={})),function(e){e.DEFAULT={allowTrailingComma:!0}}(n=t.ParseOptions||(t.ParseOptions={})),t.createScanner=r,function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",
e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",
e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",
e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"}(i||(i={})),t.getLocation=function(e,t){const n=[],i=new Object;let r=void 0;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function a(e,t,n,i){s.value=e,s.offset=t,s.length=n,s.type=i,s.colonOffset=void 0,r=s}try{l(e,{onObjectBegin:(e,s)=>{if(t<=e)throw i;r=void 0,o=t>e,n.push("")},onObjectProperty:(e,r,s)=>{if(t<r)throw i;if(a(e,r,s,"property"),n[n.length-1]=e,t<=r+s)throw i},onObjectEnd:(e,s)=>{if(t<=e)throw i;r=void 0,n.pop()},onArrayBegin:(e,s)=>{if(t<=e)throw i;r=void 0,n.push(0)},onArrayEnd:(e,s)=>{if(t<=e)throw i;r=void 0,n.pop()},
onLiteralValue:(e,n,r)=>{if(t<n)throw i;if(a(e,n,r,u(e)),t<=n+r)throw i},onSeparator:(e,s,a)=>{if(t<=s)throw i;if(":"===e&&r&&"property"===r.type)r.colonOffset=s,o=!1,r=void 0;else if(","===e){const e=n[n.length-1];"number"==typeof e?n[n.length-1]=e+1:(o=!0,n[n.length-1]=""),r=void 0}}})}catch(e){if(e!==i)throw e}return{path:n,previousNode:r,isAtPropertyKey:o,matches:e=>{let t=0;for(let i=0;t<e.length&&i<n.length;i++)if(e[t]===n[i]||"*"===e[t])t++;else if("**"!==e[t])return!1;return t===e.length}}},t.parse=function(e,t=[],i=n.DEFAULT){let r=null,s=[];const o=[];function a(e){Array.isArray(s)?s.push(e):null!==r&&(s[r]=e)}return l(e,{onObjectBegin:()=>{const e={};a(e),o.push(s),s=e,r=null},onObjectProperty:e=>{r=e},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const e=[];a(e),o.push(s),s=e,r=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:a,onError:(e,n,i)=>{t.push({error:e,offset:n,length:i})}},i),s[0]},t.parseTree=function(e,t=[],i=n.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0}
;function s(e){"property"===r.type&&(r.length=e-r.offset,r=r.parent)}function o(e){return r.children.push(e),e}l(e,{onObjectBegin:e=>{r=o({type:"object",offset:e,length:-1,parent:r,children:[]})},onObjectProperty:(e,t,n)=>{(r=o({type:"property",offset:t,length:-1,parent:r,children:[]})).children.push({type:"string",value:e,offset:t,length:n,parent:r})},onObjectEnd:(e,t)=>{r.length=e+t-r.offset,r=r.parent,s(e+t)},onArrayBegin:(e,t)=>{r=o({type:"array",offset:e,length:-1,parent:r,children:[]})},onArrayEnd:(e,t)=>{r.length=e+t-r.offset,r=r.parent,s(e+t)},onLiteralValue:(e,t,n)=>{o({type:u(e),offset:t,length:n,parent:r,value:e}),s(t+n)},onSeparator:(e,t,n)=>{"property"===r.type&&(":"===e?r.colonOffset=t:","===e&&s(t))},onError:(e,n,i)=>{t.push({error:e,offset:n,length:i})}},i);const a=r.children[0];return a&&delete a.parent,a},t.findNodeAtLocation=function(e,t){if(!e)return;let n=e;for(let e of t)if("string"==typeof e){if("object"!==n.type||!Array.isArray(n.children))return;let t=!1
;for(const i of n.children)if(Array.isArray(i.children)&&i.children[0].value===e){n=i.children[1],t=!0;break}if(!t)return}else{const t=e;if("array"!==n.type||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n},t.getNodePath=function e(t){if(!t.parent||!t.parent.children)return[];const n=e(t.parent);if("property"===t.parent.type){const e=t.parent.children[0].value;n.push(e)}else if("array"===t.parent.type){const e=t.parent.children.indexOf(t);-1!==e&&n.push(e)}return n},t.getNodeValue=function e(t){switch(t.type){case"array":return t.children.map(e);case"object":const n=Object.create(null);for(let i of t.children){const t=i.children[1];t&&(n[i.children[0].value]=e(t))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}},t.contains=c,t.findNodeAtOffset=function e(t,n,i=!1){if(c(t,n,i)){const r=t.children;if(Array.isArray(r))for(let t=0;t<r.length&&r[t].offset<=n;t++){const s=e(r[t],n,i);if(s)return s}return t}},t.visit=l,
t.stripComments=function(e,t){let n,i,s=r(e),o=[],a=0;do{switch(i=s.getPosition(),n=s.scan()){case 12:case 13:case 17:a!==i&&o.push(e.substring(a,i)),void 0!==t&&o.push(s.getTokenValue().replace(/[^\r\n]/g,t)),a=s.getPosition()}}while(17!==n);return o.join("")},t.getNodeType=u})),define(t[3],n([0,1,65,49]),(function(e,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ImmortalReference=t.ReferenceCollection=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=void 0;const r=!1,s="__is_disposable_tracked__";function o(e){if(r&&e&&e!==h.None)try{e[s]=!0}catch(e){}}function a(e){if(!r)return e;const t=new Error("Potentially leaked disposable").stack;return setTimeout(()=>{e[s]||console.log(t)},3e3),e}class c extends Error{constructor(e){super(`Encounter errors while disposing of store. Errors: [${e.join(", ")}]`),this.errors=e}}function l(e){if(i.Iterable.is(e)){let t=[];for(const n of e)if(n){o(n);try{n.dispose()
}catch(e){t.push(e)}}if(1===t.length)throw t[0];if(t.length>1)throw new c(t);return Array.isArray(e)?[]:e}if(e)return o(e),e.dispose(),e}t.MultiDisposeError=c,t.isDisposable=function(e){return"function"==typeof e.dispose&&0===e.dispose.length},t.dispose=l,t.combinedDisposable=function(...e){return e.forEach(o),a({dispose:()=>l(e)})},t.toDisposable=function(e){const t=a({dispose:()=>{o(t),e()}});return t};class u{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(o(this),this._isDisposed=!0,this.clear())}clear(){try{l(this._toDispose.values())}finally{this._toDispose.clear()}}add(e){if(!e)return e;if(e===this)throw new Error("Cannot register a disposable on itself!");return o(e),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(e),e}}t.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){
this._store=new u,a(this)}dispose(){o(this),this._store.dispose()}_register(e){if(e===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(e)}}t.Disposable=h,h.None=Object.freeze({dispose(){}});t.MutableDisposable=class{constructor(){this._isDisposed=!1,a(this)}get value(){return this._isDisposed?void 0:this._value}set value(e){this._isDisposed||e===this._value||(this._value&&this._value.dispose(),e&&o(e),this._value=e)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,o(this),this._value&&this._value.dispose(),this._value=void 0}};t.ReferenceCollection=class{constructor(){this.references=new Map}acquire(e,...t){let i=this.references.get(e);i||(i={counter:0,object:this.createReferencedObject(e,...t)},this.references.set(e,i));const{object:r}=i,s=n.once(()=>{0==--i.counter&&(this.destroyReferencedObject(e,i.object),this.references.delete(e))});return i.counter++,{object:r,dispose:s}}};t.ImmortalReference=class{constructor(e){this.object=e}dispose(){}}})),
define(t[90],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class n{constructor(e){this.element=e,this.next=n.Undefined,this.prev=n.Undefined}}n.Undefined=new n(void 0);t.LinkedList=class{constructor(){this._first=n.Undefined,this._last=n.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===n.Undefined}clear(){this._first=n.Undefined,this._last=n.Undefined,this._size=0}unshift(e){return this._insert(e,!1)}push(e){return this._insert(e,!0)}_insert(e,t){const i=new n(e);if(this._first===n.Undefined)this._first=i,this._last=i;else if(t){const e=this._last;this._last=i,i.prev=e,e.next=i}else{const e=this._first;this._first=i,i.next=e,e.prev=i}this._size+=1;let r=!1;return()=>{r||(r=!0,this._remove(i))}}shift(){if(this._first!==n.Undefined){const e=this._first.element;return this._remove(this._first),e}}pop(){if(this._last!==n.Undefined){const e=this._last.element;return this._remove(this._last),e}}_remove(e){
if(e.prev!==n.Undefined&&e.next!==n.Undefined){const t=e.prev;t.next=e.next,e.next.prev=t}else e.prev===n.Undefined&&e.next===n.Undefined?(this._first=n.Undefined,this._last=n.Undefined):e.next===n.Undefined?(this._last=this._last.prev,this._last.next=n.Undefined):e.prev===n.Undefined&&(this._first=this._first.next,this._first.prev=n.Undefined);this._size-=1}*[Symbol.iterator](){let e=this._first;for(;e!==n.Undefined;)yield e.element,e=e.next}toArray(){const e=[];for(let t=this._first;t!==n.Undefined;t=t.next)e.push(t.element);return e}}})),define(t[5],n([0,1,16,65,3,90]),(function(e,t,n,i,r,s){"use strict";var o;Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.AsyncEmitter=t.PauseableEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0,function(e){function t(e){return(t,n=null,i)=>{let r,s=!1;return r=e(e=>{if(!s)return r?r.dispose():s=!0,t.call(n,e)},null,i),s&&r.dispose(),r}}function n(e,t){return a((n,i=null,r)=>e(e=>n.call(i,t(e)),null,r))}
function i(e,t){return a((n,i=null,r)=>e(e=>{t(e),n.call(i,e)},null,r))}function s(e,t){return a((n,i=null,r)=>e(e=>t(e)&&n.call(i,e),null,r))}function o(e,t,i){let r=i;return n(e,e=>r=t(r,e))}function a(e){let t;const n=new l({onFirstListenerAdd(){t=e(n.fire,n)},onLastListenerRemove(){t.dispose()}});return n.event}function c(e,t,n=100,i=!1,r){let s,o=void 0,a=void 0,c=0;const u=new l({leakWarningThreshold:r,onFirstListenerAdd(){s=e(e=>{c++,o=t(o,e),i&&!a&&(u.fire(o),o=void 0),clearTimeout(a),a=setTimeout(()=>{const e=o;o=void 0,a=void 0,(!i||c>1)&&u.fire(e),c=0},n)})},onLastListenerRemove(){s.dispose()}});return u.event}function u(e){let t,n=!0;return s(e,e=>{const i=n||e!==t;return n=!1,t=e,i})}e.None=()=>r.Disposable.None,e.once=t,e.map=n,e.forEach=i,e.filter=s,e.signal=function(e){return e},e.any=function(...e){return(t,n=null,i)=>r.combinedDisposable(...e.map(e=>e(e=>t.call(n,e),null,i)))},e.reduce=o,e.snapshot=a,e.debounce=c,e.stopwatch=function(e){const i=(new Date).getTime()
;return n(t(e),e=>(new Date).getTime()-i)},e.latch=u,e.buffer=function(e,t=!1,n=[]){let i=n.slice(),r=e(e=>{i?i.push(e):o.fire(e)});const s=()=>{i&&i.forEach(e=>o.fire(e)),i=null},o=new l({onFirstListenerAdd(){r||(r=e(e=>o.fire(e)))},onFirstListenerDidAdd(){i&&(t?setTimeout(s):s())},onLastListenerRemove(){r&&r.dispose(),r=null}});return o.event};class h{constructor(e){this.event=e}map(e){return new h(n(this.event,e))}forEach(e){return new h(i(this.event,e))}filter(e){return new h(s(this.event,e))}reduce(e,t){return new h(o(this.event,e,t))}latch(){return new h(u(this.event))}debounce(e,t=100,n=!1,i){return new h(c(this.event,e,t,n,i))}on(e,t,n){return this.event(e,t,n)}once(e,n,i){return t(this.event)(e,n,i)}}e.chain=function(e){return new h(e)},e.fromNodeEventEmitter=function(e,t,n=(e=>e)){const i=(...e)=>r.fire(n(...e)),r=new l({onFirstListenerAdd:()=>e.on(t,i),onLastListenerRemove:()=>e.removeListener(t,i)});return r.event},e.fromDOMEventEmitter=function(e,t,n=(e=>e)){
const i=(...e)=>r.fire(n(...e)),r=new l({onFirstListenerAdd:()=>e.addEventListener(t,i),onLastListenerRemove:()=>e.removeEventListener(t,i)});return r.event},e.fromPromise=function(e){const t=new l;let n=!1;return e.then(void 0,()=>null).then(()=>{n?t.fire(void 0):setTimeout(()=>t.fire(void 0),0)}),n=!0,t.event},e.toPromise=function(e){return new Promise(n=>t(e)(n))}}(o=t.Event||(t.Event={}));let a=-1;t.setGlobalLeakWarningThreshold=function(e){const t=a;return a=e,{dispose(){a=t}}};class c{constructor(e,t=Math.random().toString(18).slice(2,5)){this.customThreshold=e,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(e){let t=a;if("number"==typeof this.customThreshold&&(t=this.customThreshold),t<=0||e<t)return;this._stacks||(this._stacks=new Map);const n=(new Error).stack.split("\n").slice(3).join("\n"),i=this._stacks.get(n)||0;if(this._stacks.set(n,i+1),this._warnCountdown-=1,this._warnCountdown<=0){let n;this._warnCountdown=.5*t;let i=0
;for(const[e,t]of this._stacks)(!n||i<t)&&(n=e,i=t);console.warn(`[${this.name}] potential listener LEAK detected, having ${e} listeners already. MOST frequent listener (${i}):`),console.warn(n)}return()=>{const e=this._stacks.get(n)||0;this._stacks.set(n,e-1)}}}class l{constructor(e){this._disposed=!1,this._options=e,this._leakageMon=a>0?new c(this._options&&this._options.leakWarningThreshold):void 0}get event(){return this._event||(this._event=(e,t,n)=>{this._listeners||(this._listeners=new s.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const o=this._listeners.push(t?[e,t]:e);let a,c;return i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,e,t),this._leakageMon&&(a=this._leakageMon.check(this._listeners.size)),c={dispose:()=>{if(a&&a(),c.dispose=l._noop,!this._disposed&&(o(),
this._options&&this._options.onLastListenerRemove)){this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)}}},n instanceof r.DisposableStore?n.add(c):Array.isArray(n)&&n.push(c),c}),this._event}fire(e){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,e]);for(;this._deliveryQueue.size>0;){const[e,t]=this._deliveryQueue.shift();try{"function"==typeof e?e.call(void 0,t):e[0].call(e[1],t)}catch(e){n.onUnexpectedError(e)}}}}dispose(){this._listeners&&this._listeners.clear(),this._deliveryQueue&&this._deliveryQueue.clear(),this._leakageMon&&this._leakageMon.dispose(),this._disposed=!0}}t.Emitter=l,l._noop=function(){};t.PauseableEmitter=class extends l{constructor(e){super(e),this._isPaused=0,this._eventQueue=new s.LinkedList,this._mergeFn=e&&e.merge}pause(){this._isPaused++}resume(){if(0!==this._isPaused&&0==--this._isPaused)if(this._mergeFn){const e=this._eventQueue.toArray()
;this._eventQueue.clear(),super.fire(this._mergeFn(e))}else for(;!this._isPaused&&0!==this._eventQueue.size;)super.fire(this._eventQueue.shift())}fire(e){this._listeners&&(0!==this._isPaused?this._eventQueue.push(e):super.fire(e))}};t.AsyncEmitter=class extends l{async fireAsync(e,t,i){if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new s.LinkedList);for(const t of this._listeners)this._asyncDeliveryQueue.push([t,e]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[e,t]=this._asyncDeliveryQueue.shift(),r=[],s=Object.assign(Object.assign({},t),{waitUntil:t=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");i&&(t=i(t,"function"==typeof e?e:e[0])),r.push(t)}});try{"function"==typeof e?e.call(void 0,s):e[0].call(e[1],s)}catch(e){n.onUnexpectedError(e);continue}Object.freeze(r),await Promise.all(r).catch(e=>n.onUnexpectedError(e))}}}};t.EventMultiplexer=class{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({
onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(e){const t={event:e,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);return r.toDisposable(i.once(()=>{this.hasListeners&&this.unhook(t);const e=this.events.indexOf(t);this.events.splice(e,1)}))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(e=>this.hook(e))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(e=>this.unhook(e))}hook(e){e.listener=e.event(e=>this.emitter.fire(e))}unhook(e){e.listener&&e.listener.dispose(),e.listener=null}dispose(){this.emitter.dispose()}};t.EventBufferer=class{constructor(){this.buffers=[]}wrapEvent(e){return(t,n,i)=>e(e=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>t.call(n,e)):t.call(n,e)},void 0,i)}bufferEvents(e){const t=[];this.buffers.push(t);const n=e();return this.buffers.pop(),t.forEach(e=>e()),n}};t.Relay=class{constructor(){this.listening=!1,this.inputEvent=o.None,
this.inputEventListener=r.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(e){this.inputEvent=e,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=e(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}})),define(t[24],n([0,1,5]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const i=Object.freeze((function(e,t){const n=setTimeout(e.bind(t),0);return{dispose(){clearTimeout(n)}}}));var r;!function(e){e.isCancellationToken=function(t){return t===e.None||t===e.Cancelled||(t instanceof s||!(!t||"object"!=typeof t)&&("boolean"==typeof t.isCancellationRequested&&"function"==typeof t.onCancellationRequested))},e.None=Object.freeze({
isCancellationRequested:!1,onCancellationRequested:n.Event.None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})}(r=t.CancellationToken||(t.CancellationToken={}));class s{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new n.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}t.CancellationTokenSource=class{constructor(e){this._token=void 0,this._parentListener=void 0,this._parentListener=e&&e.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new s),this._token}cancel(){this._token?this._token instanceof s&&this._token.cancel():this._token=r.Cancelled}dispose(e=!1){e&&this.cancel(),this._parentListener&&this._parentListener.dispose(),
this._token?this._token instanceof s&&this._token.dispose():this._token=r.None}}})),define(t[15],n([0,1,24,16,5,3]),(function(e,t,n,i,r,s){"use strict";function o(e){return e&&"function"==typeof e.then}function a(e){const t=new n.CancellationTokenSource,r=e(t.token),s=new Promise((e,n)=>{t.token.onCancellationRequested(()=>{n(i.canceled())}),Promise.resolve(r).then(n=>{t.dispose(),e(n)},e=>{t.dispose(),n(e)})});return new class{cancel(){t.cancel()}then(e,t){return s.then(e,t)}catch(e){return this.then(void 0,e)}finally(e){return s.finally(e)}}}Object.defineProperty(t,"__esModule",{value:!0}),t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.RunOnceWorker=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.first=t.sequence=t.ignoreErrors=t.disposableTimeout=t.timeout=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0,
t.isThenable=o,t.createCancelablePromise=a,t.raceCancellation=function(e,t,n){return Promise.race([e,new Promise(e=>t.onCancellationRequested(()=>e(n)))])},t.raceCancellablePromises=async function(e){let t=-1;const n=e.map((e,n)=>e.then(e=>(t=n,e))),i=await Promise.race(n);return e.forEach((e,n)=>{n!==t&&e.cancel()}),i},t.raceTimeout=function(e,t,n){let i=void 0;const r=setTimeout(()=>{null==i||i(void 0),null==n||n()},t);return Promise.race([e.finally(()=>clearTimeout(r)),new Promise(e=>i=e)])},t.asPromise=function(e){return new Promise((t,n)=>{const i=e();o(i)?i.then(t,n):t(i)})};class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(e){if(this.activePromise){if(this.queuedPromiseFactory=e,!this.queuedPromise){const e=()=>{this.queuedPromise=null;const e=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,e};this.queuedPromise=new Promise(t=>{this.activePromise.then(e,e).then(t)})}return new Promise((e,t)=>{
this.queuedPromise.then(e,t)})}return this.activePromise=e(),new Promise((e,t)=>{this.activePromise.then(t=>{this.activePromise=null,e(t)},e=>{this.activePromise=null,t(e)})})}}t.Throttler=c;t.Sequencer=class{constructor(){this.current=Promise.resolve(null)}queue(e){return this.current=this.current.then(()=>e())}};t.SequencerByKey=class{constructor(){this.promiseMap=new Map}queue(e,t){var n;const i=(null!==(n=this.promiseMap.get(e))&&void 0!==n?n:Promise.resolve()).catch(()=>{}).then(t).finally(()=>{this.promiseMap.get(e)===i&&this.promiseMap.delete(e)});return this.promiseMap.set(e,i),i}};class l{constructor(e){this.defaultDelay=e,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(e,t=this.defaultDelay){return this.task=e,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((e,t)=>{this.doResolve=e,this.doReject=t}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const e=this.task
;return this.task=null,e()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},t),this.completionPromise}isTriggered(){return null!==this.timeout}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(i.canceled()),this.completionPromise=null)}cancelTimeout(){null!==this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}t.Delayer=l;t.ThrottledDelayer=class{constructor(e){this.delayer=new l(e),this.throttler=new c}trigger(e,t){return this.delayer.trigger(()=>this.throttler.queue(e),t)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}};function u(e,t){return t?new Promise((n,r)=>{const s=setTimeout(n,e);t.onCancellationRequested(()=>{clearTimeout(s),r(i.canceled())})}):a(t=>u(e,t))}t.Barrier=class{constructor(){this._isOpen=!1,this._promise=new Promise((e,t)=>{this._completePromise=e})}isOpen(){return this._isOpen}open(){this._isOpen=!0,
this._completePromise(!0)}wait(){return this._promise}},t.timeout=u,t.disposableTimeout=function(e,t=0){const n=setTimeout(e,t);return s.toDisposable(()=>clearTimeout(n))},t.ignoreErrors=function(e){return e.then(void 0,e=>void 0)},t.sequence=function(e){const t=[];let n=0;const i=e.length;return Promise.resolve(null).then((function r(s){null!=s&&t.push(s);const o=n<i?e[n++]():null;return o?o.then(r):Promise.resolve(t)}))},t.first=function(e,t=(e=>!!e),n=null){let i=0;const r=e.length,s=()=>{if(i>=r)return Promise.resolve(n);const o=e[i++];return Promise.resolve(o()).then(e=>t(e)?Promise.resolve(e):s())};return s()};class h{constructor(e){this._size=0,this.maxDegreeOfParalellism=e,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new r.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(e){return this._size++,new Promise((t,n)=>{this.outstandingPromises.push({factory:e,c:t,e:n}),this.consume()})}consume(){
for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const e=this.outstandingPromises.shift();this.runningPromises++;const t=e.factory();t.then(e.c,e.e),t.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}t.Limiter=h;class d extends h{constructor(){super(1)}}t.Queue=d;t.ResourceQueue=class{constructor(){this.queues=new Map}queueFor(e){const t=e.toString();if(!this.queues.has(t)){const e=new d;e.onFinished(()=>{e.dispose(),this.queues.delete(t)}),this.queues.set(t,e)}return this.queues.get(t)}dispose(){this.queues.forEach(e=>e.dispose()),this.queues.clear()}};t.TimeoutTimer=class{constructor(e,t){this._token=-1,"function"==typeof e&&"number"==typeof t&&this.setIfNotSet(e,t)}dispose(){this.cancel()}cancel(){-1!==this._token&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(e,t){this.cancel(),
this._token=setTimeout(()=>{this._token=-1,e()},t)}setIfNotSet(e,t){-1===this._token&&(this._token=setTimeout(()=>{this._token=-1,e()},t))}};t.IntervalTimer=class{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){-1!==this._token&&(clearInterval(this._token),this._token=-1)}cancelAndSet(e,t){this.cancel(),this._token=setInterval(()=>{e()},t)}};class f{constructor(e,t){this.timeoutToken=-1,this.runner=e,this.timeout=t,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(e=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,e)}get delay(){return this.timeout}set delay(e){this.timeout=e}isScheduled(){return-1!==this.timeoutToken}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}t.RunOnceScheduler=f;t.RunOnceWorker=class extends f{constructor(e,t){super(e,t),this.units=[]}work(e){this.units.push(e),
this.isScheduled()||this.schedule()}doRun(){const e=this.units;this.units=[],this.runner&&this.runner(e)}dispose(){this.units=[],super.dispose()}},function(){if("function"!=typeof requestIdleCallback||"function"!=typeof cancelIdleCallback){const e=Object.freeze({didTimeout:!0,timeRemaining:()=>15});t.runWhenIdle=t=>{const n=setTimeout(()=>t(e));let i=!1;return{dispose(){i||(i=!0,clearTimeout(n))}}}}else t.runWhenIdle=(e,t)=>{const n=requestIdleCallback(e,"number"==typeof t?{timeout:t}:void 0);let i=!1;return{dispose(){i||(i=!0,cancelIdleCallback(n))}}}}();t.IdleValue=class{constructor(e){this._didRun=!1,this._executor=()=>{try{this._value=e()}catch(e){this._error=e}finally{this._didRun=!0}},this._handle=t.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}},t.retry=async function(e,t,n){let i;for(let r=0;r<n;r++)try{return await e()}catch(e){i=e,await u(t)}throw i}
;t.TaskSequentializer=class{hasPending(e){return!!this._pending&&("number"==typeof e?this._pending.taskId===e:!!this._pending)}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var e;null===(e=this._pending)||void 0===e||e.cancel()}setPending(e,t,n){return this._pending={taskId:e,cancel:()=>null==n?void 0:n(),promise:t},t.then(()=>this.donePending(e),()=>this.donePending(e)),t}donePending(e){this._pending&&e===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const e=this._next;this._next=void 0,e.run().then(e.promiseResolve,e.promiseReject)}}setNext(e){if(this._next)this._next.run=e;else{let t,n;const i=new Promise((e,i)=>{t=e,n=i});this._next={run:e,promise:i,promiseResolve:t,promiseReject:n}}return this._next.promise}}})),e="object"==typeof global?global:"object"==typeof self?self:{},"function"==typeof define?define("vs/base/common/performance",[],(function(){return i(e)
})):"object"==typeof module&&"object"==typeof module.exports?module.exports=i(e):e.perf=i(e),define(t[6],n([0,1]),(function(e,t){"use strict";var n;Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.OperatingSystem=t.setImmediate=t.globals=t.translationsConfigFile=t.locale=t.Language=t.language=t.isRootUser=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isNative=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=void 0;let i=!1,r=!1,s=!1,o=!1,a=!1,c=!1,l=void 0,u="en",h=void 0,d=void 0;const f="object"==typeof self?self:"object"==typeof global?global:{};let p=void 0;"undefined"!=typeof process?p=process:void 0!==f.vscode&&(p=f.vscode.process);const g="string"==typeof(null===(n=null==p?void 0:p.versions)||void 0===n?void 0:n.electron)&&"renderer"===p.type;if("object"!=typeof navigator||g)if("object"==typeof p){i="win32"===p.platform,r="darwin"===p.platform,s="linux"===p.platform,l="en",u="en";const e=p.env.VSCODE_NLS_CONFIG;if(e)try{
const t=JSON.parse(e),n=t.availableLanguages["*"];l=t.locale,u=n||"en",h=t._translationsConfigFile}catch(e){}o=!0}else console.error("Unable to resolve platform.");else d=navigator.userAgent,i=d.indexOf("Windows")>=0,r=d.indexOf("Macintosh")>=0,c=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,s=d.indexOf("Linux")>=0,a=!0,u=l=navigator.language;!function(e){e[e.Web=0]="Web",e[e.Mac=1]="Mac",e[e.Linux=2]="Linux",e[e.Windows=3]="Windows"}(t.Platform||(t.Platform={})),t.PlatformToString=function(e){switch(e){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}};let m=0;r?m=1:i?m=3:s&&(m=2),t.isWindows=i,t.isMacintosh=r,t.isLinux=s,t.isNative=o,t.isWeb=a,t.isIOS=c,t.platform=m,t.userAgent=d,t.isRootUser=function(){return!!p&&!i&&0===p.getuid()},t.language=u,function(e){e.value=function(){return t.language},e.isDefaultVariant=function(){
return 2===t.language.length?"en"===t.language:t.language.length>=3&&("e"===t.language[0]&&"n"===t.language[1]&&"-"===t.language[2])},e.isDefault=function(){return"en"===t.language}}(t.Language||(t.Language={})),t.locale=l,t.translationsConfigFile=h,t.globals=f,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if("function"==typeof t.globals.postMessage&&!t.globals.importScripts){let e=[];t.globals.addEventListener("message",t=>{if(t.data&&t.data.vscodeSetImmediateId)for(let n=0,i=e.length;n<i;n++){const i=e[n];if(i.id===t.data.vscodeSetImmediateId)return e.splice(n,1),void i.callback()}});let n=0;return i=>{const r=++n;e.push({id:r,callback:i}),t.globals.postMessage({vscodeSetImmediateId:r},"*")}}if(p)return p.nextTick.bind(p);const e=Promise.resolve();return t=>e.then(t)}(),function(e){e[e.Windows=1]="Windows",e[e.Macintosh=2]="Macintosh",e[e.Linux=3]="Linux"}(t.OperatingSystem||(t.OperatingSystem={})),t.OS=r||c?2:i?1:3;let v=!0,y=!1
;t.isLittleEndian=function(){if(!y){y=!0;const e=new Uint8Array(2);e[0]=1,e[1]=2;const t=new Uint16Array(e.buffer);v=513===t[0]}return v}})),define(t[51],n([0,1,6]),(function(e,t,n){"use strict";let i;Object.defineProperty(t,"__esModule",{value:!0}),t.nextTick=t.platform=t.env=t.cwd=void 0,i="undefined"!=typeof process?process:void 0!==n.globals.vscode?n.globals.vscode.process:{get platform(){return n.isWindows?"win32":n.isMacintosh?"darwin":"linux"},nextTick:e=>n.setImmediate(e),get env(){return Object.create(null)},cwd:()=>"/",getuid:()=>-1},t.cwd=i.cwd,t.env=i.env,t.platform=i.platform,t.nextTick=i.nextTick})),define(t[2],n([0,1,51]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const i=65,r=97,s=90,o=122,a=46,c=47,l=92;class u extends Error{constructor(e,t,n){let i
;"string"==typeof t&&0===t.indexOf("not ")?(i="must not be",t=t.replace(/^not /,"")):i="must be";const r=-1!==e.indexOf(".")?"property":"argument";let s=`The "${e}" ${r} ${i} of type ${t}`;super(s+=`. Received type ${typeof n}`),this.code="ERR_INVALID_ARG_TYPE"}}function h(e,t){if("string"!=typeof e)throw new u(t,"string",e)}function d(e){return e===c||e===l}function f(e){return e===c}function p(e){return e>=i&&e<=s||e>=r&&e<=o}function g(e,t,n,i){let r="",s=0,o=-1,l=0,u=0;for(let h=0;h<=e.length;++h){if(h<e.length)u=e.charCodeAt(h);else{if(i(u))break;u=c}if(i(u)){if(o===h-1||1===l);else if(2===l){if(r.length<2||2!==s||r.charCodeAt(r.length-1)!==a||r.charCodeAt(r.length-2)!==a){if(r.length>2){const e=r.lastIndexOf(n);-1===e?(r="",s=0):s=(r=r.slice(0,e)).length-1-r.lastIndexOf(n),o=h,l=0;continue}if(0!==r.length){r="",s=0,o=h,l=0;continue}}t&&(r+=r.length>0?`${n}..`:"..",s=2)}else r.length>0?r+=`${n}${e.slice(o+1,h)}`:r=e.slice(o+1,h),s=h-o-1;o=h,l=0}else u===a&&-1!==l?++l:l=-1}return r}function m(e,t){
if(null===t||"object"!=typeof t)throw new u("pathObject","Object",t);const n=t.dir||t.root,i=t.base||`${t.name||""}${t.ext||""}`;return n?n===t.root?`${n}${i}`:`${n}${e}${i}`:i}t.win32={resolve(...e){let t="",i="",r=!1;for(let s=e.length-1;s>=-1;s--){let o;if(s>=0){if(h(o=e[s],"path"),0===o.length)continue}else 0===t.length?o=n.cwd():(void 0===(o=n.env[`=${t}`]||n.cwd())||o.slice(0,2).toLowerCase()!==t.toLowerCase()&&o.charCodeAt(2)===l)&&(o=`${t}\\`);const a=o.length;let c=0,u="",f=!1;const g=o.charCodeAt(0);if(1===a)d(g)&&(c=1,f=!0);else if(d(g))if(f=!0,d(o.charCodeAt(1))){let e=2,t=e;for(;e<a&&!d(o.charCodeAt(e));)e++;if(e<a&&e!==t){const n=o.slice(t,e);for(t=e;e<a&&d(o.charCodeAt(e));)e++;if(e<a&&e!==t){for(t=e;e<a&&!d(o.charCodeAt(e));)e++;e!==a&&e===t||(u=`\\\\${n}\\${o.slice(t,e)}`,c=e)}}}else c=1;else p(g)&&58===o.charCodeAt(1)&&(u=o.slice(0,2),c=2,a>2&&d(o.charCodeAt(2))&&(f=!0,c=3));if(u.length>0)if(t.length>0){if(u.toLowerCase()!==t.toLowerCase())continue}else t=u;if(r){if(t.length>0)break
}else if(i=`${o.slice(c)}\\${i}`,r=f,f&&t.length>0)break}return i=g(i,!r,"\\",d),r?`${t}\\${i}`:`${t}${i}`||"."},normalize(e){h(e,"path");const t=e.length;if(0===t)return".";let n,i=0,r=!1;const s=e.charCodeAt(0);if(1===t)return f(s)?"\\":e;if(d(s))if(r=!0,d(e.charCodeAt(1))){let r=2,s=r;for(;r<t&&!d(e.charCodeAt(r));)r++;if(r<t&&r!==s){const o=e.slice(s,r);for(s=r;r<t&&d(e.charCodeAt(r));)r++;if(r<t&&r!==s){for(s=r;r<t&&!d(e.charCodeAt(r));)r++;if(r===t)return`\\\\${o}\\${e.slice(s)}\\`;r!==s&&(n=`\\\\${o}\\${e.slice(s,r)}`,i=r)}}}else i=1;else p(s)&&58===e.charCodeAt(1)&&(n=e.slice(0,2),i=2,t>2&&d(e.charCodeAt(2))&&(r=!0,i=3));let o=i<t?g(e.slice(i),!r,"\\",d):"";return 0!==o.length||r||(o="."),o.length>0&&d(e.charCodeAt(t-1))&&(o+="\\"),void 0===n?r?`\\${o}`:o:r?`${n}\\${o}`:`${n}${o}`},isAbsolute(e){h(e,"path");const t=e.length;if(0===t)return!1;const n=e.charCodeAt(0);return d(n)||t>2&&p(n)&&58===e.charCodeAt(1)&&d(e.charCodeAt(2))},join(...e){if(0===e.length)return".";let n,i
;for(let t=0;t<e.length;++t){const r=e[t];h(r,"path"),r.length>0&&(void 0===n?n=i=r:n+=`\\${r}`)}if(void 0===n)return".";let r=!0,s=0;if("string"==typeof i&&d(i.charCodeAt(0))){++s;const e=i.length;e>1&&d(i.charCodeAt(1))&&(++s,e>2&&(d(i.charCodeAt(2))?++s:r=!1))}if(r){for(;s<n.length&&d(n.charCodeAt(s));)s++;s>=2&&(n=`\\${n.slice(s)}`)}return t.win32.normalize(n)},relative(e,n){if(h(e,"from"),h(n,"to"),e===n)return"";const i=t.win32.resolve(e),r=t.win32.resolve(n);if(i===r)return"";if((e=i.toLowerCase())===(n=r.toLowerCase()))return"";let s=0;for(;s<e.length&&e.charCodeAt(s)===l;)s++;let o=e.length;for(;o-1>s&&e.charCodeAt(o-1)===l;)o--;const a=o-s;let c=0;for(;c<n.length&&n.charCodeAt(c)===l;)c++;let u=n.length;for(;u-1>c&&n.charCodeAt(u-1)===l;)u--;const d=u-c,f=a<d?a:d;let p=-1,g=0;for(;g<f;g++){const t=e.charCodeAt(s+g);if(t!==n.charCodeAt(c+g))break;t===l&&(p=g)}if(g!==f){if(-1===p)return r}else{if(d>f){if(n.charCodeAt(c+g)===l)return r.slice(c+g+1);if(2===g)return r.slice(c+g)}
a>f&&(e.charCodeAt(s+g)===l?p=g:2===g&&(p=3)),-1===p&&(p=0)}let m="";for(g=s+p+1;g<=o;++g)g!==o&&e.charCodeAt(g)!==l||(m+=0===m.length?"..":"\\..");return c+=p,m.length>0?`${m}${r.slice(c,u)}`:(r.charCodeAt(c)===l&&++c,r.slice(c,u))},toNamespacedPath(e){if("string"!=typeof e)return e;if(0===e.length)return"";const n=t.win32.resolve(e);if(n.length<=2)return e;if(n.charCodeAt(0)===l){if(n.charCodeAt(1)===l){const e=n.charCodeAt(2);if(63!==e&&e!==a)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(p(n.charCodeAt(0))&&58===n.charCodeAt(1)&&n.charCodeAt(2)===l)return`\\\\?\\${n}`;return e},dirname(e){h(e,"path");const t=e.length;if(0===t)return".";let n=-1,i=0;const r=e.charCodeAt(0);if(1===t)return d(r)?e:".";if(d(r)){if(n=i=1,d(e.charCodeAt(1))){let r=2,s=r;for(;r<t&&!d(e.charCodeAt(r));)r++;if(r<t&&r!==s){for(s=r;r<t&&d(e.charCodeAt(r));)r++;if(r<t&&r!==s){for(s=r;r<t&&!d(e.charCodeAt(r));)r++;if(r===t)return e;r!==s&&(n=i=r+1)}}}}else p(r)&&58===e.charCodeAt(1)&&(i=n=t>2&&d(e.charCodeAt(2))?3:2);let s=-1,o=!0
;for(let n=t-1;n>=i;--n)if(d(e.charCodeAt(n))){if(!o){s=n;break}}else o=!1;if(-1===s){if(-1===n)return".";s=n}return e.slice(0,s)},basename(e,t){void 0!==t&&h(t,"ext"),h(e,"path");let n,i=0,r=-1,s=!0;if(e.length>=2&&p(e.charCodeAt(0))&&58===e.charCodeAt(1)&&(i=2),void 0!==t&&t.length>0&&t.length<=e.length){if(t===e)return"";let o=t.length-1,a=-1;for(n=e.length-1;n>=i;--n){const c=e.charCodeAt(n);if(d(c)){if(!s){i=n+1;break}}else-1===a&&(s=!1,a=n+1),o>=0&&(c===t.charCodeAt(o)?-1==--o&&(r=n):(o=-1,r=a))}return i===r?r=a:-1===r&&(r=e.length),e.slice(i,r)}for(n=e.length-1;n>=i;--n)if(d(e.charCodeAt(n))){if(!s){i=n+1;break}}else-1===r&&(s=!1,r=n+1);return-1===r?"":e.slice(i,r)},extname(e){h(e,"path");let t=0,n=-1,i=0,r=-1,s=!0,o=0;e.length>=2&&58===e.charCodeAt(1)&&p(e.charCodeAt(0))&&(t=i=2);for(let c=e.length-1;c>=t;--c){const t=e.charCodeAt(c);if(d(t)){if(!s){i=c+1;break}}else-1===r&&(s=!1,r=c+1),t===a?-1===n?n=c:1!==o&&(o=1):-1!==n&&(o=-1)}return-1===n||-1===r||0===o||1===o&&n===r-1&&n===i+1?"":e.slice(n,r)},
format:m.bind(null,"\\"),parse(e){h(e,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;const n=e.length;let i=0,r=e.charCodeAt(0);if(1===n)return d(r)?(t.root=t.dir=e,t):(t.base=t.name=e,t);if(d(r)){if(i=1,d(e.charCodeAt(1))){let t=2,r=t;for(;t<n&&!d(e.charCodeAt(t));)t++;if(t<n&&t!==r){for(r=t;t<n&&d(e.charCodeAt(t));)t++;if(t<n&&t!==r){for(r=t;t<n&&!d(e.charCodeAt(t));)t++;t===n?i=t:t!==r&&(i=t+1)}}}}else if(p(r)&&58===e.charCodeAt(1)){if(n<=2)return t.root=t.dir=e,t;if(i=2,d(e.charCodeAt(2))){if(3===n)return t.root=t.dir=e,t;i=3}}i>0&&(t.root=e.slice(0,i));let s=-1,o=i,c=-1,l=!0,u=e.length-1,f=0;for(;u>=i;--u)if(d(r=e.charCodeAt(u))){if(!l){o=u+1;break}}else-1===c&&(l=!1,c=u+1),r===a?-1===s?s=u:1!==f&&(f=1):-1!==s&&(f=-1);return-1!==c&&(-1===s||0===f||1===f&&s===c-1&&s===o+1?t.base=t.name=e.slice(o,c):(t.name=e.slice(o,s),t.base=e.slice(o,c),t.ext=e.slice(s,c))),t.dir=o>0&&o!==i?e.slice(0,o-1):t.root,t},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...e){
let t="",i=!1;for(let r=e.length-1;r>=-1&&!i;r--){const s=r>=0?e[r]:n.cwd();h(s,"path"),0!==s.length&&(t=`${s}/${t}`,i=s.charCodeAt(0)===c)}return t=g(t,!i,"/",f),i?`/${t}`:t.length>0?t:"."},normalize(e){if(h(e,"path"),0===e.length)return".";const t=e.charCodeAt(0)===c,n=e.charCodeAt(e.length-1)===c;return 0===(e=g(e,!t,"/",f)).length?t?"/":n?"./":".":(n&&(e+="/"),t?`/${e}`:e)},isAbsolute:e=>(h(e,"path"),e.length>0&&e.charCodeAt(0)===c),join(...e){if(0===e.length)return".";let n;for(let t=0;t<e.length;++t){const i=e[t];h(i,"path"),i.length>0&&(void 0===n?n=i:n+=`/${i}`)}return void 0===n?".":t.posix.normalize(n)},relative(e,n){if(h(e,"from"),h(n,"to"),e===n)return"";if((e=t.posix.resolve(e))===(n=t.posix.resolve(n)))return"";const i=e.length,r=i-1,s=n.length-1,o=r<s?r:s;let a=-1,l=0;for(;l<o;l++){const t=e.charCodeAt(1+l);if(t!==n.charCodeAt(1+l))break;t===c&&(a=l)}if(l===o)if(s>o){if(n.charCodeAt(1+l)===c)return n.slice(1+l+1);if(0===l)return n.slice(1+l)}else r>o&&(e.charCodeAt(1+l)===c?a=l:0===l&&(a=0))
;let u="";for(l=1+a+1;l<=i;++l)l!==i&&e.charCodeAt(l)!==c||(u+=0===u.length?"..":"/..");return`${u}${n.slice(1+a)}`},toNamespacedPath:e=>e,dirname(e){if(h(e,"path"),0===e.length)return".";const t=e.charCodeAt(0)===c;let n=-1,i=!0;for(let t=e.length-1;t>=1;--t)if(e.charCodeAt(t)===c){if(!i){n=t;break}}else i=!1;return-1===n?t?"/":".":t&&1===n?"//":e.slice(0,n)},basename(e,t){void 0!==t&&h(t,"ext"),h(e,"path");let n,i=0,r=-1,s=!0;if(void 0!==t&&t.length>0&&t.length<=e.length){if(t===e)return"";let o=t.length-1,a=-1;for(n=e.length-1;n>=0;--n){const l=e.charCodeAt(n);if(l===c){if(!s){i=n+1;break}}else-1===a&&(s=!1,a=n+1),o>=0&&(l===t.charCodeAt(o)?-1==--o&&(r=n):(o=-1,r=a))}return i===r?r=a:-1===r&&(r=e.length),e.slice(i,r)}for(n=e.length-1;n>=0;--n)if(e.charCodeAt(n)===c){if(!s){i=n+1;break}}else-1===r&&(s=!1,r=n+1);return-1===r?"":e.slice(i,r)},extname(e){h(e,"path");let t=-1,n=0,i=-1,r=!0,s=0;for(let o=e.length-1;o>=0;--o){const l=e.charCodeAt(o);if(l!==c)-1===i&&(r=!1,i=o+1),
l===a?-1===t?t=o:1!==s&&(s=1):-1!==t&&(s=-1);else if(!r){n=o+1;break}}return-1===t||-1===i||0===s||1===s&&t===i-1&&t===n+1?"":e.slice(t,i)},format:m.bind(null,"/"),parse(e){h(e,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;const n=e.charCodeAt(0)===c;let i;n?(t.root="/",i=1):i=0;let r=-1,s=0,o=-1,l=!0,u=e.length-1,d=0;for(;u>=i;--u){const t=e.charCodeAt(u);if(t!==c)-1===o&&(l=!1,o=u+1),t===a?-1===r?r=u:1!==d&&(d=1):-1!==r&&(d=-1);else if(!l){s=u+1;break}}if(-1!==o){const i=0===s&&n?1:s;-1===r||0===d||1===d&&r===o-1&&r===s+1?t.base=t.name=e.slice(i,o):(t.name=e.slice(i,r),t.base=e.slice(i,o),t.ext=e.slice(r,o))}return s>0?t.dir=e.slice(0,s-1):n&&(t.dir="/"),t},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize="win32"===n.platform?t.win32.normalize:t.posix.normalize,t.isAbsolute="win32"===n.platform?t.win32.isAbsolute:t.posix.isAbsolute,t.join="win32"===n.platform?t.win32.join:t.posix.join,
t.resolve="win32"===n.platform?t.win32.resolve:t.posix.resolve,t.relative="win32"===n.platform?t.win32.relative:t.posix.relative,t.dirname="win32"===n.platform?t.win32.dirname:t.posix.dirname,t.basename="win32"===n.platform?t.win32.basename:t.posix.basename,t.extname="win32"===n.platform?t.win32.extname:t.posix.extname,t.format="win32"===n.platform?t.win32.format:t.posix.format,t.parse="win32"===n.platform?t.win32.parse:t.posix.parse,t.toNamespacedPath="win32"===n.platform?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep="win32"===n.platform?t.win32.sep:t.posix.sep,t.delimiter="win32"===n.platform?t.win32.delimiter:t.posix.delimiter})),define(t[41],n([0,1,3]),(function(e,t,n){"use strict";function i(e){const t=e;return t&&[t.on,t.pause,t.resume,t.destroy].every(e=>"function"==typeof e)}function r(e,t){return new s(e,t)}Object.defineProperty(t,"__esModule",{value:!0}),
t.transform=t.toReadable=t.toStream=t.peekStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0,t.isReadableStream=i,t.isReadableBufferedStream=function(e){const t=e;return t&&i(t.stream)&&Array.isArray(t.buffer)&&"boolean"==typeof t.ended},t.newWriteableStream=r;class s{constructor(e,t){this.reducer=e,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(e){var t;if(!this.state.destroyed)if(this.state.flowing)this.listeners.data.forEach(t=>t(e));else if(this.buffer.data.push(e),
"number"==typeof(null===(t=this.options)||void 0===t?void 0:t.highWaterMark)&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}error(e){this.state.destroyed||(this.state.flowing?this.listeners.error.forEach(t=>t(e)):this.buffer.error.push(e))}end(e){this.state.destroyed||(e instanceof Error?this.error(e):e&&this.write(e),this.state.flowing?(this.listeners.end.forEach(e=>e()),this.destroy()):this.state.ended=!0)}on(e,t){if(!this.state.destroyed)switch(e){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors()}}removeListener(e,t){if(this.state.destroyed)return;let n=void 0;switch(e){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error}if(n){const e=n.indexOf(t);e>=0&&n.splice(e,1)}}flowData(){if(this.buffer.data.length>0){
const e=this.reducer(this.buffer.data);this.listeners.data.forEach(t=>t(e)),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const e of this.buffer.error)this.listeners.error.forEach(t=>t(e));this.buffer.error.length=0}}flowEnd(){return!!this.state.ended&&(this.listeners.end.forEach(e=>e()),this.listeners.end.length>0)}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}t.consumeReadable=function(e,t){const n=[];let i;for(;null!==(i=e.read());)n.push(i);return t(n)},t.peekReadable=function(e,t,n){const i=[];let r=void 0;for(;null!==(r=e.read())&&i.length<n;)i.push(r);return null===r&&i.length>0?t(i):{read:()=>{if(i.length>0)return i.shift();if(void 0!==r){const e=r;return r=void 0,e}
return e.read()}}},t.consumeStream=function(e,t){return new Promise((n,i)=>{const r=[];e.on("data",e=>r.push(e)),e.on("error",e=>i(e)),e.on("end",()=>n(t(r)))})},t.peekStream=function(e,t){return new Promise((i,r)=>{const s=new n.DisposableStore,o=[],a=n=>{if(o.push(n),o.length>t)return s.dispose(),e.pause(),i({stream:e,buffer:o,ended:!1})};s.add(n.toDisposable(()=>e.removeListener("data",a))),e.on("data",a);const c=e=>r(e);s.add(n.toDisposable(()=>e.removeListener("error",c))),e.on("error",c);const l=()=>i({stream:e,buffer:o,ended:!0});s.add(n.toDisposable(()=>e.removeListener("end",l))),e.on("end",l)})},t.toStream=function(e,t){const n=r(t);return n.end(e),n},t.toReadable=function(e){let t=!1;return{read:()=>t?null:(t=!0,e)}},t.transform=function(e,t,n){const i=r(n);return e.on("data",e=>i.write(t.data(e))),e.on("end",()=>i.end()),e.on("error",e=>i.error(t.error?t.error(e):e)),i}})),define(t[11],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.GraphemeBreakType=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.decodeUTF8=t.encodeUTF8=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.escapeRegExpCharacters=t.escape=t.format=t.pad=t.isFalsyOrWhitespace=void 0,
t.isFalsyOrWhitespace=function(e){return!e||"string"!=typeof e||0===e.trim().length},t.pad=function(e,t,n="0"){const i=""+e,r=[i];for(let e=i.length;e<t;e++)r.push(n);return r.reverse().join("")};const n=/{(\d+)}/g;function i(e){return e.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function r(e,t){if(!e||!t)return e;const n=t.length;if(0===n||0===e.length)return e;let i=0;for(;e.indexOf(t,i)===i;)i+=n;return e.substring(i)}function s(e,t){if(!e||!t)return e;const n=t.length,i=e.length;if(0===n||0===i)return e;let r=i,s=-1;for(;-1!==(s=e.lastIndexOf(t,r-1))&&s+n===r;){if(0===s)return"";r=s}return e.substring(0,r)}function o(e,t,n=0,i=e.length,r=0,s=t.length){for(;n<i&&r<s;n++,r++){let i=e.charCodeAt(n),s=t.charCodeAt(r);if(i<s)return-1;if(i>s)return 1}const o=i-n,a=s-r;return o<a?-1:o>a?1:0}function a(e,t,n=0,i=e.length,r=0,s=t.length){for(;n<i&&r<s;n++,r++){let a=e.charCodeAt(n),u=t.charCodeAt(r);if(a===u)continue;const h=a-u
;if((32!==h||!l(u))&&(-32!==h||!l(a)))return c(a)&&c(u)?h:o(e.toLowerCase(),t.toLowerCase(),n,i,r,s)}const a=i-n,u=s-r;return a<u?-1:a>u?1:0}function c(e){return e>=97&&e<=122}function l(e){return e>=65&&e<=90}function u(e){return c(e)||l(e)}function h(e,t,n=e.length){for(let i=0;i<n;i++){const n=e.charCodeAt(i),r=t.charCodeAt(i);if(n!==r)if(u(n)&&u(r)){const e=Math.abs(n-r);if(0!==e&&32!==e)return!1}else if(String.fromCharCode(n).toLowerCase()!==String.fromCharCode(r).toLowerCase())return!1}return!0}function d(e){return 55296<=e&&e<=56319}function f(e){return 56320<=e&&e<=57343}function p(e,t){return t-56320+(e-55296<<10)+65536}function g(e,t,n){const i=e.charCodeAt(n);if(d(i)&&n+1<t){const t=e.charCodeAt(n+1);if(f(t))return p(i,t)}return i}function m(e,t){const n=e.charCodeAt(t-1);if(f(n)&&t>1){const i=e.charCodeAt(t-2);if(d(i))return p(i,n)}return n}function v(e,t){const n=I.getInstance(),i=e.length,r=t,s=g(e,i,t),o=n.getGraphemeBreakType(s);t+=s>=65536?2:1;let a=o;for(;t<i;){
const r=g(e,i,t),s=n.getGraphemeBreakType(r);if(P(a,s))break;t+=r>=65536?2:1,a=s}const c=t;for(t=r,a=o;t>0;){const i=m(e,t),r=n.getGraphemeBreakType(i);if(P(r,a))break;t-=i>=65536?2:1,a=r}return[t,c]}t.format=function(e,...t){return 0===t.length?e:e.replace(n,(function(e,n){const i=parseInt(n,10);return isNaN(i)||i<0||i>=t.length?e:t[i]}))},t.escape=function(e){return e.replace(/[<>&]/g,(function(e){switch(e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return e}}))},t.escapeRegExpCharacters=i,t.trim=function(e,t=" "){return s(r(e,t),t)},t.ltrim=r,t.rtrim=s,t.convertSimple2RegExpPattern=function(e){return e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")},t.stripWildcards=function(e){return e.replace(/\*/g,"")},t.createRegExp=function(e,t,n={}){if(!e)throw new Error("Cannot create regex from empty string");t||(e=i(e)),n.wholeWord&&(/\B/.test(e.charAt(0))||(e="\\b"+e),/\B/.test(e.charAt(e.length-1))||(e+="\\b"));let r="";return n.global&&(r+="g"),
n.matchCase||(r+="i"),n.multiline&&(r+="m"),n.unicode&&(r+="u"),new RegExp(e,r)},t.regExpLeadsToEndlessLoop=function(e){return"^"!==e.source&&"^$"!==e.source&&"$"!==e.source&&"^\\s*$"!==e.source&&!(!e.exec("")||0!==e.lastIndex)},t.regExpContainsBackreference=function(e){return!!e.match(/([^\\]|^)(\\\\)*\\\d+/)},t.regExpFlags=function(e){return(e.global?"g":"")+(e.ignoreCase?"i":"")+(e.multiline?"m":"")+(e.unicode?"u":"")},t.firstNonWhitespaceIndex=function(e){for(let t=0,n=e.length;t<n;t++){const n=e.charCodeAt(t);if(32!==n&&9!==n)return t}return-1},t.getLeadingWhitespace=function(e,t=0,n=e.length){for(let i=t;i<n;i++){const n=e.charCodeAt(i);if(32!==n&&9!==n)return e.substring(t,i)}return e.substring(t,n)},t.lastNonWhitespaceIndex=function(e,t=e.length-1){for(let n=t;n>=0;n--){const t=e.charCodeAt(n);if(32!==t&&9!==t)return n}return-1},t.compare=function(e,t){return e<t?-1:e>t?1:0},t.compareSubstring=o,t.compareIgnoreCase=function(e,t){return a(e,t,0,e.length,0,t.length)},t.compareSubstringIgnoreCase=a,
t.isLowerAsciiLetter=c,t.isUpperAsciiLetter=l,t.equalsIgnoreCase=function(e,t){return e.length===t.length&&h(e,t)},t.startsWithIgnoreCase=function(e,t){const n=t.length;return!(t.length>e.length)&&h(e,t,n)},t.commonPrefixLength=function(e,t){let n,i=Math.min(e.length,t.length);for(n=0;n<i;n++)if(e.charCodeAt(n)!==t.charCodeAt(n))return n;return i},t.commonSuffixLength=function(e,t){let n,i=Math.min(e.length,t.length);const r=e.length-1,s=t.length-1;for(n=0;n<i;n++)if(e.charCodeAt(r-n)!==t.charCodeAt(s-n))return n;return i},t.isHighSurrogate=d,t.isLowSurrogate=f,t.computeCodePoint=p,t.getNextCodePoint=g,t.nextCharLength=function(e,t){const n=I.getInstance(),i=t,r=e.length,s=g(e,r,t);t+=s>=65536?2:1;let o=n.getGraphemeBreakType(s);for(;t<r;){const i=g(e,r,t),s=n.getGraphemeBreakType(i);if(P(o,s))break;t+=i>=65536?2:1,o=s}return t-i},t.prevCharLength=function(e,t){const n=I.getInstance(),i=t,r=m(e,t);t-=r>=65536?2:1;let s=n.getGraphemeBreakType(r);for(;t>0;){const i=m(e,t),r=n.getGraphemeBreakType(i)
;if(P(r,s))break;t-=i>=65536?2:1,s=r}return i-t},t.getCharContainingOffset=function(e,t){return t>0&&f(e.charCodeAt(t))?v(e,t-1):v(e,t)},t.encodeUTF8=function(e){const t=e.length;let n=0,i=0;for(;i<t;){const r=g(e,t,i);i+=r>=65536?2:1,n+=r<128?1:r<2048?2:r<65536?3:4}const r=new Uint8Array(n);i=0;let s=0;for(;i<t;){const n=g(e,t,i);i+=n>=65536?2:1,n<128?r[s++]=n:n<2048?(r[s++]=192|(1984&n)>>>6,r[s++]=128|(63&n)>>>0):n<65536?(r[s++]=224|(61440&n)>>>12,r[s++]=128|(4032&n)>>>6,r[s++]=128|(63&n)>>>0):(r[s++]=240|(1835008&n)>>>18,r[s++]=128|(258048&n)>>>12,r[s++]=128|(4032&n)>>>6,r[s++]=128|(63&n)>>>0)}return r},t.decodeUTF8=function(e){const t=e.byteLength,n=[];let i=0;for(;i<t;){const r=e[i];let s
;if((s=r>=240&&i+3<t?(7&e[i++])<<18>>>0|(63&e[i++])<<12>>>0|(63&e[i++])<<6>>>0|(63&e[i++])<<0>>>0:r>=224&&i+2<t?(15&e[i++])<<12>>>0|(63&e[i++])<<6>>>0|(63&e[i++])<<0>>>0:r>=192&&i+1<t?(31&e[i++])<<6>>>0|(63&e[i++])<<0>>>0:e[i++])>=0&&s<=55295||s>=57344&&s<=65535)n.push(String.fromCharCode(s));else if(s>=65536&&s<=1114111){const e=s-65536,t=55296+((1047552&e)>>>10),i=56320+((1023&e)>>>0);n.push(String.fromCharCode(t)),n.push(String.fromCharCode(i))}else n.push(String.fromCharCode(65533))}return n.join("")};const y=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/
;t.containsRTL=function(e){return y.test(e)};const w=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDE73\uDE78-\uDE82\uDE90-\uDE95])/;t.containsEmoji=function(e){return w.test(e)};const E=/^[\t\n\r\x20-\x7E]*$/;function _(e){return(e=+e)>=11904&&e<=55215||e>=63744&&e<=64255||e>=65281&&e<=65374}t.isBasicASCII=function(e){return E.test(e)},t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/,t.containsUnusualLineTerminators=function(e){return t.UNUSUAL_LINE_TERMINATORS.test(e)},t.containsFullWidthCharacter=function(e){for(let t=0,n=e.length;t<n;t++)if(_(e.charCodeAt(t)))return!0;return!1},t.isFullWidthCharacter=_,t.isEmojiImprecise=function(e){return e>=127462&&e<=127487||e>=9728&&e<=10175||e>=127744&&e<=128591||e>=128640&&e<=128764||e>=128992&&e<=129003||e>=129280&&e<=129535||e>=129648&&e<=129651||e>=129656&&e<=129666||e>=129680&&e<=129685},t.lcut=function(e,t){if(e.length<t)return e;const n=/\b/g
;let i=0;for(;n.test(e)&&!(e.length-n.lastIndex<t);)i=n.lastIndex,n.lastIndex+=1;return e.substring(i).replace(/^\s/,"")};const S=/\x1B\x5B[12]?K/g,b=/\x1b\[\d+m/g,C=/\x1b\[0?m/g;function x(e){return!!(e&&e.length>0&&65279===e.charCodeAt(0))}function P(e,t){return 0===e?5!==t&&7!==t:(2!==e||3!==t)&&(4===e||2===e||3===e||(4===t||2===t||3===t||(8!==e||8!==t&&9!==t&&11!==t&&12!==t)&&((11!==e&&9!==e||9!==t&&10!==t)&&((12!==e&&10!==e||10!==t)&&(5!==t&&13!==t&&(7!==t&&(1!==e&&((13!==e||14!==t)&&(6!==e||6!==t)))))))))}t.removeAnsiEscapeCodes=function(e){return e&&(e=(e=(e=e.replace(S,"")).replace(b,"")).replace(C,"")),e},t.UTF8_BOM_CHARACTER=String.fromCharCode(65279),t.startsWithUTF8BOM=x,t.stripUTF8BOM=function(e){return x(e)?e.substr(1):e},t.fuzzyContains=function(e,t){if(!e||!t)return!1;if(e.length<t.length)return!1;const n=t.length,i=e.toLowerCase();let r=0,s=-1;for(;r<n;){const e=i.indexOf(t[r],s+1);if(e<0)return!1;s=e,r++}return!0},t.containsUppercaseCharacter=function(e,t=!1){
return!!e&&(t&&(e=e.replace(/\\./g,"")),e.toLowerCase()!==e)},t.uppercaseFirstLetter=function(e){return e.charAt(0).toUpperCase()+e.slice(1)},t.getNLines=function(e,t=1){if(0===t)return"";let n=-1;do{n=e.indexOf("\n",n+1),t--}while(t>0&&n>=0);return n>=0?e.substr(0,n):e},t.singleLetterHash=function(e){return(e%=52)<26?String.fromCharCode(97+e):String.fromCharCode(65+e-26)},t.getGraphemeBreakType=function(e){return I.getInstance().getGraphemeBreakType(e)},t.breakBetweenGraphemeBreakType=P,function(e){e[e.Other=0]="Other",e[e.Prepend=1]="Prepend",e[e.CR=2]="CR",e[e.LF=3]="LF",e[e.Control=4]="Control",e[e.Extend=5]="Extend",e[e.Regional_Indicator=6]="Regional_Indicator",e[e.SpacingMark=7]="SpacingMark",e[e.L=8]="L",e[e.V=9]="V",e[e.T=10]="T",e[e.LV=11]="LV",e[e.LVT=12]="LVT",e[e.ZWJ=13]="ZWJ",e[e.Extended_Pictographic=14]="Extended_Pictographic"}(t.GraphemeBreakType||(t.GraphemeBreakType={}));class I{constructor(){
this._data=JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")
}static getInstance(){return I._INSTANCE||(I._INSTANCE=new I),I._INSTANCE}getGraphemeBreakType(e){if(e<32)return 10===e?3:13===e?2:4;if(e<127)return 0;const t=this._data,n=t.length/3;let i=1;for(;i<=n;)if(e<t[3*i])i*=2;else{if(!(e>t[3*i+1]))return t[3*i+2];i=2*i+1}return 0}}I._INSTANCE=null})),define(t[17],n([0,1,11,41]),(function(e,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const r="undefined"!=typeof Buffer,s="undefined"!=typeof TextEncoder,o="undefined"!=typeof TextDecoder;let a,c;class l{constructor(e){this.buffer=e,this.byteLength=this.buffer.byteLength}static alloc(e){return new l(r?Buffer.allocUnsafe(e):new Uint8Array(e))}static wrap(e){
return r&&!Buffer.isBuffer(e)&&(e=Buffer.from(e.buffer,e.byteOffset,e.byteLength)),new l(e)}static fromString(e){return r?new l(Buffer.from(e)):s?(a||(a=new TextEncoder),new l(a.encode(e))):new l(n.encodeUTF8(e))}static concat(e,t){if(void 0===t){t=0;for(let n=0,i=e.length;n<i;n++)t+=e[n].byteLength}const n=l.alloc(t);let i=0;for(let t=0,r=e.length;t<r;t++){const r=e[t];n.set(r,i),i+=r.byteLength}return n}toString(){return r?this.buffer.toString():o?(c||(c=new TextDecoder),c.decode(this.buffer)):n.decodeUTF8(this.buffer)}slice(e,t){return new l(this.buffer.subarray(e,t))}set(e,t){e instanceof l?this.buffer.set(e.buffer,t):this.buffer.set(e,t)}readUInt32BE(e){return u(this.buffer,e)}writeUInt32BE(e,t){h(this.buffer,e,t)}readUInt32LE(e){return d(this.buffer,e)}writeUInt32LE(e,t){f(this.buffer,e,t)}readUInt8(e){return p(this.buffer,e)}writeUInt8(e,t){g(this.buffer,e,t)}}function u(e,t){return e[t]*2**24+65536*e[t+1]+256*e[t+2]+e[t+3]}function h(e,t,n){e[n+3]=t,t>>>=8,e[n+2]=t,t>>>=8,e[n+1]=t,t>>>=8,e[n]=t}
function d(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0|e[t+2]<<16>>>0|e[t+3]<<24>>>0}function f(e,t,n){e[n+0]=255&t,t>>>=8,e[n+1]=255&t,t>>>=8,e[n+2]=255&t,t>>>=8,e[n+3]=255&t}function p(e,t){return e[t]}function g(e,t,n){e[n]=t}function m(e){return i.consumeStream(e,e=>l.concat(e))}t.VSBuffer=l,t.readUInt16LE=function(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0},t.writeUInt16LE=function(e,t,n){e[n+0]=255&t,t>>>=8,e[n+1]=255&t},t.readUInt32BE=u,t.writeUInt32BE=h,t.readUInt32LE=d,t.writeUInt32LE=f,t.readUInt8=p,t.writeUInt8=g,t.readableToBuffer=function(e){return i.consumeReadable(e,e=>l.concat(e))},t.bufferToReadable=function(e){return i.toReadable(e)},t.streamToBuffer=m,t.bufferedStreamToBuffer=async function(e){return e.ended?l.concat(e.buffer):l.concat([...e.buffer,await m(e.stream)])},t.bufferToStream=function(e){return i.toStream(e,e=>l.concat(e))},t.streamToBufferReadableStream=function(e){return i.transform(e,{data:e=>"string"==typeof e?l.fromString(e):l.wrap(e)},e=>l.concat(e))},
t.newWriteableBufferStream=function(e){return i.newWriteableStream(e=>l.concat(e),e)}})),define(t[91],n([0,1,11]),(function(e,t,n){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),function(e){e[e.Ignore=0]="Ignore",e[e.Info=1]="Info",e[e.Warning=2]="Warning",e[e.Error=3]="Error"}(i||(i={})),function(e){const t="error",i="warning",r="warn",s="info";e.fromValue=function(o){return o?n.equalsIgnoreCase(t,o)?e.Error:n.equalsIgnoreCase(i,o)||n.equalsIgnoreCase(r,o)?e.Warning:n.equalsIgnoreCase(s,o)?e.Info:e.Ignore:e.Ignore}}(i||(i={})),t.default=i})),define(t[12],n([0,1]),(function(e,t){"use strict";function n(e){return"string"==typeof e}function i(e){return!("object"!=typeof e||null===e||Array.isArray(e)||e instanceof RegExp||e instanceof Date)}function r(e){return void 0===e}function s(e){return r(e)||null===e}Object.defineProperty(t,"__esModule",{value:!0}),
t.NotImplementedProxy=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0,t.isArray=function(e){return Array.isArray(e)},t.isString=n,t.isStringArray=function(e){return Array.isArray(e)&&e.every(e=>n(e))},t.isObject=i,t.isNumber=function(e){return"number"==typeof e&&!isNaN(e)},t.isBoolean=function(e){return!0===e||!1===e},t.isUndefined=r,t.isDefined=function(e){return!s(e)},t.isUndefinedOrNull=s,t.assertType=function(e,t){if(!e)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")},t.assertIsDefined=function(e){if(s(e))throw new Error("Assertion Failed: argument is undefined or null");return e},t.assertAllDefined=function(...e){const t=[];for(let n=0;n<e.length;n++){const i=e[n]
;if(s(i))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(i)}return t};const o=Object.prototype.hasOwnProperty;function a(e){return"function"==typeof e}function c(e,t){if(n(t)){if(typeof e!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(e instanceof t)return}catch(e){}if(!s(e)&&e.constructor===t)return;if(1===t.length&&!0===t.call(void 0,e))return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function l(e){let t=[],n=Object.getPrototypeOf(e);for(;Object.prototype!==n;)t=t.concat(Object.getOwnPropertyNames(n)),n=Object.getPrototypeOf(n);return t}t.isEmptyObject=function(e){if(!i(e))return!1;for(let t in e)if(o.call(e,t))return!1;return!0},t.isFunction=a,t.areFunctions=function(...e){return e.length>0&&e.every(a)},t.validateConstraints=function(e,t){const n=Math.min(e.length,t.length);for(let i=0;i<n;i++)c(e[i],t[i])},
t.validateConstraint=c,t.getAllPropertyNames=l,t.getAllMethodNames=function(e){const t=[];for(const n of l(e))"function"==typeof e[n]&&t.push(n);return t},t.createProxyObject=function(e,t){const n=e=>(function(){const n=Array.prototype.slice.call(arguments,0);return t(e,n)});let i={};for(const t of e)i[t]=n(t);return i},t.withNullAsUndefined=function(e){return null===e?void 0:e},t.withUndefinedAsNull=function(e){return void 0===e?null:e},t.NotImplementedProxy=function(e){return class{constructor(){return new Proxy({},{get(t,n){if(t[n])return t[n];throw new Error(`Not Implemented: ${e}->${String(n)}`)}})}}}})),define(t[30],n([0,1,6,11,2,12]),(function(e,t,n,i,r,s){"use strict";function o(e){return 47===e||92===e}Object.defineProperty(t,"__esModule",{value:!0}),t.parseLineAndColumnAware=t.indexOfPath=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toSlashes=t.isPathSeparator=void 0,t.isPathSeparator=o,t.toSlashes=function(e){
return e.replace(/[\\/]/g,r.posix.sep)},t.getRoot=function(e,t=r.posix.sep){if(!e)return"";const n=e.length,i=e.charCodeAt(0);if(o(i)){if(o(e.charCodeAt(1))&&!o(e.charCodeAt(2))){let i=3;const r=i;for(;i<n&&!o(e.charCodeAt(i));i++);if(r!==i&&!o(e.charCodeAt(i+1)))for(i+=1;i<n;i++)if(o(e.charCodeAt(i)))return e.slice(0,i+1).replace(/[\\/]/g,t)}return t}if(u(i)&&58===e.charCodeAt(1))return o(e.charCodeAt(2))?e.slice(0,2)+t:e.slice(0,2);let s=e.indexOf("://");if(-1!==s)for(s+=3;s<n;s++)if(o(e.charCodeAt(s)))return e.slice(0,s+1);return""},t.isUNC=function(e){if(!n.isWindows)return!1;if(!e||e.length<5)return!1;let t=e.charCodeAt(0);if(92!==t)return!1;if(92!==(t=e.charCodeAt(1)))return!1;let i=2;const r=i;for(;i<e.length&&92!==(t=e.charCodeAt(i));i++);return r!==i&&(t=e.charCodeAt(i+1),!isNaN(t)&&92!==t)};const a=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(e){return e>=65&&e<=90||e>=97&&e<=122}t.isValidBasename=function(e,t=n.isWindows){const i=t?a:c
;return!(!e||0===e.length||/^\s+$/.test(e))&&(i.lastIndex=0,!i.test(e)&&((!t||!l.test(e))&&("."!==e&&".."!==e&&((!t||"."!==e[e.length-1])&&((!t||e.length===e.trim().length)&&!(e.length>255))))))},t.isEqual=function(e,t,n){const r=e===t;return!n||r?r:!(!e||!t)&&i.equalsIgnoreCase(e,t)},t.isEqualOrParent=function(e,t,n,s=r.sep){if(e===t)return!0;if(!e||!t)return!1;if(t.length>e.length)return!1;if(n){if(!i.startsWithIgnoreCase(e,t))return!1;if(t.length===e.length)return!0;let n=t.length;return t.charAt(t.length-1)===s&&n--,e.charAt(n)===s}return t.charAt(t.length-1)!==s&&(t+=s),0===e.indexOf(t)},t.isWindowsDriveLetter=u,t.sanitizeFilePath=function(e,t){return n.isWindows&&e.endsWith(":")&&(e+=r.sep),r.isAbsolute(e)||(e=r.join(t,e)),e=r.normalize(e),n.isWindows?(e=i.rtrim(e,r.sep)).endsWith(":")&&(e+=r.sep):(e=i.rtrim(e,r.sep))||(e=r.sep),e},t.isRootOrDriveLetter=function(e){const t=r.normalize(e)
;return n.isWindows?!(e.length>3)&&(u(t.charCodeAt(0))&&58===t.charCodeAt(1)&&(2===e.length||92===t.charCodeAt(2))):t===r.posix.sep},t.indexOfPath=function(e,t,n){return t.length>e.length?-1:e===t?0:(n&&(e=e.toLowerCase(),t=t.toLowerCase()),e.indexOf(t))},t.parseLineAndColumnAware=function(e){const t=e.split(":");let n=void 0,i=void 0,r=void 0;if(t.forEach(e=>{const t=Number(e);s.isNumber(t)?void 0===i?i=t:void 0===r&&(r=t):n=n?[n,e].join(":"):e}),!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:void 0!==i?i:void 0,column:void 0!==r?r:void 0!==i?1:void 0}}})),define(t[19],n([0,1,12]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0,t.deepClone=function e(t){if(!t||"object"!=typeof t)return t;if(t instanceof RegExp)return t;const n=Array.isArray(t)?[]:{};return Object.keys(t).forEach(i=>{
t[i]&&"object"==typeof t[i]?n[i]=e(t[i]):n[i]=t[i]}),n},t.deepFreeze=function(e){if(!e||"object"!=typeof e)return e;const t=[e];for(;t.length>0;){const e=t.shift();Object.freeze(e);for(const n in e)if(i.call(e,n)){const i=e[n];"object"!=typeof i||Object.isFrozen(i)||t.push(i)}}return e};const i=Object.prototype.hasOwnProperty;function r(e,t){if(e===t)return!0;if(null==e||null==t)return!1;if(typeof e!=typeof t)return!1;if("object"!=typeof e)return!1;if(Array.isArray(e)!==Array.isArray(t))return!1;let n,i;if(Array.isArray(e)){if(e.length!==t.length)return!1;for(n=0;n<e.length;n++)if(!r(e[n],t[n]))return!1}else{const s=[];for(i in e)s.push(i);s.sort();const o=[];for(i in t)o.push(i);if(o.sort(),!r(s,o))return!1;for(n=0;n<s.length;n++)if(!r(e[s[n]],t[s[n]]))return!1}return!0}t.cloneAndChange=function(e,t){return function e(t,r,s){if(n.isUndefinedOrNull(t))return t;const o=r(t);if(void 0!==o)return o;if(n.isArray(t)){const n=[];for(const i of t)n.push(e(i,r,s));return n}if(n.isObject(t)){
if(s.has(t))throw new Error("Cannot clone recursive data-structure");s.add(t);const n={};for(let o in t)i.call(t,o)&&(n[o]=e(t[o],r,s));return s.delete(t),n}return t}(e,t,new Set)},t.mixin=function e(t,i,r=!0){return n.isObject(t)?(n.isObject(i)&&Object.keys(i).forEach(s=>{s in t?r&&(n.isObject(t[s])&&n.isObject(i[s])?e(t[s],i[s],r):t[s]=i[s]):t[s]=i[s]}),t):i},t.equals=r,t.safeStringify=function(e){const t=new Set;return JSON.stringify(e,(e,i)=>{if(n.isObject(i)||Array.isArray(i)){if(t.has(i))return"[Circular]";t.add(i)}return i})},t.getOrDefault=function(e,t,n){const i=t(e);return void 0===i?n:i},t.distinct=function(e,t){const n=Object.create(null);return e&&t?(Object.keys(t).forEach(i=>{const s=e[i],o=t[i];r(s,o)||(n[i]=o)}),n):n}})),define(t[7],n([0,1,6,2]),(function(e,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,s=/^\//,o=/^\/\//;const a="",c="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{
constructor(e,t,n,i,l,u=!1){"object"==typeof e?(this.scheme=e.scheme||a,this.authority=e.authority||a,this.path=e.path||a,this.query=e.query||a,this.fragment=e.fragment||a):(this.scheme=function(e,t){return e||t?e:"file"}(e,u),this.authority=t||a,this.path=function(e,t){switch(e){case"https":case"http":case"file":t?t[0]!==c&&(t=c+t):t=c}return t}(this.scheme,n||a),this.query=i||a,this.fragment=l||a,function(e,t){if(!e.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${e.authority}", path: "${e.path}", query: "${e.query}", fragment: "${e.fragment}"}`);if(e.scheme&&!r.test(e.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(e.path)if(e.authority){if(!s.test(e.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')
}else if(o.test(e.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}(this,u))}static isUri(e){return e instanceof u||!!e&&("string"==typeof e.authority&&"string"==typeof e.fragment&&"string"==typeof e.path&&"string"==typeof e.query&&"string"==typeof e.scheme&&"function"==typeof e.fsPath&&"function"==typeof e.with&&"function"==typeof e.toString)}get fsPath(){return m(this,!1)}with(e){if(!e)return this;let{scheme:t,authority:n,path:i,query:r,fragment:s}=e;return void 0===t?t=this.scheme:null===t&&(t=a),void 0===n?n=this.authority:null===n&&(n=a),void 0===i?i=this.path:null===i&&(i=a),void 0===r?r=this.query:null===r&&(r=a),void 0===s?s=this.fragment:null===s&&(s=a),t===this.scheme&&n===this.authority&&i===this.path&&r===this.query&&s===this.fragment?this:new d(t,n,i,r,s)}static parse(e,t=!1){const n=l.exec(e);return n?new d(n[2]||a,w(n[4]||a),w(n[5]||a),w(n[7]||a),w(n[9]||a),t):new d(a,a,a,a,a)}static file(e){
let t=a;if(n.isWindows&&(e=e.replace(/\\/g,c)),e[0]===c&&e[1]===c){const n=e.indexOf(c,2);-1===n?(t=e.substring(2),e=c):(t=e.substring(2,n),e=e.substring(n)||c)}return new d("file",t,e,a,a)}static from(e){return new d(e.scheme,e.authority,e.path,e.query,e.fragment)}static joinPath(e,...t){if(!e.path)throw new Error("[UriError]: cannot call joinPaths on URI without path");let r;return r=n.isWindows&&"file"===e.scheme?u.file(i.win32.join(m(e,!0),...t)).path:i.posix.join(e.path,...t),e.with({path:r})}toString(e=!1){return v(this,e)}toJSON(){return this}static revive(e){if(e){if(e instanceof u)return e;{const t=new d(e);return t._formatted=e.external,t._fsPath=e._sep===h?e.fsPath:null,t}}return e}}t.URI=u;const h=n.isWindows?1:void 0;class d extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(e=!1){return e?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const e={
$mid:1};return this._fsPath&&(e.fsPath=this._fsPath,e._sep=h),this._formatted&&(e.external=this._formatted),this.path&&(e.path=this.path),this.scheme&&(e.scheme=this.scheme),this.authority&&(e.authority=this.authority),this.query&&(e.query=this.query),this.fragment&&(e.fragment=this.fragment),e}}const f={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function p(e,t){let n=void 0,i=-1;for(let r=0;r<e.length;r++){const s=e.charCodeAt(r);if(s>=97&&s<=122||s>=65&&s<=90||s>=48&&s<=57||45===s||46===s||95===s||126===s||t&&47===s)-1!==i&&(n+=encodeURIComponent(e.substring(i,r)),i=-1),void 0!==n&&(n+=e.charAt(r));else{void 0===n&&(n=e.substr(0,r));const t=f[s];void 0!==t?(-1!==i&&(n+=encodeURIComponent(e.substring(i,r)),i=-1),n+=t):-1===i&&(i=r)}}return-1!==i&&(n+=encodeURIComponent(e.substring(i))),void 0!==n?n:e}function g(e){let t=void 0;for(let n=0;n<e.length;n++){const i=e.charCodeAt(n)
;35===i||63===i?(void 0===t&&(t=e.substr(0,n)),t+=f[i]):void 0!==t&&(t+=e[n])}return void 0!==t?t:e}function m(e,t){let i;return i=e.authority&&e.path.length>1&&"file"===e.scheme?`//${e.authority}${e.path}`:47===e.path.charCodeAt(0)&&(e.path.charCodeAt(1)>=65&&e.path.charCodeAt(1)<=90||e.path.charCodeAt(1)>=97&&e.path.charCodeAt(1)<=122)&&58===e.path.charCodeAt(2)?t?e.path.substr(1):e.path[1].toLowerCase()+e.path.substr(2):e.path,n.isWindows&&(i=i.replace(/\//g,"\\")),i}function v(e,t){const n=t?g:p;let i="",{scheme:r,authority:s,path:o,query:a,fragment:l}=e;if(r&&(i+=r,i+=":"),(s||"file"===r)&&(i+=c,i+=c),s){let e=s.indexOf("@");if(-1!==e){const t=s.substr(0,e);s=s.substr(e+1),-1===(e=t.indexOf(":"))?i+=n(t,!1):(i+=n(t.substr(0,e),!1),i+=":",i+=n(t.substr(e+1),!1)),i+="@"}-1===(e=(s=s.toLowerCase()).indexOf(":"))?i+=n(s,!1):(i+=n(s.substr(0,e),!1),i+=s.substr(e))}if(o){if(o.length>=3&&47===o.charCodeAt(0)&&58===o.charCodeAt(2)){const e=o.charCodeAt(1)
;e>=65&&e<=90&&(o=`/${String.fromCharCode(e+32)}:${o.substr(3)}`)}else if(o.length>=2&&58===o.charCodeAt(1)){const e=o.charCodeAt(0);e>=65&&e<=90&&(o=`${String.fromCharCode(e+32)}:${o.substr(2)}`)}i+=n(o,!0)}return a&&(i+="?",i+=n(a,!1)),l&&(i+="#",i+=t?l:p(l,!1)),i}t.uriToFsPath=m;const y=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function w(e){return e.match(y)?e.replace(y,e=>(function e(t){try{return decodeURIComponent(t)}catch(n){return t.length>3?t.substr(0,3)+e(t.substr(3)):t}})(e)):e}})),define(t[92],n([0,1,7]),(function(e,t,n){"use strict";function i(e){const t=[];let n;try{const i=JSON.parse(e.arguments),r=i[i.length-1];r&&r.__$stack&&(i.pop(),n=r.__$stack),t.push(...i)}catch(n){t.push("Unable to log remote console arguments",e.arguments)}return{args:t,stack:n}}function r(e){if(!e)return e;const t=e.indexOf("\n");return-1===t?e:e.substring(0,t)}function s(e){return`color: ${e}`}Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0,
t.isRemoteConsoleLog=function(e){const t=e;return t&&"string"==typeof t.type&&"string"==typeof t.severity},t.parse=i,t.getFirstFrame=function e(t){if("string"!=typeof t)return e(i(t).stack);if(t){const e=r(t),i=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(e||"");if(i&&4===i.length)return{uri:n.URI.file(i[1]),line:Number(i[2]),column:Number(i[3])}}},t.log=function(e,t){const{args:n,stack:o}=i(e),a="string"==typeof n[0]&&1===n.length;let c=r(o);c&&(c=`(${c.trim()})`);let l=[];if(l="string"==typeof n[0]?c&&a?[`%c[${t}] %c${n[0]} %c${c}`,s("blue"),s(""),s("grey")]:[`%c[${t}] %c${n[0]}`,s("blue"),s(""),...n.slice(1)]:[`%c[${t}]%`,s("blue"),...n],c&&!a&&l.push(c),"function"!=typeof console[e.severity])throw new Error("Unknown console method");console[e.severity].apply(console,l)}})),define(t[93],n([0,1,17,11,7]),(function(e,t,n,i,r){"use strict";function s(e,t){return t instanceof RegExp?{$mid:2,source:t.source,flags:i.regExpFlags(t)}:t}function o(e,t=0){if(!e||t>200)return e
;if("object"==typeof e){switch(e.$mid){case 1:return r.URI.revive(e);case 2:return new RegExp(e.source,e.flags)}if(e instanceof n.VSBuffer||e instanceof Uint8Array)return e;if(Array.isArray(e))for(let n=0;n<e.length;++n)e[n]=o(e[n],t+1);else for(const n in e)Object.hasOwnProperty.call(e,n)&&(e[n]=o(e[n],t+1))}return e}Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0,t.stringify=function(e){return JSON.stringify(e,s)},t.parse=function(e){let t=JSON.parse(e);return t=o(t)},t.revive=o})),define(t[4],n([0,1,7,6]),(function(e,t,n,i){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.FileAccess=t.RemoteAuthorities=t.Schemas=void 0,function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",
e.vscodeRemoteResource="vscode-remote-resource",e.userData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebook="vscode-notebook",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeSettings="vscode-settings",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.vscodeWebviewResource="vscode-webview-resource",e.extension="extension"}(r=t.Schemas||(t.Schemas={}));t.RemoteAuthorities=new class{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(e){this._preferredWebSchema=e}setDelegate(e){this._delegate=e}set(e,t,n){this._hosts[e]=t,this._ports[e]=n}setConnectionToken(e,t){this._connectionTokens[e]=t}rewrite(e){if(this._delegate)return this._delegate(e);const t=e.authority;let s=this._hosts[t];s&&-1!==s.indexOf(":")&&(s=`[${s}]`);const o=this._ports[t],a=this._connectionTokens[t];let c=`path=${encodeURIComponent(e.path)}`
;return"string"==typeof a&&(c+=`&tkn=${encodeURIComponent(a)}`),n.URI.from({scheme:i.isWeb?this._preferredWebSchema:r.vscodeRemoteResource,authority:`${s}:${o}`,path:"/vscode-remote-resource",query:c})}};t.FileAccess=new class{asBrowserUri(e,n){const i=this.toUri(e,n);return i.scheme===r.vscodeRemote?t.RemoteAuthorities.rewrite(i):i}asFileUri(e,t){return this.toUri(e,t)}toUri(e,t){return n.URI.isUri(e)?e:n.URI.parse(t.toUrl(e))}}})),define(t[33],n([0,1,7,11,4,6]),(function(e,t,n,i,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCache=t.LinkedMap=t.Touch=t.ResourceMap=t.TernarySearchTree=t.UriIterator=t.PathIterator=t.StringIterator=t.setToString=t.mapToString=t.getOrSet=void 0,t.getOrSet=function(e,t,n){let i=e.get(t);return void 0===i&&(i=n,e.set(t,i)),i},t.mapToString=function(e){const t=[];return e.forEach((e,n)=>{t.push(`${n} => ${e}`)}),`Map(${e.size}) {${t.join(", ")}}`},t.setToString=function(e){const t=[];return e.forEach(e=>{t.push(e)}),`Set(${e.size}) {${t.join(", ")}}`}
;class o{constructor(){this._value="",this._pos=0}reset(e){return this._value=e,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(e){return e.charCodeAt(0)-this._value.charCodeAt(this._pos)}value(){return this._value[this._pos]}}t.StringIterator=o;class a{constructor(e=!0,t=!0){this._splitOnBackslash=e,this._caseSensitive=t}reset(e){return this._value=e.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let e=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(47===t||this._splitOnBackslash&&92===t){if(!e)break;this._from++}else e=!1}return this}cmp(e){return this._caseSensitive?i.compareSubstring(e,this._value,0,e.length,this._from,this._to):i.compareSubstringIgnoreCase(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}var c;t.PathIterator=a,function(e){e[e.Scheme=1]="Scheme",
e[e.Authority=2]="Authority",e[e.Path=3]="Path",e[e.Query=4]="Query",e[e.Fragment=5]="Fragment"}(c||(c={}));class l{constructor(){this._states=[],this._stateIdx=0}reset(e){if(this._value=e,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path){const t=e.scheme===r.Schemas.file&&s.isLinux;this._pathIterator=new a(!1,t),this._pathIterator.reset(e.path),this._pathIterator.value()&&this._states.push(3)}return this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return 3===this._states[this._stateIdx]&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return 3===this._states[this._stateIdx]&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(e){if(1===this._states[this._stateIdx])return i.compare(e,this._value.scheme);if(2===this._states[this._stateIdx])return i.compareSubstringIgnoreCase(e,this._value.authority)
;if(3===this._states[this._stateIdx])return this._pathIterator.cmp(e);if(4===this._states[this._stateIdx])return i.compare(e,this._value.query);if(5===this._states[this._stateIdx])return i.compare(e,this._value.fragment);throw new Error}value(){if(1===this._states[this._stateIdx])return this._value.scheme;if(2===this._states[this._stateIdx])return this._value.authority;if(3===this._states[this._stateIdx])return this._pathIterator.value();if(4===this._states[this._stateIdx])return this._value.query;if(5===this._states[this._stateIdx])return this._value.fragment;throw new Error}}t.UriIterator=l;class u{isEmpty(){return!(this.left||this.mid||this.right||this.value)}}class h{constructor(e){this._iter=e}static forUris(){return new h(new l)}static forPaths(){return new h(new a)}static forStrings(){return new h(new o)}clear(){this._root=void 0}set(e,t){const n=this._iter.reset(e);let i;for(this._root||(this._root=new u,this._root.segment=n.value()),i=this._root;;){const e=n.cmp(i.segment)
;if(e>0)i.left||(i.left=new u,i.left.segment=n.value()),i=i.left;else if(e<0)i.right||(i.right=new u,i.right.segment=n.value()),i=i.right;else{if(!n.hasNext())break;n.next(),i.mid||(i.mid=new u,i.mid.segment=n.value()),i=i.mid}}const r=i.value;return i.value=t,i.key=e,r}get(e){const t=this._iter.reset(e);let n=this._root;for(;n;){const e=t.cmp(n.segment);if(e>0)n=n.left;else if(e<0)n=n.right;else{if(!t.hasNext())break;t.next(),n=n.mid}}return n?n.value:void 0}delete(e){const t=this._iter.reset(e),n=[];let i=this._root;for(;i;){const e=t.cmp(i.segment);if(e>0)n.push([1,i]),i=i.left;else if(e<0)n.push([-1,i]),i=i.right;else{if(!t.hasNext()){for(i.value=void 0;n.length>0&&i.isEmpty();){let[e,t]=n.pop();switch(e){case 1:t.left=void 0;break;case 0:t.mid=void 0;break;case-1:t.right=void 0}i=t}break}t.next(),n.push([0,i]),i=i.mid}}}findSubstr(e){const t=this._iter.reset(e);let n=this._root,i=void 0;for(;n;){const e=t.cmp(n.segment);if(e>0)n=n.left;else if(e<0)n=n.right;else{if(!t.hasNext())break;t.next(),
i=n.value||i,n=n.mid}}return n&&n.value||i}findSuperstr(e){const t=this._iter.reset(e);let n=this._root;for(;n;){const e=t.cmp(n.segment);if(e>0)n=n.left;else if(e<0)n=n.right;else{if(!t.hasNext())return n.mid?this._nodeIterator(n.mid):void 0;t.next(),n=n.mid}}}_nodeIterator(e){let t,n,i;return{next:()=>(i||(i=[],n=0,this._forEach(e,e=>i.push(e))),n>=i.length?{done:!0,value:void 0}:(t?t.value=i[n++]:t={done:!1,value:i[n++]},t))}}forEach(e){this._forEach(this._root,e)}_forEach(e,t){e&&(this._forEach(e.left,t),e.value&&t(e.value,e.key),this._forEach(e.mid,t),this._forEach(e.right,t))}}t.TernarySearchTree=h;class d{constructor(e,t){this[Symbol.toStringTag]="ResourceMap",e instanceof d?(this.map=new Map(e.map),this.toKey=null!=t?t:d.defaultToKey):(this.map=new Map,this.toKey=null!=e?e:d.defaultToKey)}set(e,t){return this.map.set(this.toKey(e),t),this}get(e){return this.map.get(this.toKey(e))}has(e){return this.map.has(this.toKey(e))}get size(){return this.map.size}clear(){this.map.clear()}delete(e){
return this.map.delete(this.toKey(e))}forEach(e,t){void 0!==t&&(e=e.bind(t));for(let[t,i]of this.map)e(i,n.URI.parse(t),this)}values(){return this.map.values()}*keys(){for(let e of this.map.keys())yield n.URI.parse(e)}*entries(){for(let e of this.map.entries())yield[n.URI.parse(e[0]),e[1]]}*[Symbol.iterator](){for(let e of this.map)yield[n.URI.parse(e[0]),e[1]]}}t.ResourceMap=d,d.defaultToKey=e=>e.toString(),function(e){e[e.None=0]="None",e[e.AsOld=1]="AsOld",e[e.AsNew=2]="AsNew"}(t.Touch||(t.Touch={}));class f{constructor(){this[Symbol.toStringTag]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var e;return null===(e=this._head)||void 0===e?void 0:e.value}get last(){var e;return null===(e=this._tail)||void 0===e?void 0:e.value}has(e){return this._map.has(e)}get(e,t=0){const n=this._map.get(e)
;if(n)return 0!==t&&this.touch(n,t),n.value}set(e,t,n=0){let i=this._map.get(e);if(i)i.value=t,0!==n&&this.touch(i,n);else{switch(i={key:e,value:t,next:void 0,previous:void 0},n){case 0:this.addItemLast(i);break;case 1:this.addItemFirst(i);break;case 2:default:this.addItemLast(i)}this._map.set(e,i),this._size++}return this}delete(e){return!!this.remove(e)}remove(e){const t=this._map.get(e);if(t)return this._map.delete(e),this.removeItem(t),this._size--,t.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const e=this._head;return this._map.delete(e.key),this.removeItem(e),this._size--,e.value}forEach(e,t){const n=this._state;let i=this._head;for(;i;){if(t?e.bind(t)(i.value,i.key,this):e(i.value,i.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const e=this,t=this._state;let n=this._head;const i={[Symbol.iterator]:()=>i,next(){
if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const e={value:n.key,done:!1};return n=n.next,e}return{value:void 0,done:!0}}};return i}values(){const e=this,t=this._state;let n=this._head;const i={[Symbol.iterator]:()=>i,next(){if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const e={value:n.value,done:!1};return n=n.next,e}return{value:void 0,done:!0}}};return i}entries(){const e=this,t=this._state;let n=this._head;const i={[Symbol.iterator]:()=>i,next(){if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const e={value:[n.key,n.value],done:!1};return n=n.next,e}return{value:void 0,done:!0}}};return i}[Symbol.iterator](){return this.entries()}trimOld(e){if(e>=this.size)return;if(0===e)return void this.clear();let t=this._head,n=this.size;for(;t&&n>e;)this._map.delete(t.key),t=t.next,n--;this._head=t,this._size=n,t&&(t.previous=void 0),this._state++}addItemFirst(e){if(this._head||this._tail){
if(!this._head)throw new Error("Invalid list");e.next=this._head,this._head.previous=e}else this._tail=e;this._head=e,this._state++}addItemLast(e){if(this._head||this._tail){if(!this._tail)throw new Error("Invalid list");e.previous=this._tail,this._tail.next=e}else this._head=e;this._tail=e,this._state++}removeItem(e){if(e===this._head&&e===this._tail)this._head=void 0,this._tail=void 0;else if(e===this._head){if(!e.next)throw new Error("Invalid list");e.next.previous=void 0,this._head=e.next}else if(e===this._tail){if(!e.previous)throw new Error("Invalid list");e.previous.next=void 0,this._tail=e.previous}else{const t=e.next,n=e.previous;if(!t||!n)throw new Error("Invalid list");t.previous=n,n.next=t}e.next=void 0,e.previous=void 0,this._state++}touch(e,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(1===t||2===t)if(1===t){if(e===this._head)return;const t=e.next,n=e.previous;e===this._tail?(n.next=void 0,this._tail=n):(t.previous=n,n.next=t),e.previous=void 0,e.next=this._head,
this._head.previous=e,this._head=e,this._state++}else if(2===t){if(e===this._tail)return;const t=e.next,n=e.previous;e===this._head?(t.previous=void 0,this._head=t):(t.previous=n,n.next=t),e.next=void 0,e.previous=this._tail,this._tail.next=e,this._tail=e,this._state++}}toJSON(){const e=[];return this.forEach((t,n)=>{e.push([n,t])}),e}fromJSON(e){this.clear();for(const[t,n]of e)this.set(t,n)}}t.LinkedMap=f;t.LRUCache=class extends f{constructor(e,t=1){super(),this._limit=e,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(e){this._limit=e,this.checkTrim()}get ratio(){return this._ratio}set ratio(e){this._ratio=Math.min(Math.max(0,e),1),this.checkTrim()}get(e,t=2){return super.get(e,t)}peek(e){return super.get(e,0)}set(e,t){return super.set(e,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}})),define(t[52],n([0,1,11,30,2,33,15]),(function(e,t,n,i,r,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0,t.getEmptyExpression=function(){return Object.create(null)};const a="**",c="/",l="[/\\\\]",u="[^/\\\\]",h=/\//g;function d(e){switch(e){case 0:return"";case 1:return`${u}*?`;default:return`(?:${l}|${u}+${l}|${l}${u}+)*?`}}function f(e,t){if(!e)return[];const n=[];let i=!1,r=!1,s="";for(const o of e){switch(o){case t:if(!i&&!r){n.push(s),s="";continue}break;case"{":i=!0;break;case"}":i=!1;break;case"[":r=!0;break;case"]":r=!1}s+=o}return s&&n.push(s),n}t.splitGlobAware=f;const p=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,E=new s.LRUCache(1e4),_=function(){return!1},S=function(){return null};function b(e,t){if(!e)return S;let i
;const r=`${i=(i="string"!=typeof e?e.pattern:e).trim()}_${!!t.trimForExclusions}`;let s,o=E.get(r);if(o)return C(o,e);if(p.test(i)){const e=i.substr(4);o=function(t,n){return"string"==typeof t&&t.endsWith(e)?i:null}}else o=(s=g.exec(x(i,t)))?function(e,t){const n=`/${e}`,i=`\\${e}`,r=function(r,s){return"string"!=typeof r?null:s?s===e?t:null:r===e||r.endsWith(n)||r.endsWith(i)?t:null},s=[e];return r.basenames=s,r.patterns=[t],r.allBasenames=s,r}(s[1],i):(t.trimForExclusions?v:m).test(i)?function(e,t){const n=D(e.slice(1,-1).split(",").map(e=>b(e,t)).filter(e=>e!==S),e),i=n.length;if(!i)return S;if(1===i)return n[0];const r=function(t,i){for(let r=0,s=n.length;r<s;r++)if(n[r](t,i))return e;return null},s=n.find(e=>!!e.allBasenames);s&&(r.allBasenames=s.allBasenames);const o=n.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);o.length&&(r.allPaths=o);return r}(i,t):(s=y.exec(x(i,t)))?P(s[1].substr(1),i,!0):(s=w.exec(x(i,t)))?P(s[1],i,!1):function(e){try{const t=new RegExp(`^${function e(t){if(!t)return""
;let i="";const r=f(t,c);if(r.every(e=>e===a))i=".*";else{let t=!1;r.forEach((s,o)=>{if(s===a)return void(t||(i+=d(2),t=!0));let h=!1,p="",g=!1,m="";for(const t of s)if("}"!==t&&h)p+=t;else if(!g||"]"===t&&m)switch(t){case"{":h=!0;continue;case"[":g=!0;continue;case"}":const r=`(?:${f(p,",").map(t=>e(t)).join("|")})`;i+=r,h=!1,p="";break;case"]":i+="["+m+"]",g=!1,m="";break;case"?":i+=u;continue;case"*":i+=d(1);continue;default:i+=n.escapeRegExpCharacters(t)}else{let e;m+=e="-"===t?t:"^"!==t&&"!"!==t||m?t===c?"":n.escapeRegExpCharacters(t):"^"}o<r.length-1&&(r[o+1]!==a||o+2<r.length)&&(i+=l),t=!1})}return i}(e)}$`);return function(n){return t.lastIndex=0,"string"==typeof n&&t.test(n)?e:null}}catch(e){return S}}(i);return E.set(r,o),C(o,e)}function C(e,t){return"string"==typeof t?e:function(n,s){return i.isEqualOrParent(n,t.base)?e(r.relative(t.base,n),s):null}}function x(e,t){return t.trimForExclusions&&e.endsWith("/**")?e.substr(0,e.length-2):e}function P(e,t,n){
const i=r.sep!==r.posix.sep?e.replace(h,r.sep):e,s=r.sep+i,o=n?function(e,n){return"string"!=typeof e||e!==i&&!e.endsWith(s)?null:t}:function(e,n){return"string"==typeof e&&e===i?t:null};return o.allPaths=[(n?"*/":"./")+e],o}function I(e,t={}){if(!e)return _;if("string"==typeof e||O(e)){const n=b(e,t);if(n===S)return _;const i=function(e,t){return!!n(e,t)};return n.allBasenames&&(i.allBasenames=n.allBasenames),n.allPaths&&(i.allPaths=n.allPaths),i}return function(e,t){const n=D(Object.getOwnPropertyNames(e).map(n=>(function(e,t,n){if(!1===t)return S;const i=b(e,n);if(i===S)return S;if("boolean"==typeof t)return i;if(t){const n=t.when;if("string"==typeof n){const t=(t,r,s,a)=>{if(!a||!i(t,r))return null;const c=a(n.replace("$(basename)",s));return o.isThenable(c)?c.then(t=>t?e:null):c?e:null};return t.requiresSiblings=!0,t}}return i})(n,e[n],t)).filter(e=>e!==S)),i=n.length;if(!i)return S;if(!n.some(e=>!!e.requiresSiblings)){if(1===i)return n[0];const e=function(e,t){for(let i=0,r=n.length;i<r;i++){
const r=n[i](e,t);if(r)return r}return null},t=n.find(e=>!!e.allBasenames);t&&(e.allBasenames=t.allBasenames);const r=n.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);return r.length&&(e.allPaths=r),e}const s=function(e,t,i){let s=void 0;for(let o=0,a=n.length;o<a;o++){const a=n[o];a.requiresSiblings&&i&&(t||(t=r.basename(e)),s||(s=t.substr(0,t.length-r.extname(e).length)));const c=a(e,t,s,i);if(c)return c}return null},a=n.find(e=>!!e.allBasenames);a&&(s.allBasenames=a.allBasenames);const c=n.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);c.length&&(s.allPaths=c);return s}(e,t)}function k(e){const t={};for(const n of e)t[n]=!0;return t}function O(e){const t=e;return t&&"string"==typeof t.base&&"string"==typeof t.pattern}function D(e,t){const n=e.filter(e=>!!e.basenames);if(n.length<2)return e;const i=n.reduce((e,t)=>{const n=t.basenames;return n?e.concat(n):e},[]);let r;if(t){r=[];for(let e=0,n=i.length;e<n;e++)r.push(t)}else r=n.reduce((e,t)=>{const n=t.patterns;return n?e.concat(n):e},[])
;const s=function(e,t){if("string"!=typeof e)return null;if(!t){let n;for(n=e.length;n>0;n--){const t=e.charCodeAt(n-1);if(47===t||92===t)break}t=e.substr(n)}const n=i.indexOf(t);return-1!==n?r[n]:null};s.basenames=i,s.patterns=r,s.allBasenames=i;const o=e.filter(e=>!e.basenames);return o.push(s),o}t.match=function(e,t,n){return!(!e||"string"!=typeof t)&&I(e)(t,void 0,n)},t.parse=I,t.hasSiblingPromiseFn=function(e){if(!e)return;let t;return n=>(t||(t=(e()||Promise.resolve([])).then(e=>e?k(e):{})),t.then(e=>!!e[n]))},t.hasSiblingFn=function(e){if(!e)return;let t;return n=>{if(!t){const n=e();t=n?k(n):{}}return!!t[n]}},t.isRelativePattern=O,t.getBasenameTerms=function(e){return e.allBasenames||[]},t.getPathTerms=function(e){return e.allPaths||[]}})),define(t[66],n([0,1,33]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.removeAccents=t.normalizeNFD=t.normalizeNFC=t.canNormalize=void 0,t.canNormalize="function"==typeof String.prototype.normalize;const i=new n.LRUCache(1e4)
;t.normalizeNFC=function(e){return a(e,"NFC",i)};const r=new n.LRUCache(1e4);function s(e){return a(e,"NFD",r)}t.normalizeNFD=s;const o=/[^\u0000-\u0080]/;function a(e,n,i){if(!t.canNormalize||!e)return e;const r=i.get(e);if(r)return r;let s;return s=o.test(e)?e.normalize(n):e,i.set(e,s),s}t.removeAccents=function(){if(t.canNormalize){const e=/[\u0300-\u036f]/g;return function(t){return s(t).replace(e,"")}}return function(e){return e}}()})),define(t[22],n([0,1,30,2,7,11,4,6,52,33]),(function(e,t,n,i,r,s,o,a,c,l){"use strict";function u(e){return r.uriToFsPath(e,!0)}Object.defineProperty(t,"__esModule",{value:!0}),
t.toLocalResource=t.ResourceGlobMatcher=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0,t.originalFSPath=u;class h{constructor(e){this._ignorePathCasing=e}compare(e,t,n=!1){return e===t?0:s.compare(this.getComparisonKey(e,n),this.getComparisonKey(t,n))}isEqual(e,t,n=!1){return e===t||!(!e||!t)&&this.getComparisonKey(e,n)===this.getComparisonKey(t,n)}getComparisonKey(e,t=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}isEqualOrParent(e,i,r=!1){if(e.scheme===i.scheme){
if(e.scheme===o.Schemas.file)return n.isEqualOrParent(u(e),u(i),this._ignorePathCasing(e))&&e.query===i.query&&(r||e.fragment===i.fragment);if(t.isEqualAuthority(e.authority,i.authority))return n.isEqualOrParent(e.path,i.path,this._ignorePathCasing(e),"/")&&e.query===i.query&&(r||e.fragment===i.fragment)}return!1}joinPath(e,...t){return r.URI.joinPath(e,...t)}basenameOrAuthority(e){return t.basename(e)||e.authority}basename(e){return i.posix.basename(e.path)}extname(e){return i.posix.extname(e.path)}dirname(e){if(0===e.path.length)return e;let t;return e.scheme===o.Schemas.file?t=r.URI.file(i.dirname(u(e))).path:(t=i.posix.dirname(e.path),e.authority&&t.length&&47!==t.charCodeAt(0)&&(console.error(`dirname("${e.toString})) resulted in a relative path`),t="/")),e.with({path:t})}normalizePath(e){if(!e.path.length)return e;let t;return t=e.scheme===o.Schemas.file?r.URI.file(i.normalize(u(e))).path:i.posix.normalize(e.path),e.with({path:t})}relativePath(e,r){
if(e.scheme!==r.scheme||!t.isEqualAuthority(e.authority,r.authority))return;if(e.scheme===o.Schemas.file){const t=i.relative(u(e),u(r));return a.isWindows?n.toSlashes(t):t}let s=e.path||"/",c=r.path||"/";if(this._ignorePathCasing(e)){let e=0;for(const t=Math.min(s.length,c.length);e<t&&(s.charCodeAt(e)===c.charCodeAt(e)||s.charAt(e).toLowerCase()===c.charAt(e).toLowerCase());e++);s=c.substr(0,e)+s.substr(e)}return i.posix.relative(s,c)}resolvePath(e,t){if(e.scheme===o.Schemas.file){const n=r.URI.file(i.resolve(u(e),t));return e.with({authority:n.authority,path:n.path})}return-1===t.indexOf("/")&&(t=n.toSlashes(t),/^[a-zA-Z]:(\/|$)/.test(t)&&(t="/"+t)),e.with({path:i.posix.resolve(e.path,t)})}isAbsolutePath(e){return!!e.path&&"/"===e.path[0]}isEqualAuthority(e,t){return e===t||s.equalsIgnoreCase(e,t)}hasTrailingPathSeparator(e,t=i.sep){if(e.scheme===o.Schemas.file){const i=u(e);return i.length>n.getRoot(i).length&&i[i.length-1]===t}{const t=e.path
;return t.length>1&&47===t.charCodeAt(t.length-1)&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,n=i.sep){return t.hasTrailingPathSeparator(e,n)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,r=i.sep){let s=!1;if(e.scheme===o.Schemas.file){const t=u(e);s=void 0!==t&&t.length===n.getRoot(t).length&&t[t.length-1]===r}else{r="/";const t=e.path;s=1===t.length&&47===t.charCodeAt(t.length-1)}return s||t.hasTrailingPathSeparator(e,r)?e:e.with({path:e.path+"/"})}}t.ExtUri=h,t.extUri=new h(()=>!1),t.extUriBiasedIgnorePathCase=new h(e=>e.scheme!==o.Schemas.file||!a.isLinux),t.extUriIgnorePathCase=new h(e=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),
t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri),t.distinctParents=function(e,n){const i=[];for(let r=0;r<e.length;r++){const s=n(e[r]);e.some((e,i)=>i!==r&&t.isEqualOrParent(s,n(e)))||i.push(e[r])}return i},function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime",e.parseMetaData=function(t){const n=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(e=>{const[t,i]=e.split(":");t&&i&&n.set(t,i)})
;const i=t.path.substring(0,t.path.indexOf(";"));return i&&n.set(e.META_DATA_MIME,i),n}}(t.DataUri||(t.DataUri={}));t.ResourceGlobMatcher=class{constructor(e,t){this.expressionsByRoot=l.TernarySearchTree.forUris(),this.globalExpression=c.parse(e);for(const e of t)this.expressionsByRoot.set(e.root,{root:e.root,expression:c.parse(e.expression)})}matches(e){const n=this.expressionsByRoot.findSubstr(e);if(n){const i=t.relativePath(n.root,e);if(i&&n.expression(i))return!0}return!!this.globalExpression(e.path)}},t.toLocalResource=function(e,t,n){if(t){let r=e.path;return r&&r[0]!==i.posix.sep&&(r=i.posix.sep+r),e.with({scheme:n,authority:t,path:r})}return e.with({scheme:n})}})),define(t[67],n([0,1,7,2,11,4,6,22]),(function(e,t,n,i,r,s,o,a){"use strict";function c(e){return!(!o.isWindows||!e||":"!==e[1])}function l(e){return c(e)?e.charAt(0).toUpperCase()+e.slice(1):e}Object.defineProperty(t,"__esModule",{value:!0}),
t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0,t.getPathLabel=function(e,t,r){if("string"==typeof e&&(e=n.URI.file(e)),r){const t=r.getWorkspaceFolder(e);if(t){const n=r.getWorkspace().folders.length>1;let i;if(i=a.isEqual(t.uri,e)?"":a.relativePath(t.uri,e),n){const e=t.name?t.name:a.basename(t.uri);i=i?e+" • "+i:e}return i}}if(e.scheme!==s.Schemas.file&&e.scheme!==s.Schemas.untitled)return e.with({query:null,fragment:null}).toString(!0);if(c(e.fsPath))return i.normalize(l(e.fsPath));let u=i.normalize(e.fsPath);return!o.isWindows&&(null==t?void 0:t.userHome)&&(u=h(u,t.userHome.fsPath)),u},t.getBaseLabel=function(e){if(!e)return;"string"==typeof e&&(e=n.URI.file(e));const t=a.basename(e)||(e.scheme===s.Schemas.file?e.fsPath:e.path);return c(t)?l(t):t},t.normalizeDriveLetter=l;let u=Object.create(null);function h(e,t){if(o.isWindows||!e||!t)return e
;let n=u.original===t?u.normalized:void 0;return n||(n=`${r.rtrim(t,i.posix.sep)}${i.posix.sep}`,u={original:t,normalized:n}),(o.isLinux?e.startsWith(n):r.startsWithIgnoreCase(e,n))&&(e=`~/${e.substr(n.length)}`),e}t.tildify=h,t.untildify=function(e,t){return e.replace(/^~($|\/|\\)/,`${t}$1`)};const d="…",f="\\\\",p="~";var g;t.shorten=function(e,t=i.sep){const n=new Array(e.length);let r=!1;for(let i=0;i<e.length;i++){let s=e[i];if(""===s){n[i]=`.${t}`;continue}if(!s){n[i]=s;continue}r=!0;let o="";0===s.indexOf(f)?(o=s.substr(0,s.indexOf(f)+f.length),s=s.substr(s.indexOf(f)+f.length)):0===s.indexOf(t)?(o=s.substr(0,s.indexOf(t)+t.length),s=s.substr(s.indexOf(t)+t.length)):0===s.indexOf(p)&&(o=s.substr(0,s.indexOf(p)+p.length),s=s.substr(s.indexOf(p)+p.length));const a=s.split(t);for(let s=1;r&&s<=a.length;s++)for(let c=a.length-s;r&&c>=0;c--){r=!1;let l=a.slice(c,c+s).join(t);for(let n=0;!r&&n<e.length;n++)if(n!==i&&e[n]&&e[n].indexOf(l)>-1){
const i=c+s===a.length,o=c>0&&e[n].indexOf(t)>-1?t+l:l,u=e[n].endsWith(o);r=!i||u}if(!r){let e="";(a[0].endsWith(":")||""!==o)&&(1===c&&(c=0,s++,l=a[0]+t+l),c>0&&(e=a[0]+t),e=o+e),c>0&&(e=e+d+t),e+=l,c+s<a.length&&(e=e+t+d),n[i]=e}}r&&(n[i]=s)}return n},function(e){e[e.TEXT=0]="TEXT",e[e.VARIABLE=1]="VARIABLE",e[e.SEPARATOR=2]="SEPARATOR"}(g||(g={})),t.template=function(e,t=Object.create(null)){const n=[];let i=!1,r="";for(const s of e)if("$"===s||i&&"{"===s)r&&n.push({value:r,type:g.TEXT}),r="",i=!0;else if("}"===s&&i){const e=t[r];if("string"==typeof e)e.length&&n.push({value:e,type:g.VARIABLE});else if(e){const t=n[n.length-1];t&&t.type===g.SEPARATOR||n.push({value:e.label,type:g.SEPARATOR})}r="",i=!1}else r+=s;return r&&!i&&n.push({value:r,type:g.TEXT}),n.filter((e,t)=>{if(e.type===g.SEPARATOR){return[n[t-1],n[t+1]].every(e=>e&&(e.type===g.VARIABLE||e.type===g.TEXT)&&e.value.length>0)}return!0}).map(e=>e.value).join("")},t.mnemonicMenuLabel=function(e,t){
return o.isMacintosh||t?e.replace(/\(&&\w\)|&&/g,"").replace(/&/g,o.isMacintosh?"&":"&&"):e.replace(/&&|&/g,e=>"&"===e?"&&":"&")},t.mnemonicButtonLabel=function(e,t){return o.isMacintosh||t?e.replace(/\(&&\w\)|&&/g,""):o.isWindows?e.replace(/&&|&/g,e=>"&"===e?"&&":"&"):e.replace(/&&/g,"_")},t.unmnemonicLabel=function(e){return e.replace(/&/g,"&&")},t.splitName=function(e){const t=-1!==e.indexOf("/")?i.posix:i.win32,n=t.basename(e),r=t.dirname(e);return n.length?{name:n,parentPath:r}:{name:r,parentPath:""}}})),define(t[94],n([0,1,2,11,52,4,22]),(function(e,t,n,i,r,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionForMimeType=t.getMediaMime=t.isUnspecific=t.guessMimeTypes=t.clearTextMimes=t.registerTextMime=t.MIME_UNKNOWN=t.MIME_BINARY=t.MIME_TEXT=void 0,t.MIME_TEXT="text/plain",t.MIME_BINARY="application/octet-stream",t.MIME_UNKNOWN="application/unknown";let a=[],c=[],l=[];function u(e,t,n){let i=null,s=null,o=null;for(let a=n.length-1;a>=0;a--){const c=n[a]
;if(t===c.filenameLowercase){i=c;break}if(c.filepattern&&(!s||c.filepattern.length>s.filepattern.length)){const n=c.filepatternOnPath?e:t;r.match(c.filepatternLowercase,n)&&(s=c)}c.extension&&(!o||c.extension.length>o.extension.length)&&t.endsWith(c.extensionLowercase)&&(o=c)}return i?i.mime:s?s.mime:o?o.mime:null}t.registerTextMime=function(e,t=!1){const i=function(e){return{id:e.id,mime:e.mime,filename:e.filename,extension:e.extension,filepattern:e.filepattern,firstline:e.firstline,userConfigured:e.userConfigured,filenameLowercase:e.filename?e.filename.toLowerCase():void 0,extensionLowercase:e.extension?e.extension.toLowerCase():void 0,filepatternLowercase:e.filepattern?e.filepattern.toLowerCase():void 0,filepatternOnPath:!!e.filepattern&&e.filepattern.indexOf(n.posix.sep)>=0}}(e);a.push(i),i.userConfigured?l.push(i):c.push(i),t&&!i.userConfigured&&a.forEach(e=>{
e.mime===i.mime||e.userConfigured||(i.extension&&e.extension===i.extension&&console.warn(`Overwriting extension <<${i.extension}>> to now point to mime <<${i.mime}>>`),i.filename&&e.filename===i.filename&&console.warn(`Overwriting filename <<${i.filename}>> to now point to mime <<${i.mime}>>`),i.filepattern&&e.filepattern===i.filepattern&&console.warn(`Overwriting filepattern <<${i.filepattern}>> to now point to mime <<${i.mime}>>`),i.firstline&&e.firstline===i.firstline&&console.warn(`Overwriting firstline <<${i.firstline}>> to now point to mime <<${i.mime}>>`))})},t.clearTextMimes=function(e){e?(a=a.filter(e=>!e.userConfigured),l=[]):(a=[],c=[],l=[])},t.guessMimeTypes=function(e,r){let h;if(e)switch(e.scheme){case s.Schemas.file:h=e.fsPath;break;case s.Schemas.data:h=o.DataUri.parseMetaData(e).get(o.DataUri.META_DATA_LABEL);break;default:h=e.path}if(!h)return[t.MIME_UNKNOWN];h=h.toLowerCase();const d=n.basename(h),f=u(h,d,l);if(f)return[f,t.MIME_TEXT];const p=u(h,d,c);if(p)return[p,t.MIME_TEXT];if(r){
const e=function(e){i.startsWithUTF8BOM(e)&&(e=e.substr(1));if(e.length>0)for(let t=a.length-1;t>=0;t--){const n=a[t];if(!n.firstline)continue;const i=e.match(n.firstline);if(i&&i.length>0)return n.mime}return null}(r);if(e)return[e,t.MIME_TEXT]}return[t.MIME_UNKNOWN]},t.isUnspecific=function e(n){return!n||("string"==typeof n?n===t.MIME_BINARY||n===t.MIME_TEXT||n===t.MIME_UNKNOWN:1===n.length&&e(n[0]))};const h={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",
".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};t.getMediaMime=function(e){const t=n.extname(e);return h[t.toLowerCase()]},t.getExtensionForMimeType=function(e){for(const t in h)if(h[t]===e)return t}})),define(t[53],n([0,1,7]),(function(e,t,n){"use strict";function i(e){return e.toJSON()}Object.defineProperty(t,"__esModule",{value:!0}),t.transformAndReviveIncomingURIs=t.transformIncomingURIs=t.transformOutgoingURIs=t.DefaultURITransformer=t.URITransformer=void 0;function r(e,t,i,s){if(!e||s>200)return null;if("object"==typeof e){if(1===e.$mid)return i?n.URI.revive(t.transformIncoming(e)):t.transformIncoming(e)
;for(let n in e)if(Object.hasOwnProperty.call(e,n)){const o=r(e[n],t,i,s+1);null!==o&&(e[n]=o)}}return null}t.URITransformer=class{constructor(e){this._uriTransformer=e}transformIncoming(e){const t=this._uriTransformer.transformIncoming(e);return t===e?e:i(n.URI.from(t))}transformOutgoing(e){const t=this._uriTransformer.transformOutgoing(e);return t===e?e:i(n.URI.from(t))}transformOutgoingURI(e){const t=this._uriTransformer.transformOutgoing(e);return t===e?e:n.URI.from(t)}transformOutgoingScheme(e){return this._uriTransformer.transformOutgoingScheme(e)}},t.DefaultURITransformer=new class{transformIncoming(e){return e}transformOutgoing(e){return e}transformOutgoingURI(e){return e}transformOutgoingScheme(e){return e}},t.transformOutgoingURIs=function(e,t){const i=function e(t,i,r){if(!t||r>200)return null;if("object"==typeof t){if(t instanceof n.URI)return i.transformOutgoing(t);for(let n in t)if(Object.hasOwnProperty.call(t,n)){const s=e(t[n],i,r+1);null!==s&&(t[n]=s)}}return null}(e,t,0);return null===i?e:i
},t.transformIncomingURIs=function(e,t){const n=r(e,t,!1,0);return null===n?e:n},t.transformAndReviveIncomingURIs=function(e,t){const n=r(e,t,!0,0);return null===n?e:n}})),define(t[20],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=t.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;t.isUUID=function(e){return n.test(e)};const i=new Uint8Array(16),r=[];for(let e=0;e<256;e++)r.push(e.toString(16).padStart(2,"0"));const s=function(e){for(let t=0;t<e.length;t++)e[t]=Math.floor(256*Math.random());return e};t.generateUuid=function(){s(i),i[6]=15&i[6]|64,i[8]=63&i[8]|128;let e=0,t="";return t+=r[i[e++]],t+=r[i[e++]],t+=r[i[e++]],t+=r[i[e++]],t+="-",t+=r[i[e++]],t+=r[i[e++]],t+="-",t+=r[i[e++]],t+=r[i[e++]],t+="-",t+=r[i[e++]],t+=r[i[e++]],t+="-",t+=r[i[e++]],t+=r[i[e++]],t+=r[i[e++]],t+=r[i[e++]],t+=r[i[e++]],t+=r[i[e++]]}})),define(t[68],n([0,1,168]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{
value:!0}),t.LineDecoder=void 0;t.LineDecoder=class{constructor(e="utf8"){this.stringDecoder=new n.StringDecoder(e),this.remaining=null}write(e){const t=[],n=this.remaining?this.remaining+this.stringDecoder.write(e):this.stringDecoder.write(e);if(n.length<1)return t;let i,r=0,s=r;for(;s<n.length;)if(13===(i=n.charCodeAt(s))||10===i){if(t.push(n.substring(r,s)),++s<n.length){const e=i;i=n.charCodeAt(s),(13===e&&10===i||10===e&&13===i)&&s++}r=s}else s++;return this.remaining=r<n.length?n.substr(r):null,t}end(){return this.remaining}}})),"function"==typeof define)define(t[95],n([169,18,170]),(function(e,t,n){return r(require.__$__nodeRequire,e,t,n)}));else{if("object"!=typeof module||"object"!=typeof module.exports)throw new Error("Unknown context");{const e=require("path"),t=require("fs"),n=require("../common/performance");module.exports=r(require,e,t,n)}}define(t[96],n([0,1,27]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMac=void 0
;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(e){const t=e.replace(/\-/g,":").toLowerCase();return!i.has(t)}t.getMac=function(){return new Promise(async(e,t)=>{const i=setTimeout(()=>t("Unable to retrieve mac address (timeout after 10s)"),1e4);try{e(await new Promise((e,t)=>{try{const i=n.networkInterfaces();for(const[,t]of Object.entries(i))for(const n of t)if(r(n.mac))return e(n.mac);t("Unable to retrieve mac address (unexpected format)")}catch(e){t(e)}}))}catch(e){t(e)}finally{clearTimeout(i)}})}})),define(t[69],n([0,1,16,20,27,33,96]),(function(e,t,n,i,r,s,o){"use strict";let a;Object.defineProperty(t,"__esModule",{value:!0}),t.getMachineId=t.virtualMachineHint=void 0,t.virtualMachineHint=new class{_isVirtualMachineMacAdress(e){return this._virtualMachineOUIs||(this._virtualMachineOUIs=s.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),
this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(e)}value(){if(void 0===this._value){let e=0,t=0;const n=r.networkInterfaces();for(let i in n)if(Object.prototype.hasOwnProperty.call(n,i))for(const{mac:r,internal:s}of n[i])s||(t+=1,this._isVirtualMachineMacAdress(r.toUpperCase())&&(e+=1));this._value=t>0?e/t:0}return this._value}},t.getMachineId=async function(){return a||(a=(async()=>{return await async function(){try{const t=await new Promise((t,n)=>{e(["crypto"],t,n)}),n=await o.getMac()
;return t.createHash("sha256").update(n,"utf8").digest("hex")}catch(e){return void n.onUnexpectedError(e)}}()||i.generateUuid()})()),a}})),define(t[97],n([0,1,4]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getDefaultUserDataPath=t.getAppDataPath=void 0;const i=n.FileAccess.asFileUri("paths",e).fsPath,r=e.__$__nodeRequire(i);t.getAppDataPath=r.getAppDataPath,t.getDefaultUserDataPath=r.getDefaultUserDataPath})),define(t[14],n([0,1,2,15,18,27,6,5,42,30,20,66]),(function(e,t,n,i,r,s,o,a,c,l,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.copy=t.move=t.whenDeleted=t.fileExists=t.dirExists=t.readDirsInDir=t.writeFileSync=t.writeFile=t.mkdirp=t.readFile=t.truncate=t.symlink=t.unlink=t.renameIgnoreError=t.rename=t.lstat=t.statLink=t.stat=t.chmod=t.exists=t.readdirSync=t.readdirWithFileTypes=t.readdir=t.rimrafSync=t.rimraf=t.RimRafMode=t.MAX_HEAP_SIZE=t.MAX_FILE_SIZE=void 0;var d;async function f(e,t=d.UNLINK){
if(l.isRootOrDriveLetter(e))throw new Error("rimraf - will refuse to recursively delete root");return t===d.UNLINK?p(e):async function(e){try{const t=n.join(s.tmpdir(),u.generateUuid());try{await _(e,t)}catch(t){return p(e)}p(t)}catch(e){if("ENOENT"!==e.code)throw e}}(e)}async function p(e){try{const t=await E(e);if(!t.isDirectory()||t.isSymbolicLink()){const n=t.mode;return 128&n||await y(e,128|n),S(e)}{const t=await g(e);await Promise.all(t.map(t=>p(n.join(e,t)))),await c.promisify(r.rmdir)(e)}}catch(e){if("ENOENT"!==e.code)throw e}}async function g(e){return v(await c.promisify(r.readdir)(e))}function m(e){return v(r.readdirSync(e))}function v(e){return o.isMacintosh?e.map(e=>h.normalizeNFC(e)):e}function y(e,t){return c.promisify(r.chmod)(e,t)}function w(e){return c.promisify(r.stat)(e)}function E(e){return c.promisify(r.lstat)(e)}function _(e,t){return c.promisify(r.rename)(e,t)}function S(e){return c.promisify(r.unlink)(e)}async function b(e,t){return c.promisify(r.mkdir)(e,{mode:t,recursive:!0})}
t.MAX_FILE_SIZE="ia32"===process.arch?314572800:17179869184,t.MAX_HEAP_SIZE="ia32"===process.arch?734003200:1468006400,function(e){e[e.UNLINK=0]="UNLINK",e[e.MOVE=1]="MOVE"}(d=t.RimRafMode||(t.RimRafMode={})),t.rimraf=f,t.rimrafSync=function e(t){if(l.isRootOrDriveLetter(t))throw new Error("rimraf - will refuse to recursively delete root");try{const i=r.lstatSync(t);if(!i.isDirectory()||i.isSymbolicLink()){const e=i.mode;return 128&e||r.chmodSync(t,128|e),r.unlinkSync(t)}m(t).map(i=>e(n.join(t,i))),r.rmdirSync(t)}catch(e){if("ENOENT"!==e.code)throw e}},t.readdir=g,t.readdirWithFileTypes=async function(e){const t=await c.promisify(r.readdir)(e,{withFileTypes:!0});if(o.isMacintosh)for(const e of t)e.name=h.normalizeNFC(e.name);return t},t.readdirSync=m,t.exists=function(e){return c.promisify(r.exists)(e)},t.chmod=y,t.stat=w,t.statLink=async function(e){let t;try{if(!(t=await E(e)).isSymbolicLink())return{stat:t}}catch(e){}try{return{stat:await w(e),symbolicLink:(null==t?void 0:t.isSymbolicLink())?{dangling:!1
}:void 0}}catch(e){if("ENOENT"===e.code&&t)return{stat:t,symbolicLink:{dangling:!0}};throw e}},t.lstat=E,t.rename=_,t.renameIgnoreError=function(e,t){return new Promise(n=>r.rename(e,t,()=>n()))},t.unlink=S,t.symlink=function(e,t,n){return c.promisify(r.symlink)(e,t,n)},t.truncate=function(e,t){return c.promisify(r.truncate)(e,t)},t.readFile=function(e,t){return c.promisify(r.readFile)(e,t)},t.mkdirp=b;const C=new Map;t.writeFile=function(e,t,n){return function(e){const t=C.get(e);if(t)return t;const n=new i.Queue;return C.set(e,n),a.Event.once(n.onFinished)(()=>{C.delete(e),n.dispose()}),n}(function(e){let t=e;(o.isWindows||o.isMacintosh)&&(t=t.toLowerCase());return t}(e)).queue(()=>{const i=P(n);return new Promise((n,s)=>(function(e,t,n,i){if(!x)return r.writeFile(e,t,{mode:n.mode,flag:n.flag},i);r.open(e,n.flag,n.mode,(e,n)=>{if(e)return i(e);r.writeFile(n,t,e=>{if(e)return r.close(n,()=>i(e))
;r.fdatasync(n,e=>(e&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",e),x=!1),r.close(n,e=>i(e))))})})})(e,t,i,e=>e?s(e):n()))})};let x=!0;function P(e){return e?{mode:"number"==typeof e.mode?e.mode:438,flag:"string"==typeof e.flag?e.flag:"w"}:{mode:438,flag:"w"}}async function I(e){try{return(await w(e)).isDirectory()}catch(e){return!1}}async function k(e,t,i){const s=i||Object.create(null),o=await w(e);if(!o.isDirectory())return async function(e,t,n){return new Promise((i,s)=>{const o=r.createReadStream(e),a=r.createWriteStream(t,{mode:n});let c=!1;const l=e=>{if(!c){if(c=!0,e)return s(e);r.chmod(t,n,e=>e?s(e):i())}};o.once("error",e=>l(e)),a.once("error",e=>l(e)),a.once("close",()=>l()),o.pipe(a)})}(e,t,511&o.mode);if(s[e])return Promise.resolve();s[e]=!0,await b(t,511&o.mode);const a=await g(e);for(let i=0;i<a.length;i++){const r=a[i];await k(n.join(e,r),n.join(t,r),s)}}t.writeFileSync=function(e,t,n){const i=P(n);if(!x)return r.writeFileSync(e,t,{mode:i.mode,
flag:i.flag});const s=r.openSync(e,i.flag,i.mode);try{r.writeFileSync(s,t);try{r.fdatasyncSync(s)}catch(e){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",e),x=!1}}finally{r.closeSync(s)}},t.readDirsInDir=async function(e){const t=await g(e),i=[];for(const r of t)await I(n.join(e,r))&&i.push(r);return i},t.dirExists=I,t.fileExists=async function(e){try{return(await w(e)).isFile()}catch(e){return!1}},t.whenDeleted=function(e){return new Promise(t=>{let n=!1;const i=setInterval(()=>{n||(n=!0,r.exists(e,e=>{n=!1,e||(clearInterval(i),t(void 0))}))},1e3)})},t.move=async function(e,t){if(e===t)return Promise.resolve();async function n(e){const t=await E(e);if(t.isDirectory()||t.isSymbolicLink())return Promise.resolve();const n=await c.promisify(r.open)(e,"a");try{await c.promisify(r.futimes)(n,t.atime,new Date)}catch(e){}return c.promisify(r.close)(n)}try{await _(e,t),await n(t)}catch(i){if(!(e.toLowerCase()!==t.toLowerCase()&&"EXDEV"===i.code||e.endsWith(".")))throw i
;await k(e,t),await f(e,d.MOVE),await n(t)}},t.copy=k})),define(t[98],n([0,1,18,11,2,14,42]),(function(e,t,n,i,r,s,o){"use strict";function a(e){return i.rtrim(r.normalize(e),r.sep)}Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0,t.realcaseSync=function e(t){const n=r.dirname(t);if(t===n)return t;const i=(r.basename(t)||t).toLowerCase();try{const t=s.readdirSync(n).filter(e=>e.toLowerCase()===i);if(1===t.length){const i=e(n);if(i)return r.join(i,t[0])}else if(t.length>1){const s=t.indexOf(i);if(s>=0){const i=e(n);if(i)return r.join(i,t[s])}}}catch(e){}return null},t.realpath=async function(e){try{return await o.promisify(n.realpath)(e)}catch(t){const i=a(e);return await o.promisify(n.access)(i,n.constants.R_OK),i}},t.realpathSync=function(e){try{return n.realpathSync(e)}catch(t){const i=a(e);return n.accessSync(i,n.constants.R_OK),i}}})),define(t[99],n([0,1,70]),(function(e,t,n){"use strict";function i(e){try{e.removeAllListeners("connect"),
e.removeAllListeners("error"),e.end(),e.destroy(),e.unref()}catch(e){console.error(e)}}Object.defineProperty(t,"__esModule",{value:!0}),t.findFreePortFaster=t.findFreePort=t.randomPort=void 0,t.randomPort=function(){return 1025+Math.floor(64510*Math.random())},t.findFreePort=function(e,t,r){let s=!1;return new Promise(o=>{const a=setTimeout(()=>{if(!s)return s=!0,o(0)},r);!function e(t,r,s){if(0===r)return s(0);const o=new n.Socket;o.once("connect",()=>(i(o),e(t+1,r-1,s)));o.once("data",()=>{});o.once("error",n=>(i(o),"ECONNREFUSED"!==n.code?e(t+1,r-1,s):s(t)));o.connect(t,"127.0.0.1")}(e,t,e=>{if(!s)return s=!0,clearTimeout(a),o(e)})})},t.findFreePortFaster=function(e,t,i){let r=!1,s=void 0,o=1;const a=n.createServer({pauseOnConnect:!0});function c(e,t){r||(r=!0,a.removeAllListeners(),a.close(),s&&clearTimeout(s),t(e))}return new Promise(n=>{s=setTimeout(()=>{c(0,n)},i),a.on("listening",()=>{c(e,n)}),a.on("error",i=>{i&&("EADDRINUSE"===i.code||"EACCES"===i.code)&&o<t?(e++,o++,a.listen(e,"127.0.0.1")):c(0,n)
}),a.on("close",()=>{c(0,n)}),a.listen(e,"127.0.0.1")})}})),define(t[71],n([0,1,34,4]),(function(e,t,n,i){"use strict";function r(e,t){const n=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,i=e.toString().split("\n");for(const e of i){const i=n.exec(e.trim());i&&6===i.length&&t(parseInt(i[1]),parseInt(i[2]),i[5],parseFloat(i[3]),parseFloat(i[4]))}}Object.defineProperty(t,"__esModule",{value:!0}),t.listProcesses=void 0,t.listProcesses=function(t){return new Promise((s,o)=>{let a;const c=new Map;function l(e,n,i,r,s){const o=c.get(n);if(e===t||o){const l={name:u(i),cmd:i,pid:e,ppid:n,load:r,mem:s};c.set(e,l),e===t&&(a=l),o&&(o.children||(o.children=[]),o.children.push(l),o.children.length>1&&(o.children=o.children.sort((e,t)=>e.pid-t.pid)))}}function u(e){const t=/--disable-blink-features=Auxclick/;if(/\\watcher\\win32\\CodeHelper\.exe/.exec(e))return"watcherService ";if(/--crashes-directory/.exec(e))return"electron-crash-reporter"
;if(/\\pipe\\winpty-control/.exec(e))return"winpty-process";if(/conhost\.exe/.exec(e))return"console-window-host (Windows internal process)";let n=/--type=([a-zA-Z-]+)/.exec(e);if(n&&2===n.length)return"renderer"===n[1]?t.exec(e)?"shared-process":"window":n[1];const i=/[a-zA-Z-]+\.js/g;let r="";do{(n=i.exec(e))&&(r+=n+" ")}while(n);return r&&e.indexOf("node ")<0&&e.indexOf("node.exe")<0?`electron_node ${r}`:e}if("win32"===process.platform){const n=e=>0===e.indexOf("\\\\?\\")?e.substr(4):0===e.indexOf("\\??\\")?e.substr(4):0===e.indexOf('"\\\\?\\')?'"'+e.substr(5):0===e.indexOf('"\\??\\')?'"'+e.substr(5):e;new Promise((t,n)=>{e(["windows-process-tree"],t,n)}).then(e=>{e.getProcessList(t,i=>{e.getProcessCpuUsage(i,e=>{const i=new Map;e.forEach(e=>{const t=n(e.commandLine||"");i.set(e.pid,{name:u(t),cmd:t,pid:e.pid,ppid:e.ppid,load:e.cpu||0,mem:e.memory||0})}),(a=i.get(t))?(i.forEach(e=>{const t=i.get(e.ppid);t&&(t.children||(t.children=[]),t.children.push(e))}),i.forEach(e=>{
e.children&&(e.children=e.children.sort((e,t)=>e.pid-t.pid))}),s(a)):o(new Error(`Root process ${t} not found`))})},e.ProcessDataFlag.CommandLine|e.ProcessDataFlag.Memory)})}else{function h(){let r=[a];const l=[];for(;r.length;){const e=r.shift();e&&(l.push(e.pid),e.children&&(r=r.concat(e.children)))}let u=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",e).fsPath);u+=" "+l.join(" "),n.exec(u,{},(e,n,i)=>{if(e||i)o(e||new Error(i.toString()));else{const e=n.toString().split("\n");for(let t=0;t<l.length;t++){c.get(l[t]).load=parseFloat(e[t])}if(!a)return void o(new Error(`Root process ${t} not found`));s(a)}})}n.exec("which ps",{},(c,u,d)=>{if(c||d)if("linux"!==process.platform)o(c||new Error(d.toString()));else{const t=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/ps.sh",e).fsPath);n.exec(t,{},(e,t,n)=>{e||n?o(e||new Error(n.toString())):(r(t,l),h())})}else{const e=u.toString().trim(),i="-ax -o pid=,ppid=,pcpu=,pmem=,command=";n.exec(`${e} ${i}`,{maxBuffer:1024e3,env:{
LC_NUMERIC:"en_US.UTF-8"}},(e,n,i)=>{e||i&&!i.includes("screen size is bogus")?o(e||new Error(i.toString())):(r(n,l),"linux"===process.platform?h():a?s(a):o(new Error(`Root process ${t} not found`)))})}})}})}})),define(t[100],n([0,1,2,18,6,66,3,14]),(function(e,t,n,i,r,s,o,a){"use strict";function c(e,l,u){const h=n.basename(e.path),d=new Map;let f=!1,p=[o.toDisposable(()=>{d.forEach(e=>o.dispose(e)),d.clear()})];try{const g=i.watch(e.path);p.push(o.toDisposable(()=>{g.removeAllListeners(),g.close()}));const m=new Set;e.isDirectory&&a.readdir(e.path).then(e=>e.forEach(e=>m.add(e))),g.on("error",(t,n)=>{f||u(`Failed to watch ${e.path} for changes using fs.watch() (${t}, ${n})`)}),g.on("change",(i,g)=>{if(f)return;let v="";if(g&&(v=g.toString(),r.isMacintosh&&(v=s.normalizeNFC(v))),!v||"change"!==i&&"rename"!==i)return;const y=e.isDirectory?n.join(e.path,v):e.path;if(e.isDirectory)if("rename"===i){const e=d.get(y);e&&o.dispose(e);const n=setTimeout(async()=>{d.delete(y);const e=await a.exists(y);if(f)return
;let t;e?m.has(v)?t="changed":(t="added",m.add(v)):(m.delete(v),t="deleted"),l(t,y)},t.CHANGE_BUFFER_DELAY);d.set(y,o.toDisposable(()=>clearTimeout(n)))}else{let e;m.has(v)?e="changed":(e="added",m.add(v)),l(e,y)}else if("rename"===i||v!==h){const n=setTimeout(async()=>{const t=await a.exists(y);f||(t?(l("changed",y),p=[c(e,l,u)]):l("deleted",y))},t.CHANGE_BUFFER_DELAY);o.dispose(p),p=[o.toDisposable(()=>clearTimeout(n))]}else l("changed",y)})}catch(t){a.exists(e.path).then(n=>{n&&!f&&u(`Failed to watch ${e.path} for changes using fs.watch() (${t.toString()})`)})}return o.toDisposable(()=>{f=!0,p=o.dispose(p)})}Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0,t.watchFile=function(e,t,n){return c({path:e,isDirectory:!1},t,n)},t.watchFolder=function(e,t,n){return c({path:e,isDirectory:!0},t,n)},t.CHANGE_BUFFER_DELAY=100})),define(t[35],n([0,1,5,3,15,24,16,17,21,12,93,11]),(function(e,t,n,i,r,s,o,a,c,l,u,h){"use strict";var d,f;function p(e){switch(e){
case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}function g(e){switch(e){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.createChannelSender=t.createChannelReceiver=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0,function(e){e[e.Promise=100]="Promise",e[e.PromiseCancel=101]="PromiseCancel",e[e.EventListen=102]="EventListen",e[e.EventDispose=103]="EventDispose"}(t.RequestType||(t.RequestType={})),function(e){e[e.Initialize=200]="Initialize",e[e.PromiseSuccess=201]="PromiseSuccess",e[e.PromiseError=202]="PromiseError",e[e.PromiseErrorObj=203]="PromiseErrorObj",e[e.EventFire=204]="EventFire"}(t.ResponseType||(t.ResponseType={})),function(e){e[e.Uninitialized=0]="Uninitialized",e[e.Idle=1]="Idle"}(d||(d={}))
;class m{constructor(e){this.buffer=e,this.pos=0}read(e){const t=this.buffer.slice(this.pos,this.pos+e);return this.pos+=t.byteLength,t}}class v{constructor(){this.buffers=[]}get buffer(){return a.VSBuffer.concat(this.buffers)}write(e){this.buffers.push(e)}}function y(e){const t=a.VSBuffer.alloc(4);return t.writeUInt32BE(e,0),t}function w(e){return e.read(4).readUInt32BE(0)}function E(e){const t=a.VSBuffer.alloc(1);return t.writeUInt8(e,0),t}!function(e){e[e.Undefined=0]="Undefined",e[e.String=1]="String",e[e.Buffer=2]="Buffer",e[e.VSBuffer=3]="VSBuffer",e[e.Array=4]="Array",e[e.Object=5]="Object"}(f||(f={}));const _={Undefined:E(f.Undefined),String:E(f.String),Buffer:E(f.Buffer),VSBuffer:E(f.VSBuffer),Array:E(f.Array),Object:E(f.Object)},S="undefined"!=typeof Buffer;function b(e,t){if(void 0===t)e.write(_.Undefined);else if("string"==typeof t){const n=a.VSBuffer.fromString(t);e.write(_.String),e.write(y(n.byteLength)),e.write(n)}else if(S&&Buffer.isBuffer(t)){const n=a.VSBuffer.wrap(t);e.write(_.Buffer),
e.write(y(n.byteLength)),e.write(n)}else if(t instanceof a.VSBuffer)e.write(_.VSBuffer),e.write(y(t.byteLength)),e.write(t);else if(Array.isArray(t)){e.write(_.Array),e.write(y(t.length));for(const n of t)b(e,n)}else{const n=a.VSBuffer.fromString(JSON.stringify(t));e.write(_.Object),e.write(y(n.byteLength)),e.write(n)}}function C(e){switch(e.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return e.read(w(e)).toString();case f.Buffer:return e.read(w(e)).buffer;case f.VSBuffer:return e.read(w(e));case f.Array:{const t=w(e),n=[];for(let i=0;i<t;i++)n.push(C(e));return n}case f.Object:return JSON.parse(e.read(w(e)).toString())}}class x{constructor(e,t,n=null,i=1e3){this.protocol=e,this.ctx=t,this.logger=n,this.timeoutDelay=i,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(e=>this.onRawMessage(e)),this.sendResponse({type:200})}registerChannel(e,t){this.channels.set(e,t),setTimeout(()=>this.flushPendingRequests(e),0)}
sendResponse(e){switch(e.type){case 200:{const t=this.send([e.type]);return void(this.logger&&this.logger.logOutgoing(t,0,1,g(e.type)))}case 201:case 202:case 204:case 203:{const t=this.send([e.type,e.id],e.data);return void(this.logger&&this.logger.logOutgoing(t,e.id,1,g(e.type),e.data))}}}send(e,t){const n=new v;return b(n,e),b(n,t),this.sendBuffer(n.buffer)}sendBuffer(e){try{return this.protocol.send(e),e.byteLength}catch(e){return 0}}onRawMessage(e){const t=new m(e),n=C(t),i=C(t),r=n[0];switch(r){case 100:return this.logger&&this.logger.logIncoming(e.byteLength,n[1],1,`${p(r)}: ${n[2]}.${n[3]}`,i),this.onPromise({type:r,id:n[1],channelName:n[2],name:n[3],arg:i});case 102:return this.logger&&this.logger.logIncoming(e.byteLength,n[1],1,`${p(r)}: ${n[2]}.${n[3]}`,i),this.onEventListen({type:r,id:n[1],channelName:n[2],name:n[3],arg:i});case 101:case 103:return this.logger&&this.logger.logIncoming(e.byteLength,n[1],1,`${p(r)}`),this.disposeActiveRequest({type:r,id:n[1]})}}onPromise(e){
const t=this.channels.get(e.channelName);if(!t)return void this.collectPendingRequest(e);const n=new s.CancellationTokenSource;let r;try{r=t.call(this.ctx,e.name,e.arg,n.token)}catch(e){r=Promise.reject(e)}const o=e.id;r.then(t=>{this.sendResponse({id:o,data:t,type:201}),this.activeRequests.delete(e.id)},t=>{t instanceof Error?this.sendResponse({id:o,data:{message:t.message,name:t.name,stack:t.stack?t.stack.split?t.stack.split("\n"):t.stack:void 0},type:202}):this.sendResponse({id:o,data:t,type:203}),this.activeRequests.delete(e.id)});const a=i.toDisposable(()=>n.cancel());this.activeRequests.set(e.id,a)}onEventListen(e){const t=this.channels.get(e.channelName);if(!t)return void this.collectPendingRequest(e);const n=e.id,i=t.listen(this.ctx,e.name,e.arg)(e=>this.sendResponse({id:n,data:e,type:204}));this.activeRequests.set(e.id,i)}disposeActiveRequest(e){const t=this.activeRequests.get(e.id);t&&(t.dispose(),this.activeRequests.delete(e.id))}collectPendingRequest(e){
let t=this.pendingRequests.get(e.channelName);t||(t=[],this.pendingRequests.set(e.channelName,t));const n=setTimeout(()=>{console.error(`Unknown channel: ${e.channelName}`),100===e.type&&this.sendResponse({id:e.id,data:{name:"Unknown channel",message:`Channel name '${e.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);t.push({request:e,timeoutTimer:n})}flushPendingRequests(e){const t=this.pendingRequests.get(e);if(t){for(const e of t)switch(clearTimeout(e.timeoutTimer),e.request.type){case 100:this.onPromise(e.request);break;case 102:this.onEventListen(e.request)}this.pendingRequests.delete(e)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(e=>e.dispose()),this.activeRequests.clear()}}t.ChannelServer=x,function(e){e[e.LocalSide=0]="LocalSide",e[e.OtherSide=1]="OtherSide"}(t.RequestInitiator||(t.RequestInitiator={}));class P{constructor(e,t=null){this.protocol=e,
this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new n.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(e=>this.onBuffer(e)),this.logger=t}getChannel(e){const t=this;return{call:(n,i,r)=>t.requestPromise(e,n,i,r),listen:(n,i)=>t.requestEvent(e,n,i)}}requestPromise(e,t,n,a=s.CancellationToken.None){const c=this.lastRequestId++,l={id:c,type:100,channelName:e,name:t,arg:n};if(a.isCancellationRequested)return Promise.reject(o.canceled());let u;return new Promise((e,t)=>{if(a.isCancellationRequested)return t(o.canceled());const n=()=>{this.handlers.set(c,n=>{switch(n.type){case 201:this.handlers.delete(c),e(n.data);break;case 202:this.handlers.delete(c);const i=new Error(n.data.message);i.stack=n.data.stack,i.name=n.data.name,t(i);break;case 203:this.handlers.delete(c),t(n.data)}}),this.sendRequest(l)};let s=null
;this.state===d.Idle?n():(s=r.createCancelablePromise(e=>this.whenInitialized())).then(()=>{s=null,n()});const h=()=>{s?(s.cancel(),s=null):this.sendRequest({id:c,type:101}),t(o.canceled())},f=a.onCancellationRequested(h);u=i.combinedDisposable(i.toDisposable(h),f),this.activeRequests.add(u)}).finally(()=>{this.activeRequests.delete(u)})}requestEvent(e,t,i){const s=this.lastRequestId++,o={id:s,type:102,channelName:e,name:t,arg:i};let a=null;const c=new n.Emitter({onFirstListenerAdd:()=>{(a=r.createCancelablePromise(e=>this.whenInitialized())).then(()=>{a=null,this.activeRequests.add(c),this.sendRequest(o)})},onLastListenerRemove:()=>{a?(a.cancel(),a=null):(this.activeRequests.delete(c),this.sendRequest({id:s,type:103}))}});return this.handlers.set(s,e=>c.fire(e.data)),c.event}sendRequest(e){switch(e.type){case 100:case 102:{const t=this.send([e.type,e.id,e.channelName,e.name],e.arg);return void(this.logger&&this.logger.logOutgoing(t,e.id,0,`${p(e.type)}: ${e.channelName}.${e.name}`,e.arg))}case 101:case 103:{
const t=this.send([e.type,e.id]);return void(this.logger&&this.logger.logOutgoing(t,e.id,0,p(e.type)))}}}send(e,t){const n=new v;return b(n,e),b(n,t),this.sendBuffer(n.buffer)}sendBuffer(e){try{return this.protocol.send(e),e.byteLength}catch(e){return 0}}onBuffer(e){const t=new m(e),n=C(t),i=C(t),r=n[0];switch(r){case 200:return this.logger&&this.logger.logIncoming(e.byteLength,0,0,g(r)),this.onResponse({type:n[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(e.byteLength,n[1],0,g(r),i),this.onResponse({type:n[0],id:n[1],data:i})}}onResponse(e){if(200===e.type)return this.state=d.Idle,void this._onDidInitialize.fire();const t=this.handlers.get(e.id);t&&t(e)}whenInitialized(){return this.state===d.Idle?Promise.resolve():n.Event.toPromise(this.onDidInitialize)}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(e=>e.dispose()),this.activeRequests.clear()}}t.ChannelClient=P;t.IPCServer=class{constructor(e){
this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new n.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new n.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,e(({protocol:e,onDidClientDisconnect:t})=>{n.Event.once(e.onMessage)(n=>{const i=C(new m(n)),r=new x(e,i),s=new P(e);this.channels.forEach((e,t)=>r.registerChannel(t,e));const o={channelServer:r,channelClient:s,ctx:i};this._connections.add(o),this._onDidAddConnection.fire(o),t(()=>{r.dispose(),s.dispose(),this._connections.delete(o),this._onDidRemoveConnection.fire(o)})})})}get connections(){const e=[];return this._connections.forEach(t=>e.push(t)),e}getChannel(e,t){const i=this;return{call(r,s,o){let a;if(l.isFunction(t)){let e=c.getRandomElement(i.connections.filter(t));a=e?Promise.resolve(e):n.Event.toPromise(n.Event.filter(i.onDidAddConnection,t))}else a=t.routeCall(i,r,s);return I(a.then(t=>t.channelClient.getChannel(e))).call(r,s,o)},listen(n,r){
if(l.isFunction(t))return i.getMulticastEvent(e,t,n,r);return I(t.routeEvent(i,n,r).then(t=>t.channelClient.getChannel(e))).listen(n,r)}}}getMulticastEvent(e,t,r,s){const o=this;let a=new i.DisposableStore;const c=new n.Emitter({onFirstListenerAdd:()=>{a=new i.DisposableStore;const l=new n.EventMultiplexer,u=new Map,h=t=>{const n=t.channelClient.getChannel(e).listen(r,s),i=l.add(n);u.set(t,i)};o.connections.filter(t).forEach(h),n.Event.filter(o.onDidAddConnection,t)(h,void 0,a),o.onDidRemoveConnection(e=>{const t=u.get(e);t&&(t.dispose(),u.delete(e))},void 0,a),l.event(c.fire,c,a),a.add(l)},onLastListenerRemove:()=>{a.dispose()}});return c.event}registerChannel(e,t){this.channels.set(e,t),this._connections.forEach(n=>{n.channelServer.registerChannel(e,t)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}};function I(e){return{call:(t,n,i)=>e.then(e=>e.call(t,n,i)),listen(t,i){const r=new n.Relay
;return e.then(e=>r.input=e.listen(t,i)),r.event}}}t.IPCClient=class{constructor(e,t,n=null){const i=new v;b(i,t),e.send(i.buffer),this.channelClient=new P(e,n),this.channelServer=new x(e,t,n)}getChannel(e){return this.channelClient.getChannel(e)}registerChannel(e,t){this.channelServer.registerChannel(e,t)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}},t.getDelayedChannel=I,t.getNextTickChannel=function(e){let t=!1;return{call:(n,i,s)=>t?e.call(n,i,s):r.timeout(0).then(()=>t=!0).then(()=>e.call(n,i,s)),listen(i,s){if(t)return e.listen(i,s);const o=new n.Relay;return r.timeout(0).then(()=>t=!0).then(()=>o.input=e.listen(i,s)),o.event}}};function k(e){return"o"===e[0]&&"n"===e[1]&&h.isUpperAsciiLetter(e.charCodeAt(2))}t.StaticRouter=class{constructor(e){this.fn=e}routeCall(e){return this.route(e)}routeEvent(e){return this.route(e)}async route(e){for(const t of e.connections)if(await Promise.resolve(this.fn(t.ctx)))return Promise.resolve(t)
;return await n.Event.toPromise(e.onDidAddConnection),await this.route(e)}},t.createChannelReceiver=function(e,t){const i=e,r=t&&t.disableMarshalling,s=new Map;for(const e in i)k(e)&&s.set(e,n.Event.buffer(i[e],!0));return new class{listen(e,t){const n=s.get(t);if(n)return n;throw new Error(`Event not found: ${t}`)}call(e,t,n){const s=i[t];if("function"==typeof s){if(!r&&Array.isArray(n))for(let e=0;e<n.length;e++)n[e]=u.revive(n[e]);return s.apply(i,n)}throw new Error(`Method not found: ${t}`)}}},t.createChannelSender=function(e,t){const n=t&&t.disableMarshalling;return new Proxy({},{get(i,r){var s;if("string"==typeof r)return(null===(s=null==t?void 0:t.properties)||void 0===s?void 0:s.has(r))?t.properties.get(r):k(r)?e.listen(r):async function(...i){let s;s=t&&!l.isUndefinedOrNull(t.context)?[t.context,...i]:i;const o=await e.call(r,s);return n?o:u.revive(o)};throw new Error(`Property not found: ${String(r)}`)}})}
;const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function D(e){if(Array.isArray(e))return e;if(e&&"object"==typeof e&&"function"==typeof e.toString){let t=e.toString();if("[object Object]"!==t)return t}return e}function L(e,t,n,i,r,s,o){o=function(e){return Array.isArray(e)?e.map(D):D(e)}(o);const a=O[r],c=a[i%a.length];let l=[`%c[${e}]%c[${String(t).padStart(7," ")}]%c[len: ${String(n).padStart(5," ")}]%c${String(i).padStart(5," ")} - ${s}`,"color: darkgreen","color: grey","color: grey",`color: ${c}`];/\($/.test(s)?(l=l.concat(o)).push(")"):l.push(o),console.log.apply(console,l)}t.logWithColors=L;t.IPCLogger=class{constructor(e,t){this._outgoingPrefix=e,this._incomingPrefix=t,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(e,t,n,i,r){this._totalOutgoing+=e,L(this._outgoingPrefix,this._totalOutgoing,e,t,n,i,r)}logIncoming(e,t,n,i,r){this._totalIncoming+=e,L(this._incomingPrefix,this._totalIncoming,e,t,n,i,r)}}})),
define(t[72],n([0,1,5,35,3,17,6,51]),(function(e,t,n,i,r,s,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PersistentProtocol=t.BufferedEmitter=t.Client=t.Protocol=t.ProtocolConstants=t.ChunkStream=void 0;let c=null;function l(){return c||(c=s.VSBuffer.alloc(0)),c}class u{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(e){this._chunks.push(e),this._totalLength+=e.byteLength}read(e){return this._read(e,!0)}peek(e){return this._read(e,!1)}_read(e,t){if(0===e)return l();if(e>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===e){const n=this._chunks[0];return t&&(this._chunks.shift(),this._totalLength-=e),n}if(this._chunks[0].byteLength>e){const n=this._chunks[0].slice(0,e);return t&&(this._chunks[0]=this._chunks[0].slice(e),this._totalLength-=e),n}let n=s.VSBuffer.alloc(e),i=0,r=0;for(;e>0;){const s=this._chunks[r];if(s.byteLength>e){const o=s.slice(0,e);n.set(o,i),i+=e,
t&&(this._chunks[r]=s.slice(e),this._totalLength-=e),e-=e}else n.set(s,i),i+=s.byteLength,t?(this._chunks.shift(),this._totalLength-=s.byteLength):r++,e-=s.byteLength}return n}}var h;t.ChunkStream=u,function(e){e[e.None=0]="None",e[e.Regular=1]="Regular",e[e.Control=2]="Control",e[e.Ack=3]="Ack",e[e.KeepAlive=4]="KeepAlive",e[e.Disconnect=5]="Disconnect"}(h||(h={})),function(e){e[e.HeaderLength=13]="HeaderLength",e[e.AcknowledgeTime=2e3]="AcknowledgeTime",e[e.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",e[e.KeepAliveTime=5e3]="KeepAliveTime",e[e.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",e[e.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",e[e.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"}(t.ProtocolConstants||(t.ProtocolConstants={}));class d{constructor(e,t,n,i){this.type=e,this.id=t,this.ack=n,this.data=i,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends r.Disposable{constructor(e){super(),this._onMessage=this._register(new n.Emitter),
this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=e,this._isDisposed=!1,this._incomingData=new u,this._register(this._socket.onData(e=>this.acceptChunk(e))),this.lastReadTime=Date.now()}acceptChunk(e){if(e&&0!==e.byteLength)for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;){const e=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=e.readUInt32BE(9),this._state.messageType=e.readUInt8(0),this._state.id=e.readUInt32BE(1),this._state.ack=e.readUInt32BE(5);else{const t=this._state.messageType,n=this._state.id,i=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(t,n,i,e)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}
class p{constructor(e){this._isDisposed=!1,this._socket=e,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){this.flush(),this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(e){if(this._isDisposed)return;e.writtenTime=Date.now(),this.lastWriteTime=Date.now();const t=s.VSBuffer.alloc(13);t.writeUInt8(e.type,0),t.writeUInt32BE(e.id,1),t.writeUInt32BE(e.ack,5),t.writeUInt32BE(e.data.byteLength,9),this._writeSoon(t,e.data)}_bufferAdd(e,t){const n=0===this._totalLength;return this._data.push(e,t),this._totalLength+=e.byteLength+t.byteLength,n}_bufferTake(){const e=s.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,e}_writeSoon(e,t){this._bufferAdd(e,t)&&o.setImmediate(()=>{this._writeNow()})}_writeNow(){0!==this._totalLength&&this._socket.write(this._bufferTake())}}class g extends r.Disposable{constructor(e){super(),this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onClose=new n.Emitter,
this.onClose=this._onClose.event,this._socket=e,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(e=>{1===e.type&&this._onMessage.fire(e.data)})),this._register(this._socket.onClose(()=>this._onClose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(e){this._socketWriter.write(new d(1,0,0,e))}}t.Protocol=g;class m extends i.IPCClient{constructor(e,t,n=null){super(e,t,n),this.protocol=e}static fromSocket(e,t){return new m(new g(e),t)}get onClose(){return this.protocol.onClose}dispose(){super.dispose();const e=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),e.end()}}t.Client=m;class v{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,a.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{
this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(e){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(e):this._emitter.fire(e):this._bufferedMessages.push(e)}flushBuffer(){this._bufferedMessages=[]}}t.BufferedEmitter=v;class y{constructor(e){this.data=e,this.next=null}}class w{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let e=[],t=0,n=this._first;for(;n;)e[t++]=n.data,n=n.next;return e}pop(){if(this._first)return this._first===this._last?(this._first=null,void(this._last=null)):void(this._first=this._first.next)}push(e){const t=new y(e);if(!this._first)return this._first=t,void(this._last=t);this._last.next=t,this._last=t}}class E{constructor(){this.lastRuns=[];const e=Date.now()
;for(let t=0;t<E._HISTORY_LENGTH;t++)this.lastRuns[t]=e-1e3*t;setInterval(()=>{for(let e=E._HISTORY_LENGTH;e>=1;e--)this.lastRuns[e]=this.lastRuns[e-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return E._INSTANCE||(E._INSTANCE=new E),E._INSTANCE}load(){const e=Date.now(),t=1e3*(1+E._HISTORY_LENGTH);let n=0;for(let i=0;i<E._HISTORY_LENGTH;i++)e-this.lastRuns[i]<=t&&n++;return 1-n/E._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}E._HISTORY_LENGTH=10,E._INSTANCE=null;t.PersistentProtocol=class{constructor(e,t=null){this._loadEstimator=E.getInstance(),this._onControlMessage=new v,this.onControlMessage=this._onControlMessage.event,this._onMessage=new v,this.onMessage=this._onMessage.event,this._onClose=new v,this.onClose=this._onClose.event,this._onSocketClose=new v,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new v,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new w,this._outgoingMsgId=0,this._outgoingAckId=0,
this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._socketDisposables=[],this._socket=e,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(e=>this._receiveMessage(e))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),t&&this._socketReader.acceptChunk(t),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),
this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=r.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const e=new d(5,0,0,l());this._socketWriter.write(e),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const e=Date.now()-this._socketWriter.lastWriteTime;if(e>=5e3){const e=new d(4,0,0,l());return this._socketWriter.write(e),void this._sendKeepAliveCheck()}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-e+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const e=Date.now()-this._socketReader.lastReadTime;e>=2e4&&!this._loadEstimator.hasHighLoad()?this._onSocketTimeout.fire(void 0):this._incomingKeepAliveTimeout=setTimeout(()=>{
this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-e,0)+5)}getSocket(){return this._socket}beginAcceptReconnection(e,t){this._isReconnecting=!0,this._socketDisposables=r.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._socket=e,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(e=>this._receiveMessage(e))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(t)}endAcceptReconnection(){this._isReconnecting=!1;const e=this._outgoingUnackMsg.toArray();for(let t=0,n=e.length;t<n;t++)this._socketWriter.write(e[t]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onClose.fire()}
_receiveMessage(e){if(e.ack>this._outgoingAckId)for(this._outgoingAckId=e.ack;;){const t=this._outgoingUnackMsg.peek();if(!(t&&t.id<=e.ack))break;this._outgoingUnackMsg.pop()}1===e.type?e.id>this._incomingMsgId&&(e.id!==this._incomingMsgId+1&&console.error(`PROTOCOL CORRUPTION, LAST SAW MSG ${this._incomingMsgId} AND HAVE NOW RECEIVED MSG ${e.id}`),this._incomingMsgId=e.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(e.data)):2===e.type?this._onControlMessage.fire(e.data):5===e.type&&this._onClose.fire()}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(e){const t=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const n=new d(1,t,this._incomingAckId,e);this._outgoingUnackMsg.push(n),this._isReconnecting||(this._socketWriter.write(n),this._recvAckCheck())}sendControl(e){const t=new d(2,0,0,e);this._socketWriter.write(t)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId)return
;if(this._incomingAckTimeout)return;const e=Date.now()-this._incomingMsgLastTime;e>=2e3?this._sendAck():this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-e+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId)return;if(this._outgoingAckTimeout)return;const e=this._outgoingUnackMsg.peek(),t=Date.now()-e.writtenTime;t>=2e4&&!this._loadEstimator.hasHighLoad()?this._onSocketTimeout.fire(void 0):this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-t,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const e=new d(3,0,this._incomingAckId,l());this._socketWriter.write(e)}}})),define(t[73],n([0,1,70,5,35,2,27,20,3,17,72,16]),(function(e,t,n,i,r,s,o,a,c,l,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.connect=t.serve=t.Server=t.generateRandomPipeName=t.WebSocketNodeSocket=t.NodeSocket=void 0;class d{constructor(e){this.socket=e}
dispose(){this.socket.destroy()}onData(e){const t=t=>e(l.VSBuffer.wrap(t));return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}onClose(e){return this.socket.on("close",e),{dispose:()=>this.socket.off("close",e)}}onEnd(e){return this.socket.on("end",e),{dispose:()=>this.socket.off("end",e)}}write(e){if(!this.socket.destroyed)try{this.socket.write(e.buffer)}catch(e){if("EPIPE"===e.code)return;h.onUnexpectedError(e)}}end(){this.socket.end()}drain(){return new Promise((e,t)=>{if(0===this.socket.bufferSize)return void e();const n=()=>{this.socket.off("close",n),this.socket.off("end",n),this.socket.off("error",n),this.socket.off("timeout",n),this.socket.off("drain",n),e()};this.socket.on("close",n),this.socket.on("end",n),this.socket.on("error",n),this.socket.on("timeout",n),this.socket.on("drain",n)})}}var f,p;t.NodeSocket=d,function(e){e[e.MinHeaderByteSize=2]="MinHeaderByteSize"}(f||(f={})),function(e){e[e.PeekHeader=1]="PeekHeader",e[e.ReadHeader=2]="ReadHeader",e[e.ReadBody=3]="ReadBody",
e[e.Fin=4]="Fin"}(p||(p={}));class g extends c.Disposable{constructor(e){super(),this._onData=this._register(new i.Emitter),this._state={state:1,readLen:2,mask:0},this.socket=e,this._incomingData=new u.ChunkStream,this._register(this.socket.onData(e=>this._acceptChunk(e)))}dispose(){this.socket.dispose()}onData(e){return this._onData.event(e)}onClose(e){return this.socket.onClose(e)}onEnd(e){return this.socket.onEnd(e)}write(e){let t=2;e.byteLength<126?t+=0:e.byteLength<65536?t+=2:t+=8;const n=l.VSBuffer.alloc(t);if(n.writeUInt8(130,0),e.byteLength<126)n.writeUInt8(e.byteLength,1);else if(e.byteLength<65536){n.writeUInt8(126,1);let t=1;n.writeUInt8(e.byteLength>>>8&255,++t),n.writeUInt8(e.byteLength>>>0&255,++t)}else{n.writeUInt8(127,1);let t=1;n.writeUInt8(0,++t),n.writeUInt8(0,++t),n.writeUInt8(0,++t),n.writeUInt8(0,++t),n.writeUInt8(e.byteLength>>>24&255,++t),n.writeUInt8(e.byteLength>>>16&255,++t),n.writeUInt8(e.byteLength>>>8&255,++t),n.writeUInt8(e.byteLength>>>0&255,++t)}
this.socket.write(l.VSBuffer.concat([n,e]))}end(){this.socket.end()}_acceptChunk(e){if(0!==e.byteLength)for(this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;)if(1===this._state.state){const e=this._incomingData.peek(this._state.readLen).readUInt8(1),t=(128&e)>>>7,n=127&e;this._state.state=2,this._state.readLen=2+(t?4:0)+(126===n?2:0)+(127===n?8:0),this._state.mask=0}else if(2===this._state.state){const e=this._incomingData.read(this._state.readLen),t=e.readUInt8(1),n=(128&t)>>>7;let i=127&t,r=1;126===i?i=256*e.readUInt8(++r)+e.readUInt8(++r):127===i&&(i=0*e.readUInt8(++r)+0*e.readUInt8(++r)+0*e.readUInt8(++r)+0*e.readUInt8(++r)+e.readUInt8(++r)*2**24+65536*e.readUInt8(++r)+256*e.readUInt8(++r)+e.readUInt8(++r));let s=0;n&&(s=e.readUInt8(++r)*2**24+65536*e.readUInt8(++r)+256*e.readUInt8(++r)+e.readUInt8(++r)),this._state.state=3,this._state.readLen=i,this._state.mask=s}else if(3===this._state.state){const e=this._incomingData.read(this._state.readLen);m(e,this._state.mask),
this._state.state=1,this._state.readLen=2,this._state.mask=0,this._onData.fire(e)}}drain(){return this.socket.drain()}}function m(e,t){if(0===t)return;let n=e.byteLength>>>2;for(let i=0;i<n;i++){const n=e.readUInt32BE(4*i);e.writeUInt32BE(n^t,4*i)}let i=4*n,r=e.byteLength-i;const s=t>>>24&255,o=t>>>16&255,a=t>>>8&255;r>=1&&e.writeUInt8(e.readUInt8(i)^s,i),r>=2&&e.writeUInt8(e.readUInt8(i+1)^o,i+1),r>=3&&e.writeUInt8(e.readUInt8(i+2)^a,i+2)}t.WebSocketNodeSocket=g;const v=process.env.XDG_RUNTIME_DIR;t.generateRandomPipeName=function(){const e=a.generateUuid();return"win32"===process.platform?`\\\\.\\pipe\\vscode-ipc-${e}-sock`:v?s.join(v,`vscode-ipc-${e}.sock`):s.join(o.tmpdir(),`vscode-ipc-${e}.sock`)};class y extends r.IPCServer{constructor(e){super(y.toClientConnectionEvent(e)),this.server=e}static toClientConnectionEvent(e){const t=i.Event.fromNodeEventEmitter(e,"connection");return i.Event.map(t,e=>({protocol:new u.Protocol(new d(e)),
onDidClientDisconnect:i.Event.once(i.Event.fromNodeEventEmitter(e,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}t.Server=y,t.serve=function(e){return new Promise((t,i)=>{const r=n.createServer();r.on("error",i),r.listen(e,()=>{r.removeListener("error",i),t(new y(r))})})},t.connect=function(e,t){return new Promise((i,r)=>{const s=n.createConnection(e,()=>{s.removeListener("error",r),i(u.Client.fromSocket(new d(s),t))});s.once("error",r)})}})),define(t[101],n([0,1,34,20,6]),(function(e,t,n,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getShellEnvironment=void 0;let s=void 0;t.getShellEnvironment=function(e,t){return s||(t.args["disable-user-env-probe"]?(e.trace("getShellEnvironment: disable-user-env-probe set, skipping"),s=Promise.resolve({})):r.isWindows?(e.trace("getShellEnvironment: running on Windows, skipping"),
s=Promise.resolve({})):"1"===process.env.VSCODE_CLI&&"1"!==process.env.VSCODE_FORCE_USER_ENV?(e.trace("getShellEnvironment: running on CLI, skipping"),s=Promise.resolve({})):(e.trace("getShellEnvironment: running on Unix"),s=function(e){return new Promise((t,r)=>{const s=process.env.ELECTRON_RUN_AS_NODE;e.trace("getUnixShellEnvironment#runAsNode",s);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;e.trace("getUnixShellEnvironment#noAttach",o);const a=i.generateUuid().replace(/-/g,"").substr(0,12),c=new RegExp(a+"(.*)"+a),l=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"}),u=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`;e.trace("getUnixShellEnvironment#env",l),e.trace("getUnixShellEnvironment#spawn",u);const h=n.spawn(process.env.SHELL,["-ilc",u],{detached:!0,stdio:["ignore","pipe",process.stderr],env:l}),d=[];h.on("error",()=>t({})),h.stdout.on("data",e=>d.push(e)),h.on("close",n=>{
if(0!==n)return r(new Error("Failed to get environment"));const i=Buffer.concat(d).toString("utf8");e.trace("getUnixShellEnvironment#raw",i);const a=c.exec(i),l=a?a[1]:"{}";try{const n=JSON.parse(l);s?n.ELECTRON_RUN_AS_NODE=s:delete n.ELECTRON_RUN_AS_NODE,o?n.ELECTRON_NO_ATTACH_CONSOLE=o:delete n.ELECTRON_NO_ATTACH_CONSOLE,delete n.XDG_RUNTIME_DIR,e.trace("getUnixShellEnvironment#result",n),t(n)}catch(t){e.error("getUnixShellEnvironment#error",t),r(t)}})}).catch(()=>({}))}(e))),s}})),define(t[102],n([9,10]),(function(e,t){return e.create("vs/base/common/date",t)})),define(t[103],n([0,1,11,102]),(function(e,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const r=60,s=60*r,o=24*s,a=7*o,c=30*o,l=365*o;t.fromNow=function e(t,n){"number"!=typeof t&&(t=t.getTime());const u=Math.round(((new Date).getTime()-t)/1e3);if(u<-30)return i.localize(0,null,e((new Date).getTime()+1e3*u,!1));if(u<30)return i.localize(1,null);let h;return u<r?(h=u,
n?1===h?i.localize(2,null,h):i.localize(3,null,h):1===h?i.localize(4,null,h):i.localize(5,null,h)):u<s?(h=Math.floor(u/r),n?1===h?i.localize(6,null,h):i.localize(7,null,h):1===h?i.localize(8,null,h):i.localize(9,null,h)):u<o?(h=Math.floor(u/s),n?1===h?i.localize(10,null,h):i.localize(11,null,h):1===h?i.localize(12,null,h):i.localize(13,null,h)):u<a?(h=Math.floor(u/o),n?1===h?i.localize(14,null,h):i.localize(15,null,h):1===h?i.localize(16,null,h):i.localize(17,null,h)):u<c?(h=Math.floor(u/a),n?1===h?i.localize(18,null,h):i.localize(19,null,h):1===h?i.localize(20,null,h):i.localize(21,null,h)):u<l?(h=Math.floor(u/c),n?1===h?i.localize(22,null,h):i.localize(23,null,h):1===h?i.localize(24,null,h):i.localize(25,null,h)):(h=Math.floor(u/l),n?1===h?i.localize(26,null,h):i.localize(27,null,h):1===h?i.localize(28,null,h):i.localize(29,null,h))},t.toLocalISOString=function(e){
return e.getFullYear()+"-"+n.pad(e.getMonth()+1,2)+"-"+n.pad(e.getDate(),2)+"T"+n.pad(e.getHours(),2)+":"+n.pad(e.getMinutes(),2)+":"+n.pad(e.getSeconds(),2)+"."+(e.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}})),define(t[104],n([9,10]),(function(e,t){return e.create("vs/base/common/errorMessage",t)})),define(t[43],n([0,1,104,12,21]),(function(e,t,n,i,r){"use strict";function s(e,t){return t&&(e.stack||e.stacktrace)?n.localize(0,null,a(e),o(e.stack)||o(e.stacktrace)):a(e)}function o(e){return Array.isArray(e)?e.join("\n"):e}function a(e){return"string"==typeof e.code&&"number"==typeof e.errno&&"string"==typeof e.syscall?n.localize(1,null,e.message):e.message||n.localize(2,null)}Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0,t.toErrorMessage=function e(t=null,o=!1){if(!t)return n.localize(3,null);if(Array.isArray(t)){const i=r.coalesce(t),s=e(i[0],o);return i.length>1?n.localize(4,null,s,i.length):s}if(i.isString(t))return t;if(t.detail){const e=t.detail
;if(e.error)return s(e.error,o);if(e.exception)return s(e.exception,o)}return t.stack?s(t,o):t.message?t.message:n.localize(5,null)}})),define(t[105],n([9,10]),(function(e,t){return e.create("vs/base/common/jsonErrorMessages",t)})),define(t[106],n([0,1,105]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getParseErrorMessage=void 0,t.getParseErrorMessage=function(e){switch(e){case 1:return n.localize(0,null);case 2:return n.localize(1,null);case 3:return n.localize(2,null);case 4:return n.localize(3,null);case 5:return n.localize(4,null);case 6:return n.localize(5,null);case 7:return n.localize(6,null);case 8:return n.localize(7,null);case 9:return n.localize(8,null);default:return""}}})),define(t[107],n([9,10]),(function(e,t){return e.create("vs/base/node/processes",t)})),define(t[108],n([0,1,2,18,42,34,107,12,19,30,6,68,4]),(function(e,t,n,i,r,s,o,a,c,l,u,h,d){"use strict";function f(e){switch(e){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}
function p(){return process.env.comspec||"cmd.exe"}Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0,t.getWindowsShell=p;class g{constructor(e,t,n,i){if(void 0!==t&&void 0!==n&&void 0!==i)this.cmd=e,this.args=t,this.shell=n,this.options=i;else{const t=e;this.cmd=t.command,this.shell=t.isShellCommand,this.args=t.args.slice(0),this.options=t.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const e=Object.create(null);Object.keys(process.env).forEach(t=>{e[t]=process.env[t]}),Object.keys(this.options.env).forEach(t=>{e[t]=this.options.env[t]}),this.options.env=e}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const t=e.lastIndexOf(n.sep);return-1!==t&&(e=e.substring(t+1)),g.WellKnowCommands[e]?e:"other"}start(e){
return u.isWindows&&(this.options&&this.options.cwd&&l.isUNC(this.options.cwd)||!this.options&&l.isUNC(process.cwd()))?Promise.reject(new Error(o.localize(0,null))):this.useExec().then(t=>{let n,i;const r=new Promise((e,t)=>{n=e,i=t});if(t){let t=this.cmd;this.args&&(t=t+" "+this.args.join(" ")),this.childProcess=s.exec(t,this.options,(t,r,s)=>{this.childProcess=null;t&&t.killed?i({killed:this.terminateRequested,stdout:r.toString(),stderr:s.toString()}):this.handleExec(n,e,t,r,s)})}else{let t=null;const r=t=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(t,n,e,i);const r={terminated:this.terminateRequested};a.isNumber(t)&&(r.cmdCode=t),n(r)};if(this.shell&&u.isWindows){const e=c.deepClone(this.options);e.windowsVerbatimArguments=!0,e.detached=!1;let n=!1,i=!1;const r=[];let o=this.ensureQuotes(this.cmd);r.push(o.value),n=o.quoted,this.args&&this.args.forEach(e=>{o=this.ensureQuotes(e),r.push(o.value),i=i&&o.quoted});const a=["/s","/c"]
;n?i?a.push('"'+r.join(" ")+'"'):r.length>1?a.push('"'+r[0]+'" '+r.slice(1).join(" ")):a.push('"'+r[0]+'"'):a.push(r.join(" ")),t=s.spawn(p(),a,e)}else this.cmd&&(t=s.spawn(this.cmd,this.args,this.options));t&&(this.childProcess=t,this.childProcessPromise=Promise.resolve(t),this.pidResolve&&(this.pidResolve(a.isNumber(t.pid)?t.pid:-1),this.pidResolve=void 0),t.on("error",e=>{this.childProcess=null,i({terminated:this.terminateRequested,error:e})}),t.pid&&(this.childProcess.on("close",r),this.handleSpawn(t,n,e,i,!0)))}return r})}handleClose(e,t,n,i){}ensureQuotes(e){return g.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&'"'===e[0]&&'"'===e[e.length-1]}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,function(t,n){if(u.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};n&&(e.cwd=n)
;const i=s.execFile("taskkill",["/T","/F","/PID",t.pid.toString()],e);return new Promise((e,t)=>{i.once("error",t=>{e({success:!1,error:t})}),i.once("exit",(t,n)=>{e(0===t?{success:!0}:{success:!1,code:null!==t?t:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?f(e.status):1})}else if(u.isLinux||u.isMacintosh)try{const n=d.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",e).fsPath;return new Promise((e,i)=>{s.execFile(n,[t.pid.toString()],{encoding:"utf8",shell:!0},(t,n,i)=>{e(t?{success:!1,error:t}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else t.kill("SIGKILL");return Promise.resolve({success:!0})}(t,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise((e,t)=>{if(!this.shell||!u.isWindows)return e(!1);const n=s.spawn(p(),["/s","/c"]);n.on("error",t=>e(!0)),n.on("exit",t=>e(!1))})}}t.AbstractProcess=g,g.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,
gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},g.regexp=/^[^"].* .*[^"]/;t.LineProcess=class extends g{constructor(e,t,n,i){super(e,t,n,i),this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,t,n,i,r){[i,r].forEach((e,n)=>{const i=new h.LineDecoder;i.write(e).forEach(e=>{t({line:e,source:0===n?0:1})});const r=i.end();r&&t({line:r,source:0===n?0:1})}),e({terminated:this.terminateRequested,error:n})}handleSpawn(e,t,n,i,r){const s=new h.LineDecoder,o=new h.LineDecoder;e.stdout.on("data",e=>{s.write(e).forEach(e=>n({line:e,source:0}))}),e.stderr.on("data",e=>{o.write(e).forEach(e=>n({line:e,source:1}))}),this.stdoutLineDecoder=s,this.stderrLineDecoder=o}handleClose(e,t,n,i){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&n({line:r,source:0});const s=this.stderrLineDecoder?this.stderrLineDecoder.end():null;s&&n({line:s,source:1})}},t.createQueuedSender=function(e){let t=[],n=!1
;const i=function(r){if(n)return void t.push(r);e.send(r,e=>{if(e&&console.error(e),n=!1,t.length>0){const e=t.slice(0);t=[],e.forEach(e=>i(e))}})&&!u.isWindows||(n=!0)};return{send:i}},function(e){e.findExecutable=async function(e,t,s){if(n.isAbsolute(e))return e;if(void 0===t&&(t=process.cwd()),"."!==n.dirname(e))return n.join(t,e);if(void 0===s&&a.isString(process.env.PATH)&&(s=process.env.PATH.split(n.delimiter)),void 0===s||0===s.length)return n.join(t,e);async function o(e){return!!await r.promisify(i.exists)(e)&&!(await r.promisify(i.stat)(e)).isDirectory()}for(let i of s){let r;if(r=n.isAbsolute(i)?n.join(i,e):n.join(t,i,e),await o(r))return r;let s=r+".com";if(await o(s))return s;if(s=r+".exe",await o(s))return s}return n.join(t,e)}}(t.win32||(t.win32={}))})),define(t[74],n([0,1,34,3,15,19,5,108,35,92,24,16,17,6]),(function(e,t,n,i,r,s,o,a,c,l,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class p extends c.ChannelServer{constructor(e){super({send:e=>{
try{process.send&&process.send(e.buffer.toString("base64"))}catch(e){}},onMessage:o.Event.fromNodeEventEmitter(process,"message",e=>d.VSBuffer.wrap(Buffer.from(e,"base64")))},e),process.once("disconnect",()=>this.dispose())}}t.Server=p;t.Client=class{constructor(e,t){this.modulePath=e,this.options=t,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new o.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const n=t&&t.timeout?t.timeout:6e4;this.disposeDelayer=new r.Delayer(n),this.child=null,this._client=null}getChannel(e){const t=this;return{call:(n,i,r)=>t.requestPromise(e,n,i,r),listen:(n,i)=>t.requestEvent(e,n,i)}}requestPromise(e,t,n,s=u.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(h.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(e),a=r.createCancelablePromise(e=>o.call(t,n,e)),c=s.onCancellationRequested(()=>a.cancel()),l=i.toDisposable(()=>a.cancel())
;return this.activeRequests.add(l),a.finally(()=>{c.dispose(),this.activeRequests.delete(l),0===this.activeRequests.size&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(e,t,n){if(!this.disposeDelayer)return o.Event.None;let i;this.disposeDelayer.cancel();const r=new o.Emitter({onFirstListenerAdd:()=>{const s=this.getCachedChannel(e).listen(t,n);i=s(r.fire,r),this.activeRequests.add(i)},onLastListenerRemove:()=>{this.activeRequests.delete(i),i.dispose(),0===this.activeRequests.size&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const e=this.options&&this.options.args?this.options.args:[],t=Object.create(null);t.env=Object.assign(Object.assign({},s.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(t.env=Object.assign(Object.assign({},t.env),this.options.env)),this.options&&this.options.freshExecArgv&&(t.execArgv=[]),
this.options&&"number"==typeof this.options.debug&&(t.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&"number"==typeof this.options.debugBrk&&(t.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.isMacintosh&&t.env&&delete t.env.DYLD_LIBRARY_PATH,this.child=n.fork(this.modulePath,e,t);const r=new o.Emitter;o.Event.fromNodeEventEmitter(this.child,"message",e=>e)(e=>{l.isRemoteConsoleLog(e)?l.log(e,`IPC Library: ${this.options.serverName}`):r.fire(d.VSBuffer.wrap(Buffer.from(e,"base64")))});const u=this.options.useQueue?a.createQueuedSender(this.child):this.child,h={send:e=>this.child&&this.child.connected&&u.send(e.buffer.toString("base64")),onMessage:r.event};this._client=new c.ChannelClient(h);const p=()=>this.disposeClient();process.once("exit",p),this.child.on("error",e=>console.warn('IPC "'+this.options.serverName+'" errored with '+e)),this.child.on("exit",(e,t)=>{process.removeListener("exit",p),this.activeRequests.forEach(e=>i.dispose(e)),this.activeRequests.clear(),
0!==e&&"SIGTERM"!==t&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+e+" and signal "+t),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:e,signal:t})})}return this._client}getCachedChannel(e){let t=this.channels.get(e);return t||(t=this.client.getChannel(e),this.channels.set(e,t)),t}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}})),define(t[109],n([9,10]),(function(e,t){return e.create("vs/base/node/zip",t)})),define(t[110],n([9,10]),(function(e,t){return e.create("vs/code/node/cliProcessMain",t)})),define(t[111],n([9,10]),(function(e,t){return e.create("vs/platform/configuration/common/configurationRegistry",t)})),define(t[112],n([9,10]),(function(e,t){
return e.create("vs/platform/environment/node/argv",t)})),define(t[113],n([9,10]),(function(e,t){return e.create("vs/platform/extensionManagement/common/extensionManagement",t)})),define(t[114],n([9,10]),(function(e,t){return e.create("vs/platform/extensionManagement/node/extensionManagementService",t)})),define(t[115],n([9,10]),(function(e,t){return e.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)})),define(t[116],n([9,10]),(function(e,t){return e.create("vs/platform/extensionManagement/node/extensionsScanner",t)})),define(t[117],n([9,10]),(function(e,t){return e.create("vs/platform/extensions/common/extensionValidator",t)})),define(t[118],n([9,10]),(function(e,t){return e.create("vs/platform/files/common/fileService",t)})),define(t[119],n([9,10]),(function(e,t){return e.create("vs/platform/files/common/files",t)})),define(t[120],n([9,10]),(function(e,t){return e.create("vs/platform/files/common/io",t)})),define(t[121],n([9,10]),(function(e,t){
return e.create("vs/platform/files/node/diskFileSystemProvider",t)})),define(t[122],n([9,10]),(function(e,t){return e.create("vs/platform/request/common/request",t)})),define(t[123],n([9,10]),(function(e,t){return e.create("vs/platform/telemetry/common/telemetryService",t)})),define(t[124],n([9,10]),(function(e,t){return e.create("vs/server/remoteAgentEnvironmentImpl",t)})),define(t[125],n([9,10]),(function(e,t){return e.create("vs/workbench/services/extensions/node/extensionPoints",t)})),define(t[126],n([0,1,5,3]),(function(e,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionHostDebugChannelClient=t.ExtensionHostDebugBroadcastChannel=void 0;class r{constructor(){this._onCloseEmitter=new n.Emitter,this._onReloadEmitter=new n.Emitter,this._onTerminateEmitter=new n.Emitter,this._onLogToEmitter=new n.Emitter,this._onAttachEmitter=new n.Emitter}call(e,t,n){switch(t){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:n[0]}));case"reload":
return Promise.resolve(this._onReloadEmitter.fire({sessionId:n[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:n[0]}));case"log":return Promise.resolve(this._onLogToEmitter.fire({sessionId:n[0],log:n[1]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:n[0],port:n[1],subId:n[2]}))}throw new Error("Method not implemented.")}listen(e,t,n){switch(t){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"log":return this._onLogToEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}t.ExtensionHostDebugBroadcastChannel=r,r.ChannelName="extensionhostdebugservice";class s extends i.Disposable{constructor(e){super(),this.channel=e}reload(e){this.channel.call("reload",[e])}get onReload(){return this.channel.listen("reload")}close(e){this.channel.call("close",[e])}get onClose(){
return this.channel.listen("close")}attachSession(e,t,n){this.channel.call("attach",[e,t,n])}get onAttachSession(){return this.channel.listen("attach")}logToSession(e,t){this.channel.call("log",[e,t])}get onLogToSession(){return this.channel.listen("log")}terminateSession(e,t){this.channel.call("terminate",[e,t])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(e,t,n){return this.channel.call("openExtensionDevelopmentHostWindow",[e,t,n])}}t.ExtensionHostDebugChannelClient=s})),define(t[127],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isRemoteDiagnosticError=void 0,t.isRemoteDiagnosticError=function(e){return!!e.hostName&&!!e.errorMessage}})),define(t[128],n([0,1,7]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadServiceChannelClient=t.DownloadServiceChannel=void 0;t.DownloadServiceChannel=class{constructor(e){this.service=e}listen(e,t,n){throw new Error("Invalid listen")}
call(e,t,i){switch(t){case"download":return this.service.download(n.URI.revive(i[0]),n.URI.revive(i[1]))}throw new Error("Invalid call")}};t.DownloadServiceChannelClient=class{constructor(e,t){this.channel=e,this.getUriTransformer=t}async download(e,t){const n=this.getUriTransformer();n&&(e=n.transformOutgoingURI(e),t=n.transformOutgoingURI(t)),await this.channel.call("download",[e,t])}}})),define(t[129],n([0,1,171,112,6]),(function(e,t,n,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildVersionMessage=t.buildHelpMessage=t.formatOptions=t.parseArgs=t.OPTIONS=void 0;const s={o:i.localize(0,null),e:i.localize(1,null),t:i.localize(2,null)};t.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:i.localize(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:i.localize(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:i.localize(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",
description:i.localize(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:i.localize(7,null)},"folder-uri":{type:"string[]",cat:"o",args:"uri",description:i.localize(8,null)},"file-uri":{type:"string[]",cat:"o",args:"uri",description:i.localize(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:i.localize(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:i.localize(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:i.localize(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:i.localize(13,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:i.localize(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:i.localize(15,null)},"show-versions":{type:"boolean",cat:"e",description:i.localize(16,null)},category:{type:"string",cat:"e",description:i.localize(17,null)},
"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:i.localize(18,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:i.localize(19,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:i.localize(20,null)},version:{type:"boolean",cat:"t",alias:"v",description:i.localize(21,null)},verbose:{type:"boolean",cat:"t",description:i.localize(22,null)},log:{type:"string",cat:"t",args:"level",description:i.localize(23,null)},status:{type:"boolean",alias:"s",cat:"t",description:i.localize(24,null)},"prof-startup":{type:"boolean",cat:"t",description:i.localize(25,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:i.localize(26,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:i.localize(27,null)},sync:{type:"string",cat:"t",description:i.localize(28,null),
args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:i.localize(29,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:i.localize(30,null)},"disable-gpu":{type:"boolean",cat:"t",description:i.localize(31,null)},"max-memory":{type:"string",cat:"t",description:i.localize(32,null)},telemetry:{type:"boolean",cat:"t",description:i.localize(33,null)},remote:{type:"string"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},
"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"disable-user-env-probe":{type:"boolean"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{
type:"boolean"},"log-net-log":{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const o={onUnknownOption:()=>{},onMultipleValues:()=>{}};function a(e,t){let n="";return t.args&&(n=Array.isArray(t.args)?` <${t.args.join("> <")}>`:` <${t.args}>`),t.alias?`-${t.alias} --${e}${n}`:`--${e}${n}`}function c(e,t){let n=0,i=[];for(const t in e){const r=e[t],s=a(t,r);n=Math.max(n,s.length),i.push([s,r.description])}let r=n+2+1;if(t-r<25)return i.reduce((e,t)=>e.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let s=t-r-1,o=[];for(const e of i){let t=e[0],n=u(e[1],s),i=l(r-t.length-2);o.push("  "+t+i+n[0]);for(let e=1;e<n.length;e++)o.push(l(r)+n[e])}return o}function l(e){return" ".repeat(e)}function u(e,t){let n=[];for(;e.length;){let i=e.length<t?e.length:e.lastIndexOf(" ",t),r=e.slice(0,i).trim();e=e.slice(i),n.push(r)}return n}t.parseArgs=function(e,t,i=o){const r={},s=[],a=[];for(let e in t){if("_"===e[0])continue;const n=t[e];n.alias&&(r[e]=n.alias),"string"===n.type||"string[]"===n.type?(s.push(e),
n.deprecates&&s.push(n.deprecates)):"boolean"===n.type&&(a.push(e),n.deprecates&&a.push(n.deprecates))}const c=n(e,{string:s,boolean:a,alias:r}),l={},u=c;l._=c._.map(e=>String(e)).filter(e=>e.length>0),delete u._;for(let e in t){const n=t[e];n.alias&&delete u[n.alias];let r=u[e];n.deprecates&&u.hasOwnProperty(n.deprecates)&&(r||(r=u[n.deprecates]),delete u[n.deprecates]),void 0!==r&&("string[]"===n.type?r&&!Array.isArray(r)&&(r=[r]):"string"===n.type&&Array.isArray(r)&&(r=r.pop(),i.onMultipleValues(e,r)),l[e]=r),delete u[e]}for(let e in u)i.onUnknownOption(e);return l},t.formatOptions=c,t.buildHelpMessage=function(e,t,n,o,a=!0){const l=process.stdout.isTTY&&process.stdout.columns||80;let u=[`${e} ${n}`];u.push(""),u.push(`${i.localize(34,null)}: ${t} [${i.localize(35,null)}][${i.localize(36,null)}...]`),u.push(""),a&&(r.isWindows?u.push(i.localize(37,null,t)):u.push(i.localize(38,null,t)),u.push(""));const h={};for(const e in o){const t=o[e];if(t.description&&t.cat){let n=h[t.cat];n||(h[t.cat]=n={}),n[e]=t}}
for(let e in h){const t=e;let n=h[t];n&&(u.push(s[t]),u.push(...c(n,l)),u.push(""))}return u.join("\n")},t.buildVersionMessage=function(e,t){return`${e||i.localize(39,null)}\n${t||i.localize(40,null)}\n${process.arch}`}})),define(t[130],n([0,1,5,7,53,19]),(function(e,t,n,i,r,s){"use strict";function o(e,t){return i.URI.revive(t?t.transformIncoming(e):e)}function a(e,t){t=t||r.DefaultURITransformer;const n=e.manifest,i=r.transformAndReviveIncomingURIs(Object.assign(Object.assign({},e),{manifest:void 0}),t);return Object.assign(Object.assign({},i),{manifest:n})}function c(e,t){return t?s.cloneAndChange(e,e=>e instanceof i.URI?t.transformOutgoingURI(e):void 0):e}Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionTipsChannel=t.ExtensionManagementChannelClient=t.ExtensionManagementChannel=void 0;t.ExtensionManagementChannel=class{constructor(e,t){this.service=e,this.getUriTransformer=t,this.onInstallExtension=n.Event.buffer(e.onInstallExtension,!0),
this.onDidInstallExtension=n.Event.buffer(e.onDidInstallExtension,!0),this.onUninstallExtension=n.Event.buffer(e.onUninstallExtension,!0),this.onDidUninstallExtension=n.Event.buffer(e.onDidUninstallExtension,!0)}listen(e,t){const i=this.getUriTransformer(e);switch(t){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return n.Event.map(this.onDidInstallExtension,e=>Object.assign(Object.assign({},e),{local:e.local?c(e.local,i):e.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(e,t,n){const i=this.getUriTransformer(e);switch(t){case"zip":return this.service.zip(a(n[0],i)).then(e=>(function(e,t){return t?t.transformOutgoingURI(e):e})(e,i));case"unzip":return this.service.unzip(o(n[0],i));case"install":return this.service.install(o(n[0],i));case"getManifest":return this.service.getManifest(o(n[0],i));case"canInstall":return this.service.canInstall(n[0])
;case"installFromGallery":return this.service.installFromGallery(n[0]);case"uninstall":return this.service.uninstall(a(n[0],i),n[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(a(n[0],i));case"getInstalled":return this.service.getInstalled(n[0]).then(e=>e.map(e=>c(e,i)));case"updateMetadata":return this.service.updateMetadata(a(n[0],i),n[1]).then(e=>c(e,i));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}};t.ExtensionManagementChannelClient=class{constructor(e){this.channel=e}get onInstallExtension(){return this.channel.listen("onInstallExtension")}get onDidInstallExtension(){return n.Event.map(this.channel.listen("onDidInstallExtension"),e=>Object.assign(Object.assign({},e),{local:e.local?a(e.local,null):e.local}))}get onUninstallExtension(){return this.channel.listen("onUninstallExtension")}get onDidUninstallExtension(){return this.channel.listen("onDidUninstallExtension")}zip(e){
return Promise.resolve(this.channel.call("zip",[e]).then(e=>i.URI.revive(e)))}unzip(e){return Promise.resolve(this.channel.call("unzip",[e]))}install(e){return Promise.resolve(this.channel.call("install",[e])).then(e=>a(e,null))}getManifest(e){return Promise.resolve(this.channel.call("getManifest",[e]))}async canInstall(e){return!0}installFromGallery(e){return Promise.resolve(this.channel.call("installFromGallery",[e])).then(e=>a(e,null))}uninstall(e,t=!1){return Promise.resolve(this.channel.call("uninstall",[e,t]))}reinstallFromGallery(e){return Promise.resolve(this.channel.call("reinstallFromGallery",[e]))}getInstalled(e=null){return Promise.resolve(this.channel.call("getInstalled",[e])).then(e=>e.map(e=>a(e,null)))}updateMetadata(e,t){return Promise.resolve(this.channel.call("updateMetadata",[e,t])).then(e=>a(e,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}};t.ExtensionTipsChannel=class{constructor(e){this.service=e}listen(e,t){
throw new Error("Invalid listen")}call(e,t,n){switch(t){case"getConfigBasedTips":return this.service.getConfigBasedTips(i.URI.revive(n[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}})),define(t[131],n([0,1,19]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const i=/^%([\w\d.-]+)%$/i;t.localizeManifest=function(e,t){return n.cloneAndChange(e,e=>{if("string"!=typeof e)return;const n=i.exec(e);return n?t[n[1]]||e:void 0})}})),define(t[54],n([0,1,117]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVersionValid=t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const i=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/
;function r(e){return"*"===(e=e.trim())||i.test(e)}function s(e){if(!r(e))return null;if("*"===(e=e.trim()))return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let t=e.match(i);return t?{hasCaret:"^"===t[1],hasGreaterEquals:">="===t[1],majorBase:"x"===t[2]?0:parseInt(t[2],10),majorMustEqual:"x"!==t[2],minorBase:"x"===t[4]?0:parseInt(t[4],10),minorMustEqual:"x"!==t[4],patchBase:"x"===t[6]?0:parseInt(t[6],10),patchMustEqual:"x"!==t[6],preRelease:t[8]||null}:null}function o(e){if(!e)return null;let t=e.majorBase,n=e.majorMustEqual,i=e.minorBase,r=e.minorMustEqual,s=e.patchBase,o=e.patchMustEqual;return e.hasCaret&&(0===t?o=!1:(r=!1,o=!1)),{majorBase:t,majorMustEqual:n,minorBase:i,minorMustEqual:r,patchBase:s,patchMustEqual:o,isMinimum:e.hasGreaterEquals}}function a(e,t){let n,i;if(n="string"==typeof e?o(s(e)):e,i="string"==typeof t?o(s(t)):t,!n||!i)return!1
;let r=n.majorBase,a=n.minorBase,c=n.patchBase,l=i.majorBase,u=i.minorBase,h=i.patchBase,d=i.majorMustEqual,f=i.minorMustEqual,p=i.patchMustEqual;return i.isMinimum?r>l||!(r<l)&&(a>u||!(a<u)&&c>=h):(1!==r||0!==l||d&&f&&p||(l=1,u=0,h=0,d=!0,f=!1,p=!1),!(r<l)&&(r>l?!d:!(a<u)&&(a>u?!f:!(c<h)&&(!(c>h)||!p))))}function c(e,t,i=[]){let r=o(s(t));if(!r)return i.push(n.localize(0,null,t)),!1;if(0===r.majorBase){if(!r.majorMustEqual||!r.minorMustEqual)return i.push(n.localize(1,null,t)),!1}else if(!r.majorMustEqual)return i.push(n.localize(2,null,t)),!1;return!!a(e,r)||(i.push(n.localize(3,null,e,t)),!1)}t.isValidVersionStr=r,t.parseVersion=s,t.normalizeVersion=o,t.isValidVersion=a,t.isValidExtensionVersion=function(e,t,n){return!(!t.isBuiltin&&void 0!==t.main)||c(e,t.engines.vscode,n)},t.isEngineValid=function(e,t){return"*"===e||c(t,e)},t.isVersionValid=c})),define(t[132],n([0,1,35,74,3,4]),(function(e,t,n,i,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0
;class o extends r.Disposable{constructor(e,t,n,i){super(),this.folders=e,this.onDidFilesChange=t,this.onLogMessage=n,this.verboseLogging=i,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const t=this._register(new i.Client(s.FileAccess.asFileUri("bootstrap-fork",e).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",PIPE_LOGGING:"true",VERBOSE_LOGGING:"true"}}));this._register(t.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=o.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=n.createChannelSender(n.getNextTickChannel(t.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(e=>!this.isDisposed&&this.onDidFilesChange(e))),
this._register(this.service.onDidLogMessage(e=>this.onLogMessage(e))),this.setFolders(this.folders)}setVerboseLogging(e){this.verboseLogging=e,!this.isDisposed&&this.service&&this.service.setVerboseLogging(e)}error(e){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${e}`})}setFolders(e){this.folders=e,this.service&&this.service.setRoots(e)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=o,o.MAX_RESTARTS=5})),define(t[133],n([0,1,35,74,3,4]),(function(e,t,n,i,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class o extends r.Disposable{constructor(e,t,n,i,r={}){super(),this.folders=e,this.onDidFilesChange=t,this.onLogMessage=n,this.verboseLogging=i,this.watcherOptions=r,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const t=this._register(new i.Client(s.FileAccess.asFileUri("bootstrap-fork",e).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{
AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",PIPE_LOGGING:"true",VERBOSE_LOGGING:"true"}}));this._register(t.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=o.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=n.createChannelSender(n.getNextTickChannel(t.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(e=>!this.isDisposed&&this.onDidFilesChange(e))),this._register(this.service.onDidLogMessage(e=>this.onLogMessage(e))),this.service.setRoots(this.folders)}error(e){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${e}`})}setVerboseLogging(e){this.verboseLogging=e,this.service&&this.service.setVerboseLogging(e)}setFolders(e){this.folders=e,
this.service&&this.service.setRoots(e)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=o,o.MAX_RESTARTS=5})),define(t[134],n([0,1,34,68,52,4]),(function(e,t,n,i,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class o{constructor(e,t,n,i,s){this.watchedFolder=e,this.eventCallback=n,this.logCallback=i,this.verboseLogging=s,this.restartCounter=0,Array.isArray(t)?this.ignored=t.map(e=>r.parse(e)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${e}`),this.startWatcher()}startWatcher(){const t=[this.watchedFolder];this.verboseLogging&&t.push("-verbose"),this.handle=n.spawn(s.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",e).fsPath,t);const r=new i.LineDecoder;this.handle.stdout.on("data",e=>{const t=[];r.write(e).forEach(e=>{const n=e.split("|");if(2===n.length){const e=Number(n[0]),i=n[1];if(e>=0&&e<3){if(this.ignored&&this.ignored.some(e=>e(i)))return void(this.verboseLogging&&this.log(i));t.push({
type:o.changeTypeMap[e],path:i})}else this.log(n[1])}}),t.length>0&&this.eventCallback(t)}),this.handle.on("error",e=>this.onError(e)),this.handle.stderr.on("data",e=>this.onError(e)),this.handle.on("exit",(e,t)=>this.onExit(e,t))}onError(e){this.error("process error: "+e.toString())}onExit(e,t){this.handle&&(this.error(`terminated unexpectedly (code: ${e}, signal: ${t})`),this.restartCounter<=o.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(e){this.logCallback({type:"error",message:`[File Watcher (C#)] ${e}`})}log(e){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${e}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=o,o.MAX_RESTARTS=5,o.changeTypeMap=[0,1,2]})),define(t[135],n([0,1,134,2,11]),(function(e,t,n,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.FileWatcher=void 0;t.FileWatcher=class{constructor(e,t,n,s){this.onDidFilesChange=t,this.onLogMessage=n,this.verboseLogging=s,this.service=void 0,this.folder=e[0],0===this.folder.path.indexOf("\\\\")&&this.folder.path.endsWith(i.posix.sep)&&(this.folder.path=r.rtrim(this.folder.path,i.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new n.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,e=>this.onFileEvents(e),e=>this.onLogMessage(e),this.verboseLogging)}setVerboseLogging(e){this.verboseLogging=e,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(e){this.isDisposed||e.length>0&&this.onDidFilesChange(e)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}})),define(t[44],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class n{constructor(e,t=[],n=!1){this.ctor=e,this.staticArguments=t,
this.supportsDelayedInstantiation=n}}t.SyncDescriptor=n;t.createSyncDescriptor=(e,...t)=>new n(e,t)})),define(t[136],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class n{constructor(e){this.incoming=new Map,this.outgoing=new Map,this.data=e}}t.Node=n;t.Graph=class{constructor(e){this._hashFn=e,this._nodes=new Map}roots(){const e=[];for(let t of this._nodes.values())0===t.outgoing.size&&e.push(t);return e}insertEdge(e,t){const n=this.lookupOrInsertNode(e),i=this.lookupOrInsertNode(t);n.outgoing.set(this._hashFn(t),i),i.incoming.set(this._hashFn(e),n)}removeNode(e){const t=this._hashFn(e);this._nodes.delete(t);for(let e of this._nodes.values())e.outgoing.delete(t),e.incoming.delete(t)}lookupOrInsertNode(e){const t=this._hashFn(e);let i=this._nodes.get(t);return i||(i=new n(e),this._nodes.set(t,i)),i}lookup(e){return this._nodes.get(this._hashFn(e))}isEmpty(){return 0===this._nodes.size}toString(){let e=[]
;for(let[t,n]of this._nodes)e.push(`${t}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return e.join("\n")}}})),define(t[8],n([0,1]),(function(e,t){"use strict";var n;function i(e,t,i,r){t[n.DI_TARGET]===t?t[n.DI_DEPENDENCIES].push({id:e,index:i,optional:r}):(t[n.DI_DEPENDENCIES]=[{id:e,index:i,optional:r}],t[n.DI_TARGET]=t)}function r(e){if(n.serviceIds.has(e))return n.serviceIds.get(e);const t=function(e,n,r){if(3!==arguments.length)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(t,e,r,!1)};return t.toString=()=>e,n.serviceIds.set(e,t),t}Object.defineProperty(t,"__esModule",{value:!0}),t.optional=t.createDecorator=t.IInstantiationService=t._util=void 0,function(e){e.serviceIds=new Map,e.DI_TARGET="$di$target",e.DI_DEPENDENCIES="$di$dependencies",e.getServiceDependencies=function(t){return t[e.DI_DEPENDENCIES]||[]}}(n=t._util||(t._util={})),t.IInstantiationService=r("instantiationService"),t.createDecorator=r,
t.optional=function(e){return function(t,n,r){if(3!==arguments.length)throw new Error("@optional-decorator can only be used to decorate a parameter");i(e,t,r,!0)}}})),define(t[137],n([0,1,11,8,6]),(function(e,t,n,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SET_CONTEXT_COMMAND_ID=t.IContextKeyService=t.RawContextKey=t.ContextKeyOrExpr=t.ContextKeyAndExpr=t.ContextKeyNotRegexExpr=t.ContextKeyRegexExpr=t.ContextKeyNotExpr=t.ContextKeyNotEqualsExpr=t.ContextKeyNotInExpr=t.ContextKeyInExpr=t.ContextKeyEqualsExpr=t.ContextKeyDefinedExpr=t.ContextKeyTrueExpr=t.ContextKeyFalseExpr=t.ContextKeyExpr=t.ContextKeyExprType=void 0;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",r.isMacintosh),s.set("isLinux",r.isLinux),s.set("isWindows",r.isWindows),s.set("isWeb",r.isWeb),s.set("isMacNative",r.isMacintosh&&!r.isWeb);const o=Object.prototype.hasOwnProperty;!function(e){e[e.False=0]="False",e[e.True=1]="True",e[e.Defined=2]="Defined",e[e.Not=3]="Not",e[e.Equals=4]="Equals",
e[e.NotEquals=5]="NotEquals",e[e.And=6]="And",e[e.Regex=7]="Regex",e[e.NotRegex=8]="NotRegex",e[e.Or=9]="Or",e[e.In=10]="In",e[e.NotIn=11]="NotIn"}(t.ContextKeyExprType||(t.ContextKeyExprType={}));class a{static false(){return l.INSTANCE}static true(){return u.INSTANCE}static has(e){return h.create(e)}static equals(e,t){return d.create(e,t)}static notEquals(e,t){return g.create(e,t)}static regex(e,t){return v.create(e,t)}static in(e,t){return f.create(e,t)}static not(e){return m.create(e)}static and(...e){return w.create(e)}static or(...e){return E.create(e)}static deserialize(e,t=!1){if(e)return this._deserializeOrExpression(e,t)}static _deserializeOrExpression(e,t){let n=e.split("||");return E.create(n.map(e=>this._deserializeAndExpression(e,t)))}static _deserializeAndExpression(e,t){let n=e.split("&&");return w.create(n.map(e=>this._deserializeOne(e,t)))}static _deserializeOne(e,t){if((e=e.trim()).indexOf("!=")>=0){let n=e.split("!=");return g.create(n[0].trim(),this._deserializeValue(n[1],t))}
if(e.indexOf("==")>=0){let n=e.split("==");return d.create(n[0].trim(),this._deserializeValue(n[1],t))}if(e.indexOf("=~")>=0){let n=e.split("=~");return v.create(n[0].trim(),this._deserializeRegexValue(n[1],t))}if(e.indexOf(" in ")>=0){let t=e.split(" in ");return f.create(t[0].trim(),t[1].trim())}return/^\!\s*/.test(e)?m.create(e.substr(1).trim()):h.create(e)}static _deserializeValue(e,t){if("true"===(e=e.trim()))return!0;if("false"===e)return!1;let n=/^'([^']*)'$/.exec(e);return n?n[1].trim():e}static _deserializeRegexValue(e,t){if(n.isFalsyOrWhitespace(e)){if(t)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let i=e.indexOf("/"),r=e.lastIndexOf("/");if(i===r||i<0){if(t)throw new Error(`bad regexp-value '${e}', missing /-enclosure`);return console.warn(`bad regexp-value '${e}', missing /-enclosure`),null}let s=e.slice(i+1,r),o="i"===e[r+1]?"i":"";try{return new RegExp(s,o)}catch(n){
if(t)throw new Error(`bad regexp-value '${e}', parse error: ${n}`);return console.warn(`bad regexp-value '${e}', parse error: ${n}`),null}}}function c(e,t){return e.cmp(t)}t.ContextKeyExpr=a;class l{constructor(){this.type=0}cmp(e){return this.type-e.type}equals(e){return e.type===this.type}evaluate(e){return!1}serialize(){return"false"}keys(){return[]}map(e){return this}negate(){return u.INSTANCE}}t.ContextKeyFalseExpr=l,l.INSTANCE=new l;class u{constructor(){this.type=1}cmp(e){return this.type-e.type}equals(e){return e.type===this.type}evaluate(e){return!0}serialize(){return"true"}keys(){return[]}map(e){return this}negate(){return l.INSTANCE}}t.ContextKeyTrueExpr=u,u.INSTANCE=new u;class h{constructor(e){this.key=e,this.type=2}static create(e){const t=s.get(e);return"boolean"==typeof t?t?u.INSTANCE:l.INSTANCE:new h(e)}cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:0}equals(e){return e.type===this.type&&this.key===e.key}evaluate(e){return!!e.getValue(this.key)}
serialize(){return this.key}keys(){return[this.key]}map(e){return e.mapDefined(this.key)}negate(){return m.create(this.key)}}t.ContextKeyDefinedExpr=h;class d{constructor(e,t){this.key=e,this.value=t,this.type=4}static create(e,t){if("boolean"==typeof t)return t?h.create(e):m.create(e);const n=s.get(e);if("boolean"==typeof n){return t===(n?"true":"false")?u.INSTANCE:l.INSTANCE}return new d(e,t)}cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:this.value<e.value?-1:this.value>e.value?1:0}equals(e){return e.type===this.type&&(this.key===e.key&&this.value===e.value)}evaluate(e){return e.getValue(this.key)==this.value}serialize(){return this.key+" == '"+this.value+"'"}keys(){return[this.key]}map(e){return e.mapEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}t.ContextKeyEqualsExpr=d;class f{constructor(e,t){this.key=e,this.valueKey=t,this.type=10}static create(e,t){return new f(e,t)}cmp(e){
return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:this.valueKey<e.valueKey?-1:this.valueKey>e.valueKey?1:0}equals(e){return e.type===this.type&&(this.key===e.key&&this.valueKey===e.valueKey)}evaluate(e){const t=e.getValue(this.valueKey),n=e.getValue(this.key);return Array.isArray(t)?t.indexOf(n)>=0:"string"==typeof n&&"object"==typeof t&&null!==t&&o.call(t,n)}serialize(){return this.key+" in '"+this.valueKey+"'"}keys(){return[this.key,this.valueKey]}map(e){return e.mapIn(this.key,this.valueKey)}negate(){return p.create(this)}}t.ContextKeyInExpr=f;class p{constructor(e){this._actual=e,this.type=11}static create(e){return new p(e)}cmp(e){return e.type!==this.type?this.type-e.type:this._actual.cmp(e._actual)}equals(e){return e.type===this.type&&this._actual.equals(e._actual)}evaluate(e){return!this._actual.evaluate(e)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(e){return new p(this._actual.map(e))}negate(){return this._actual}}
t.ContextKeyNotInExpr=p;class g{constructor(e,t){this.key=e,this.value=t,this.type=5}static create(e,t){if("boolean"==typeof t)return t?m.create(e):h.create(e);const n=s.get(e);if("boolean"==typeof n){return t===(n?"true":"false")?l.INSTANCE:u.INSTANCE}return new g(e,t)}cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:this.value<e.value?-1:this.value>e.value?1:0}equals(e){return e.type===this.type&&(this.key===e.key&&this.value===e.value)}evaluate(e){return e.getValue(this.key)!=this.value}serialize(){return this.key+" != '"+this.value+"'"}keys(){return[this.key]}map(e){return e.mapNotEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}t.ContextKeyNotEqualsExpr=g;class m{constructor(e){this.key=e,this.type=3}static create(e){const t=s.get(e);return"boolean"==typeof t?t?l.INSTANCE:u.INSTANCE:new m(e)}cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:0}equals(e){return e.type===this.type&&this.key===e.key}evaluate(e){
return!e.getValue(this.key)}serialize(){return"!"+this.key}keys(){return[this.key]}map(e){return e.mapNot(this.key)}negate(){return h.create(this.key)}}t.ContextKeyNotExpr=m;class v{constructor(e,t){this.key=e,this.regexp=t,this.type=7}static create(e,t){return new v(e,t)}cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.key<e.key)return-1;if(this.key>e.key)return 1;const t=this.regexp?this.regexp.source:"",n=e.regexp?e.regexp.source:"";return t<n?-1:t>n?1:0}equals(e){if(e.type===this.type){const t=this.regexp?this.regexp.source:"",n=e.regexp?e.regexp.source:"";return this.key===e.key&&t===n}return!1}evaluate(e){let t=e.getValue(this.key);return!!this.regexp&&this.regexp.test(t)}serialize(){const e=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${e}`}keys(){return[this.key]}map(e){return e.mapRegex(this.key,this.regexp)}negate(){return y.create(this)}}t.ContextKeyRegexExpr=v;class y{constructor(e){this._actual=e,this.type=8}static create(e){
return new y(e)}cmp(e){return e.type!==this.type?this.type-e.type:this._actual.cmp(e._actual)}equals(e){return e.type===this.type&&this._actual.equals(e._actual)}evaluate(e){return!this._actual.evaluate(e)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(e){return new y(this._actual.map(e))}negate(){return this._actual}}t.ContextKeyNotRegexExpr=y;class w{constructor(e){this.expr=e,this.type=6}static create(e){return w._normalizeArr(e)}cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.expr.length<e.expr.length)return-1;if(this.expr.length>e.expr.length)return 1;for(let t=0,n=this.expr.length;t<n;t++){const n=c(this.expr[t],e.expr[t]);if(0!==n)return n}return 0}equals(e){if(e.type===this.type){if(this.expr.length!==e.expr.length)return!1;for(let t=0,n=this.expr.length;t<n;t++)if(!this.expr[t].equals(e.expr[t]))return!1;return!0}return!1}evaluate(e){for(let t=0,n=this.expr.length;t<n;t++)if(!this.expr[t].evaluate(e))return!1;return!0}static _normalizeArr(e){
const t=[];let n=!1;for(const i of e)if(i)if(1!==i.type){if(0===i.type)return l.INSTANCE;6!==i.type?t.push(i):t.push(...i.expr)}else n=!0;if(0===t.length&&n)return u.INSTANCE;if(0!==t.length){if(1===t.length)return t[0];for(t.sort(c);t.length>1;){const e=t[t.length-1];if(9!==e.type)break;t.pop();const n=t.pop(),i=E.create(e.expr.map(e=>w.create([e,n])));i&&(t.push(i),t.sort(c))}return 1===t.length?t[0]:new w(t)}}serialize(){return this.expr.map(e=>e.serialize()).join(" && ")}keys(){const e=[];for(let t of this.expr)e.push(...t.keys());return e}map(e){return new w(this.expr.map(t=>t.map(e)))}negate(){let e=[];for(let t of this.expr)e.push(t.negate());return E.create(e)}}t.ContextKeyAndExpr=w;class E{constructor(e){this.expr=e,this.type=9}static create(e){const t=E._normalizeArr(e);if(0!==t.length)return 1===t.length?t[0]:new E(t)}cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.expr.length<e.expr.length)return-1;if(this.expr.length>e.expr.length)return 1;for(let t=0,n=this.expr.length;t<n;t++){
const n=c(this.expr[t],e.expr[t]);if(0!==n)return n}return 0}equals(e){if(e.type===this.type){if(this.expr.length!==e.expr.length)return!1;for(let t=0,n=this.expr.length;t<n;t++)if(!this.expr[t].equals(e.expr[t]))return!1;return!0}return!1}evaluate(e){for(let t=0,n=this.expr.length;t<n;t++)if(this.expr[t].evaluate(e))return!0;return!1}static _normalizeArr(e){let t=[],n=!1;if(e){for(let i=0,r=e.length;i<r;i++){const r=e[i];if(r)if(0!==r.type){if(1===r.type)return[u.INSTANCE];9!==r.type?t.push(r):t=t.concat(r.expr)}else n=!0}if(0===t.length&&n)return[l.INSTANCE];t.sort(c)}return t}serialize(){return this.expr.map(e=>e.serialize()).join(" || ")}keys(){const e=[];for(let t of this.expr)e.push(...t.keys());return e}map(e){return new E(this.expr.map(t=>t.map(e)))}negate(){let e=[];for(let t of this.expr)e.push(t.negate());const t=e=>9===e.type?e.expr:[e];for(;e.length>1;){const n=e.shift(),i=e.shift(),r=[];for(const e of t(n))for(const n of t(i))r.push(a.and(e,n));e.unshift(a.or(...r))}return e[0]}}
t.ContextKeyOrExpr=E;t.RawContextKey=class extends h{constructor(e,t){super(e),this._defaultValue=t}bindTo(e){return e.createKey(this.key,this._defaultValue)}getValue(e){return e.getContextKeyValue(this.key)}toNegated(){return a.not(this.key)}isEqualTo(e){return a.equals(this.key,e)}notEqualsTo(e){return a.notEquals(this.key,e)}},t.IContextKeyService=i.createDecorator("contextKeyService"),t.SET_CONTEXT_COMMAND_ID="setContext"})),define(t[75],n([0,1,8]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=n.createDecorator("downloadService")})),define(t[23],n([0,1,8]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=n.createDecorator("environmentService"),t.INativeEnvironmentService=n.createDecorator("nativeEnvironmentService")})),define(t[28],n([0,1,113,8,4]),(function(e,t,n,i,r){"use strict";Object.defineProperty(t,"__esModule",{
value:!0}),t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.isIExtensionIdentifier=function(e){return e&&"object"==typeof e&&"string"==typeof e.id&&(!e.uuid||"string"==typeof e.uuid)},function(e){e[e.NoneOrRelevance=0]="NoneOrRelevance",e[e.LastUpdatedDate=1]="LastUpdatedDate",e[e.Title=2]="Title",
e[e.PublisherName=3]="PublisherName",e[e.InstallCount=4]="InstallCount",e[e.PublishedDate=5]="PublishedDate",e[e.AverageRating=6]="AverageRating",e[e.WeightedRating=12]="WeightedRating"}(t.SortBy||(t.SortBy={})),function(e){e[e.Default=0]="Default",e[e.Ascending=1]="Ascending",e[e.Descending=2]="Descending"}(t.SortOrder||(t.SortOrder={})),function(e){e.Uninstall="uninstall"}(t.StatisticType||(t.StatisticType={})),function(e){e[e.None=0]="None",e[e.Install=1]="Install",e[e.Update=2]="Update"}(t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=i.createDecorator("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class s extends Error{constructor(e,t){super(e),this.code=t}}t.ExtensionManagementError=s,t.IExtensionManagementService=i.createDecorator("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",
t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=i.createDecorator("IGlobalExtensionEnablementService"),t.IExtensionTipsService=i.createDecorator("IExtensionTipsService"),t.DefaultIconPath=r.FileAccess.asBrowserUri("./media/defaultIcon.png",e).toString(!0),t.ExtensionsLabel=n.localize(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=n.localize(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"}})),define(t[37],n([0,1,11,8]),(function(e,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",
t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.isIExtensionIdentifier=function(e){return e&&"object"==typeof e&&"string"==typeof e.id&&(!e.uuid||"string"==typeof e.uuid)},t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Themes","Testing","Visualization","Other"],function(e){e[e.System=0]="System",e[e.User=1]="User"}(t.ExtensionType||(t.ExtensionType={}));t.ExtensionIdentifier=class{constructor(e){this.value=e,this._lower=e.toLowerCase()}static equals(e,t){if(null==e)return null==t;if(null==t)return!1;if("string"==typeof e||"string"==typeof t){let i="string"==typeof e?e:e.value,r="string"==typeof t?t:t.value;return n.equalsIgnoreCase(i,r)}return e._lower===t._lower}static toKey(e){return"string"==typeof e?e.toLowerCase():e._lower}},t.isLanguagePackExtension=function(e){
return!(!e.contributes||!e.contributes.localizations)&&e.contributes.localizations.length>0},t.isAuthenticaionProviderExtension=function(e){return!(!e.contributes||!e.contributes.authentication)&&e.contributes.authentication.length>0},t.IBuiltinExtensionsScannerService=i.createDecorator("IBuiltinExtensionsScannerService")})),define(t[31],n([0,1,11,37]),(function(e,t,n,i){"use strict";function r(e,t){return e.uuid&&t.uuid?e.uuid===t.uuid:e.id===t.id||0===n.compareIgnoreCase(e.id,t.id)}Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0,t.areSameExtensions=r;class s{constructor(e,t){this.identifier=e,this.version=t}key(){return`${this.identifier.id}-${this.version}`}equals(e){return e instanceof s&&(r(this.identifier,e.identifier)&&this.version===e.version)}}
t.ExtensionIdentifierWithVersion=s,t.adoptToGalleryExtensionId=function(e){return e.toLocaleLowerCase()},t.getGalleryExtensionId=function(e,t){return`${e.toLocaleLowerCase()}.${t.toLocaleLowerCase()}`},t.groupByExtension=function(e,t){const n=[],i=e=>{for(const i of n)if(i.some(n=>r(t(n),t(e))))return i;return null};for(const t of e){const e=i(t);e?e.push(t):n.push([t])}return n},t.getLocalExtensionTelemetryData=function(e){return{id:e.identifier.id,name:e.manifest.name,galleryId:null,publisherId:e.publisherId,publisherName:e.manifest.publisher,publisherDisplayName:e.publisherDisplayName,dependencies:e.manifest.extensionDependencies&&e.manifest.extensionDependencies.length>0}},t.getGalleryExtensionTelemetryData=function(e){return Object.assign({id:e.identifier.id,name:e.name,galleryId:e.identifier.uuid,publisherId:e.publisherId,publisherName:e.publisher,publisherDisplayName:e.publisherDisplayName,dependencies:!!(e.properties.dependencies&&e.properties.dependencies.length>0)},e.telemetryData)},
t.BetterMergeId=new i.ExtensionIdentifier("pprice.better-merge"),t.getMaliciousExtensionsSet=function(e){const t=new Set;for(const n of e)n.malicious&&t.add(n.id.id);return t}})),define(t[138],n([0,1,3,2,37,14]),(function(e,t,n,i,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class o extends n.Disposable{constructor(e,t){super(),this.environmentService=e,this.extensionsManifestCache=i.join(this.environmentService.userDataPath,r.MANIFEST_CACHE_FOLDER,r.USER_MANIFEST_CACHE_FILE),this._register(t.onDidInstallExtension(e=>this.onDidInstallExtension(e))),this._register(t.onDidUninstallExtension(e=>this.onDidUnInstallExtension(e)))}onDidInstallExtension(e){e.error||this.invalidate()}onDidUnInstallExtension(e){e.error||this.invalidate()}invalidate(){s.rimraf(this.extensionsManifestCache,s.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=o})),define(t[25],n([0,1,119,2,7,8,11,12]),(function(e,t,n,i,r,s,o,a){"use strict";var c
;Object.defineProperty(t,"__esModule",{value:!0}),t.BinarySize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FileType=t.IFileService=void 0,t.IFileService=s.createDecorator("fileService"),function(e){e[e.Unknown=0]="Unknown",e[e.File=1]="File",e[e.Directory=2]="Directory",e[e.SymbolicLink=64]="SymbolicLink"}(t.FileType||(t.FileType={})),function(e){
e[e.FileReadWrite=2]="FileReadWrite",e[e.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",e[e.FileReadStream=16]="FileReadStream",e[e.FileFolderCopy=8]="FileFolderCopy",e[e.PathCaseSensitive=1024]="PathCaseSensitive",e[e.Readonly=2048]="Readonly",e[e.Trash=4096]="Trash"}(t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={})),t.hasReadWriteCapability=function(e){return!!(2&e.capabilities)},t.hasFileFolderCopyCapability=function(e){return!!(8&e.capabilities)},t.hasOpenReadWriteCloseCapability=function(e){return!!(4&e.capabilities)},t.hasFileReadStreamCapability=function(e){return!!(16&e.capabilities)},function(e){e.FileExists="EntryExists",e.FileNotFound="EntryNotFound",e.FileNotADirectory="EntryNotADirectory",e.FileIsADirectory="EntryIsADirectory",e.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",e.FileTooLarge="EntryTooLarge",e.NoPermissions="NoPermissions",e.Unavailable="Unavailable",e.Unknown="Unknown"}(c=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}))
;class l extends Error{constructor(e,t){super(e),this.code=t}}function u(e,t){const n=new l(e.toString(),t);return h(n,t),n}function h(e,t){return e.name=t?`${t} (FileSystemError)`:"FileSystemError",e}function d(e){if(!e)return c.Unknown;if(e instanceof l)return e.code;const t=/^(.+) \(FileSystemError\)$/.exec(e.name);if(!t)return c.Unknown;switch(t[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileExceedsMemoryLimit:return c.FileExceedsMemoryLimit;case c.FileTooLarge:return c.FileTooLarge;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}t.FileSystemProviderError=l,t.createFileSystemProviderError=u,t.ensureFileSystemProviderError=function(e){return e||u(n.localize(0,null),c.Unknown)},t.markAsFileSystemProviderError=h,t.toFileSystemProviderErrorCode=d,t.toFileOperationResult=function(e){
if(e instanceof p)return e.fileOperationResult;switch(d(e)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 10;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileExceedsMemoryLimit:return 9;case c.FileTooLarge:return 7;default:return 11}},function(e){e[e.CREATE=0]="CREATE",e[e.DELETE=1]="DELETE",e[e.MOVE=2]="MOVE",e[e.COPY=3]="COPY"}(t.FileOperation||(t.FileOperation={}));t.FileOperationEvent=class{constructor(e,t,n){this.resource=e,this.operation=t,this.target=n}isOperation(e){return this.operation===e}},function(e){e[e.UPDATED=0]="UPDATED",e[e.ADDED=1]="ADDED",e[e.DELETED=2]="DELETED"}(t.FileChangeType||(t.FileChangeType={}));class f{constructor(e,t){this.changes=e,this.extUri=t}contains(e,t){if(!e)return!1;const n=!a.isUndefinedOrNull(t);return this.changes.some(i=>(!n||i.type===t)&&(2===i.type?this.extUri.isEqualOrParent(e,i.resource):this.extUri.isEqual(e,i.resource)))}getAdded(){return this.getOfType(1)}gotAdded(){return this.hasType(1)}
getDeleted(){return this.getOfType(2)}gotDeleted(){return this.hasType(2)}getUpdated(){return this.getOfType(0)}gotUpdated(){return this.hasType(0)}getOfType(e){return this.changes.filter(t=>t.type===e)}hasType(e){return this.changes.some(t=>t.type===e)}filter(e){return new f(this.changes.filter(t=>e(t)),this.extUri)}}t.FileChangesEvent=f,t.isParent=function(e,t,n){return!(!e||!t||e===t)&&(!(t.length>e.length)&&(t.charAt(t.length-1)!==i.sep&&(t+=i.sep),n?o.startsWithIgnoreCase(e,t):0===e.indexOf(t)))};class p extends Error{constructor(e,t,n){super(e),this.fileOperationResult=t,this.options=n}static isFileOperationError(e){return e instanceof Error&&!a.isUndefinedOrNull(e.fileOperationResult)}}t.FileOperationError=p,function(e){e[e.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",e[e.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",e[e.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",e[e.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",e[e.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",e[e.FILE_READ_ONLY=5]="FILE_READ_ONLY",
e[e.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",e[e.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",e[e.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",e[e.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",e[e.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",e[e.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"}(t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude",function(e){e[e.FILE=0]="FILE",e[e.FOLDER=1]="FOLDER",e[e.ROOT_FOLDER=2]="ROOT_FOLDER"}(t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="",t.etag=function(e){if("number"==typeof e.size&&"number"==typeof e.mtime)return e.mtime.toString(29)+e.size.toString(31)},t.whenProviderRegistered=function(e,t){return t.canHandleResource(r.URI.from({scheme:e.scheme
}))?Promise.resolve():new Promise((n,i)=>{const r=t.onDidChangeFileSystemProviderRegistrations(t=>{t.scheme===e.scheme&&t.added&&(r.dispose(),n())})})},t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class g{static formatSize(e){return e<g.KB?n.localize(1,null,e):e<g.MB?n.localize(2,null,(e/g.KB).toFixed(2)):e<g.GB?n.localize(3,null,(e/g.MB).toFixed(2)):e<g.TB?n.localize(4,null,(e/g.GB).toFixed(2)):n.localize(5,null,(e/g.TB).toFixed(2))}}t.BinarySize=g,g.KB=1024,g.MB=g.KB*g.KB,g.GB=g.MB*g.KB,g.TB=g.GB*g.KB})),define(t[76],n([0,1,120,17,25,16]),(function(e,t,n,i,r,s){"use strict";function o(e){if(e.isCancellationRequested)throw s.canceled();return!0}function a(e,t){if(null==t?void 0:t.limits){if("number"==typeof t.limits.memory&&e>t.limits.memory)throw r.createFileSystemProviderError(n.localize(0,null),r.FileSystemProviderErrorCode.FileExceedsMemoryLimit)
;if("number"==typeof t.limits.size&&e>t.limits.size)throw r.createFileSystemProviderError(n.localize(1,null),r.FileSystemProviderErrorCode.FileTooLarge)}return!0}Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0,t.readFileIntoStream=async function(e,t,n,s,c,l){let u=void 0;try{await async function(e,t,n,s,c,l){o(l);const u=await e.open(t,{create:!1});o(l);try{let t=0,r=0,h=c&&"number"==typeof c.length?c.length:void 0,d=i.VSBuffer.alloc(Math.min(c.bufferSize,"number"==typeof h?h:c.bufferSize)),f=c&&"number"==typeof c.position?c.position:0,p=0;do{r=await e.read(u,f,d.buffer,p,d.byteLength-p),f+=r,t+=r,"number"==typeof h&&(h-=r),(p+=r)===d.byteLength&&(await n.write(s(d)),d=i.VSBuffer.alloc(Math.min(c.bufferSize,"number"==typeof h?h:c.bufferSize)),p=0)}while(r>0&&("number"!=typeof h||h>0)&&o(l)&&a(t,c));if(p>0){let e=p;"number"==typeof h&&(e=Math.min(p,h)),n.write(s(d.slice(0,e)))}}catch(e){throw r.ensureFileSystemProviderError(e)}finally{await e.close(u)}}(e,t,n,s,c,l)}catch(e){u=e
}finally{u&&c.errorTransformer&&(u=c.errorTransformer(u)),n.end(u)}}})),define(t[77],n([0,1,7,25,6]),(function(e,t,n,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0,t.toFileChanges=function(e){return e.map(e=>({type:e.type,resource:n.URI.file(e.path)}))},t.normalizeFileChanges=function(e){const t=new s;for(const n of e)t.processEvent(n);return t.normalize()};class s{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(e){const t=this.mapPathToChange.get(e.path);if(t){const n=t.type,i=e.type;1===n&&2===i?(this.mapPathToChange.delete(e.path),this.normalized.splice(this.normalized.indexOf(t),1)):2===n&&1===i?t.type=0:1===n&&0===i||(t.type=i)}else this.normalized.push(e),this.mapPathToChange.set(e.path,e)}normalize(){const e=[],t=[];return this.normalized.filter(t=>2===t.type||(e.push(t),!1)).sort((e,t)=>e.path.length-t.path.length).filter(e=>!t.some(t=>i.isParent(e.path,t,!r.isLinux))&&(t.push(e.path),!0)).concat(e)}}})),
define(t[139],n([0,1,77,3,14,98,100,15,2]),(function(e,t,n,i,r,s,o,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class l extends i.Disposable{constructor(e,t,n,i){super(),this.path=e,this.onDidFilesChange=t,this.onLogMessage=n,this.verboseLogging=i,this.fileChangesDelayer=this._register(new a.ThrottledDelayer(2*o.CHANGE_BUFFER_DELAY)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(e){this.verboseLogging=e}async startWatching(){try{const{stat:e,symbolicLink:t}=await r.statLink(this.path);if(this.isDisposed)return;let n=this.path;if(t)try{n=await s.realpath(n)}catch(e){this.onError(e)}e.isDirectory()?this._register(o.watchFolder(n,(e,t)=>{this.onFileChange({type:"changed"===e?0:"added"===e?1:2,path:c.join(this.path,c.basename(t))})},e=>this.onError(e))):this._register(o.watchFile(n,e=>{this.onFileChange({type:"changed"===e?0:2,path:this.path})},e=>this.onError(e)))}catch(e){this.onError(e)}}onFileChange(e){this.fileChangesBuffer.push(e),
this.verboseLogging&&this.onVerbose(`${1===e.type?"[ADDED]":2===e.type?"[DELETED]":"[CHANGED]"} ${e.path}`),this.fileChangesDelayer.trigger(async()=>{const e=this.fileChangesBuffer;this.fileChangesBuffer=[];const t=n.normalizeFileChanges(e);this.verboseLogging&&t.forEach(e=>{this.onVerbose(`>> normalized ${1===e.type?"[ADDED]":2===e.type?"[DELETED]":"[CHANGED]"} ${e.path}`)}),t.length>0&&this.onDidFilesChange(t)})}onError(e){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${e}`})}onVerbose(e){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${e}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=l})),define(t[45],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;t.ServiceCollection=class{constructor(...e){this._entries=new Map;for(let[t,n]of e)this.set(t,n)}set(e,t){const n=this._entries.get(e);return this._entries.set(e,t),n}has(e){return this._entries.has(e)}get(e){
return this._entries.get(e)}}})),define(t[55],n([0,1,16,136,44,8,45,15]),(function(e,t,n,i,r,s,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class l extends Error{constructor(e){super("cyclic dependency between services"),this.message=e.toString()}}class u{constructor(e=new o.ServiceCollection,t=!1,n){this._services=e,this._strict=t,this._parent=n,this._services.set(s.IInstantiationService,this)}createChild(e){return new u(e,this._strict,this)}invokeFunction(e,...t){let i=d.traceInvocation(e),r=!1;try{return e({get:(e,t)=>{if(r)throw n.illegalState("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(e,i);if(!o&&t!==s.optional)throw new Error(`[invokeFunction] unknown service '${e}'`);return o}},...t)}finally{r=!0,i.stop()}}createInstance(e,...t){let n,i;return e instanceof r.SyncDescriptor?(n=d.traceCreation(e.ctor),
i=this._createInstance(e.ctor,e.staticArguments.concat(t),n)):(n=d.traceCreation(e),i=this._createInstance(e,t,n)),n.stop(),i}_createInstance(e,t=[],n){let i=s._util.getServiceDependencies(e).sort((e,t)=>e.index-t.index),r=[];for(const t of i){let i=this._getOrCreateServiceInstance(t.id,n);if(!i&&this._strict&&!t.optional)throw new Error(`[createInstance] ${e.name} depends on UNKNOWN service ${t.id}.`);r.push(i)}let o=i.length>0?i[0].index:t.length;if(t.length!==o){console.warn(`[createInstance] First service dependency of ${e.name} at position ${o+1} conflicts with ${t.length} static arguments`);let n=o-t.length;t=n>0?t.concat(new Array(n)):t.slice(0,o)}return new e(...[...t,...r])}_setServiceInstance(e,t){if(this._services.get(e)instanceof r.SyncDescriptor)this._services.set(e,t);else{if(!this._parent)throw new Error("illegalState - setting UNKNOWN service instance");this._parent._setServiceInstance(e,t)}}_getServiceInstanceOrDescriptor(e){let t=this._services.get(e)
;return!t&&this._parent?this._parent._getServiceInstanceOrDescriptor(e):t}_getOrCreateServiceInstance(e,t){let n=this._getServiceInstanceOrDescriptor(e);return n instanceof r.SyncDescriptor?this._createAndCacheServiceInstance(e,n,t.branch(e,!0)):(t.branch(e,!1),n)}_createAndCacheServiceInstance(e,t,n){const o=new i.Graph(e=>e.id.toString());let a=0;const c=[{id:e,desc:t,_trace:n}];for(;c.length;){const t=c.pop();if(o.lookupOrInsertNode(t),a++>1e3)throw new l(o);for(let n of s._util.getServiceDependencies(t.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(n.id);if(i||n.optional||console.warn(`[createInstance] ${e} depends on ${n.id} which is NOT registered.`),i instanceof r.SyncDescriptor){const e={id:n.id,desc:i,_trace:t._trace.branch(n.id,!0)};o.insertEdge(t,e),c.push(e)}}}for(;;){const e=o.roots();if(0===e.length){if(!o.isEmpty())throw new l(o);break}for(const{data:t}of e){if(this._getServiceInstanceOrDescriptor(t.id)instanceof r.SyncDescriptor){
const e=this._createServiceInstanceWithOwner(t.id,t.desc.ctor,t.desc.staticArguments,t.desc.supportsDelayedInstantiation,t._trace);this._setServiceInstance(t.id,e)}o.removeNode(t)}}return this._getServiceInstanceOrDescriptor(e)}_createServiceInstanceWithOwner(e,t,n=[],i,s){if(this._services.get(e)instanceof r.SyncDescriptor)return this._createServiceInstance(t,n,i,s);if(this._parent)return this._parent._createServiceInstanceWithOwner(e,t,n,i,s);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}_createServiceInstance(e,t=[],n,i){if(n){const n=new a.IdleValue(()=>this._createInstance(e,t,i));return new Proxy(Object.create(null),{get(e,t){if(t in e)return e[t];let i=n.value,r=i[t];return"function"!=typeof r?r:(r=r.bind(i),e[t]=r,r)},set:(e,t,i)=>(n.value[t]=i,!0)})}return this._createInstance(e,t,i)}}var h;t.InstantiationService=u,function(e){e[e.Creation=0]="Creation",e[e.Invocation=1]="Invocation",e[e.Branch=2]="Branch"}(h||(h={}));class d{constructor(e,t){this.type=e,this.name=t,
this._start=Date.now(),this._dep=[]}static traceInvocation(e){return c?new d(1,e.name||e.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(e){return c?new d(0,e.name):d._None}branch(e,t){let n=new d(2,e.toString());return this._dep.push([e,t,n]),n}stop(){let e=Date.now()-this._start;d._totals+=e;let t=!1;let n=[`${0===this.type?"CREATE":"CALL"} ${this.name}`,`${function e(n,i){let r=[],s=new Array(n+1).join("\t");for(const[o,a,c]of i._dep)if(a&&c){t=!0,r.push(`${s}CREATES -> ${o}`);let i=e(n+1,c);i&&r.push(i)}else r.push(`${s}uses -> ${o}`);return r.join("\n")}(1,this)}`,`DONE, took ${e.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(e>2||t)&&console.log(n.join("\n"))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0})),define(t[78],n([0,1,8]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,
t.ILocalizationsService=n.createDecorator("localizationsService"),t.isValidLocalization=function(e){if("string"!=typeof e.languageId)return!1;if(!Array.isArray(e.translations)||0===e.translations.length)return!1;for(const t of e.translations){if("string"!=typeof t.id)return!1;if("string"!=typeof t.path)return!1}return(!e.languageName||"string"==typeof e.languageName)&&(!e.localizedLanguageName||"string"==typeof e.localizedLanguageName)}})),define(t[13],n([0,1,8,3,6,5,43]),(function(e,t,n,i,r,s,o){"use strict";function a(){return(new Date).toISOString()}var c;Object.defineProperty(t,"__esModule",{value:!0}),t.getLogLevel=t.NullLogService=t.DelegatedLogService=t.MultiplexLogService=t.ConsoleLogInMainService=t.LogServiceAdapter=t.ConsoleLogService=t.ConsoleLogMainService=t.AbstractLogService=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=n.createDecorator("logService"),t.ILoggerService=n.createDecorator("loggerService"),function(e){e[e.Trace=0]="Trace",e[e.Debug=1]="Debug",
e[e.Info=2]="Info",e[e.Warning=3]="Warning",e[e.Error=4]="Error",e[e.Critical=5]="Critical",e[e.Off=6]="Off"}(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;class l extends i.Disposable{constructor(){super(...arguments),this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new s.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogService=l;t.ConsoleLogMainService=class extends l{constructor(e=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(e),this.useColors=!r.isWindows}trace(e,...t){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}debug(e,...t){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}info(e,...t){
this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}warn(e,...t){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${a()}][0m`,e,...t):console.warn(`[main ${a()}]`,e,...t))}error(e,...t){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${a()}][0m`,e,...t):console.error(`[main ${a()}]`,e,...t))}critical(e,...t){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${a()}][0m`,e,...t):console.error(`[main ${a()}]`,e,...t))}dispose(){}flush(){}};t.ConsoleLogService=class extends l{constructor(e=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(e)}trace(e,...t){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...t)}debug(e,...t){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...t)}info(e,...t){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...t)}warn(e,...t){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...t)
}error(e,...t){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...t)}critical(e,...t){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...t)}dispose(){}flush(){}};class u extends l{constructor(e,n=t.DEFAULT_LOG_LEVEL){super(),this.adapter=e,this.setLevel(n)}trace(e,...t){this.getLevel()<=c.Trace&&this.adapter.consoleLog("trace",[this.extractMessage(e),...t])}debug(e,...t){this.getLevel()<=c.Debug&&this.adapter.consoleLog("debug",[this.extractMessage(e),...t])}info(e,...t){this.getLevel()<=c.Info&&this.adapter.consoleLog("info",[this.extractMessage(e),...t])}warn(e,...t){this.getLevel()<=c.Warning&&this.adapter.consoleLog("warn",[this.extractMessage(e),...t])}error(e,...t){this.getLevel()<=c.Error&&this.adapter.consoleLog("error",[this.extractMessage(e),...t])}critical(e,...t){this.getLevel()<=c.Critical&&this.adapter.consoleLog("critical",[this.extractMessage(e),...t])}extractMessage(e){return"string"==typeof e?e:o.toErrorMessage(e,this.getLevel()<=c.Trace)
}dispose(){}flush(){}}t.LogServiceAdapter=u;t.ConsoleLogInMainService=class extends u{constructor(e,n=t.DEFAULT_LOG_LEVEL){super({consoleLog:(t,n)=>e.consoleLog(t,n)},n)}};t.MultiplexLogService=class extends l{constructor(e){super(),this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const t of this.logServices)t.setLevel(e);super.setLevel(e)}trace(e,...t){for(const n of this.logServices)n.trace(e,...t)}debug(e,...t){for(const n of this.logServices)n.debug(e,...t)}info(e,...t){for(const n of this.logServices)n.info(e,...t)}warn(e,...t){for(const n of this.logServices)n.warn(e,...t)}error(e,...t){for(const n of this.logServices)n.error(e,...t)}critical(e,...t){for(const n of this.logServices)n.critical(e,...t)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}};class h extends i.Disposable{constructor(e){super(),this.logService=e,this._register(e)}get onDidChangeLogLevel(){return this.logService.onDidChangeLogLevel}setLevel(e){
this.logService.setLevel(e)}getLevel(){return this.logService.getLevel()}trace(e,...t){this.logService.trace(e,...t)}debug(e,...t){this.logService.debug(e,...t)}info(e,...t){this.logService.info(e,...t)}warn(e,...t){this.logService.warn(e,...t)}error(e,...t){this.logService.error(e,...t)}critical(e,...t){this.logService.critical(e,...t)}flush(){this.logService.flush()}}t.DelegatedLogService=h;t.NullLogService=class{constructor(){this.onDidChangeLogLevel=(new s.Emitter).event}setLevel(e){}getLevel(){return c.Info}trace(e,...t){}debug(e,...t){}info(e,...t){}warn(e,...t){}error(e,...t){}critical(e,...t){}dispose(){}flush(){}},t.getLogLevel=function(e){if(e.verbose)return c.Trace;if("string"==typeof e.logLevel){switch(e.logLevel.toLowerCase()){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}return t.DEFAULT_LOG_LEVEL}}));var s=this&&this.__decorate||function(e,t,n,i){
var r,s=arguments.length,o=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)o=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(r=e[a])&&(o=(s<3?r(o):s>3?r(t,n,o):r(t,n))||o);return s>3&&o&&Object.defineProperty(t,n,o),o},o=this&&this.__param||function(e,t){return function(n,i){t(n,i,e)}};define(t[140],n([0,1,3,25,28,23,7,22,31,13,20,56]),(function(e,t,n,i,r,a,c,l,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let g=class extends n.Disposable{constructor(e,t,n,i){super(),this.fileService=t,this.extensionGalleryService=n,this.logService=i,this.extensionsDownloadDir=c.URI.file(e.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(e,t){await this.cleanUpPromise;const n=l.joinPath(this.extensionsDownloadDir,this.getName(e));return await this.download(e,n,t),n}async delete(e){}
async download(e,t,n){await this.fileService.exists(t)||await this.extensionGalleryService.download(e,t,n)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir))return void this.logService.trace("Extension VSIX downlads cache dir does not exist");const e=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(e.children){const t=[],n=[];for(const t of e.children){const e=this.parse(t.name);e&&n.push([e,t])}const i=u.groupByExtension(n,([e])=>e.identifier),r=[];for(const e of i)e.sort((e,t)=>f.rcompare(e[0].version,t[0].version)),t.push(...e.slice(1).map(e=>e[1].resource)),r.push(e[0][1]);r.sort((e,t)=>e.mtime-t.mtime),t.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(e=>e.resource)),await Promise.all(t.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(e){this.logService.error(e)}}getName(e){
return this.cache?new u.ExtensionIdentifierWithVersion(e.identifier,e.version).key().toLowerCase():d.generateUuid()}parse(e){const t=p.exec(e);return t&&t[1]&&t[2]?new u.ExtensionIdentifierWithVersion({id:t[1]},t[2]):null}};g=s([o(0,a.INativeEnvironmentService),o(1,i.IFileService),o(2,r.IExtensionGalleryService),o(3,h.ILogService)],g),t.ExtensionsDownloader=g})),define(t[141],n([0,1,3,13,34,43,2,15,5,4,14,23]),(function(e,t,n,i,r,a,c,l,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let p=class extends n.Disposable{constructor(e,t){super(),this.environmentService=e,this.logService=t,this.processesLimiter=new l.Limiter(5)}async postUninstall(e){const t=this.parseScript(e,"uninstall");return t&&(this.logService.info(e.identifier.id,e.manifest.version,"Running post uninstall script"),
await this.processesLimiter.queue(()=>this.runLifecycleHook(t.script,"uninstall",t.args,!0,e).then(()=>this.logService.info(e.identifier.id,e.manifest.version,"Finished running post uninstall script"),t=>this.logService.error(e.identifier.id,e.manifest.version,`Failed to run post uninstall script: ${t}`)))),d.rimraf(this.getExtensionStoragePath(e)).then(void 0,e=>this.logService.error("Error while removing extension storage path",e))}parseScript(e,t){const n=`vscode:${t}`;if(e.location.scheme===h.Schemas.file&&e.manifest&&e.manifest.scripts&&"string"==typeof e.manifest.scripts[n]){const t=e.manifest.scripts[n].split(" ");return t.length<2||"node"!==t[0]||!t[1]?(this.logService.warn(e.identifier.id,e.manifest.version,`${n} should be a node script`),null):{script:c.join(e.location.fsPath,t[1]),args:t.slice(2)||[]}}return null}runLifecycleHook(e,t,n,i,r){return new Promise((s,o)=>{const c=this.start(e,t,n,r);let l;const u=e=>{l&&(clearTimeout(l),l=null),e?o(e):s(void 0)};c.on("error",e=>{
u(a.toErrorMessage(e)||"Unknown")}),c.on("exit",(e,n)=>{u(e?`post-${t} process exited with code ${e}`:void 0)}),i&&(l=setTimeout(()=>{l=null,c.kill(),o("timed out")},5e3))})}start(e,t,n,i){const s={silent:!0,execArgv:void 0},o=r.fork(e,[`--type=extension-post-${t}`,...n],s);o.stdout.setEncoding("utf8"),o.stderr.setEncoding("utf8");const a=u.Event.fromNodeEventEmitter(o.stdout,"data"),c=u.Event.fromNodeEventEmitter(o.stderr,"data");a(e=>this.logService.info(i.identifier.id,i.manifest.version,`post-${t}`,e)),c(e=>this.logService.error(i.identifier.id,i.manifest.version,`post-${t}`,e));const l=u.Event.any(u.Event.map(a,e=>({data:`%c${e}`,format:[""]})),u.Event.map(c,e=>({data:`%c${e}`,format:["color: red"]})));return u.Event.debounce(l,(e,t)=>e?{data:e.data+t.data,format:[...e.format,...t.format]}:{data:t.data,format:t.format},100)(e=>{console.group(i.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),o}getExtensionStoragePath(e){
return c.join(this.environmentService.globalStorageHome.fsPath,e.identifier.id.toLowerCase())}};p=s([o(0,f.IEnvironmentService),o(1,i.ILogService)],p),t.ExtensionsLifecycle=p})),define(t[57],n([0,1,3,25,5,22,118,33,21,67,13,17,41,15,24,4,76,49]),(function(e,t,n,i,r,a,c,l,u,h,d,f,p,g,m,v,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let E=class extends n.Disposable{constructor(e){super(),this.logService=e,this.BUFFER_SIZE=65536,this._onDidChangeFileSystemProviderRegistrations=this._register(new r.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new r.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new r.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,
this._onDidRunOperation=this._register(new r.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new r.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new r.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueues=new Map}registerProvider(e,t){if(this.provider.has(e))throw new Error(`A filesystem provider for the scheme '${e}' is already registered.`);this.provider.set(e,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:e,provider:t});const r=new n.DisposableStore;return r.add(t.onDidChangeFile(e=>this._onDidFilesChange.fire(new i.FileChangesEvent(e,this.getExtUri(t).extUri)))),r.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:e}))),"function"==typeof t.onDidErrorOccur&&r.add(t.onDidErrorOccur(e=>this._onError.fire(new Error(e)))),n.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({
added:!1,scheme:e,provider:t}),this.provider.delete(e),n.dispose(r)})}async activateProvider(e){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:e,join(e){e&&t.push(e)}}),this.provider.has(e)||await Promise.all(t)}canHandleResource(e){return this.provider.has(e.scheme)}hasCapability(e,t){const n=this.provider.get(e.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return w.Iterable.map(this.provider,([e,t])=>({scheme:e,capabilities:t.capabilities}))}async withProvider(e){if(!a.isAbsolutePath(e))throw new i.FileOperationError(c.localize(0,null,this.resourceForError(e)),8);await this.activateProvider(e.scheme);const t=this.provider.get(e.scheme);if(!t){const t=new Error;throw t.name="ENOPRO",t.message=c.localize(1,null,e.toString()),t}return t}async withReadProvider(e){const t=await this.withProvider(e);if(i.hasOpenReadWriteCloseCapability(t)||i.hasReadWriteCapability(t)||i.hasFileReadStreamCapability(t))return t
;throw new Error(`Filesystem provider for scheme '${e.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(e){const t=await this.withProvider(e);if(i.hasOpenReadWriteCloseCapability(t)||i.hasReadWriteCapability(t))return t;throw new Error(`Filesystem provider for scheme '${e.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(e,t){try{return await this.doResolveFile(e,t)}catch(t){if(i.toFileSystemProviderErrorCode(t)===i.FileSystemProviderErrorCode.FileNotFound)throw new i.FileOperationError(c.localize(2,null,this.resourceForError(e)),1);throw i.ensureFileSystemProviderError(t)}}async doResolveFile(e,t){const n=await this.withProvider(e),i=null==t?void 0:t.resolveTo,r=null==t?void 0:t.resolveSingleChildDescendants,s=null==t?void 0:t.resolveMetadata,o=await n.stat(e);let a
;return this.toFileStat(n,e,o,void 0,!!s,(t,n)=>(a||((a=l.TernarySearchTree.forUris()).set(e,!0),u.isNonEmptyArray(i)&&i.forEach(e=>a.set(e,!0))),!!Boolean(a.findSuperstr(t.resource)||a.get(t.resource))||!(!t.isDirectory||!r)&&1===n))}async toFileStat(e,t,n,r,s,o){const c={resource:t,name:h.getBaseLabel(t),isFile:0!=(n.type&i.FileType.File),isDirectory:0!=(n.type&i.FileType.Directory),isSymbolicLink:0!=(n.type&i.FileType.SymbolicLink),mtime:n.mtime,ctime:n.ctime,size:n.size,etag:i.etag({mtime:n.mtime,size:n.size})};if(c.isDirectory&&o(c,r)){try{const n=await e.readdir(t),i=await Promise.all(n.map(async([i,r])=>{try{const c=a.joinPath(t,i),l=s?await e.stat(c):{type:r};return await this.toFileStat(e,c,l,n.length,s,o)}catch(e){return this.logService.trace(e),null}}));c.children=u.coalesce(i)}catch(e){this.logService.trace(e),c.children=[]}return c}return c}async resolveAll(e){return Promise.all(e.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(e){
return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(e){const t=await this.withProvider(e);try{return!!await t.stat(e)}catch(e){return!1}}async canCreateFile(e,t){try{await this.doValidateCreateFile(e,t)}catch(e){return e}return!0}async doValidateCreateFile(e,t){if(!(null==t?void 0:t.overwrite)&&await this.exists(e))throw new i.FileOperationError(c.localize(3,null,this.resourceForError(e)),3,t)}async createFile(e,t=f.VSBuffer.fromString(""),n){await this.doValidateCreateFile(e,n);const r=await this.writeFile(e,t);return this._onDidRunOperation.fire(new i.FileOperationEvent(e,0,r)),r}async writeFile(e,t,n){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);try{let s;if(await this.validateWriteFile(r,e,n)||await this.mkdirp(r,a.dirname(e)),!i.hasReadWriteCapability(r)||t instanceof f.VSBuffer)s=t;else if(p.isReadableStream(t)){const e=await p.peekStream(t,3);s=e.ended?f.VSBuffer.concat(e.buffer):e}else s=p.peekReadable(t,e=>f.VSBuffer.concat(e),3)
;!i.hasOpenReadWriteCloseCapability(r)||i.hasReadWriteCapability(r)&&s instanceof f.VSBuffer?await this.doWriteUnbuffered(r,e,s):await this.doWriteBuffered(r,e,s instanceof f.VSBuffer?f.bufferToReadable(s):s)}catch(t){throw new i.FileOperationError(c.localize(4,null,this.resourceForError(e),i.ensureFileSystemProviderError(t).toString()),i.toFileOperationResult(t),n)}return this.resolve(e,{resolveMetadata:!0})}async validateWriteFile(e,t,n){let r=void 0;try{r=await e.stat(t)}catch(e){return}if(0!=(r.type&i.FileType.Directory))throw new i.FileOperationError(c.localize(5,null,this.resourceForError(t)),0,n);if(n&&"number"==typeof n.mtime&&"string"==typeof n.etag&&n.etag!==i.ETAG_DISABLED&&"number"==typeof r.mtime&&"number"==typeof r.size&&n.mtime<r.mtime&&n.etag!==i.etag({mtime:n.mtime,size:r.size}))throw new i.FileOperationError(c.localize(6,null),3,n);return r}async readFile(e,t){const n=await this.withReadProvider(e),i=await this.doReadAsFileStream(n,e,Object.assign(Object.assign({},t),{preferUnbuffered:!0}))
;return Object.assign(Object.assign({},i),{value:await f.streamToBuffer(i.value)})}async readFileStream(e,t){const n=await this.withReadProvider(e);return this.doReadAsFileStream(n,e,t)}async doReadAsFileStream(e,t,n){const r=new m.CancellationTokenSource,s=this.validateReadFile(t,n).then(e=>e,e=>{throw r.cancel(),e});try{let o;n&&"string"==typeof n.etag&&n.etag!==i.ETAG_DISABLED&&await s,o=!i.hasOpenReadWriteCloseCapability(e)&&!i.hasFileReadStreamCapability(e)||i.hasReadWriteCapability(e)&&(null==n?void 0:n.preferUnbuffered)?this.readFileUnbuffered(e,t,n):i.hasFileReadStreamCapability(e)?Promise.resolve(this.readFileStreamed(e,t,r.token,n)):Promise.resolve(this.readFileBuffered(e,t,r.token,n));const[a,c]=await Promise.all([s,o]);return Object.assign(Object.assign({},a),{value:c})}catch(e){throw new i.FileOperationError(c.localize(7,null,this.resourceForError(t),i.ensureFileSystemProviderError(e).toString()),i.toFileOperationResult(e),n)}}readFileStreamed(e,t,n,r=Object.create(null)){
const s=e.readFileStream(t,r,n);return p.transform(s,{data:e=>e instanceof f.VSBuffer?e:f.VSBuffer.wrap(e),error:e=>new i.FileOperationError(c.localize(8,null,this.resourceForError(t),i.ensureFileSystemProviderError(e).toString()),i.toFileOperationResult(e),r)},e=>f.VSBuffer.concat(e))}readFileBuffered(e,t,n,r=Object.create(null)){const s=f.newWriteableBufferStream();return y.readFileIntoStream(e,t,s,e=>e,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:e=>new i.FileOperationError(c.localize(9,null,this.resourceForError(t),i.ensureFileSystemProviderError(e).toString()),i.toFileOperationResult(e),r)}),n),s}async readFileUnbuffered(e,t,n){let i=await e.readFile(t);return n&&"number"==typeof n.position&&(i=i.slice(n.position)),n&&"number"==typeof n.length&&(i=i.slice(0,n.length)),this.validateReadFileLimits(t,i.byteLength,n),f.bufferToStream(f.VSBuffer.wrap(i))}async validateReadFile(e,t){const n=await this.resolve(e,{resolveMetadata:!0})
;if(n.isDirectory)throw new i.FileOperationError(c.localize(10,null,this.resourceForError(e)),0,t);if(t&&"string"==typeof t.etag&&t.etag!==i.ETAG_DISABLED&&t.etag===n.etag)throw new i.FileOperationError(c.localize(11,null),2,t);return this.validateReadFileLimits(e,n.size,t),n}validateReadFileLimits(e,t,n){if(null==n?void 0:n.limits){let r=void 0;if("number"==typeof n.limits.memory&&t>n.limits.memory&&(r=9),"number"==typeof n.limits.size&&t>n.limits.size&&(r=7),"number"==typeof r)throw new i.FileOperationError(c.localize(12,null,this.resourceForError(e)),r)}}async canMove(e,t,n){return this.doCanMoveCopy(e,t,"move",n)}async canCopy(e,t,n){return this.doCanMoveCopy(e,t,"copy",n)}async doCanMoveCopy(e,t,n,i){if(e.toString()!==t.toString())try{const r="move"===n?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e):await this.withReadProvider(e),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(r,e,s,t,n,i)}catch(e){return e}return!0}
async move(e,t,n){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(r,e,s,t,"move",!!n),a=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new i.FileOperationEvent(e,"move"===o?2:3,a)),a}async copy(e,t,n){const r=await this.withReadProvider(e),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(r,e,s,t,"copy",!!n),a=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new i.FileOperationEvent(e,"copy"===o?3:2,a)),a}async doMoveCopy(e,t,n,r,s,o){if(t.toString()===r.toString())return s;const{exists:c,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(e,t,n,r,s,o);if(c&&!l&&o&&await this.del(r,{recursive:!0}),await this.mkdirp(n,a.dirname(r)),"copy"===s){if(e===n&&i.hasFileFolderCopyCapability(e))await e.copy(t,r,{overwrite:o});else{const i=await this.resolve(t)
;i.isDirectory?await this.doCopyFolder(e,i,n,r):await this.doCopyFile(e,t,n,r)}return s}return e===n?(await e.rename(t,r,{overwrite:o}),s):(await this.doMoveCopy(e,t,n,r,"copy",o),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(e,t,n,r){return i.hasOpenReadWriteCloseCapability(e)&&i.hasOpenReadWriteCloseCapability(n)?this.doPipeBuffered(e,t,n,r):i.hasOpenReadWriteCloseCapability(e)&&i.hasReadWriteCapability(n)?this.doPipeBufferedToUnbuffered(e,t,n,r):i.hasReadWriteCapability(e)&&i.hasOpenReadWriteCloseCapability(n)?this.doPipeUnbufferedToBuffered(e,t,n,r):i.hasReadWriteCapability(e)&&i.hasReadWriteCapability(n)?this.doPipeUnbuffered(e,t,n,r):void 0}async doCopyFolder(e,t,n,i){await n.mkdir(i),Array.isArray(t.children)&&await Promise.all(t.children.map(async t=>{const r=a.joinPath(i,t.name);return t.isDirectory?this.doCopyFolder(e,await this.resolve(t.resource),n,r):this.doCopyFile(e,t.resource,n,r)}))}async doValidateMoveCopy(e,t,n,r,s,o){let a=!1;if(e===n){
const{extUri:n,isPathCaseSensitive:i}=this.getExtUri(e);if(i||(a=n.isEqual(t,r)),a&&"copy"===s)throw new Error(c.localize(13,null,this.resourceForError(t),this.resourceForError(r)));if(!a&&n.isEqualOrParent(r,t))throw new Error(c.localize(14,null,this.resourceForError(t),this.resourceForError(r)))}const l=await this.exists(r);if(l&&!a){if(!o)throw new i.FileOperationError(c.localize(15,null,this.resourceForError(t),this.resourceForError(r)),4);if(e===n){const{extUri:n}=this.getExtUri(e);if(n.isEqualOrParent(t,r))throw new Error(c.localize(16,null,this.resourceForError(t),this.resourceForError(r)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}getExtUri(e){const t=!!(1024&e.capabilities);return{extUri:t?a.extUri:a.extUriIgnorePathCase,isPathCaseSensitive:t}}async createFolder(e){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(e),e);await this.mkdirp(t,e);const n=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new i.FileOperationEvent(e,0,n)),n}
async mkdirp(e,t){const n=[],{extUri:r}=this.getExtUri(e);for(;!r.isEqual(t,a.dirname(t));)try{if(0==((await e.stat(t)).type&i.FileType.Directory))throw new Error(c.localize(17,null,this.resourceForError(t)));break}catch(e){if(i.toFileSystemProviderErrorCode(e)!==i.FileSystemProviderErrorCode.FileNotFound)throw e;n.push(a.basename(t)),t=a.dirname(t)}for(let r=n.length-1;r>=0;r--){t=a.joinPath(t,n[r]);try{await e.mkdir(t)}catch(e){if(i.toFileSystemProviderErrorCode(e)!==i.FileSystemProviderErrorCode.FileExists)throw e}}}async canDelete(e,t){try{await this.doValidateDelete(e,t)}catch(e){return e}return!0}async doValidateDelete(e,t){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(e),e);if(!!(null==t?void 0:t.useTrash)&&!(4096&n.capabilities))throw new Error(c.localize(18,null,this.resourceForError(e)));const r=await this.exists(e);if(!r)throw new i.FileOperationError(c.localize(19,null,this.resourceForError(e)),1);if(!!!(null==t?void 0:t.recursive)&&r){const t=await this.resolve(e)
;if(t.isDirectory&&Array.isArray(t.children)&&t.children.length>0)throw new Error(c.localize(20,null,this.resourceForError(e)))}return n}async del(e,t){const n=await this.doValidateDelete(e,t),r=!!(null==t?void 0:t.useTrash),s=!!(null==t?void 0:t.recursive);await n.delete(e,{recursive:s,useTrash:r}),this._onDidRunOperation.fire(new i.FileOperationEvent(e,1))}watch(e,t={recursive:!1,excludes:[]}){let i=!1,r=n.toDisposable(()=>i=!0);return this.doWatch(e,t).then(e=>{i?n.dispose(e):r=e},e=>this.logService.error(e)),n.toDisposable(()=>n.dispose(r))}async doWatch(e,t){const i=await this.withProvider(e),r=this.toWatchKey(i,e,t),s=this.activeWatchers.get(r)||{count:0,disposable:i.watch(e,t)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,s),s.count+=1,n.toDisposable(()=>{s.count--,0===s.count&&(n.dispose(s.disposable),this.activeWatchers.delete(r))})}toWatchKey(e,t,n){const{extUri:i}=this.getExtUri(e);return[i.getComparisonKey(t),String(n.recursive),n.excludes.join()].join()}dispose(){super.dispose(),
this.activeWatchers.forEach(e=>n.dispose(e.disposable)),this.activeWatchers.clear()}ensureWriteQueue(e,t){const{extUri:i}=this.getExtUri(e),s=i.getComparisonKey(t);let o=this.writeQueues.get(s);if(!o){o=new g.Queue,this.writeQueues.set(s,o),r.Event.once(o.onFinished)(()=>{this.writeQueues.delete(s),n.dispose(o)})}return o}async doWriteBuffered(e,t,n){return this.ensureWriteQueue(e,t).queue(async()=>{const r=await e.open(t,{create:!0});try{p.isReadableStream(n)||p.isReadableBufferedStream(n)?await this.doWriteStreamBufferedQueued(e,r,n):await this.doWriteReadableBufferedQueued(e,r,n)}catch(e){throw i.ensureFileSystemProviderError(e)}finally{await e.close(r)}})}async doWriteStreamBufferedQueued(e,t,n){let i,r=0;if(p.isReadableBufferedStream(n)){if(n.buffer.length>0){const i=f.VSBuffer.concat(n.buffer);await this.doWriteBuffer(e,t,i,i.byteLength,r,0),r+=i.byteLength}if(n.ended)return;i=n.stream}else i=n;return new Promise(async(n,s)=>{i.on("data",async n=>{i.pause();try{
await this.doWriteBuffer(e,t,n,n.byteLength,r,0)}catch(e){return s(e)}r+=n.byteLength,setTimeout(()=>i.resume())}),i.on("error",e=>s(e)),i.on("end",()=>n())})}async doWriteReadableBufferedQueued(e,t,n){let i,r=0;for(;null!==(i=n.read());)await this.doWriteBuffer(e,t,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(e,t,n,i,r,s){let o=0;for(;o<i;){o+=await e.write(t,r+o,n.buffer,s+o,i-o)}}async doWriteUnbuffered(e,t,n){return this.ensureWriteQueue(e,t).queue(()=>this.doWriteUnbufferedQueued(e,t,n))}async doWriteUnbufferedQueued(e,t,n){let i;i=n instanceof f.VSBuffer?n:p.isReadableStream(n)?await f.streamToBuffer(n):p.isReadableBufferedStream(n)?await f.bufferedStreamToBuffer(n):f.readableToBuffer(n),await e.writeFile(t,i.buffer,{create:!0,overwrite:!0})}async doPipeBuffered(e,t,n,i){return this.ensureWriteQueue(n,i).queue(()=>this.doPipeBufferedQueued(e,t,n,i))}async doPipeBufferedQueued(e,t,n,r){let s=void 0,o=void 0;try{s=await e.open(t,{create:!1}),o=await n.open(r,{create:!0})
;const i=f.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,c=0,l=0;do{l=await e.read(s,a,i.buffer,c,i.byteLength-c),await this.doWriteBuffer(n,o,i,l,a,c),a+=l,(c+=l)===i.byteLength&&(c=0)}while(l>0)}catch(e){throw i.ensureFileSystemProviderError(e)}finally{await Promise.all(["number"==typeof s?e.close(s):Promise.resolve(),"number"==typeof o?n.close(o):Promise.resolve()])}}async doPipeUnbuffered(e,t,n,i){return this.ensureWriteQueue(n,i).queue(()=>this.doPipeUnbufferedQueued(e,t,n,i))}async doPipeUnbufferedQueued(e,t,n,i){return n.writeFile(i,await e.readFile(t),{create:!0,overwrite:!0})}async doPipeUnbufferedToBuffered(e,t,n,i){return this.ensureWriteQueue(n,i).queue(()=>this.doPipeUnbufferedToBufferedQueued(e,t,n,i))}async doPipeUnbufferedToBufferedQueued(e,t,n,r){const s=await n.open(r,{create:!0});try{const i=await e.readFile(t);await this.doWriteBuffer(n,s,f.VSBuffer.wrap(i),i.byteLength,0,0)}catch(e){throw i.ensureFileSystemProviderError(e)}finally{await n.close(s)}}async doPipeBufferedToUnbuffered(e,t,n,i){
const r=await f.streamToBuffer(this.readFileBuffered(e,t,m.CancellationToken.None));await this.doWriteUnbuffered(n,i,r)}throwIfFileSystemIsReadonly(e,t){if(2048&e.capabilities)throw new i.FileOperationError(c.localize(21,null,this.resourceForError(t)),6);return e}resourceForError(e){return e.scheme===v.Schemas.file?e.fsPath:e.toString(!0)}};E=s([o(0,d.ILogService)],E),t.FileService=E})),define(t[46],n([0,1,18,42,3,25,5,6,14,2,22,30,15,13,121,77,133,135,132,139,41,76,21,17]),(function(e,t,n,i,r,s,o,a,c,l,u,h,d,f,p,g,m,v,y,w,E,_,S,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class C extends r.Disposable{constructor(e,t){var n;super(),this.logService=e,this.options=t,this.BUFFER_SIZE=(null===(n=this.options)||void 0===n?void 0:n.bufferSize)||65536,this.onDidChangeCapabilities=o.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Set,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new o.Emitter),
this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new o.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new d.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=30,a.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:t,symbolicLink:n}=await c.statLink(this.toFilePath(e));return{type:this.toType(t,n),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(e){throw this.toFileSystemProviderError(e)}}async readdir(e){try{const t=await c.readdirWithFileTypes(this.toFilePath(e)),n=[];return await Promise.all(t.map(async t=>{try{let i;i=t.isSymbolicLink()?(await this.stat(u.joinPath(e,t.name))).type:this.toType(t),n.push([t.name,i])}catch(e){this.logService.trace(e)}})),n}catch(e){throw this.toFileSystemProviderError(e)}}toType(e,t){let n
;return n=(null==t?void 0:t.dangling)?s.FileType.Unknown:e.isFile()?s.FileType.File:e.isDirectory()?s.FileType.Directory:s.FileType.Unknown,t&&(n|=s.FileType.SymbolicLink),n}async readFile(e){try{const t=this.toFilePath(e);return await c.readFile(t)}catch(e){throw this.toFileSystemProviderError(e)}}readFileStream(e,t,n){const i=E.newWriteableStream(e=>b.VSBuffer.concat(e.map(e=>b.VSBuffer.wrap(e))).buffer);return _.readFileIntoStream(this,e,i,e=>e.buffer,Object.assign(Object.assign({},t),{bufferSize:this.BUFFER_SIZE}),n),i}async writeFile(e,t,n){let i=void 0;try{const r=this.toFilePath(e);if(!n.create||!n.overwrite){if(await c.exists(r)){if(!n.overwrite)throw s.createFileSystemProviderError(p.localize(0,null),s.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw s.createFileSystemProviderError(p.localize(1,null),s.FileSystemProviderErrorCode.FileNotFound)}i=await this.open(e,{create:!0}),await this.write(i,0,t,0,t.byteLength)}catch(e){throw this.toFileSystemProviderError(e)}finally{
"number"==typeof i&&await this.close(i)}}async open(e,t){try{const r=this.toFilePath(e);let s=void 0;if(t.create){if(a.isWindows&&await c.exists(r))try{await c.truncate(r,0),s="r+"}catch(e){this.logService.trace(e)}s||(s="w")}else s="r";const o=await i.promisify(n.open)(r,s);return this.mapHandleToPos.set(o,0),t.create&&this.writeHandles.add(o),o}catch(e){throw this.toFileSystemProviderError(e)}}async close(e){try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await i.promisify(n.fdatasync)(e)}catch(e){this.canFlush=!1,this.logService.error(e)}return await i.promisify(n.close)(e)}catch(e){throw this.toFileSystemProviderError(e)}}async read(e,t,r,s,o){const a=this.normalizePos(e,t);let c=null;try{const t=await i.promisify(n.read)(e,r,s,o,a);return c="number"==typeof t?t:t.bytesRead}catch(e){throw this.toFileSystemProviderError(e)}finally{this.updatePos(e,a,c)}}normalizePos(e,t){return t===this.mapHandleToPos.get(e)?null:t}updatePos(e,t,n){const i=this.mapHandleToPos.get(e)
;"number"==typeof i&&("number"==typeof t||("number"==typeof n?this.mapHandleToPos.set(e,i+n):this.mapHandleToPos.delete(e)))}async write(e,t,n,i,r){return d.retry(()=>this.doWrite(e,t,n,i,r),100,3)}async doWrite(e,t,r,s,o){const a=this.normalizePos(e,t);let c=null;try{const t=await i.promisify(n.write)(e,r,s,o,a);return c="number"==typeof t?t:t.bytesWritten}catch(e){throw this.toFileSystemProviderError(e)}finally{this.updatePos(e,a,c)}}async mkdir(e){try{await i.promisify(n.mkdir)(this.toFilePath(e))}catch(e){throw this.toFileSystemProviderError(e)}}async delete(e,t){try{const n=this.toFilePath(e);await this.doDelete(n,t)}catch(e){throw this.toFileSystemProviderError(e)}}async doDelete(e,t){t.recursive?await c.rimraf(e,c.RimRafMode.MOVE):await c.unlink(e)}async rename(e,t,n){const i=this.toFilePath(e),r=this.toFilePath(t);if(i!==r)try{await this.validateTargetDeleted(e,t,"move",n.overwrite),await c.move(i,r)}catch(e){
throw"EINVAL"!==e.code&&"EBUSY"!==e.code&&"ENAMETOOLONG"!==e.code||(e=new Error(p.localize(2,null,l.basename(i),l.basename(l.dirname(r)),e.toString()))),this.toFileSystemProviderError(e)}}async copy(e,t,n){const i=this.toFilePath(e),r=this.toFilePath(t);if(i!==r)try{await this.validateTargetDeleted(e,t,"copy",n.overwrite),await c.copy(i,r)}catch(e){throw"EINVAL"!==e.code&&"EBUSY"!==e.code&&"ENAMETOOLONG"!==e.code||(e=new Error(p.localize(3,null,l.basename(i),l.basename(l.dirname(r)),e.toString()))),this.toFileSystemProviderError(e)}}async validateTargetDeleted(e,t,n,i){const r=this.toFilePath(e),o=this.toFilePath(t);let a=!1;if(!!(1024&this.capabilities)||(a=h.isEqual(r,o,!0)),a&&"copy"===n)throw s.createFileSystemProviderError(p.localize(4,null),s.FileSystemProviderErrorCode.FileExists);if(!a&&await c.exists(o)){if(!i)throw s.createFileSystemProviderError(p.localize(5,null),s.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}watch(e,t){
return t.recursive?this.watchRecursive(e,t.excludes):this.watchNonRecursive(e)}watchRecursive(e,t){const n={path:this.toFilePath(e),excludes:t},i=S.insert(this.recursiveFoldersToWatch,n);return this.refreshRecursiveWatchers(),r.toDisposable(()=>{i(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var e,t,n;if(this.recursiveWatcher instanceof y.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(r.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,r=void 0;(null===(t=null===(e=this.options)||void 0===e?void 0:e.watcher)||void 0===t?void 0:t.usePolling)?(i=m.FileWatcher,r=null===(n=this.options)||void 0===n?void 0:n.watcher):i=1===this.recursiveFoldersToWatch.length?a.isWindows?v.FileWatcher:m.FileWatcher:y.FileWatcher,
this.recursiveWatcher=new i(this.recursiveFoldersToWatch,e=>this._onDidChangeFile.fire(g.toFileChanges(e)),e=>{"error"===e.type&&this._onDidWatchErrorOccur.fire(e.message),this.logService[e.type](e.message)},this.logService.getLevel()===f.LogLevel.Trace,r),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))}}watchNonRecursive(e){const t=new w.FileWatcher(this.toFilePath(e),e=>this._onDidChangeFile.fire(g.toFileChanges(e)),e=>{"error"===e.type&&this._onDidWatchErrorOccur.fire(e.message),this.logService[e.type](e.message)},this.logService.getLevel()===f.LogLevel.Trace),n=this.logService.onDidChangeLogLevel(()=>{t.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)});return r.combinedDisposable(t,n)}toFilePath(e){return l.normalize(e.fsPath)}toFileSystemProviderError(e){if(e instanceof s.FileSystemProviderError)return e
;let t;switch(e.code){case"ENOENT":t=s.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=s.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=s.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=s.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=s.FileSystemProviderErrorCode.NoPermissions;break;default:t=s.FileSystemProviderErrorCode.Unknown}return s.createFileSystemProviderError(e,t)}dispose(){super.dispose(),r.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,r.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=C})),define(t[79],n([0,1,14,58,28,3,23,15,31,13,78,21,5,4,2]),(function(e,t,n,i,r,a,c,l,u,h,d,f,p,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let v=class extends a.Disposable{constructor(e,t,n){super(),this.extensionManagementService=e,this.logService=n,
this._onDidLanguagesChange=this._register(new p.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new y(t,n)),this._register(e.onDidInstallExtension(({local:e})=>this.onDidInstallExtension(e))),this._register(e.onDidUninstallExtension(({identifier:e})=>this.onDidUninstallExtension(e)))}getLanguageIds(){return this.cache.getLanguagePacks().then(e=>{const t=["en",...Object.keys(e)];return f.distinct(t)})}onDidInstallExtension(e){e&&e.manifest&&e.manifest.contributes&&e.manifest.contributes.localizations&&e.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",e.identifier.id),this.update().then(e=>{e&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(e){this.cache.getLanguagePacks().then(t=>{Object.keys(t).some(n=>t[n]&&t[n].extensions.some(t=>u.areSameExtensions(t.extensionIdentifier,e)))&&(this.logService.debug("Removing language packs from the extension",e.id),this.update().then(e=>{
e&&this._onDidLanguagesChange.fire()}))})}update(){return Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]).then(([e,t])=>this.cache.update(t).then(t=>!f.equals(Object.keys(e),Object.keys(t))))}};v=s([o(0,r.IExtensionManagementService),o(1,c.INativeEnvironmentService),o(2,h.ILogService)],v),t.LocalizationsService=v;let y=class extends a.Disposable{constructor(e,t){super(),this.logService=t,this.languagePacks={},this.languagePacksFilePath=m.join(e.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new l.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(e){return this.withLanguagePacks(t=>{Object.keys(t).forEach(e=>delete t[e]),this.createLanguagePacksFromExtensions(t,...e)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(e,...t){
for(const n of t)n&&n.manifest&&n.manifest.contributes&&n.manifest.contributes.localizations&&n.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(e,n);Object.keys(e).forEach(t=>this.updateHash(e[t]))}createLanguagePacksFromExtension(e,t){const n=t.identifier,i=t.manifest.contributes&&t.manifest.contributes.localizations?t.manifest.contributes.localizations:[];for(const r of i)if(t.location.scheme===g.Schemas.file&&d.isValidLocalization(r)){let i=e[r.languageId];i||(i={hash:"",extensions:[],translations:{}},e[r.languageId]=i);let s=i.extensions.filter(e=>u.areSameExtensions(e.extensionIdentifier,n))[0];s?s.version=t.manifest.version:i.extensions.push({extensionIdentifier:n,version:t.manifest.version});for(const e of r.translations)i.translations[e.id]=m.join(t.location.fsPath,e.path)}}updateHash(e){if(e){const t=i.createHash("md5");for(const n of e.extensions)t.update(n.extensionIdentifier.uuid||n.extensionIdentifier.id).update(n.version);e.hash=t.digest("hex")}}
withLanguagePacks(e=(()=>null)){return this.languagePacksFileLimiter.queue(()=>{let t=null;return n.readFile(this.languagePacksFilePath,"utf8").then(void 0,e=>"ENOENT"===e.code?Promise.resolve("{}"):Promise.reject(e)).then(e=>{try{return JSON.parse(e)}catch(e){return{}}}).then(n=>(t=e(n),n)).then(e=>{for(const t of Object.keys(e))e[t]||delete e[t];this.languagePacks=e,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),n.writeFile(this.languagePacksFilePath,t)}).then(()=>t,e=>this.logService.error(e))})}};y=s([o(0,c.INativeEnvironmentService),o(1,h.ILogService)],y)})),define(t[142],n([0,1,13,5]),(function(e,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FollowerLogService=t.LoggerChannelClient=t.LoggerChannel=void 0;t.LoggerChannel=class{constructor(e){this.service=e,this.onDidChangeLogLevel=i.Event.buffer(e.onDidChangeLogLevel,!0)}listen(e,t){switch(t){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}
throw new Error(`Event not found: ${t}`)}call(e,t,n){switch(t){case"setLevel":return this.service.setLevel(n),Promise.resolve();case"consoleLog":return this.consoleLog(n[0],n[1]),Promise.resolve()}throw new Error(`Call not found: ${t}`)}consoleLog(e,t){let n=console.log;switch(e){case"error":n=console.error;break;case"warn":n=console.warn;break;case"info":n=console.info}n.call(console,...t)}};class r{constructor(e){this.channel=e}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(e){r.setLevel(this.channel,e)}static setLevel(e,t){return e.call("setLevel",t)}consoleLog(e,t){this.channel.call("consoleLog",[e,t])}}t.LoggerChannelClient=r;class s extends n.DelegatedLogService{constructor(e,t){super(t),this.parent=e,this._register(e.onDidChangeLogLevel(e=>t.setLevel(e)))}setLevel(e){super.setLevel(e),this.parent.setLevel(e)}}t.FollowerLogService=s})),define(t[80],n([0,1,2,13]),(function(e,t,n,i){"use strict";function r(e,t,n){switch(t){case i.LogLevel.Trace:e.trace(n);break
;case i.LogLevel.Debug:e.debug(n);break;case i.LogLevel.Info:e.info(n);break;case i.LogLevel.Warning:e.warn(n);break;case i.LogLevel.Error:e.error(n);break;case i.LogLevel.Critical:e.critical(n);break;default:throw new Error("Invalid log level")}}Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogService=t.createRotatingLogger=void 0,t.createRotatingLogger=function(t,n,i,r){return e.__$__nodeRequire("spdlog").createRotatingLogger(t,n,i,r)};class s extends i.AbstractLogService{constructor(e,t,n){super(),this.name=e,this.logsFolder=t,this.buffer=[],this._loggerCreationPromise=void 0,this.setLevel(n),this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(e=>{this._logger&&this._logger.setLevel(e)}))}_createSpdLogLogger(){return this._loggerCreationPromise||(this._loggerCreationPromise=async function(t,i){try{const r=await new Promise((t,n)=>{e(["spdlog"],t,n)});r.setAsyncMode(8192,500);const s=n.join(i,`${t}.log`);return r.createRotatingLoggerAsync(t,s,5242880,6)}catch(e){console.error(e)}
return null}(this.name,this.logsFolder).then(e=>{if(e){this._logger=e,this._logger.setLevel(this.getLevel());for(const{level:e,message:t}of this.buffer)r(this._logger,e,t);this.buffer=[]}})),this._loggerCreationPromise}_log(e,t){this._logger?r(this._logger,e,t):this.getLevel()<=e&&this.buffer.push({level:e,message:t})}trace(e,...t){this.getLevel()<=i.LogLevel.Trace&&this._log(i.LogLevel.Trace,this.format([e,...t]))}debug(e,...t){this.getLevel()<=i.LogLevel.Debug&&this._log(i.LogLevel.Debug,this.format([e,...t]))}info(e,...t){this.getLevel()<=i.LogLevel.Info&&this._log(i.LogLevel.Info,this.format([e,...t]))}warn(e,...t){this.getLevel()<=i.LogLevel.Warning&&this._log(i.LogLevel.Warning,this.format([e,...t]))}error(e,...t){if(this.getLevel()<=i.LogLevel.Error)if(e instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=e.stack,this._log(i.LogLevel.Error,this.format(t))}else this._log(i.LogLevel.Error,this.format([e,...t]))}critical(e,...t){
this.getLevel()<=i.LogLevel.Critical&&this._log(i.LogLevel.Critical,this.format([e,...t]))}flush(){this._logger?this._logger.flush():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.disposeLogger()),this._loggerCreationPromise=void 0}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}format(e){let t="";for(let n=0;n<e.length;n++){let i=e[n];if("object"==typeof i)try{i=JSON.stringify(i)}catch(e){}t+=(n>0?" ":"")+i}return t}}t.SpdLogService=s})),define(t[143],n([0,1,91,8,5]),(function(e,t,n,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NoOpProgress=t.NoOpNotification=t.NotificationsFilter=t.NeverShowAgainScope=t.INotificationService=t.Severity=void 0,t.Severity=n.default,t.INotificationService=i.createDecorator("notificationService"),function(e){e[e.WORKSPACE=0]="WORKSPACE",e[e.GLOBAL=1]="GLOBAL"
}(t.NeverShowAgainScope||(t.NeverShowAgainScope={})),function(e){e[e.OFF=0]="OFF",e[e.SILENT=1]="SILENT",e[e.ERROR=2]="ERROR"}(t.NotificationsFilter||(t.NotificationsFilter={}));t.NoOpNotification=class{constructor(){this.progress=new s,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(e){}updateMessage(e){}updateActions(e){}close(){}};class s{infinite(){}done(){}total(e){}worked(e){}}t.NoOpProgress=s})),define(t[26],n([0,1,6,51,4,22]),(function(e,t,n,i,r,s){"use strict";let o;if(Object.defineProperty(t,"__esModule",{value:!0}),n.isWeb||void 0===e||"function"!=typeof e.__$__nodeRequire)o={webBuiltInExtensions:[{name:"ms-vscode.github-browser",version:"0.0.13",repo:"https://github.com/microsoft/vscode-github-browser",metadata:{id:"c1bcff4b-4ecb-466e-b8f6-b02788b5fb5a",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],nameShort:"Code",
nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",
updateUrl:"https://update.code.visualstudio.com",quality:"stable",extensionsGallery:{serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","msjsdiag.debugger-for-chrome":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","austin.code-gnu-global":"{**/*.c,**/*.cpp,**/*.h}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}",
"dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","dbaeumer.jshint":"{**/*.js,**/*.jsx,**/*.es6,**/.babelrc,**/jsconfig.json,**/.jshintrc,**/.jshintignore}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","felixfbecker.php-intellisense":"{**/*.php,**/php.ini}","felixfbecker.php-debug":"{**/*.php,**/php.ini}","ikappas.phpcs":"{**/*.php,**/php.ini}","rust-lang.rust":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}",
"HookyQR.beautify":"{**/.jsbeautifyrc,**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.babelrc,**/jsconfig.json}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","shinnn.stylelint":"{**/.stylelintrc,**/stylelint.config.js}","eg2.vscode-npm-script":"{**/package.json}","ms-mssql.mssql":"{**/*.sql}","bajdzis.vscode-database":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","octref.vetur":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}",
"Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py,**/*.ipynb}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools":{name:"C/C++",languages:["c","cpp"],
pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"octref.vetur":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","hiro-sun.vscode-emacs","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{
name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{
name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",
windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",
windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{
friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-maven":{name:"Maven for Java"}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{
"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",
windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},minikube:{
friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",
extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],
ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},
extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{
"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774"},enableTelemetry:!0,aiConfig:{asimovKey:"AIF-444c3af9-8e69-4462-ab49-4191e6ad1916"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",
keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",telemetryOptOutUrl:"https://go.microsoft.com/fwlink/?linkid=870136",npsSurveyUrl:"https://www.research.net/r/Z2RMYRJ",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",
settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],
extensionAllowedProposedApi:["ms-vscode.references-view","ms-vsliveshare.vsliveshare","ms-vsliveshare.cloudenv","ms-vsliveshare.cloudenv-explorer","ms-vsonline.vsonline","GitHub.vscode-pull-request-github","GitHub.vscode-pull-request-github-insiders","Microsoft.vscode-nmake-tools","ms-vscode-remote.remote-containers","ms-vscode-remote.remote-containers-nightly","ms-vscode-remote.remote-ssh","ms-vscode-remote.remote-ssh-nightly","ms-vscode-remote.remote-ssh-edit","ms-vscode-remote.remote-ssh-edit-nightly","ms-vscode-remote.remote-wsl","ms-vscode-remote.remote-wsl-nightly","ms-vscode-remote.vscode-remote-extensionpack","ms-vscode-remote.vscode-remote-extensionpack-nightly","ms-vscode.azure-account","ms-vscode.js-debug","ms-vscode.js-debug-nightly","ms-vscode.vscode-js-profile-table","ms-vscode.vscode-js-profile-flame","ms-dotnettools.dotnet-interactive-vscode","ms-python.python","ms-python.gather","ms-ai-tools.notebook-renderers","ms-vscode.azure-sphere-tools","ms-vscode.azure-sphere-tools-ui","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.lsif-browser","sandy081.999-test-github-issue-notebooks"],
tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"manasxx.background-cover":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"]},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://vscode-auth.github.com","https://*.gallerycdn.vsassets.io","https://github.com/microsoft/","https://github.com/MicrosoftDocs/","https://login.microsoftonline.com"],auth:{
loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["https://management.core.windows.net/.default","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.node-debug",version:"1.44.14",repo:"https://github.com/microsoft/vscode-node-debug",metadata:{id:"b6ded8fb-a0a0-4c1c-acbd-ab2a3bc995a6",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.node-debug2",version:"1.42.5",
repo:"https://github.com/microsoft/vscode-node-debug2",metadata:{id:"36d19e17-7569-4841-a001-947eb18602b2",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.references-view",version:"0.0.68",repo:"https://github.com/microsoft/vscode-reference-view",metadata:{id:"dc489f46-520d-4556-ae85-1f9eab3c412d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug-companion",version:"1.0.8",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.50.2",
repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"0.0.11",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],version:"1.50.0",commit:"93c2f0fbf16c5a4b10e4d5f89737d9c2c25488a3",date:"2020-10-07T05:51:51.031Z"},0===Object.keys(o).length&&Object.assign(o,{version:"1.50.0-dev",nameShort:n.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:n.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",
licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/master/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.references-view","ms-vscode.github-browser"]});else{const t=s.dirname(r.FileAccess.asFileUri("",e));o=e.__$__nodeRequire(s.joinPath(t,"product.json").fsPath);const n=e.__$__nodeRequire(s.joinPath(t,"package.json").fsPath);i.env.VSCODE_DEV&&Object.assign(o,{nameShort:`${o.nameShort} Dev`,nameLong:`${o.nameLong} Dev`,dataFolderName:`${o.dataFolderName}-dev`}),Object.assign(o,{version:n.version})}t.default=o})),define(t[81],n([0,1,58,97,27,2,22,89,26,103,6,4,7]),(function(e,t,n,i,r,o,a,c,l,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseUserDataDir=t.parsePathArg=t.parseSearchPort=t.parseExtensionHostPort=t.xdgRuntimeDir=t.NativeEnvironmentService=void 0;class p{constructor(e){if(this._args=e,!process.env.VSCODE_LOGS){const e=u.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")
;process.env.VSCODE_LOGS=o.join(this.userDataPath,"logs",e)}this.logsPath=process.env.VSCODE_LOGS}get args(){return this._args}get appRoot(){return o.dirname(d.FileAccess.asFileUri("",e).fsPath)}get userHome(){return f.URI.file(r.homedir())}get userDataPath(){const e=process.env.VSCODE_PORTABLE;return e?o.join(e,"user-data"):E(this._args,process)}get appSettingsHome(){return f.URI.file(o.join(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(r.tmpdir())}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return a.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return a.joinPath(this.userRoamingDataHome,"sync")}get userDataSyncLogResource(){return f.URI.file(o.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return a.joinPath(f.URI.file(o.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return f.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){
return f.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return a.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return a.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const e=process.env.VSCODE_PORTABLE;return e?f.URI.file(o.join(e,"argv.json")):a.joinPath(this.userHome,l.default.dataFolderName,"argv.json")}get snippetsHome(){return a.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this._args.extensionDevelopmentPath}get backupHome(){return o.join(this.userDataPath,"Backups")}get backupWorkspacesPath(){return o.join(this.backupHome,"workspaces.json")}get untitledWorkspacesHome(){return f.URI.file(o.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return o.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const t=w(this._args["builtin-extensions-dir"],process);return t||o.normalize(o.join(d.FileAccess.asFileUri("",e).fsPath,"..","extensions"))}
get extensionsDownloadPath(){const e=w(this._args["extensions-download-dir"],process);return e||o.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const e=w(this._args["extensions-dir"],process);if(e)return e;const t=process.env.VSCODE_EXTENSIONS;if(t)return t;const n=process.env.VSCODE_PORTABLE;return n?o.join(n,"extensions"):a.joinPath(this.userHome,l.default.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const e=this._args.extensionDevelopmentPath;if(Array.isArray(e))return e.map(e=>/^[^:/?#]+?:\/\//.test(e)?f.URI.parse(e):f.URI.file(o.normalize(e)))}get extensionTestsLocationURI(){const e=this._args.extensionTestsPath;if(e)return/^[^:/?#]+?:\/\//.test(e)?f.URI.parse(e):f.URI.file(o.normalize(e))}get disableExtensions(){if(this._args["disable-extensions"])return!0;const e=this._args["disable-extension"];if(e){if("string"==typeof e)return[e];if(Array.isArray(e)&&e.length>0)return e}return!1}get debugExtensionHost(){return v(this._args,this.isBuilt)}
get isBuilt(){return!process.env.VSCODE_DEV}get verbose(){return!!this._args.verbose}get logLevel(){return this._args.log}get mainIPCHandle(){return m(this.userDataPath,"main")}get sharedIPCHandle(){return m(this.userDataPath,"shared")}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}get serviceMachineIdResource(){return a.joinPath(f.URI.file(this.userDataPath),"machineid")}get disableUpdates(){return!!this._args["disable-updates"]}get crashReporterId(){return this._args["crash-reporter-id"]}get crashReporterDirectory(){return this._args["crash-reporter-directory"]}get driverHandle(){return this._args.driver}get driverVerbose(){return!!this._args["driver-verbose"]}get disableTelemetry(){return!!this._args["disable-telemetry"]}get sandbox(){return!!this._args.__sandbox}}s([c.memoize],p.prototype,"appRoot",null),s([c.memoize],p.prototype,"userHome",null),s([c.memoize],p.prototype,"userDataPath",null),s([c.memoize],p.prototype,"appSettingsHome",null),
s([c.memoize],p.prototype,"tmpDir",null),s([c.memoize],p.prototype,"userRoamingDataHome",null),s([c.memoize],p.prototype,"settingsResource",null),s([c.memoize],p.prototype,"userDataSyncHome",null),s([c.memoize],p.prototype,"userDataSyncLogResource",null),s([c.memoize],p.prototype,"sync",null),s([c.memoize],p.prototype,"machineSettingsResource",null),s([c.memoize],p.prototype,"globalStorageHome",null),s([c.memoize],p.prototype,"workspaceStorageHome",null),s([c.memoize],p.prototype,"keybindingsResource",null),s([c.memoize],p.prototype,"keyboardLayoutResource",null),s([c.memoize],p.prototype,"argvResource",null),s([c.memoize],p.prototype,"snippetsHome",null),s([c.memoize],p.prototype,"isExtensionDevelopment",null),s([c.memoize],p.prototype,"backupHome",null),s([c.memoize],p.prototype,"backupWorkspacesPath",null),s([c.memoize],p.prototype,"untitledWorkspacesHome",null),s([c.memoize],p.prototype,"installSourcePath",null),s([c.memoize],p.prototype,"builtinExtensionsPath",null),
s([c.memoize],p.prototype,"extensionsPath",null),s([c.memoize],p.prototype,"extensionDevelopmentLocationURI",null),s([c.memoize],p.prototype,"extensionTestsLocationURI",null),s([c.memoize],p.prototype,"debugExtensionHost",null),s([c.memoize],p.prototype,"mainIPCHandle",null),s([c.memoize],p.prototype,"sharedIPCHandle",null),s([c.memoize],p.prototype,"nodeCachedDataDir",null),s([c.memoize],p.prototype,"serviceMachineIdResource",null),t.NativeEnvironmentService=p,t.xdgRuntimeDir=process.env.XDG_RUNTIME_DIR;const g={2:107,1:103};function m(e,i){return h.isWindows?function(e,t){return`\\\\.\\pipe\\${n.createHash("md5").update(e).digest("hex")}-${l.default.version}-${t}-sock`}(e,i):function(e,i){const r=process.env.VSCODE_PORTABLE;let s;if(t.xdgRuntimeDir&&!r){const r=n.createHash("md5").update(e).digest("hex").substr(0,8);s=o.join(t.xdgRuntimeDir,`vscode-${r}-${l.default.version}-${i}.sock`)}else s=o.join(e,`${l.default.version}-${i}.sock`);const a=g[h.platform]
;return"number"==typeof a&&s.length>=a&&console.warn(`WARNING: IPC handle "${s}" is longer than ${a} chars, try a shorter --user-data-dir`),s}(e,i)}function v(e,t){return y(e["inspect-extensions"],e["inspect-brk-extensions"],5870,t,e.debugId)}function y(e,t,n,i,r){const s=Number(t||e)||(i?null:n);return{port:s,break:!!s&&Boolean(!!t),debugId:r}}function w(e,t){if(!e)return;const n=o.resolve(e);return o.normalize(e)===n?n:o.resolve(t.env.VSCODE_CWD||t.cwd(),e)}function E(e,t){return w(e["user-data-dir"],t)||o.resolve(i.getDefaultUserDataPath(t.platform))}t.parseExtensionHostPort=v,t.parseSearchPort=function(e,t){return y(e["inspect-search"],e["inspect-brk-search"],5876,t)},t.parsePathArg=w,t.parseUserDataDir=E})),define(t[38],n([0,1,8]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=n.createDecorator("productService")})),define(t[32],n([0,1,12,88]),(function(e,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.Registry=void 0;t.Registry=new class{constructor(){this.data=new Map}add(e,t){i.ok(n.isString(e)),i.ok(n.isObject(t)),i.ok(!this.data.has(e),"There is already an extension with this id"),this.data.set(e,t)}knows(e){return this.data.has(e)}as(e){return this.data.get(e)||null}}})),define(t[144],n([0,1,32,5]),(function(e,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};const r=new class{constructor(){this._onDidChangeSchema=new i.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(e,t){var n;this.schemasById[(n=e,n.length>0&&"#"===n.charAt(n.length-1)?n.substring(0,n.length-1):n)]=t,this._onDidChangeSchema.fire(e)}notifySchemaChanged(e){this._onDidChangeSchema.fire(e)}getSchemaContributions(){return{schemas:this.schemasById}}};n.Registry.add(t.Extensions.JSONContribution,r)})),define(t[39],n([0,1,111,5,32,12,144]),(function(e,t,n,i,r,s,o){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"},function(e){e[e.APPLICATION=1]="APPLICATION",e[e.MACHINE=2]="MACHINE",e[e.WINDOW=3]="WINDOW",e[e.RESOURCE=4]="RESOURCE",e[e.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",e[e.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"}(t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}
},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const a=r.Registry.as(o.Extensions.JSONContribution);function c(e){return e.substring(1,e.length-1)}function l(e){switch(Array.isArray(e)?e[0]:e){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.OVERRIDE_PROPERTY_PATTERN=new RegExp("\\[.*\\]$"),t.overrideIdentifierFromKey=c,t.getDefaultValue=l;const u=new class{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:n.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},
patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},a.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(e,t=!0){this.registerConfigurations([e],t)}registerConfigurations(e,n=!0){const i=[];e.forEach(e=>{i.push(...this.validateAndRegisterProperties(e,n)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),a.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(i)}deregisterConfigurations(e){const n=[],i=e=>{if(e.properties)for(const t in e.properties)n.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,e.properties[t]);e.allOf&&e.allOf.forEach(e=>i(e))};for(const t of e){i(t);const e=this.configurationContributors.indexOf(t)
;-1!==e&&this.configurationContributors.splice(e,1)}a.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(n)}registerDefaultConfigurations(e){const i=[],r=[];for(const s of e)for(const e in s)if(i.push(e),this.defaultValues[e]=s[e],t.OVERRIDE_PROPERTY_PATTERN.test(e)){const i={type:"object",default:this.defaultValues[e],description:n.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};r.push(c(e)),this.configurationProperties[e]=i,this.defaultLanguageConfigurationOverridesNode.properties[e]=i}else{const t=this.configurationProperties[e];t&&(this.updatePropertyDefaultValue(e,t),this.updateSchema(e,t))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(i)}deregisterDefaultConfigurations(e){const n=[];for(const i of e)for(const e in i)if(n.push(e),delete this.defaultValues[e],t.OVERRIDE_PROPERTY_PATTERN.test(e))delete this.configurationProperties[e],
delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const t=this.configurationProperties[e];t&&(this.updatePropertyDefaultValue(e,t),this.updateSchema(e,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(n)}notifyConfigurationSchemaUpdated(...e){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(e){for(const t of e)this.overrideIdentifiers.add(t);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(e,n=!0,i=3){i=s.isUndefinedOrNull(e.scope)?i:e.scope;let r=[],o=e.properties;if(o)for(let e in o){if(n&&h(e)){delete o[e];continue}const a=o[e];this.updatePropertyDefaultValue(e,a),t.OVERRIDE_PROPERTY_PATTERN.test(e)?a.scope=void 0:a.scope=s.isUndefinedOrNull(a.scope)?i:a.scope,!o[e].hasOwnProperty("included")||o[e].included?(this.configurationProperties[e]=o[e],!o[e].deprecationMessage&&o[e].markdownDeprecationMessage&&(o[e].deprecationMessage=o[e].markdownDeprecationMessage),
r.push(e)):(this.excludedConfigurationProperties[e]=o[e],delete o[e])}let a=e.allOf;if(a)for(let e of a)r.push(...this.validateAndRegisterProperties(e,n,i));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(e){const t=e=>{let n=e.properties;if(n)for(const e in n)this.updateSchema(e,n[e]);let i=e.allOf;i&&i.forEach(t)};t(e)}updateSchema(e,n){switch(t.allSettings.properties[e]=n,n.scope){case 1:t.applicationSettings.properties[e]=n;break;case 2:t.machineSettings.properties[e]=n;break;case 6:t.machineOverridableSettings.properties[e]=n;break;case 3:t.windowSettings.properties[e]=n;break;case 4:t.resourceSettings.properties[e]=n;break;case 5:t.resourceSettings.properties[e]=n,this.resourceLanguageSettingsSchema.properties[e]=n}}removeFromSchema(e,n){switch(delete t.allSettings.properties[e],n.scope){case 1:
delete t.applicationSettings.properties[e];break;case 2:delete t.machineSettings.properties[e];break;case 6:delete t.machineOverridableSettings.properties[e];break;case 3:delete t.windowSettings.properties[e];break;case 4:case 5:delete t.resourceSettings.properties[e]}}updateOverridePropertyPatternKey(){for(const e of this.overrideIdentifiers.values()){const i=`[${e}]`,r={type:"object",description:n.localize(2,null),errorMessage:n.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(i,r),t.allSettings.properties[i]=r,t.applicationSettings.properties[i]=r,t.machineSettings.properties[i]=r,t.machineOverridableSettings.properties[i]=r,t.windowSettings.properties[i]=r,t.resourceSettings.properties[i]=r}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(e,t){let n=this.defaultValues[e];s.isUndefined(n)&&(n=t.default),s.isUndefined(n)&&(n=l(t.type)),t.default=n}};function h(e){
return t.OVERRIDE_PROPERTY_PATTERN.test(e)?n.localize(4,null,e):void 0!==u.getConfigurationProperties()[e]?n.localize(5,null,e):null}r.Registry.add(t.Extensions.Configuration,u),t.validateProperty=h,t.getScopes=function(){const e=[],t=u.getConfigurationProperties();for(const n of Object.keys(t))e.push([n,t[n].scope]);return e.push(["launch",4]),e.push(["task",4]),e}})),define(t[29],n([0,1,19,12,7,32,8,39]),(function(e,t,n,i,r,s,o,a){"use strict";function c(e,t){const n=Object.create(null);for(let i in e)l(n,i,e[i],t);return n}function l(e,t,n,i){const r=t.split("."),s=r.pop();let o=e;for(let e=0;e<r.length;e++){let n=r[e],s=o[n];switch(typeof s){case"undefined":s=o[n]=Object.create(null);break;case"object":break;default:return void i(`Ignoring ${t} as ${r.slice(0,e+1).join(".")} is ${JSON.stringify(s)}`)}o=s}if("object"==typeof o&&null!==o)try{o[s]=n}catch(e){i(`Ignoring ${t} as ${r.join(".")} is ${JSON.stringify(o)}`)}else i(`Ignoring ${t} as ${r.join(".")} is ${JSON.stringify(o)}`)}function u(e,t,n){
const i=function(e,t){let n=e;for(const e of t){if("object"!=typeof n||null===n)return;n=n[e]}return n}(e,t.split("."));return void 0===i?n:i}function h(e){return`[${e}]`}Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=o.createDecorator("configurationService"),t.isConfigurationOverrides=function(e){return e&&"object"==typeof e&&(!e.overrideIdentifier||"string"==typeof e.overrideIdentifier)&&(!e.resource||e.resource instanceof r.URI)},function(e){e[e.USER=1]="USER",e[e.USER_LOCAL=2]="USER_LOCAL",e[e.USER_REMOTE=3]="USER_REMOTE",e[e.WORKSPACE=4]="WORKSPACE",e[e.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",e[e.DEFAULT=6]="DEFAULT",e[e.MEMORY=7]="MEMORY"
}(t.ConfigurationTarget||(t.ConfigurationTarget={})),t.ConfigurationTargetToString=function(e){switch(e){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}},t.compare=function e(t,i){const r=i?t?i.keys.filter(e=>-1===t.keys.indexOf(e)):[...i.keys]:[],s=t?i?t.keys.filter(e=>-1===i.keys.indexOf(e)):[...t.keys]:[],o=[];if(i&&t)for(const e of t.keys)if(-1!==i.keys.indexOf(e)){const r=u(t.contents,e),s=u(i.contents,e);n.equals(r,s)||o.push(e)}const c=[],l=e=>{const t={};for(const n of e)for(const e of n.identifiers)t[h(e)]=n;return t},d=i?l(i.overrides):{},f=t?l(t.overrides):{};if(Object.keys(d).length)for(const e of r){const t=d[e];t&&c.push([a.overrideIdentifierFromKey(e),t.keys])}if(Object.keys(f).length)for(const e of s){const t=f[e];t&&c.push([a.overrideIdentifierFromKey(e),t.keys])}if(Object.keys(d).length&&Object.keys(f).length)for(const t of o){const n=f[t],i=d[t];if(n&&i){
const r=e({contents:n.contents,keys:n.keys,overrides:[]},{contents:i.contents,keys:i.keys,overrides:[]});c.push([a.overrideIdentifierFromKey(t),[...r.added,...r.removed,...r.updated]])}}return{added:r,removed:s,updated:o,overrides:c}},t.toOverrides=function(e,t){const n=[];for(const i of Object.keys(e))if(a.OVERRIDE_PROPERTY_PATTERN.test(i)){const r={};for(const t in e[i])r[t]=e[i][t];n.push({identifiers:[a.overrideIdentifierFromKey(i).trim()],keys:Object.keys(r),contents:c(r,t)})}return n},t.toValuesTree=c,t.addToValueTree=l,t.removeFromValueTree=function(e,t){!function e(t,n){const i=n.shift();if(0===n.length)return void delete t[i];if(-1!==Object.keys(t).indexOf(i)){const r=t[i];"object"!=typeof r||Array.isArray(r)||(e(r,n),0===Object.keys(r).length&&delete t[i])}}(e,t.split("."))},t.getConfigurationValue=u,t.merge=function e(t,n,r){Object.keys(n).forEach(s=>{"__proto__"!==s&&(s in t?i.isObject(t[s])&&i.isObject(n[s])?e(t[s],n[s],r):r&&(t[s]=n[s]):t[s]=n[s])})},t.getConfigurationKeys=function(){
const e=s.Registry.as(a.Extensions.Configuration).getConfigurationProperties();return Object.keys(e)},t.getDefaultValues=function(){const e=Object.create(null),t=s.Registry.as(a.Extensions.Configuration).getConfigurationProperties();for(let n in t){l(e,n,t[n].default,e=>console.error(`Conflict in default settings: ${e}`))}return e},t.keyFromOverrideIdentifier=h,t.getMigratedSettingValue=function(e,t,n){const i=e.inspect(t),r=e.inspect(n);return void 0!==i.userValue||void 0!==i.workspaceValue||void 0!==i.workspaceFolderValue?i.value:void 0!==r.userValue||void 0!==r.workspaceValue||void 0!==r.workspaceFolderValue?r.value:i.defaultValue}})),define(t[145],n([0,1,50,33,21,12,19,7,39,29,32,3,5,22]),(function(e,t,n,i,r,s,o,a,c,l,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class p{
constructor(e={},t=[],n=[]){this._contents=e,this._keys=t,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return 0===this._keys.length&&0===Object.keys(this._contents).length&&0===this._overrides.length}getValue(e){return e?l.getConfigurationValue(this.contents,e):this.contents}getOverrideValue(e,t){const n=this.getContentsForOverrideIdentifer(t);return n?e?l.getConfigurationValue(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const t of this.overrides)if(-1!==t.identifiers.indexOf(e))return t.keys;return[]}override(e){const t=this.getContentsForOverrideIdentifer(e);if(!t||"object"!=typeof t||!Object.keys(t).length)return this;let n={};for(const e of r.distinct([...Object.keys(this.contents),...Object.keys(t)])){let i=this.contents[e],r=t[e];r&&("object"==typeof i&&"object"==typeof r?(i=o.deepClone(i),this.mergeContents(i,r)):i=r),n[e]=i}
return new p(n,this.keys,this.overrides)}merge(...e){const t=o.deepClone(this.contents),n=o.deepClone(this.overrides),i=[...this.keys];for(const s of e){this.mergeContents(t,s.contents);for(const e of s.overrides){const[t]=n.filter(t=>r.equals(t.identifiers,e.identifiers));t?this.mergeContents(t.contents,e.contents):n.push(o.deepClone(e))}for(const e of s.keys)-1===i.indexOf(e)&&i.push(e)}return new p(t,i,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,t){for(const n of Object.keys(t))n in e&&s.isObject(e[n])&&s.isObject(t[n])?this.mergeContents(e[n],t[n]):e[n]=o.deepClone(t[n])}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?o.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const t of this.overrides)if(-1!==t.identifiers.indexOf(e))return t.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,t){this.addKey(e),l.addToValueTree(this.contents,e,t,e=>{throw new Error(e)})}removeValue(e){
this.removeKey(e)&&l.removeFromValueTree(this.contents,e)}addKey(e){let t=this.keys.length;for(let n=0;n<t;n++)0===e.indexOf(this.keys[n])&&(t=n);this.keys.splice(t,1,e)}removeKey(e){let t=this.keys.indexOf(e);return-1!==t&&(this.keys.splice(t,1),!0)}}t.ConfigurationModel=p;t.DefaultConfigurationModel=class extends p{constructor(){const e=l.getDefaultValues(),t=l.getConfigurationKeys(),n=[];for(const t of Object.keys(e))c.OVERRIDE_PROPERTY_PATTERN.test(t)&&n.push({identifiers:[c.overrideIdentifierFromKey(t).trim()],keys:Object.keys(e[t]),contents:l.toValuesTree(e[t],e=>console.error(`Conflict in default settings file: ${e}`))});super(e,t,n)}};class g{constructor(e,t){this._name=e,this._scopes=t,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get errors(){return this._parseErrors}parseContent(e){if(!s.isUndefinedOrNull(e)){const t=this.doParseContent(e);this.parseRaw(t)}}parseRaw(e){this._raw=e;const t=this.doParseRaw(e)
;this._configurationModel=new p(t.contents,t.keys,t.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(e){let t={},i=null,r=[],s=[],o=[];function a(e){Array.isArray(r)?r.push(e):i&&(r[i]=e)}let c={onObjectBegin:()=>{let e={};a(e),s.push(r),r=e,i=null},onObjectProperty:e=>{i=e},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{let e=[];a(e),s.push(r),r=e,i=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:a,onError:(e,t,n)=>{o.push({error:e,offset:t,length:n})}};if(e)try{n.visit(e,c),t=r[0]||{}}catch(e){console.error(`Error while parsing settings file ${this._name}: ${e}`),this._parseErrors=[e]}return t}doParseRaw(e){if(this._scopes){const t=u.Registry.as(c.Extensions.Configuration).getConfigurationProperties();e=this.filterByScope(e,t,!0,this._scopes)}return{contents:l.toValuesTree(e,e=>console.error(`Conflict in settings file ${this._name}: ${e}`)),keys:Object.keys(e),overrides:l.toOverrides(e,e=>console.error(`Conflict in settings file ${this._name}: ${e}`))}}filterByScope(e,t,n,i){const r={}
;for(let s in e)if(c.OVERRIDE_PROPERTY_PATTERN.test(s)&&n)r[s]=this.filterByScope(e[s],t,!1,i);else{const n=this.getScope(s,t);void 0!==n&&-1===i.indexOf(n)||(r[s]=e[s])}return r}getScope(e,t){const n=t[e];return n?void 0!==n.scope?n.scope:3:void 0}}t.ConfigurationModelParser=g;class m extends h.Disposable{constructor(e,t,n){super(),this.userSettingsResource=e,this.scopes=t,this.fileService=n,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(f.dirname(this.userSettingsResource))),this._register(d.Event.filter(this.fileService.onDidFilesChange,e=>e.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(e.value.toString()||"{}"),this.parser.configurationModel}catch(e){return new p}}reprocess(){return this.parser.parse(),
this.parser.configurationModel}}t.UserSettings=m;class v{constructor(e,t,n=new p,r=new p,s=new i.ResourceMap,o=new p,a=new i.ResourceMap,c=!0){this._defaultConfiguration=e,this._localUserConfiguration=t,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=s,this._memoryConfiguration=o,this._memoryConfigurationByResource=a,this._freeze=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new i.ResourceMap,this._userConfiguration=null}getValue(e,t,n){return this.getConsolidateConfigurationModel(t,n).getValue(e)}updateValue(e,t,n={}){let i;n.resource?(i=this._memoryConfigurationByResource.get(n.resource))||(i=new p,this._memoryConfigurationByResource.set(n.resource,i)):i=this._memoryConfiguration,void 0===t?i.removeValue(e):i.setValue(e,t),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,t,n){
const i=this.getConsolidateConfigurationModel(t,n),s=this.getFolderConfigurationModelForResource(t.resource,n),o=t.resource&&this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration,a=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),c=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),l=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),u=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),h=n?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,d=s?t.overrideIdentifier?s.freeze().override(t.overrideIdentifier).getValue(e):s.freeze().getValue(e):void 0,f=t.overrideIdentifier?o.override(t.overrideIdentifier).getValue(e):o.getValue(e),p=i.getValue(e),g=r.distinct(r.flatten(i.overrides.map(e=>e.identifiers))).filter(t=>void 0!==i.getOverrideValue(e,t))
;return{defaultValue:a,userValue:c,userLocalValue:l,userRemoteValue:u,workspaceValue:h,workspaceFolderValue:d,memoryValue:f,value:p,default:void 0!==a?{value:this._defaultConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,user:void 0!==c?{value:this.userConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userLocal:void 0!==l?{value:this.localUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userRemote:void 0!==u?{value:this.remoteUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspace:void 0!==h?{value:this._workspaceConfiguration.freeze().getValue(e),
override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspaceFolder:void 0!==d?{value:null==s?void 0:s.freeze().getValue(e),override:t.overrideIdentifier?null==s?void 0:s.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,memory:void 0!==f?{value:o.getValue(e),override:t.overrideIdentifier?o.getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:g.length?g:void 0}}keys(e){const t=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,
this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,t){this._folderConfigurations.set(e,t),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,t){const n=t.filter(e=>c.OVERRIDE_PROPERTY_PATTERN.test(e)).map(t=>{
const n=c.overrideIdentifierFromKey(t),i=this._defaultConfiguration.getKeysForOverrideIdentifier(n),r=e.getKeysForOverrideIdentifier(n),s=[...r.filter(e=>-1===i.indexOf(e)),...i.filter(e=>-1===r.indexOf(e)),...i.filter(t=>!o.equals(this._defaultConfiguration.override(n).getValue(t),e.override(n).getValue(t)))];return[n,s]});return this.updateDefaultConfiguration(e),{keys:t,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:t,updated:n,removed:i,overrides:r}=l.compare(this.localUserConfiguration,e),s=[...t,...n,...i];return s.length&&this.updateLocalUserConfiguration(e),{keys:s,overrides:r}}compareAndUpdateRemoteUserConfiguration(e){const{added:t,updated:n,removed:i,overrides:r}=l.compare(this.remoteUserConfiguration,e);let s=[...t,...n,...i];return s.length&&this.updateRemoteUserConfiguration(e),{keys:s,overrides:r}}compareAndUpdateWorkspaceConfiguration(e){const{added:t,updated:n,removed:i,overrides:r}=l.compare(this.workspaceConfiguration,e);let s=[...t,...n,...i]
;return s.length&&this.updateWorkspaceConfiguration(e),{keys:s,overrides:r}}compareAndUpdateFolderConfiguration(e,t){const n=this.folderConfigurations.get(e),{added:i,updated:r,removed:s,overrides:o}=l.compare(n,t);let a=[...i,...r,...s];return!a.length&&n||this.updateFolderConfiguration(e,t),{keys:a,overrides:o}}compareAndDeleteFolderConfiguration(e){const t=this.folderConfigurations.get(e);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:i,removed:r,overrides:s}=l.compare(t,void 0);return{keys:[...n,...i,...r],overrides:s}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){
return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,t){let n=this.getConsolidatedConfigurationModelForResource(e,t);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},t){let n=this.getWorkspaceConsolidatedConfiguration();if(t&&e){const i=t.getFolder(e);i&&(n=this.getFolderConsolidatedConfiguration(i.uri)||n);const r=this._memoryConfigurationByResource.get(e);r&&(n=n.merge(r))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){
let t=this._foldersConsolidatedConfigurations.get(e);if(!t){const n=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(e);i?(t=n.merge(i),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(e,t)):t=n}return t}getFolderConfigurationModelForResource(e,t){if(t&&e){const n=t.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,t)=>{const{contents:n,overrides:i,keys:r}=this._folderConfigurations.get(t);return e.push([t,{contents:n,overrides:i,keys:r}]),e},[])}}allKeys(){
const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>e.add(t)),this.userConfiguration.freeze().keys.forEach(t=>e.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>e.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(t=>e.add(t))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e))),[...t.values()]}static parse(e){const t=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),r=this.parseConfigurationModel(e.workspace),s=e.folders.reduce((e,t)=>(e.set(a.URI.revive(t[0]),this.parseConfigurationModel(t[1])),e),new i.ResourceMap);return new v(t,n,new p,r,s,new p,new i.ResourceMap,!1)}
static parseConfigurationModel(e){return new p(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=v,t.mergeChanges=function(...e){if(0===e.length)return{keys:[],overrides:[]};if(1===e.length)return e[0];const t=new Set,n=new Map;for(const r of e)r.keys.forEach(e=>t.add(e)),r.overrides.forEach(([e,t])=>{const r=i.getOrSet(n,e,new Set);t.forEach(e=>r.add(e))});const r=[];return n.forEach((e,t)=>r.push([t,[...e.values()]])),{keys:[...t.values()],overrides:r}};class y{constructor(e,t,n,i){this.change=e,this.previous=t,this.currentConfiguraiton=n,this.currentWorkspace=i,this._previousConfiguration=void 0;const r=new Set;e.keys.forEach(e=>r.add(e)),e.overrides.forEach(([,e])=>e.forEach(e=>r.add(e))),this.affectedKeys=[...r.values()];const s=new p;this.affectedKeys.forEach(e=>s.setValue(e,{})),this.affectedKeysTree=s.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}
affectsConfiguration(e,t){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(t){const i=this.previousConfiguration?this.previousConfiguration.getValue(e,t,null===(n=this.previous)||void 0===n?void 0:n.workspace):void 0,r=this.currentConfiguraiton.getValue(e,t,this.currentWorkspace);return!o.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(e,t){let n,i=l.toValuesTree({[t]:!0},()=>{});for(;"object"==typeof i&&(n=Object.keys(i)[0]);){if(!(e=e[n]))return!1;i=i[n]}return!0}}t.ConfigurationChangeEvent=y;t.AllKeysConfigurationChangeEvent=class extends y{constructor(e,t,n,i){super({keys:e.allKeys(),overrides:[]},void 0,e,t),this.source=n,this.sourceConfig=i}}})),define(t[59],n([0,1,32,39,3,29,145,5,15]),(function(e,t,n,i,r,s,o,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class l extends r.Disposable{constructor(e,t){super(),this.settingsResource=e,this._onDidChangeConfiguration=this._register(new a.Emitter),
this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new o.UserSettings(this.settingsResource,void 0,t)),this.configuration=new o.Configuration(new o.DefaultConfigurationModel,new o.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new c.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(n.Registry.as(i.Extensions.Configuration).onDidUpdateConfiguration(e=>this.onDidDefaultConfigurationChange(e))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const e=await this.userConfiguration.loadConfiguration();this.configuration=new o.Configuration(new o.DefaultConfigurationModel,e)}getConfigurationData(){return this.configuration.toData()}getValue(e,t){const n="string"==typeof e?e:void 0,i=s.isConfigurationOverrides(e)?e:s.isConfigurationOverrides(t)?t:{};return this.configuration.getValue(n,i,void 0)}updateValue(e,t,n,i){
return Promise.reject(new Error("not supported"))}inspect(e){return this.configuration.inspect(e,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const e=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(e)}onDidChangeUserConfiguration(e){const t=this.configuration.toData(),n=this.configuration.compareAndUpdateLocalUserConfiguration(e);this.trigger(n,t,1)}onDidDefaultConfigurationChange(e){const t=this.configuration.toData(),n=this.configuration.compareAndUpdateDefaultConfiguration(new o.DefaultConfigurationModel,e);this.trigger(n,t,6)}trigger(e,t,n){const i=new o.ConfigurationChangeEvent(e,{data:t},this.configuration);i.source=n,i.sourceConfig=this.getTargetConfiguration(n),this._onDidChangeConfiguration.fire(i)}getTargetConfiguration(e){switch(e){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=l})),
define(t[47],n([0,1,122,8,39,32,17]),(function(e,t,n,i,r,s,o){"use strict";function a(e){return e.res.statusCode&&e.res.statusCode>=200&&e.res.statusCode<300||1223===e.res.statusCode}function c(e){return 204===e.res.statusCode}Object.defineProperty(t,"__esModule",{value:!0}),t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=i.createDecorator("requestService"),t.isSuccess=a,t.asText=async function(e){if(!a(e))throw new Error("Server returned "+e.res.statusCode);return c(e)?null:(await o.streamToBuffer(e.stream)).toString()},t.asJson=async function(e){if(!a(e))throw new Error("Server returned "+e.res.statusCode);if(c(e))return null;const t=(await o.streamToBuffer(e.stream)).toString();try{return JSON.parse(t)}catch(e){throw e.message+=":\n"+t,e}},s.Registry.as(r.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:n.localize(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",
markdownDescription:n.localize(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:n.localize(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:n.localize(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[n.localize(4,null),n.localize(5,null),n.localize(6,null)],default:"override",description:n.localize(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:n.localize(8,null)}}})})),define(t[146],n([0,1,24,17]),(function(e,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestChannelClient=t.RequestChannel=void 0;t.RequestChannel=class{constructor(e){this.service=e}listen(e,t){throw new Error("Invalid listen")}call(e,t,r){switch(t){case"request":return this.service.request(r[0],n.CancellationToken.None).then(async({res:e,stream:t})=>{const n=await i.streamToBuffer(t);return[{statusCode:e.statusCode,headers:e.headers},n]})}throw new Error("Invalid call")}};class r{
constructor(e){this.channel=e}async request(e,t){return r.request(this.channel,e,t)}static async request(e,t,n){const[r,s]=await e.call("request",[t]);return{res:r,stream:i.bufferToStream(s)}}}t.RequestChannelClient=r})),define(t[147],n([0,1,60,12]),(function(e,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0,t.getProxyAgent=async function(t,r={}){const s=n.parse(t),o=r.proxyUrl||function(e){return"http:"===e.protocol?process.env.HTTP_PROXY||process.env.http_proxy||null:"https:"===e.protocol&&(process.env.HTTPS_PROXY||process.env.https_proxy||process.env.HTTP_PROXY||process.env.http_proxy)||null}(s);if(!o)return null;const a=n.parse(o);if(!/^https?:$/.test(a.protocol||""))return null;const c={host:a.hostname||"",port:a.port||("https"===a.protocol?"443":"80"),auth:a.auth,rejectUnauthorized:!i.isBoolean(r.strictSSL)||r.strictSSL};return"http:"===s.protocol?new(await new Promise((t,n)=>{e(["http-proxy-agent"],t,n)}))(c):new(await new Promise((t,n)=>{
e(["https-proxy-agent"],t,n)}))(c)}})),define(t[148],n([0,1,20,17]),(function(e,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0,t.getServiceMachineId=async function(e,t,r){let s=r&&r.get("storage.serviceMachineId",0)||null;if(s)return s;try{const i=(await t.readFile(e.serviceMachineIdResource)).value.toString();s=n.isUUID(i)?i:null}catch(e){s=null}if(!s){s=n.generateUuid();try{await t.writeFile(e.serviceMachineIdResource,i.VSBuffer.fromString(s))}catch(e){}}return r&&r.store("storage.serviceMachineId",s,0),s}})),define(t[149],n([0,1,8]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IStateService=void 0,t.IStateService=n.createDecorator("stateService")})),define(t[150],n([0,1,2,18,23,14,12,13]),(function(e,t,n,i,r,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.FileStorage=void 0;class u{constructor(e,t){this.dbPath=e,this.onError=t,this._database=null,
this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(this._database)return;const e=await this.loadAsync();this._database||(this._database=e)}loadSync(){try{return this.lastFlushedSerializedDatabase=i.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(e){return"ENOENT"!==e.code&&this.onError(e),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await a.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(e){return"ENOENT"!==e.code&&this.onError(e),{}}}getItem(e,t){const n=this.database[e];return c.isUndefinedOrNull(n)?t:n}setItem(e,t){if(c.isUndefinedOrNull(t))return this.removeItem(e);("string"!=typeof t&&"number"!=typeof t&&"boolean"!=typeof t||this.database[e]!==t)&&(this.database[e]=t,this.saveSync())}removeItem(e){c.isUndefined(this.database[e])||(this.database[e]=void 0,this.saveSync())}saveSync(){
const e=JSON.stringify(this.database,null,4);if(e!==this.lastFlushedSerializedDatabase)try{a.writeFileSync(this.dbPath,e),this.lastFlushedSerializedDatabase=e}catch(e){this.onError(e)}}}t.FileStorage=u;let h=class e{constructor(t,i){this.fileStorage=new u(n.join(t.userDataPath,e.STATE_FILE),e=>i.error(e))}init(){return this.fileStorage.init()}getItem(e,t){return this.fileStorage.getItem(e,t)}setItem(e,t){this.fileStorage.setItem(e,t)}removeItem(e){this.fileStorage.removeItem(e)}};h.STATE_FILE="storage.json",h=s([o(0,r.INativeEnvironmentService),o(1,l.ILogService)],h),t.StateService=h})),define(t[151],n([0,1,8,5,3,12]),(function(e,t,n,i,r,s){"use strict";var o;Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker",t.IStorageService=n.createDecorator("storageService"),function(e){e[e.NONE=0]="NONE",e[e.SHUTDOWN=1]="SHUTDOWN"
}(o=t.WillSaveStateReason||(t.WillSaveStateReason={})),function(e){e[e.GLOBAL=0]="GLOBAL",e[e.WORKSPACE=1]="WORKSPACE"}(t.StorageScope||(t.StorageScope={}));class a extends r.Disposable{constructor(){super(...arguments),this._onDidChangeStorage=this._register(new i.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onWillSaveState=this._register(new i.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.globalCache=new Map,this.workspaceCache=new Map}getCache(e){return 0===e?this.globalCache:this.workspaceCache}get(e,t,n){const i=this.getCache(t).get(e);return s.isUndefinedOrNull(i)?n:i}getBoolean(e,t,n){const i=this.getCache(t).get(e);return s.isUndefinedOrNull(i)?n:"true"===i}getNumber(e,t,n){const i=this.getCache(t).get(e);return s.isUndefinedOrNull(i)?n:parseInt(i,10)}store(e,t,n){if(s.isUndefinedOrNull(t))return this.remove(e,n);const i=String(t);return this.getCache(n).get(e)===i?Promise.resolve():(this.getCache(n).set(e,i),this._onDidChangeStorage.fire({scope:n,key:e}),
Promise.resolve())}remove(e,t){return this.getCache(t).delete(e)?(this._onDidChangeStorage.fire({scope:t,key:e}),Promise.resolve()):Promise.resolve()}logStorage(){c(this.globalCache,this.workspaceCache,"inMemory","inMemory")}async migrate(e){}flush(){this._onWillSaveState.fire({reason:o.NONE})}isNew(){return!0}async close(){}}async function c(e,t,n,i){const r=e=>{try{return JSON.parse(e)}catch(t){return e}},s=new Map,o=new Map;e.forEach((e,t)=>{s.set(t,e),o.set(t,r(e))});const a=new Map,c=new Map;t.forEach((e,t)=>{a.set(t,e),c.set(t,r(e))}),console.group(`Storage: Global (path: ${n})`);let l=[];s.forEach((e,t)=>{l.push({key:t,value:e})}),console.table(l),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${i})`);let u=[];a.forEach((e,t)=>{u.push({key:t,value:e})}),console.table(u),console.groupEnd(),console.log(c)}t.InMemoryStorageService=a,t.logStorage=c})),define(t[152],n([0,1,21,16,3,19]),(function(e,t,n,i,r,s){"use strict";var o;Object.defineProperty(t,"__esModule",{value:!0}),
t.ErrorEvent=void 0,function(e){e.compare=function(e,t){return e.callstack<t.callstack?-1:e.callstack>t.callstack?1:0}}(o=t.ErrorEvent||(t.ErrorEvent={}));class a{constructor(e,t=a.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new r.DisposableStore,this._telemetryService=e,this._flushDelay=t;const n=i.errorHandler.addListener(e=>this._onErrorEvent(e));this._disposables.add(r.toDisposable(n)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(e){if(!e)return;e.detail&&e.detail.stack&&(e=e.detail);let t=Array.isArray(e.stack)?e.stack.join("\n"):e.stack,n=e.message?e.message:s.safeStringify(e);t&&this._enqueue({msg:n,callstack:t})}_enqueue(e){const t=n.binarySearch(this._buffer,e,o.compare);t<0?(e.count=1,this._buffer.splice(~t,0,e)):(this._buffer[t].count||(this._buffer[t].count=0),this._buffer[t].count+=1),-1===this._flushHandle&&(this._flushHandle=setTimeout(()=>{
this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let e of this._buffer)this._telemetryService.publicLogError2("UnhandledError",e);this._buffer.length=0}}t.default=a,a.ERROR_FLUSH_TIMEOUT=5e3})),define(t[36],n([0,1,8]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ITelemetryService=void 0,t.ITelemetryService=n.createDecorator("telemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"})),define(t[153],n([0,1,27,69,127,18,2,50,71,26,6,7,36,8,49,4]),(function(e,t,n,i,r,a,c,l,u,h,d,f,p,g,m,v){"use strict";async function y(e,t){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",
filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,r=new Map,s=2e4;const o={count:0,maxReached:!1};await function e(t,o,l,u){const h=o.substring(t.length+1);return new Promise(d=>{a.readdir(o,{withFileTypes:!0},async(a,f)=>{var p,g,m
;if(a)return void d();if(u.count>=s)return u.count+=f.length,u.maxReached=!0,void d();let v=f.length;if(0===v)return void d();let y=f;u.count+f.length>s&&(u.maxReached=!0,v=s-u.count,y=f.slice(0,v)),u.count+=f.length;for(const s of y)if(s.isDirectory()){if(l.includes(s.name)||await e(t,c.join(o,s.name),l,u),0==--v)return void d()}else{const e=s.name.lastIndexOf(".");if(e>=0){const t=s.name.substring(e+1);t&&i.set(t,(null!==(p=i.get(t))&&void 0!==p?p:0)+1)}for(const e of n)!1!==(null===(g=e.relativePathPattern)||void 0===g?void 0:g.test(h))&&e.filePattern.test(s.name)&&r.set(e.tag,(null!==(m=r.get(e.tag))&&void 0!==m?m:0)+1);if(0==--v)return void d()}})})}(e,e,t,o);const l=await _(e);return{configFiles:w(r),fileTypes:w(i),fileCount:o.count,maxFilesReached:o.maxReached,launchConfigFiles:l}}function w(e){return[...m.Iterable.map(e.entries(),([e,t])=>({name:e,count:t}))].sort((e,t)=>t.count-e.count)}function E(){const e=1073741824,t={os:`${n.type()} ${n.arch()} ${n.release()}`,
memory:`${(n.totalmem()/e).toFixed(2)}GB (${(n.freemem()/e).toFixed(2)}GB free)`,vmHint:`${Math.round(100*i.virtualMachineHint.value())}%`},r=n.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}function _(e){let t=new Map,n=c.join(e,".vscode","launch.json");return new Promise((e,i)=>{a.exists(n,i=>{if(!i)return e([]);a.readFile(n,(i,r)=>{if(i)return e([]);const s=[],o=l.parse(r.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),e([]);if("object"===l.getNodeType(o)&&o.configurations)for(const e of o.configurations){const n=e.type;n&&(t.has(n)?t.set(n,t.get(n)+1):t.set(n,1))}return e(w(t))})})})}Object.defineProperty(t,"__esModule",{value:!0}),t.DiagnosticsService=t.collectLaunchConfigs=t.getMachineInfo=t.collectWorkspaceStats=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=g.createDecorator(t.ID),t.collectWorkspaceStats=y,t.getMachineInfo=E,t.collectLaunchConfigs=_;let S=class{constructor(e){this.telemetryService=e}
formatMachineInfo(e){const t=[];return t.push(`OS Version:       ${e.os}`),t.push(`CPUs:             ${e.cpus}`),t.push(`Memory (System):  ${e.memory}`),t.push(`VM:               ${e.vmHint}`),t.join("\n")}formatEnvironment(e){const t=1073741824,r=[];r.push(`Version:          ${h.default.nameShort} ${h.default.version} (${h.default.commit||"Commit unknown"}, ${h.default.date||"Date unknown"})`),r.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const s=n.cpus();return s&&s.length>0&&r.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),r.push(`Memory (System):  ${(n.totalmem()/t).toFixed(2)}GB (${(n.freemem()/t).toFixed(2)}GB free)`),d.isWindows||r.push(`Load (avg):       ${n.loadavg().map(e=>Math.round(e)).join(", ")}`),r.push(`VM:               ${Math.round(100*i.virtualMachineHint.value())}%`),r.push(`Screen Reader:    ${e.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${e.mainArguments.join(" ")}`),
r.push(`GPU Status:       ${this.expandGPUFeatures(e.gpuFeatureStatus)}`),r.join("\n")}async getPerformanceInfo(e,t){return Promise.all([u.listProcesses(e.mainPID),this.formatWorkspaceMetadata(e)]).then(async n=>{let[i,s]=n,o=this.formatProcessList(e,i);return t.forEach(t=>{if(r.isRemoteDiagnosticError(t))o+=`\n${t.errorMessage}`,s+=`\n${t.errorMessage}`;else if(o+=`\n\nRemote: ${t.hostName}`,t.processes&&(o+=`\n${this.formatProcessList(e,t.processes)}`),t.workspaceMetadata){s+=`\n|  Remote: ${t.hostName}`;for(const e of Object.keys(t.workspaceMetadata)){const n=t.workspaceMetadata[e];let i=`${n.fileCount} files`;n.maxFilesReached&&(i=`more than ${i}`),s+=`|    Folder (${e}): ${i}`,s+=this.formatWorkspaceStats(n)}}}),{processInfo:o,workspaceInfo:s}})}async getSystemInfo(e,t){const{memory:i,vmHint:r,os:s,cpus:o}=E(),a={os:s,memory:i,cpus:o,vmHint:r,processArgs:`${e.mainArguments.join(" ")}`,gpuStatus:e.gpuFeatureStatus,screenReader:`${e.screenReader?"yes":"no"}`,remoteData:t}
;return d.isWindows||(a.load=`${n.loadavg().map(e=>Math.round(e)).join(", ")}`),d.isLinux&&(a.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(a)}async getDiagnostics(e,t){const n=[];return u.listProcesses(e.mainPID).then(async i=>(n.push(""),n.push(this.formatEnvironment(e)),n.push(""),n.push(this.formatProcessList(e,i)),e.windows.some(e=>e.folderURIs&&e.folderURIs.length>0&&!e.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(e))),t.forEach(t=>{if(r.isRemoteDiagnosticError(t))n.push(`\n${t.errorMessage}`);else if(n.push("\n\n"),n.push(`Remote:           ${t.hostName}`),n.push(this.formatMachineInfo(t.machineInfo)),t.processes&&n.push(this.formatProcessList(e,t.processes)),t.workspaceMetadata)for(const e of Object.keys(t.workspaceMetadata)){const i=t.workspaceMetadata[e]
;let r=`${i.fileCount} files`;i.maxFilesReached&&(r=`more than ${r}`),n.push(`Folder (${e}): ${r}`),n.push(this.formatWorkspaceStats(i))}}),n.push(""),n.push(""),n.join("\n")))}formatWorkspaceStats(e){const t=[];let n=0;const i=(e,i)=>{const s=` ${e}(${i})`;n+s.length>60?(t.push(r),n=(r="|                 ").length):n+=s.length,r+=s};let r="|      File types:";let s=e.fileTypes.length>10?10:e.fileTypes.length;for(let t=0;t<s;t++){const n=e.fileTypes[t];i(n.name,n.count)}if(t.push(r),e.configFiles.length>=0&&(r="|      Conf files:",n=0,e.configFiles.forEach(e=>{i(e.name,e.count)}),t.push(r)),e.launchConfigFiles.length>0){let n="|      Launch Configs:";e.launchConfigFiles.forEach(e=>{const t=e.count>1?` ${e.name}(${e.count})`:` ${e.name}`;n+=t}),t.push(n)}return t.join("\n")}expandGPUFeatures(e){const t=Math.max(...Object.keys(e).map(e=>e.length));return Object.keys(e).map(n=>`${n}:  ${" ".repeat(t-n.length)}  ${e[n]}`).join("\n                  ")}formatWorkspaceMetadata(e){const t=[],n=[]
;return e.windows.forEach(e=>{0===e.folderURIs.length||e.remoteAuthority||(t.push(`|  Window (${e.title})`),e.folderURIs.forEach(e=>{const i=f.URI.revive(e);if(i.scheme===v.Schemas.file){const e=i.fsPath;n.push(y(e,["node_modules",".git"]).then(n=>{let i=`${n.fileCount} files`;n.maxFilesReached&&(i=`more than ${i}`),t.push(`|    Folder (${c.basename(e)}): ${i}`),t.push(this.formatWorkspaceStats(n))}).catch(n=>{t.push(`|      Error: Unable to collect workspace stats for folder ${e} (${n.toString()})`)}))}else t.push(`|    Folder (${i.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(e=>t.join("\n")).catch(e=>`Unable to collect workspace stats: ${e}`)}formatProcessList(e,t){const n=new Map;e.windows.forEach(e=>n.set(e.pid,e.title));const i=[];return i.push("CPU %\tMem MB\t   PID\tProcess"),t&&this.formatProcessItem(e.mainPID,n,i,t,0),i.join("\n")}formatProcessItem(e,t,i,r,s){let o;0===s?o=r.pid===e?`${h.default.applicationName} main`:"remote agent":(o=`${"  ".repeat(s)} ${r.name}`,
"window"===r.name&&(o=`${o} (${t.get(r.pid)})`));const a="win32"===process.platform?r.mem:n.totalmem()*(r.mem/100);i.push(`${r.load.toFixed(0).padStart(5," ")}\t${(a/1048576).toFixed(0).padStart(6," ")}\t${r.pid.toFixed(0).padStart(6," ")}\t${o}`),Array.isArray(r.children)&&r.children.forEach(n=>this.formatProcessItem(e,t,i,n,s+1))}async reportWorkspaceStats(e){for(const{uri:t}of e.folders){const n=f.URI.revive(t);if(n.scheme!==v.Schemas.file)continue;const i=n.fsPath;try{const t=await y(i,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":e.telemetryId,rendererSessionId:e.rendererSessionId}),t.fileTypes.forEach(t=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:e.rendererSessionId,type:t.name,count:t.count})}),t.launchConfigFiles.forEach(t=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:e.rendererSessionId,type:t.name,count:t.count})}),t.configFiles.forEach(t=>{
this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:e.rendererSessionId,type:t.name,count:t.count})})}catch(e){}}}};S=s([o(0,p.ITelemetryService)],S),t.DiagnosticsService=S})),define(t[61],n([0,1,16,28,31,19,36,47,54,23,24,13,25,7,38,151,148,8,22]),(function(e,t,n,i,r,a,c,l,u,h,d,f,p,g,m,v,y,w,E){"use strict";var _,S;Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0,function(e){e[e.None=0]="None",e[e.IncludeVersions=1]="IncludeVersions",e[e.IncludeFiles=2]="IncludeFiles",e[e.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",e[e.IncludeSharedAccounts=8]="IncludeSharedAccounts",e[e.IncludeVersionProperties=16]="IncludeVersionProperties",e[e.ExcludeNonValidated=32]="ExcludeNonValidated",e[e.IncludeInstallationTargets=64]="IncludeInstallationTargets",e[e.IncludeAssetUri=128]="IncludeAssetUri",e[e.IncludeStatistics=256]="IncludeStatistics",e[e.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",
e[e.Unpublished=4096]="Unpublished"}(_||(_={})),function(e){e[e.Tag=1]="Tag",e[e.ExtensionId=4]="ExtensionId",e[e.Category=5]="Category",e[e.ExtensionName=7]="ExtensionName",e[e.Target=8]="Target",e[e.Featured=9]="Featured",e[e.SearchText=10]="SearchText",e[e.ExcludeWithFlags=12]="ExcludeWithFlags"}(S||(S={}));const b={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},C={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},x={pageNumber:1,
pageSize:10,sortBy:0,sortOrder:0,flags:_.None,criteria:[],assetTypes:[]};class P{constructor(e=x){this.state=e}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(e,t=this.state.pageSize){return new P(Object.assign(Object.assign({},this.state),{pageNumber:e,pageSize:t}))}withFilter(e,...t){const n=[...this.state.criteria,...t.length?t.map(t=>({filterType:e,value:t})):[{filterType:e}]];return new P(Object.assign(Object.assign({},this.state),{criteria:n}))}withSortBy(e){return new P(Object.assign(Object.assign({},this.state),{sortBy:e}))}withSortOrder(e){return new P(Object.assign(Object.assign({},this.state),{sortOrder:e}))}withFlags(...e){return new P(Object.assign(Object.assign({},this.state),{flags:e.reduce((e,t)=>e|t,0)}))}withAssetTypes(...e){return new P(Object.assign(Object.assign({},this.state),{assetTypes:e}))}get raw(){
const{criteria:e,pageNumber:t,pageSize:n,sortBy:i,sortOrder:r,flags:s,assetTypes:o}=this.state;return{filters:[{criteria:e,pageNumber:t,pageSize:n,sortBy:i,sortOrder:r}],assetTypes:o,flags:s}}get searchText(){const e=this.state.criteria.filter(e=>e.filterType===S.SearchText)[0];return e&&e.value?e.value:""}}function I(e,t){const n=(e||[]).filter(e=>e.statisticName===t)[0];return n?n.value:0}function k(e){return e.files.filter(e=>0===e.assetType.indexOf("Microsoft.VisualStudio.Code.Translation.")).reduce((t,n)=>{const i=T(e,n.assetType);return i&&t.push([n.assetType.substring("Microsoft.VisualStudio.Code.Translation.".length),i]),t},[])}function O(e){if(e.properties){const t=e.properties.filter(e=>e.key===b.Repository),n=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),i=t.filter(e=>n.test(e.value))[0];return i?{uri:i.value,fallbackUri:i.value}:null}return T(e,b.Repository)}function D(e){return{uri:`${e.fallbackAssetUri}/${b.VSIX}?redirect=true`,
fallbackUri:`${e.fallbackAssetUri}/${b.VSIX}`}}function L(e){const t=T(e,b.Icon);if(t)return t;const n=i.DefaultIconPath;return{uri:n,fallbackUri:n}}function T(e,t){return e.files.filter(e=>e.assetType===t)[0]?{uri:`${e.assetUri}/${t}`,fallbackUri:`${e.fallbackAssetUri}/${t}`}:null}function A(e,t){const n=e.properties?e.properties.filter(e=>e.key===t):[],i=n.length>0&&n[0].value;return i?i.split(",").map(e=>r.adoptToGalleryExtensionId(e)):[]}function R(e){const t=e.properties?e.properties.filter(e=>e.key===C.Engine):[];return t.length>0&&t[0].value||""}function F(e){const t=e.properties?e.properties.filter(e=>e.key===C.LocalizedLanguages):[],n=t.length>0&&t[0].value||"";return n?n.split(","):[]}function M(e){const t=e.properties?e.properties.find(e=>e.key===C.WebExtension):void 0;return!!t&&"true"===t.value}function N(e){return e.files.some(e=>e.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?E.joinPath(g.URI.parse(e.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}
function U(e,t,n,i,s){const o={manifest:T(t,b.Manifest),readme:T(t,b.Details),changelog:T(t,b.Changelog),license:T(t,b.License),repository:O(t),download:D(t),icon:L(t),coreTranslations:k(t)};return{identifier:{id:r.getGalleryExtensionId(e.publisher.publisherName,e.extensionName),uuid:e.extensionId},name:e.extensionName,version:t.version,date:t.lastUpdated,displayName:e.displayName,publisherId:e.publisher.publisherId,publisher:e.publisher.publisherName,publisherDisplayName:e.publisher.displayName,description:e.shortDescription||"",installCount:I(e.statistics,"install"),rating:I(e.statistics,"averagerating"),ratingCount:I(e.statistics,"ratingcount"),assetUri:g.URI.parse(t.assetUri),webResource:N(t),assetTypes:t.files.map(({assetType:e})=>e),assets:o,properties:{dependencies:A(t,C.Dependency),extensionPack:A(t,C.ExtensionPack),engine:R(t),localizedLanguages:F(t),webExtension:M(t)},telemetryData:{index:(i.pageNumber-1)*i.pageSize+n,searchText:i.searchText,querySource:s},preview:(a=e.flags,
-1!==a.indexOf("preview"))};var a}let j=class{constructor(e,t,n,i,r,s,o){this.requestService=e,this.logService=t,this.environmentService=n,this.telemetryService=i,this.fileService=r,this.productService=s;const a=s.extensionsGallery;this.extensionsGalleryUrl=a&&a.serviceUrl,this.extensionsControlUrl=a&&a.controlUrl,this.commonHeadersPromise=z(s.version,this.environmentService,this.fileService,o)}api(e=""){return`${this.extensionsGalleryUrl}${e}`}isEnabled(){return!!this.extensionsGalleryUrl}async getCompatibleExtension(e,t){const n=await this.getCompatibleExtensionByEngine(e,t);return(null==n?void 0:n.properties.webExtension)?n.webResource?n:null:n}async getCompatibleExtensionByEngine(e,t){const n=i.isIExtensionIdentifier(e)?null:e;if(n&&n.properties.engine&&u.isEngineValid(n.properties.engine,this.productService.version))return n;const{id:r,uuid:s}=n?n.identifier:e
;let o=(new P).withFlags(_.IncludeAssetUri,_.IncludeStatistics,_.IncludeFiles,_.IncludeVersionProperties).withPage(1,1).withFilter(S.Target,"Microsoft.VisualStudio.Code");o=s?o.withFilter(S.ExtensionId,s):o.withFilter(S.ExtensionName,r);const{galleryExtensions:a}=await this.queryGallery(o,d.CancellationToken.None),[c]=a;if(!c||!c.versions.length)return null;if(t){const e=c.versions.filter(e=>e.version===t)[0];if(e){const t=U(c,e,0,o);if(t.properties.engine&&u.isEngineValid(t.properties.engine,this.productService.version))return t}return null}const l=await this.getLastValidExtensionVersion(c,c.versions);return l?U(c,l,0,o):null}async query(e,t){const i=d.CancellationToken.isCancellationToken(e)?{}:e,r=d.CancellationToken.isCancellationToken(e)?e:t;if(!this.isEnabled())throw new Error("No extension gallery service configured.");const s=i.names?"ids":i.text?"text":"all";let o=i.text||"";const c=a.getOrDefault(i,e=>e.pageSize,50);this.telemetryService.publicLog2("galleryService:query",{type:s,text:o})
;let l=(new P).withFlags(_.IncludeLatestVersionOnly,_.IncludeAssetUri,_.IncludeStatistics,_.IncludeFiles,_.IncludeVersionProperties).withPage(1,c).withFilter(S.Target,"Microsoft.VisualStudio.Code");o?((o=(o=(o=(o=o.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(e,t,n)=>(l=l.withFilter(S.Category,n||t),""))).replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(e,t,n)=>(l=l.withFilter(S.Tag,n||t),""))).replace(/\bfeatured(\s+|\b|$)/g,()=>(l=l.withFilter(S.Featured),""))).trim())&&(o=o.length<200?o:o.substring(0,200),l=l.withFilter(S.SearchText,o)),l=l.withSortBy(0)):l=i.ids?l.withFilter(S.ExtensionId,...i.ids):i.names?l.withFilter(S.ExtensionName,...i.names):l.withSortBy(4),"number"==typeof i.sortBy&&(l=l.withSortBy(i.sortBy)),"number"==typeof i.sortOrder&&(l=l.withSortOrder(i.sortOrder));const{galleryExtensions:u,total:h}=await this.queryGallery(l,r);return{firstPage:u.map((e,t)=>U(e,e.versions[0],t,l,i.source)),total:h,pageSize:l.pageSize,getPage:async(e,t)=>{
if(t.isCancellationRequested)throw n.canceled();const r=l.withPage(e+1),{galleryExtensions:s}=await this.queryGallery(r,t);return s.map((e,t)=>U(e,e.versions[0],t,r,i.source))}}}async queryGallery(e,t){if(!this.isEnabled())throw new Error("No extension gallery service configured.");e=e.withFlags(e.flags,_.ExcludeNonValidated).withFilter(S.ExcludeWithFlags,function(...e){return String(e.reduce((e,t)=>e|t,0))}(_.Unpublished));const n=await this.commonHeadersPromise,i=JSON.stringify(e.raw),r=Object.assign(Object.assign({},n),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(i.length)}),s=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:i,headers:r},t);if(s.res.statusCode&&s.res.statusCode>=400&&s.res.statusCode<500)return{galleryExtensions:[],total:0};const o=await l.asJson(s);if(o){
const e=o.results[0],t=e.extensions,n=e.resultMetadata&&e.resultMetadata.filter(e=>"ResultCount"===e.metadataType)[0];return{galleryExtensions:t,total:n&&n.metadataItems.filter(e=>"TotalCount"===e.name)[0].count||0}}return{galleryExtensions:[],total:0}}async reportStatistic(e,t,n,i){if(!this.isEnabled())return;const r=await this.commonHeadersPromise,s=Object.assign(Object.assign({},r),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${e}/extensions/${t}/${n}/stats?statType=${i}`),headers:s},d.CancellationToken.None)}catch(e){}}async download(e,t,n){this.logService.trace("ExtensionGalleryService#download",e.identifier.id);const i=r.getGalleryExtensionTelemetryData(e),s=(new Date).getTime(),o=1===n?"install":2===n?"update":"",a=o?{uri:`${e.assets.download.uri}&${o}=true`,fallbackUri:`${e.assets.download.fallbackUri}?${o}=true`}:e.assets.download,c=await this.getAsset(a);await this.fileService.writeFile(t,c.stream),
(e=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},i),{duration:e})))((new Date).getTime()-s)}async getReadme(e,t){if(e.assets.readme){const n=await this.getAsset(e.assets.readme,{},t);return await l.asText(n)||""}return""}async getManifest(e,t){if(e.assets.manifest){const n=await this.getAsset(e.assets.manifest,{},t),i=await l.asText(n);return i?JSON.parse(i):null}return null}async getCoreTranslation(e,t){const n=e.assets.coreTranslations.filter(e=>e[0]===t.toUpperCase())[0];if(n){const e=await this.getAsset(n[1]),t=await l.asText(e);return t?JSON.parse(t):null}return null}async getChangelog(e,t){if(e.assets.changelog){const n=await this.getAsset(e.assets.changelog,{},t);return await l.asText(n)||""}return""}async getAllVersions(e,t){let n=(new P).withFlags(_.IncludeVersions,_.IncludeFiles,_.IncludeVersionProperties).withPage(1,1).withFilter(S.Target,"Microsoft.VisualStudio.Code")
;n=e.identifier.uuid?n.withFilter(S.ExtensionId,e.identifier.uuid):n.withFilter(S.ExtensionName,e.identifier.id);const i=[],{galleryExtensions:r}=await this.queryGallery(n,d.CancellationToken.None);return r.length&&(t?await Promise.all(r[0].versions.map(async e=>{let t;try{t=await this.getEngine(e)}catch(e){}t&&u.isEngineValid(t,this.productService.version)&&i.push({version:e.version,date:e.lastUpdated})})):i.push(...r[0].versions.map(e=>({version:e.version,date:e.lastUpdated})))),i}async getAsset(e,t={},i=d.CancellationToken.None){const r=await this.commonHeadersPromise,s=Object.assign(Object.assign({},r),t.headers||{});t=Object.assign(Object.assign(Object.assign({},t),{type:"GET"}),{headers:s});const o=e.uri,a=e.fallbackUri,c=Object.assign(Object.assign({},t),{url:o});try{const e=await this.requestService.request(c,i);if(200===e.res.statusCode)return e;const t=await l.asText(e);throw new Error(`Expected 200, got back ${e.res.statusCode} instead.\n\n${t}`)}catch(e){if(n.isPromiseCanceledError(e))throw e
;const r=n.getErrorMessage(e);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:o,message:r});const s=Object.assign(Object.assign({},t),{url:a});return this.requestService.request(s,i)}}async getLastValidExtensionVersion(e,t){const n=this.getLastValidExtensionVersionFromProperties(e,t);return n||this.getLastValidExtensionVersionRecursively(e,t)}getLastValidExtensionVersionFromProperties(e,t){for(const e of t){const t=R(e);if(!t)return null;if(u.isEngineValid(t,this.productService.version))return e}return null}async getEngine(e){const t=R(e);if(t)return t;const n=T(e,b.Manifest);if(!n)throw new Error("Manifest was not found");const i=await this.getAsset(n,{headers:{"Accept-Encoding":"gzip"}}),r=await l.asJson(i);if(r)return r.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(e,t){if(!t.length)return null;const n=t[0],i=await this.getEngine(n);return u.isEngineValid(i,this.productService.version)?(n.properties=n.properties||[],
n.properties.push({key:C.Engine,value:i}),n):this.getLastValidExtensionVersionRecursively(e,t.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const e=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},d.CancellationToken.None);if(200!==e.res.statusCode)throw new Error("Could not get extensions report.");const t=await l.asJson(e),n=new Map;if(t)for(const e of t.malicious){const t=n.get(e)||{id:{id:e},malicious:!0,slow:!1};t.malicious=!0,n.set(e,t)}return[...n.values()]}};async function z(e,t,n,i){const r={"X-Market-Client-Id":`VSCode ${e}`,"User-Agent":`VSCode ${e}`},s=await y.getServiceMachineId(t,n,i);return r["X-Market-User-Id"]=s,r}j=s([o(0,l.IRequestService),o(1,f.ILogService),o(2,h.IEnvironmentService),o(3,c.ITelemetryService),o(4,p.IFileService),o(5,m.IProductService),o(6,w.optional(v.IStorageService))],j),t.ExtensionGalleryService=j,t.resolveMarketplaceHeaders=z})),
define(t[82],n([0,1,123,11,8,29,39,3,19,32]),(function(e,t,n,i,r,a,c,l,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let d=class{constructor(e,t){this._configurationService=t,this._experimentProperties={},this._disposables=new l.DisposableStore,this._cleanupPatterns=[],this._appender=e.appender,this._commonProperties=e.commonProperties||Promise.resolve({}),this._piiPaths=e.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!e.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let e of this._piiPaths)this._cleanupPatterns.push(new RegExp(i.escapeRegExpCharacters(e),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(e=>{const t=/^[a-f0-9]+$/i.test(e["common.machineId"]);this.publicLog2("machineIdFallback",{
usingFallbackGuid:!t})}))}setExperimentProperty(e,t){this._experimentProperties[e]=t}setEnabled(e){this._enabled=e}_updateUserOptIn(){var e;const t=null===(e=this._configurationService)||void 0===e?void 0:e.getValue(f);this._userOptIn=t?t.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const e=await this._commonProperties;return{sessionId:e.sessionID,instanceId:e["common.instanceId"],machineId:e["common.machineId"],msftInternal:e["common.msftInternal"]}}dispose(){this._disposables.dispose()}publicLog(e,t,n){return this.isOptedIn?this._commonProperties.then(i=>{t=u.mixin(t,i),t=u.mixin(t,this._experimentProperties),t=u.cloneAndChange(t,e=>{if("string"==typeof e)return this._cleanupInfo(e,n)}),this._appender.log(e,t)},e=>{console.error(e)}):Promise.resolve(void 0)}publicLog2(e,t,n){return this.publicLog(e,t,n)}publicLogError(e,t){return this.sendErrorTelemetry?this.publicLog(e,t,!0):Promise.resolve(void 0)}publicLogError2(e,t){
return this.publicLogError(e,t)}_cleanupInfo(e,t){let n=e;if(t){const t=[];for(let n of this._cleanupPatterns)for(;;){const i=n.exec(e);if(!i)break;t.push([i.index,n.lastIndex])}const i=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(n="";;){const o=r.exec(e);if(!o)break;!i.test(o[0])&&t.every(([e,t])=>o.index<e||o.index>=t)&&(n+=e.substring(s,o.index)+"<REDACTED: user-file-path>",s=r.lastIndex)}s<e.length&&(n+=e.substr(s))}for(let e of this._cleanupPatterns)n=n.replace(e,"");return n}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=s([o(1,r.optional(a.IConfigurationService))],d),t.TelemetryService=d;const f="telemetry";h.Registry.as(c.Extensions.Configuration).registerConfiguration({id:f,order:110,type:"object",title:n.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",description:n.localize(1,null),default:!0,tags:["usesOnlineServices"]}}})})),
define(t[48],n([0,1,29,13,19,12]),(function(e,t,n,i,r,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.LogAppender=t.NullAppender=t.combinedAppender=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(e,t){return Promise.resolve(void 0)}publicLog2(e,t){return this.publicLog(e,t)}publicLogError(e,t){return Promise.resolve(void 0)}publicLogError2(e,t){return this.publicLogError(e,t)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId"})}},t.combinedAppender=function(...e){return{log:(t,n)=>e.forEach(e=>e.log(t,n)),flush:()=>Promise.all(e.map(e=>e.flush()))}},t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};let c=class{constructor(e){this._logService=e,
this.commonPropertiesRegex=/^sessionID$|^version$|^timestamp$|^commitHash$|^common\./}flush(){return Promise.resolve(void 0)}log(e,t){const n={};Object.keys(t).forEach(e=>{this.commonPropertiesRegex.test(e)||(n[e]=t[e])}),this._logService.trace(`telemetry/${e}`,n)}};function l(e){if(!e)return[];const t=[];return function e(t,n,i){i&&"object"==typeof i&&!Array.isArray(i)?Object.keys(i).forEach(r=>e(t,n?`${n}.${r}`:r,i[r])):t.push(n)}(t,"",e),t}c=s([o(0,i.ILogService)],c),t.LogAppender=c,t.configurationTelemetry=function(e,t){return t.onDidChangeConfiguration(t=>{6!==t.source&&e.publicLog2("updateConfiguration",{configurationSource:n.ConfigurationTargetToString(t.source),configurationKeys:l(t.sourceConfig)})})},t.validateTelemetryData=function(e){const t=Object.create(null),n=Object.create(null),i=Object.create(null);!function e(t,n,i=0,s){if(!t)return;for(let o of Object.getOwnPropertyNames(t)){const c=t[o],l=s?s+o:o
;Array.isArray(c)?n[l]=r.safeStringify(c):c instanceof Date?n[l]=c.toISOString():a.isObject(c)?i<2?e(c,n,i+1,l+"."):n[l]=r.safeStringify(c):n[l]=c}}(e,i);for(let e in i){const r=i[e=e.length>150?e.substr(e.length-149):e];"number"==typeof r?n[e]=r:"boolean"==typeof r?n[e]=r?1:0:"string"==typeof r?t[e]=r.substring(0,1023):null!=r&&(t[e]=r)}return{properties:t,measurements:n}},t.cleanRemoteAuthority=function(e){if(!e)return"none";let t="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(n=>{0===e.indexOf(`${n}+`)&&(t=n)}),t}})),define(t[83],n([0,1,172,19,48,13]),(function(e,t,n,i,r,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;let c=class{constructor(e,t,i,r){this._eventPrefix=e,this._defaultData=t,this._logService=r,this._defaultData||(this._defaultData=Object.create(null)),"string"==typeof i?this._aiClient=function(e){let t
;return n.defaultClient?(t=new n.TelemetryClient(e)).channel.setUseDiskRetryCaching(!0):(n.setup(e).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),t=n.defaultClient),0===e.indexOf("AIF-")&&(t.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),t}(i):"function"==typeof i&&(this._aiClient=i())}log(e,t){this._aiClient&&(t=i.mixin(t,this._defaultData),t=r.validateTelemetryData(t),this._logService&&this._logService.trace(`telemetry/${e}`,t),this._aiClient.trackEvent({name:this._eventPrefix+"/"+e,properties:t.properties,measurements:t.measurements}))}flush(){return this._aiClient?new Promise(e=>{this._aiClient.flush({callback:()=>{this._aiClient=void 0,e(void 0)}})}):Promise.resolve(void 0)}};c=s([o(3,a.ILogService)],c),t.AppInsightsAppender=c})),define(t[84],n([0,1,6,27,20,14]),(function(e,t,n,i,r,s){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.resolveCommonProperties=void 0,t.resolveCommonProperties=async function(e,t,o,a,c,l){const u=Object.create(null);u["common.machineId"]=o,u.sessionID=r.generateUuid()+Date.now(),u.commitHash=e,u.version=t,u["common.platformVersion"]=(i.release()||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=n.PlatformToString(n.platform),u["common.nodePlatform"]=process.platform,u["common.nodeArch"]=process.arch,u["common.product"]=l||"desktop";const h=function(e){if(!process||!process.env||!process.env.USERDNSDOMAIN)return!1;const t=process.env.USERDNSDOMAIN.toLowerCase();return e.some(e=>t===e)}(a||[]);h&&(u["common.msftInternal"]=h);let d=0;const f=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),"linux"===process.platform&&process.env.SNAP&&process.env.SNAP_REVISION&&(u["common.snap"]="true");try{
const e=await s.readFile(c,"utf8");u["common.source"]=e.slice(0,30)}catch(e){}return u}})),define(t[154],n([0,1,16,152]),(function(e,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0});class r extends i.default{installErrorListeners(){n.setUnexpectedErrorHandler(e=>console.error(e));const e=[];process.on("unhandledRejection",(t,i)=>{e.push(i),setTimeout(()=>{const r=e.indexOf(i);r>=0&&i.catch(i=>{e.splice(r,1),console.warn(`rejected promise not handled within 1 second: ${i}`),i.stack&&console.warn(`stack trace: ${i.stack}`),n.onUnexpectedError(t)})},1e3)}),process.on("rejectionHandled",t=>{const n=e.indexOf(t);n>=0&&e.splice(n,1)}),process.on("uncaughtException",e=>{n.onUnexpectedError(e)})}}t.default=r})),define(t[155],n([0,1,14,18,2]),(function(e,t,n,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0,t.buildTelemetryMessage=function(e,t){const s=Object.create(null),o=(e,t)=>{const n=JSON.parse(e);s[t]=n};if(t){
const e=n.readdirSync(t).filter(e=>{try{return i.statSync(r.join(t,e)).isDirectory()}catch(e){return!1}}),s=[];e.forEach(e=>{1===n.readdirSync(r.join(t,e)).filter(e=>"telemetry.json"===e).length&&s.push(e)}),s.forEach(e=>{const n=i.readFileSync(r.join(t,e,"telemetry.json")).toString();o(n,e)})}let a=i.readFileSync(r.join(e,"telemetry-core.json")).toString();return o(a,"vscode-core"),a=i.readFileSync(r.join(e,"telemetry-extensions.json")).toString(),o(a,"vscode-extensions"),JSON.stringify(s,null,4)}})),define(t[85],n([0,1,18,4,2,95,26]),(function(e,t,n,i,r,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InternalNLSConfiguration=t.getNLSConfiguration=void 0;const a=r.join(i.FileAccess.asFileUri("",e).fsPath,"nls.metadata.json"),c=new Map;var l;t.getNLSConfiguration=function(e,t){return(i=a,new Promise(e=>n.exists(i,e))).then(n=>{if(!n||!o.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let i=`${e}||${t}`,r=c.get(i)
;return r||(r=s.getNLSConfiguration(o.default.commit,t,a,e).then(e=>(l.is(e)&&(e._languagePackSupport=!0),e)),c.set(i,r)),r});var i},function(e){e.is=function(e){return e&&"string"==typeof e._languagePackId}}(l=t.InternalNLSConfiguration||(t.InternalNLSConfiguration={}))})),define(t[40],n([0,1,53,4]),(function(e,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createRemoteURITransformer=t.uriTransformerPath=void 0,t.uriTransformerPath=i.FileAccess.asFileUri("vs/server/uriTransformer.js",e).fsPath,t.createRemoteURITransformer=function(i){const r=e.__$__nodeRequire(t.uriTransformerPath)(i);return new n.URITransformer(r)}})),define(t[156],n([0,1,34,85,40,4,2,5,73,101]),(function(e,t,n,i,r,s,o,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionHostConnection=void 0;t.ExtensionHostConnection=class{constructor(e,t,n,i,r,s){this._environmentService=e,this._logService=t,this._reconnectionToken=n,this._onClose=new a.Emitter,this.onClose=this._onClose.event,
this._disposed=!1,this._remoteAddress=i,this._extensionHostProcess=null;const{skipWebSocketFrames:o,socket:c}=this._getUnderlyingSocket(r);this._skipWebSocketFrames=o,this._rendererConnection=c,this._rendererConnection.pause(),this._initialDataChunk=s,this._log("New connection established.")}_log(e){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${e}`)}_logError(e){this._logService.error(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${e}`)}_getUnderlyingSocket(e){return e instanceof c.NodeSocket?{skipWebSocketFrames:!0,socket:e.socket}:{skipWebSocketFrames:!1,socket:e.socket.socket}}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;this._extensionHostProcess.send({type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"})}acceptReconnection(e,t,n){this._remoteAddress=e,this._log("The client has reconnected.");const{skipWebSocketFrames:i,socket:r}=this._getUnderlyingSocket(t)
;if(!this._extensionHostProcess)return this._skipWebSocketFrames=i,this._rendererConnection=r,this._rendererConnection.pause(),void(this._initialDataChunk=n);r.pause();const s={type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:n.buffer.toString("base64"),skipWebSocketFrames:i};this._extensionHostProcess.send(s,r)}_cleanResources(){this._disposed||(this._disposed=!0,this._rendererConnection&&(this._rendererConnection.end(),this._rendererConnection=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(t){try{const c=await i.getNLSConfiguration(t.language,this._environmentService.userDataPath);let u=[];t.port&&!process.pkg&&(u=[`--inspect${t.break?"-brk":""}=0.0.0.0:${t.port}`])
;const h=await l.getShellEnvironment(this._logService,this._environmentService),d=process.env,f=this._environmentService.isBuilt?o.join(this._environmentService.appRoot,"bin"):o.join(this._environmentService.appRoot,"resources","server","bin-dev"),p=t.env||{};let g=p.PATH||h.PATH||d.PATH;g=g?f+o.delimiter+g:f;const m={env:Object.assign(Object.assign(Object.assign(Object.assign({},d),h),{AMD_ENTRYPOINT:"vs/server/remoteExtensionHostProcess",PIPE_LOGGING:"true",VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(c,void 0,0)}),p),execArgv:u,silent:!0};!function(e,t,n){const i=Object.keys(e).filter(e=>e.toLowerCase()===t.toLowerCase()),r=i.length>0?i[0]:t;e[r]=n}(m.env,"PATH",g),function(e){for(let t of Object.keys(e))null===e[t]&&delete e[t]}(m.env);const v=["--type=extensionHost",`--uriTransformerPath=${r.uriTransformerPath}`],y=this._environmentService.args["use-host-proxy"]
;void 0!==y&&v.push(`--useHostProxy=${y}`),this._extensionHostProcess=n.fork(s.FileAccess.asFileUri("bootstrap-fork",e).fsPath,v,m);const w=this._extensionHostProcess.pid;this._log(`<${w}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const E=a.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),_=a.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");E(e=>console.log("EXTHOST-STDOUT::::::::"+e)),_(e=>console.log("EXTHOST-STDERR::::::::"+e)),this._extensionHostProcess.on("message",e=>{e&&"__$console"===e.type&&(console.log("EXTHOST-LOG:::::"),console.log(e.arguments))}),this._extensionHostProcess.on("error",e=>{this._logError(`<${w}> Extension Host Process had an error`),this._logService.error(e),this._cleanResources()}),this._extensionHostProcess.on("exit",(e,t)=>{this._log(`<${w}> Extension Host Process exited with code: ${e}, signal: ${t}.`),this._cleanResources()});const S=e=>{
if("VSCODE_EXTHOST_IPC_READY"===e.type){this._extensionHostProcess.removeListener("message",S);const e={type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this._initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:this._skipWebSocketFrames};this._extensionHostProcess.send(e,this._rendererConnection),this._initialDataChunk=null,this._rendererConnection=null}};this._extensionHostProcess.on("message",S)}catch(e){console.error("ExtensionHostConnection errored"),e&&console.error(e)}}}})),define(t[157],n([0,1,5,3,7,40,46,17,2,24]),(function(e,t,n,i,r,s,o,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteAgentFileSystemChannel=void 0;class u extends i.Disposable{constructor(e,t,n,i){super(),this.logService=e,this.environmentService=t,this.uriTransformer=n,this.watcherRequests=new Map,this.fileWatcher=this._register(new o.DiskFileSystemProvider(this.logService,{watcher:this.getWatcherOptions()})),this.registerListeners(i)}registerListeners(e){const t=this._register(new n.Emitter)
;this._register(t.event(t=>{e.fire(t.map(e=>({resource:this.uriTransformer.transformOutgoingURI(e.resource),type:e.type})))})),this._register(this.fileWatcher.onDidChangeFile(e=>t.fire(e))),this._register(this.fileWatcher.onDidErrorOccur(t=>e.fire(t)))}getWatcherOptions(){const e=this.environmentService.args.fileWatcherPolling,t=Number(e);if(t>0)return{usePolling:!0,pollingInterval:t}}watch(e,t,n){const s=r.URI.revive(this.uriTransformer.transformIncoming(t));return this.environmentService.extensionsPath&&(n.excludes=[...n.excludes||[],c.posix.join(this.environmentService.extensionsPath,"**")]),this.watcherRequests.set(e,this.fileWatcher.watch(s,n)),i.toDisposable(()=>{i.dispose(this.watcherRequests.get(e)),this.watcherRequests.delete(e)})}dispose(){super.dispose(),this.watcherRequests.forEach(e=>i.dispose(e)),this.watcherRequests.clear()}}class h extends i.Disposable{constructor(e,t){super(),this.logService=e,this.environmentService=t,this.BUFFER_SIZE=262144,this.uriTransformerCache=new Map,
this.fileWatchers=new Map,this.fsProvider=this._register(new o.DiskFileSystemProvider(this.logService,{bufferSize:this.BUFFER_SIZE})),this.watchRequests=new Map}call(e,t,n){const i=this.getUriTransformer(e.remoteAuthority);switch(t){case"stat":return this.stat(i,n[0]);case"readdir":return this.readdir(i,n[0]);case"open":return this.open(i,n[0],n[1]);case"close":return this.close(n[0]);case"read":return this.read(n[0],n[1],n[2]);case"readFile":return this.readFile(i,n[0]);case"write":return this.write(n[0],n[1],n[2],n[3],n[4]);case"writeFile":return this.writeFile(i,n[0],n[1],n[2]);case"rename":return this.rename(i,n[0],n[1],n[2]);case"copy":return this.copy(i,n[0],n[1],n[2]);case"mkdir":return this.mkdir(i,n[0]);case"delete":return this.delete(i,n[0],n[1]);case"watch":return Promise.resolve(this.watch(n[0],n[1],n[2],n[3]));case"unwatch":return Promise.resolve(this.unwatch(n[0],n[1]))}throw new Error(`IPC Command ${t} not found`)}listen(e,t,n){const i=this.getUriTransformer(e.remoteAuthority);switch(t){
case"filechange":return this.onFileChange(i,n[0]);case"readFileStream":return this.onReadFileStream(i,n[0],n[1])}throw new Error(`Unknown event ${t}`)}onFileChange(e,t){const r=new n.Emitter({onFirstListenerAdd:()=>{this.fileWatchers.set(t,new u(this.logService,this.environmentService,e,r))},onLastListenerRemove:()=>{i.dispose(this.fileWatchers.get(t)),this.fileWatchers.delete(t)}});return r.event}onReadFileStream(e,t,i){const r=this.transformIncoming(e,t,!0),s=new l.CancellationTokenSource,o=new n.Emitter({onLastListenerRemove:()=>{s.cancel()}}),c=this.fsProvider.readFileStream(r,i,s.token);return c.on("data",e=>o.fire(a.VSBuffer.wrap(e))),c.on("error",e=>o.fire(e)),c.on("end",()=>{o.fire("end"),o.dispose(),s.dispose()}),o.event}getUriTransformer(e){let t=this.uriTransformerCache.get(e);return t||(t=s.createRemoteURITransformer(e),this.uriTransformerCache.set(e,t)),t}stat(e,t){const n=this.transformIncoming(e,t,!0);return this.fsProvider.stat(n)}readdir(e,t){const n=this.transformIncoming(e,t)
;return this.fsProvider.readdir(n)}open(e,t,n){const i=this.transformIncoming(e,t,!0);return this.fsProvider.open(i,n)}close(e){return this.fsProvider.close(e)}async read(e,t,n){const i=a.VSBuffer.alloc(n);return[i,await this.fsProvider.read(e,t,i.buffer,0,n)]}async readFile(e,t){const n=this.transformIncoming(e,t,!0),i=await this.fsProvider.readFile(n);return a.VSBuffer.wrap(i)}write(e,t,n,i,r){return this.fsProvider.write(e,t,n.buffer,i,r)}writeFile(e,t,n,i){const r=this.transformIncoming(e,t);return this.fsProvider.writeFile(r,n.buffer,i)}rename(e,t,n,i){const s=r.URI.revive(e.transformIncoming(t)),o=r.URI.revive(e.transformIncoming(n));return this.fsProvider.rename(s,o,i)}copy(e,t,n,i){const r=this.transformIncoming(e,t),s=this.transformIncoming(e,n);return this.fsProvider.copy(r,s,i)}mkdir(e,t){const n=this.transformIncoming(e,t);return this.fsProvider.mkdir(n)}delete(e,t,n){const i=this.transformIncoming(e,t);return this.fsProvider.delete(i,n)}transformIncoming(e,t,n=!1){
if(n&&"/vscode-resource"===t.path&&t.query){const e=JSON.parse(t.query).requestResourcePath;return r.URI.from({scheme:"file",path:e})}return r.URI.revive(e.transformIncoming(t))}watch(e,t,n,i){const r=e+t,s=this.fileWatchers.get(e);if(s){const e=s.watch(t,n,i);this.watchRequests.set(r,e)}}unwatch(e,t){const n=e+t,r=this.watchRequests.get(n);r&&(i.dispose(r),this.watchRequests.delete(n))}dispose(){super.dispose(),this.watchRequests.forEach(e=>i.dispose(e)),this.watchRequests.clear(),this.fileWatchers.forEach(e=>i.dispose(e)),this.fileWatchers.clear()}}t.RemoteAgentFileSystemChannel=h})),define(t[158],n([0,1,143]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Logger=t.Translations=void 0,function(e){e.equals=function(e,t){if(e===t)return!0;let n=Object.keys(e),i=new Set;for(let e of Object.keys(t))i.add(e);if(n.length!==i.size)return!1;for(let r of n){if(e[r]!==t[r])return!1;i.delete(r)}return 0===i.size}}(t.Translations||(t.Translations={}));t.Logger=class{constructor(e){
this._messageHandler=e}error(e,t){this._messageHandler(n.Severity.Error,e,t)}warn(e,t){this._messageHandler(n.Severity.Warning,e,t)}info(e,t){this._messageHandler(n.Severity.Info,e,t)}}})),define(t[159],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WEB_WORKER_IFRAME=void 0,t.WEB_WORKER_IFRAME={sha:"sha256-r24mDVsMuFEo8ChaY9ppVJKbY3CUM4I12Aw/yscWZbg=",
js:"\n(function() {\n\tconst workerSrc = document.getElementById('vscode-worker-src').getAttribute('data-value');\n\tconst worker = new Worker(workerSrc, { name: 'WorkerExtensionHost' });\n\tconst vscodeWebWorkerExtHostId = document.getElementById('vscode-web-worker-ext-host-id').getAttribute('data-value');\n\n\tworker.onmessage = (event) => {\n\t\tconst { data } = event;\n\t\tif (!(data instanceof MessagePort)) {\n\t\t\tconsole.warn('Unknown data received', event);\n\t\t\twindow.parent.postMessage({\n\t\t\t\tvscodeWebWorkerExtHostId,\n\t\t\t\terror: {\n\t\t\t\t\tname: 'Error',\n\t\t\t\t\tmessage: 'Unknown data received',\n\t\t\t\t\tstack: []\n\t\t\t\t}\n\t\t\t}, '*');\n\t\t\treturn;\n\t\t}\n\t\twindow.parent.postMessage({\n\t\t\tvscodeWebWorkerExtHostId,\n\t\t\tdata: data\n\t\t}, '*', [data]);\n\t};\n\n\tworker.onerror = (event) => {\n\t\tconsole.error(event.message, event.error);\n\t\twindow.parent.postMessage({\n\t\t\tvscodeWebWorkerExtHostId,\n\t\t\terror: {\n\t\t\t\tname: event.error ? event.error.name : '',\n\t\t\t\tmessage: event.error ? event.error.message : '',\n\t\t\t\tstack: event.error ? event.error.stack : []\n\t\t\t}\n\t\t}, '*');\n\t};\n})();\n"
}})),define(t[160],n([0,1,18,60,42,173,58,30,94,6,7,40,26,2,159,4]),(function(e,t,n,i,r,s,o,a,c,l,u,h,d,f,p,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WebClientServer=t.serveFile=t.serveError=void 0;const m={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function v(e,t,n,i){t.writeHead(n,{"Content-Type":"text/plain"}),t.end(i)}async function y(e,t,i,s,o=Object.create(null)){try{const e=await r.promisify(n.stat)(s),a=`W/"${[e.ino,e.size,e.mtime.getTime()].join("-")}"`;if(t.headers["if-none-match"]===a)return i.writeHead(304),i.end();o["Content-Type"]=m[f.extname(s)]||c.getMediaMime(s)||"text/plain",o.Etag=a,i.writeHead(200,o),n.createReadStream(s).pipe(i)}catch(t){return"ENOENT"!==t.code&&(e.error(t),console.error(t.toString())),i.writeHead(404,{"Content-Type":"text/plain"}),i.end("Not found")}}t.serveError=v,t.serveFile=y;const w=f.dirname(g.FileAccess.asFileUri("",e).fsPath);t.WebClientServer=class{
constructor(e,t,n){this._connectionToken=e,this._environmentService=t,this._logService=n,this._webviewEndpoint="https://{{uuid}}.vscode-webview-test.com/{{commit}}",this._mapCallbackUriToRequestId=new Map}async handle(e,t,n){try{const i=n.pathname;return"/favicon.ico"===i||"/manifest.json"===i||"/code-192.png"===i||"/code-512.png"===i?y(this._logService,e,t,f.join(w,"resources","server",i.substr(1))):/^\/static\//.test(i)?this._handleStatic(e,t,n):"/"===i?this._handleRoot(e,t,n):"/callback"===i?this._handleCallback(e,t,n):"/fetch-callback"===i?this._handleFetchCallback(e,t,n):v(0,t,404,"Not found.")}catch(e){return this._logService.error(e),console.error(e.toString()),v(0,t,500,"Internal Server Error.")}}_hasCorrectTokenCookie(e){return s.parse(e.headers.cookie||"")["vscode-tkn"]===this._connectionToken}async _handleStatic(e,t,n){const i=Object.create(null),r=decodeURIComponent(n.pathname),s=f.normalize(r.substr("/static/".length)),o=f.join(w,s)
;return a.isEqualOrParent(o,w,!l.isLinux)?y(this._logService,e,t,o,i):v(0,t,400,"Bad request.")}async _handleRoot(t,o,a){if(!t.headers.host)return v(0,o,400,"Bad request.");const c=a.query.tkn;if("string"==typeof c){const e=Object.create(null);e["Set-Cookie"]=s.serialize("vscode-tkn",c,{maxAge:604800});const t=Object.create(null);for(let e in a.query)"tkn"!==e&&(t[e]=a.query[e]);const n=i.format({pathname:"/",query:t});return e.Location=n,o.writeHead(302,e),o.end()}if(this._environmentService.isBuilt&&!this._hasCorrectTokenCookie(t))return v(0,o,403,"Forbidden.");const l=t.headers.host,d=h.createRemoteURITransformer(l),{workspacePath:f,isFolder:m}=await this._getWorkspaceFromCLI();const y=g.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",e).fsPath,w=(await r.promisify(n.readFile)(y)).toString().replace("{{WORKBENCH_WEB_CONFIGURATION}}",JSON.stringify({folderUri:f&&m?d.transformOutgoing(u.URI.file(f)):void 0,
workspaceUri:f&&!m?d.transformOutgoing(u.URI.file(f)):void 0,remoteAuthority:l,webviewEndpoint:this._webviewEndpoint,driver:"web"===this._environmentService.driverHandle||void 0}).replace(/"/g,"&quot;"));const E=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' 'unsafe-eval' https://az416426.vo.msecnd.net ${this._getScriptCspHashes(w).join(" ")} '${p.WEB_WORKER_IFRAME.sha}' http://${l};`,"child-src 'self';","frame-src 'self' https://*.vscode-webview-test.com data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ");return o.writeHead(200,{"Content-Type":"text/html","Set-Cookie":s.serialize("vscode-tkn",this._connectionToken,{maxAge:604800}),"Content-Security-Policy":E}),o.end(w)}_getScriptCspHashes(e){const t=/<script>([\s\S]+?)<\/script>/gim,n=[];let i;for(;i=t.exec(e);){
const e=o.createHash("sha256"),t=i[1].replace(/\r\n/g,"\n"),r=e.update(Buffer.from(t)).digest().toString("base64");n.push(`'sha256-${r}'`)}return n}async _getWorkspaceFromCLI(){const e=process.env.VSCODE_CWD||process.cwd(),t=this._environmentService.args.workspace;if(t&&t.length>0){const i=a.sanitizeFilePath(t,e);if(await r.promisify(n.exists)(i))return{workspacePath:i}}const i=this._environmentService.args.folder;if(i&&i.length>0){const t=a.sanitizeFilePath(i,e);if(await r.promisify(n.exists)(t))return{workspacePath:t,isFolder:!0}}return{}}_getFirstQueryValue(e,t){const n=e.query[t];return Array.isArray(n)?n[0]:n}_getFirstQueryValues(e,t){const n=new Map;for(const i in e.query){if(t&&t.indexOf(i)>=0)continue;const r=this._getFirstQueryValue(e,i);"string"==typeof r&&n.set(i,r)}return n}async _handleCallback(t,n,i){const r=["vscode-requestId","vscode-scheme","vscode-authority","vscode-path","vscode-query","vscode-fragment"],[s,o,a,c,l,h]=r.map(e=>{const t=this._getFirstQueryValue(i,e)
;return t?decodeURIComponent(t):t});if(!s)return n.writeHead(400,{"Content-Type":"text/plain"}),n.end("Bad request.");let f=l,p=0;return this._getFirstQueryValues(i,r).forEach((e,t)=>{f||(f="");const n=0==p++?"":"&";f+=`${n}${t}=${e}`}),this._mapCallbackUriToRequestId.set(s,u.URI.from({scheme:o||d.default.urlProtocol,authority:a,path:c,query:f,fragment:h}).toJSON()),y(this._logService,t,n,g.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",e).fsPath,{"Content-Type":"text/html"})}async _handleFetchCallback(e,t,n){const i=this._getFirstQueryValue(n,"vscode-requestId");if(!i)return t.writeHead(400,{"Content-Type":"text/plain"}),t.end("Bad request.");const r=this._mapCallbackUriToRequestId.get(i);return r&&this._mapCallbackUriToRequestId.delete(i),t.writeHead(200,{"Content-Type":"text/json"}),t.end(JSON.stringify(r))}}})),define(t[161],n([0,1,125,2,56,50,21,106,12,7,14,31,54,37,158]),(function(e,t,n,i,r,s,o,a,c,l,u,h,d,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.ExtensionScanner=t.ExtensionScannerInput=void 0;const g="package.json";class m{constructor(e,t,n,r,s){this._ourVersion=e,this._log=t,this._absoluteFolderPath=n,this._isBuiltin=r,this._isUnderDevelopment=s,this._absoluteManifestPath=i.join(n,g)}}class v extends m{parse(){return u.readFile(this._absoluteManifestPath).then(e=>{const t=[],i=s.parse(e.toString(),t);return 0===t.length&&"object"===s.getNodeType(i)?(i.__metadata&&(i.uuid=i.__metadata.id),delete i.__metadata,i):(t.forEach(e=>{this._log.error(this._absoluteFolderPath,n.localize(0,null,this._absoluteManifestPath,e.offset,e.length,a.getParseErrorMessage(e.error)))}),null)},e=>"ENOENT"===e.code?null:(this._log.error(this._absoluteFolderPath,n.localize(1,null,this._absoluteManifestPath,e.message)),null))}}class y extends m{constructor(e,t,n,i,r,s){super(e,t,n,i,r),this._nlsConfig=s}replaceNLS(e){const t=(e,t)=>{t.forEach(t=>{this._log.error(this._absoluteFolderPath,n.localize(2,null,e,a.getParseErrorMessage(t.error)))})},r=e=>{
this._log.error(this._absoluteFolderPath,n.localize(3,null,e))};let o=i.extname(this._absoluteManifestPath),c=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-o.length);const l=`${e.publisher}.${e.name}`;let h,d=this._nlsConfig.translations[l];return(h=d?u.readFile(d,"utf8").then(e=>{let n=[],i=s.parse(e,n);if(n.length>0)return t(d,n),{values:void 0,default:`${c}.nls.json`};if("object"!==s.getNodeType(i))return r(d),{values:void 0,default:`${c}.nls.json`};return{values:i.contents?i.contents.package:void 0,default:`${c}.nls.json`}},e=>({values:void 0,default:`${c}.nls.json`})):u.fileExists(c+".nls"+o).then(e=>{if(e)return y.findMessageBundles(this._nlsConfig,c).then(e=>e.localized?u.readFile(e.localized,"utf8").then(n=>{let i=[],o=s.parse(n,i);return i.length>0?(t(e.localized,i),{values:void 0,default:e.original}):"object"!==s.getNodeType(o)?(r(e.localized),{values:void 0,default:e.original}):{values:o,default:e.original}},t=>({values:void 0,default:e.original})):{values:void 0,
default:e.original},e=>{})})).then(n=>{if(void 0===n)return e;let i=[];return y.resolveOriginalMessageBundle(n.default,i).then(o=>{if(i.length>0)return t(n.default,i),e;if("object"!==s.getNodeType(n))return r(n.default),e;const a=n.values||Object.create(null);return y._replaceNLStrings(this._nlsConfig,e,a,o,this._log,this._absoluteFolderPath),e})},t=>e)}static resolveOriginalMessageBundle(e,t){return new Promise((n,i)=>{e?u.readFile(e).then(e=>{n(s.parse(e.toString(),t))},e=>{n(null)}):n(null)})}static findMessageBundles(e,t){return new Promise((n,i)=>{if(e.devMode||e.pseudo||!e.locale)return n({localized:t+".nls.json",original:null});!function e(t,i){let r=`${t}.nls.${i}.json`;u.fileExists(r).then(s=>{s&&n({localized:r,original:`${t}.nls.json`});let o=i.lastIndexOf("-");-1===o?n({localized:`${t}.nls.json`,original:null}):(i=i.substring(0,o),e(t,i))})}(t,e.locale)})}static _replaceNLStrings(e,t,i,r,s,o){function a(t,l,u){let h=t[l];if(c.isString(h)){let a=h,c=a.length;if(c>1&&"%"===a[0]&&"%"===a[c-1]){
let h=a.substr(1,c-2),d=i[h];void 0===d&&r&&(d=r[h]),d?(e.pseudo&&(d="［"+d.replace(/[aouei]/g,"$&$&")+"］"),t[l]=u&&("title"===l||"category"===l)&&r?{value:d,original:r[h]}:d):s.warn(o,n.localize(4,null,h))}}else if(c.isObject(h))for(let e in h)h.hasOwnProperty(e)&&a(h,e,"commands"===e||u);else if(c.isArray(h))for(let e=0;e<h.length;e++)a(h,e,u)}for(let e in t)t.hasOwnProperty(e)&&a(t,e)}}class w extends m{validate(e){let t=e;t.isBuiltin=this._isBuiltin,t.isUnderDevelopment=this._isUnderDevelopment;let n=[];return w.isValidExtensionDescription(this._ourVersion,this._absoluteFolderPath,t,n)?(n.forEach(e=>{this._log.warn(this._absoluteFolderPath,e)}),t.publisher||(t.publisher="undefined_publisher"),t.id=`${t.publisher}.${t.name}`,t.identifier=new f.ExtensionIdentifier(t.id),t.extensionLocation=l.URI.file(this._absoluteFolderPath),t):(n.forEach(e=>{this._log.error(this._absoluteFolderPath,e)}),null)}static isValidExtensionDescription(e,t,i,s){
return!!w.baseIsValidExtensionDescription(t,i,s)&&(r.valid(i.version)?d.isValidExtensionVersion(e,i,s):(s.push(n.localize(5,null)),!1))}static baseIsValidExtensionDescription(e,t,r){if(!t)return r.push(n.localize(6,null)),!1;if(void 0!==t.publisher&&"string"!=typeof t.publisher)return r.push(n.localize(7,null)),!1;if("string"!=typeof t.name)return r.push(n.localize(8,null,"name")),!1;if("string"!=typeof t.version)return r.push(n.localize(9,null,"version")),!1;if(!t.engines)return r.push(n.localize(10,null,"engines")),!1;if("string"!=typeof t.engines.vscode)return r.push(n.localize(11,null,"engines.vscode")),!1;if(void 0!==t.extensionDependencies&&!w._isStringArray(t.extensionDependencies))return r.push(n.localize(12,null,"extensionDependencies")),!1;if(void 0!==t.activationEvents){if(!w._isStringArray(t.activationEvents))return r.push(n.localize(13,null,"activationEvents")),!1;if(void 0===t.main&&void 0===t.browser)return r.push(n.localize(14,null,"activationEvents","main")),!1}if(void 0!==t.main){
if("string"!=typeof t.main)return r.push(n.localize(15,null,"main")),!1;{const s=i.join(e,t.main);s.startsWith(e)||r.push(n.localize(16,null,s,e))}if(void 0===t.activationEvents)return r.push(n.localize(17,null,"activationEvents","main")),!1}if(void 0!==t.browser){if("string"!=typeof t.browser)return r.push(n.localize(18,null,"browser")),!1;{const s=i.join(e,t.browser);s.startsWith(e)||r.push(n.localize(19,null,s,e))}if(void 0===t.activationEvents)return r.push(n.localize(20,null,"activationEvents","browser")),!1}return!0}static _isStringArray(e){if(!Array.isArray(e))return!1;for(let t=0,n=e.length;t<n;t++)if("string"!=typeof e[t])return!1;return!0}}class E{constructor(e,t,n,i,r,s,o,a){this.ourVersion=e,this.commit=t,this.locale=n,this.devMode=i,this.absoluteFolderPath=r,this.isBuiltin=s,this.isUnderDevelopment=o,this.tanslations=a}static createNLSConfig(e){return{devMode:e.devMode,locale:e.locale,pseudo:"pseudo"===e.locale,translations:e.tanslations}}static equals(e,t){
return e.ourVersion===t.ourVersion&&e.commit===t.commit&&e.locale===t.locale&&e.devMode===t.devMode&&e.absoluteFolderPath===t.absoluteFolderPath&&e.isBuiltin===t.isBuiltin&&e.isUnderDevelopment===t.isUnderDevelopment&&e.mtime===t.mtime&&p.Translations.equals(e.tanslations,t.tanslations)}}t.ExtensionScannerInput=E;class _{constructor(e){this.root=e}resolveExtensions(){return u.readDirsInDir(this.root).then(e=>e.map(e=>({name:e,path:i.join(this.root,e)})))}}t.ExtensionScanner=class{static scanExtension(e,t,n,r,s,o){return n=i.normalize(n),new v(e,t,n,r,s).parse().then(i=>{if(null===i)return null;return new y(e,t,n,r,s,o).replaceNLS(i)}).then(i=>{if(null===i)return null;return new w(e,t,n,r,s).validate(i)})}static async scanExtensions(e,t,n=null){const s=e.absoluteFolderPath,a=e.isBuiltin,c=e.isUnderDevelopment;n||(n=new _(s));try{let l={};if(!a)try{const e=await u.readFile(i.join(s,".obsolete"),"utf8");l=JSON.parse(e)}catch(e){}let d=await n.resolveExtensions();d.sort((e,t)=>e.name<t.name?-1:1),
a||(d=d.filter(e=>0!==e.name.indexOf(".")));const f=E.createNLSConfig(e);let p=await Promise.all(d.map(n=>this.scanExtension(e.ourVersion,t,n.path,a,c,f))),g=o.coalesce(p);if(g=g.filter(e=>null!==e&&!l[new h.ExtensionIdentifierWithVersion({id:h.getGalleryExtensionId(e.publisher,e.name)},e.version).key()]),!a){g=h.groupByExtension(g,e=>({id:e.identifier.value,uuid:e.uuid})).map(e=>e.sort((e,t)=>r.rcompare(e.version,t.version))[0])}return g.sort((e,t)=>e.extensionLocation.fsPath<t.extensionLocation.fsPath?-1:1),g}catch(e){return t.error(s,e),[]}}static scanOneOrMultipleExtensions(e,t){const n=e.absoluteFolderPath,r=e.isBuiltin,s=e.isUnderDevelopment;return u.fileExists(i.join(n,g)).then(i=>{if(i){const i=E.createNLSConfig(e);return this.scanExtension(e.ourVersion,t,n,r,s,i).then(e=>null===e?[]:[e])}return this.scanExtensions(e,t)},e=>(t.error(n,e),[]))}static scanSingleExtension(e,t){const n=e.absoluteFolderPath,i=e.isBuiltin,r=e.isUnderDevelopment,s=E.createNLSConfig(e)
;return this.scanExtension(e.ourVersion,t,n,i,r,s)}static mergeBuiltinExtensions(e,t){return Promise.all([e,t]).then(([e,t])=>{let n=Object.create(null);for(let t=0,i=e.length;t<i;t++)n[f.ExtensionIdentifier.toKey(e[t].identifier)]=e[t];for(let e=0,i=t.length;e<i;e++)n[f.ExtensionIdentifier.toKey(t[e].identifier)]=t[e];let r=Object.keys(n).map(e=>n[e]);return r.sort((e,t)=>{const n=i.basename(e.extensionLocation.fsPath),r=i.basename(t.extensionLocation.fsPath);return n<r?-1:n>r?1:0}),r})}}})),define(t[162],n([0,1,6,7,40,124,14,4,26,161,37,53,85,137,71,153,2]),(function(e,t,n,i,r,s,o,a,c,l,u,h,d,f,p,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteAgentEnvironmentChannel=void 0;let v=null;let y=null;function w(){return y||(y=m.normalize(m.join(a.FileAccess.asFileUri("",e).fsPath,"..",".build","builtInExtensions"))),y}class E{constructor(e,t,n,i,r){this._connectionToken=e,this.environmentService=t,this.logService=n,this.telemetryService=i,this.telemetryAppender=r,
this._logger=new class{error(e,t){n.error(e,t)}warn(e,t){n.warn(e,t)}info(e,t){n.info(e,t)}}}async call(e,t,n){switch(t){case"disableTelemetry":return void this.telemetryService.setEnabled(!1);case"getEnvironmentData":{const e=n,t=r.createRemoteURITransformer(e.remoteAuthority);let i=await this._getEnvironmentData();return i=h.transformOutgoingURIs(i,t)}case"scanExtensions":{const e=n,t=e.language;this.logService.trace(`Scanning extensions using UI language: ${t}`);const s=r.createRemoteURITransformer(e.remoteAuthority),o=e.extensionDevelopmentPath&&e.extensionDevelopmentPath.map(e=>i.URI.revive(s.transformIncoming(e))),c=o?o.filter(e=>e.scheme===a.Schemas.file).map(e=>e.fsPath):void 0;let l=await this._scanExtensions(t,c);return l=h.transformOutgoingURIs(l,s),E._massageWhenConditions(l),l}case"scanSingleExtension":{const e=n,t=e.language,s=e.isBuiltin,o=r.createRemoteURITransformer(e.remoteAuthority),c=i.URI.revive(o.transformIncoming(e.extensionLocation)),l=c.scheme===a.Schemas.file?c.fsPath:null
;if(!l)return null;const u=await this._getTranslations(t);let d=await this._scanSingleExtension(l,s,t,u);return d?(d=h.transformOutgoingURIs(d,o),E._massageWhenConditions([d]),d):null}case"getDiagnosticInfo":{const e=n,t={machineInfo:g.getMachineInfo()},s=e.includeProcesses?p.listProcesses(process.pid):Promise.resolve();let o=[];const a={};if(e.folders){const t=r.createRemoteURITransformer("");o=e.folders.map(e=>i.URI.revive(t.transformIncoming(e))).filter(e=>"file"===e.scheme).map(e=>g.collectWorkspaceStats(e.fsPath,["node_modules",".git"]).then(t=>{a[m.basename(e.fsPath)]=t}))}return Promise.all([s,...o]).then(([n,i])=>(t.processes=n||void 0,t.workspaceMetadata=e.folders?a:void 0,t))}case"logTelemetry":{const{eventName:e,data:t}=n;return this.telemetryAppender?this.telemetryAppender.log(e,t):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve()}throw new Error(`IPC Command ${t} not found`)}listen(e,t,n){throw new Error("Not supported")}
static _massageWhenConditions(e){const t=(e,t)=>e.replace(/file/g,"vscode-remote"),n=new class{mapDefined(e){return f.ContextKeyDefinedExpr.create(e)}mapNot(e){return f.ContextKeyNotExpr.create(e)}mapEquals(e,n){return"resourceScheme"===e&&"string"==typeof n?f.ContextKeyEqualsExpr.create(e,t(n)):f.ContextKeyEqualsExpr.create(e,n)}mapNotEquals(e,n){return"resourceScheme"===e&&"string"==typeof n?f.ContextKeyNotEqualsExpr.create(e,t(n)):f.ContextKeyNotEqualsExpr.create(e,n)}mapRegex(e,n){return"resourceScheme"===e&&n?f.ContextKeyRegexExpr.create(e,(e=>{let n="";return n+=e.global?"g":"",n+=e.ignoreCase?"i":"",n+=e.multiline?"m":"",new RegExp(t(e.source),n)})(n)):f.ContextKeyRegexExpr.create(e,n)}mapIn(e,t){return f.ContextKeyInExpr.create(e,t)}},i=e=>{if(!e||!e.when||!/resourceScheme/.test(e.when))return;const t=f.ContextKeyExpr.deserialize(e.when);if(!t)return;const i=t.map(n);e.when=i.serialize()},r=e=>{if(Array.isArray(e))for(let t of e)i(t);else i(e)},s=e=>{for(let t in e)r(e[t])};e.forEach(e=>{
e.contributes&&(e.contributes.menus&&s(e.contributes.menus),e.contributes.keybindings&&r(e.contributes.keybindings),e.contributes.views&&s(e.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken,appRoot:i.URI.file(this.environmentService.appRoot),settingsPath:this.environmentService.machineSettingsResource,logsPath:i.URI.file(this.environmentService.logsPath),extensionsPath:i.URI.file(this.environmentService.extensionsPath),extensionHostLogsPath:i.URI.file(m.join(this.environmentService.logsPath,`exthost${E._namePool++}`)),globalStorageHome:this.environmentService.globalStorageHome,workspaceStorageHome:this.environmentService.workspaceStorageHome,userHome:this.environmentService.userHome,os:n.OS}}async _getTranslations(e){const t=await d.getNLSConfiguration(e,this.environmentService.userDataPath);if(!d.InternalNLSConfiguration.is(t))return Object.create(null);try{const e=await o.readFile(t._translationsConfigFile,"utf8");return JSON.parse(e)}catch(e){
return Object.create(null)}}async _scanExtensions(e,t){const n=await this._getTranslations(e),[i,r,o]=await Promise.all([this._scanBuiltinExtensions(e,n),this._scanInstalledExtensions(e,n),this._scanDevelopedExtensions(e,n,t)]);let a=new Map;i.forEach(e=>{e&&a.set(u.ExtensionIdentifier.toKey(e.identifier),e)}),r.forEach(e=>{e&&(a.has(u.ExtensionIdentifier.toKey(e.identifier))&&console.warn(s.localize(0,null,a.get(u.ExtensionIdentifier.toKey(e.identifier)).extensionLocation.fsPath,e.extensionLocation.fsPath)),a.set(u.ExtensionIdentifier.toKey(e.identifier),e))}),o.forEach(e=>{e&&a.set(u.ExtensionIdentifier.toKey(e.identifier),e)});const c=[];return a.forEach(e=>c.push(e)),c}_scanDevelopedExtensions(e,t,n){if(n){const i=n.map(n=>l.ExtensionScanner.scanOneOrMultipleExtensions(new l.ExtensionScannerInput(c.default.version,c.default.commit,e,!0,n,!1,!0,t),this._logger));return Promise.all(i).then(e=>{let t=[];for(let n of e)t=t.concat(n);return t})}return Promise.resolve([])}_scanBuiltinExtensions(t,n){
const i=c.default.version,r=c.default.commit,s=!!process.env.VSCODE_DEV,o=new l.ExtensionScannerInput(i,r,t,s,(v||(v=m.normalize(m.join(a.FileAccess.asFileUri("",e).fsPath,"..","extensions"))),v),!0,!1,n),u=l.ExtensionScanner.scanExtensions(o,this._logger);let h=u;if(s){class e{constructor(e){this.builtInExtensions=e}resolveExtensions(){return Promise.resolve(this.builtInExtensions.map(e=>({name:e.name,path:m.join(w(),e.name)})))}}const n=Promise.resolve(c.default.builtInExtensions||[]),o=new l.ExtensionScannerInput(i,r,t,s,w(),!0,!1,{}),a=n.then(t=>new e(t)).then(e=>l.ExtensionScanner.scanExtensions(o,this._logger,e));h=l.ExtensionScanner.mergeBuiltinExtensions(u,a)}return h}_scanInstalledExtensions(e,t){const n=!!process.env.VSCODE_DEV,i=new l.ExtensionScannerInput(c.default.version,c.default.commit,e,n,this.environmentService.extensionsPath,!1,!1,t);return l.ExtensionScanner.scanExtensions(i,this._logger)}_scanSingleExtension(e,t,n,i){
const r=!!process.env.VSCODE_DEV,s=new l.ExtensionScannerInput(c.default.version,c.default.commit,n,r,e,t,!1,i);return l.ExtensionScanner.scanSingleExtension(s,this._logger)}}t.RemoteAgentEnvironmentChannel=E,E._namePool=1})),define(t[163],n([0,1,5,3,7,20,17,41,16,43]),(function(e,t,n,i,r,s,o,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteFileSystemProvider=t.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,t.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remotefilesystem";class u extends i.Disposable{constructor(e){super(),this.session=s.generateUuid(),this._onDidChange=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchErrorOccur=this._register(new n.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeCapabilities=this._register(new n.Emitter),this.onDidChangeCapabilities=this._onDidChangeCapabilities.event;const i=e.getConnection();this.channel=i.getChannel(t.REMOTE_FILE_SYSTEM_CHANNEL_NAME),this.setCaseSensitive(!0),(async()=>{
const t=await e.getEnvironment();this.setCaseSensitive(3===(null==t?void 0:t.os))})(),this.registerListeners()}get capabilities(){return this._capabilities}registerListeners(){this._register(this.channel.listen("filechange",[this.session])(e=>{if(Array.isArray(e)){const t=e;this._onDidChange.fire(t.map(e=>({resource:r.URI.revive(e.resource),type:e.type})))}else{const t=e;this._onDidWatchErrorOccur.fire(t)}}))}setCaseSensitive(e){let t=30;e&&(t|=1024),this._capabilities=t,this._onDidChangeCapabilities.fire(void 0)}stat(e){return this.channel.call("stat",[e])}open(e,t){return this.channel.call("open",[e,t])}close(e){return this.channel.call("close",[e])}async read(e,t,n,i,r){const[s,o]=await this.channel.call("read",[e,t,r]);return n.set(s.buffer.slice(0,o),i),o}async readFile(e){return(await this.channel.call("readFile",[e])).buffer}readFileStream(e,t,n){const i=a.newWriteableStream(e=>o.VSBuffer.concat(e.map(e=>o.VSBuffer.wrap(e))).buffer),r=this.channel.listen("readFileStream",[e,t])(e=>{
if(e instanceof o.VSBuffer)i.write(e.buffer);else{if("end"===e)i.end();else{let t=e;t instanceof Error||(t=new Error(l.toErrorMessage(t))),i.end(t)}r.dispose()}});return n.onCancellationRequested(()=>{i.end(c.canceled()),r.dispose()}),i}write(e,t,n,i,r){return this.channel.call("write",[e,t,o.VSBuffer.wrap(n),i,r])}writeFile(e,t,n){return this.channel.call("writeFile",[e,o.VSBuffer.wrap(t),n])}delete(e,t){return this.channel.call("delete",[e,t])}mkdir(e){return this.channel.call("mkdir",[e])}readdir(e){return this.channel.call("readdir",[e])}rename(e,t,n){return this.channel.call("rename",[e,t,n])}copy(e,t,n){return this.channel.call("copy",[e,t,n])}watch(e,t){const n=Math.random();return this.channel.call("watch",[this.session,n,e,t]),i.toDisposable(()=>this.channel.call("unwatch",[this.session,n]))}}t.RemoteFileSystemProvider=u})),define(t[164],n([0,1,8]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IRemoteAgentService=t.RemoteExtensionLogFileName=void 0,
t.RemoteExtensionLogFileName="remoteagent",t.IRemoteAgentService=n.createDecorator("remoteAgentService")})),define(t[62],n([0,1,109,2,18,15,14,174,175,12]),(function(e,t,n,i,r,s,o,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class u extends Error{constructor(e,t){let n=t.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`}super(n),this.type=e,this.cause=t}}function h(e){if(e instanceof u)return e;let t=void 0;return/end of central directory record signature not found/.test(e.message)&&(t="CorruptZip"),new u(t,e)}function d(e,t,a,c){let l=s.createCancelablePromise(()=>Promise.resolve()),h=0;return c.onCancellationRequested(()=>{l.cancel(),e.close()}),new Promise((d,f)=>{const g=new s.Sequencer,m=t=>{t.isCancellationRequested||(h++,e.readEntry())};e.once("error",f),e.once("close",()=>l.then(()=>{c.isCancellationRequested||e.entryCount===h?d():f(new u("Incomplete",new Error(n.localize(1,null,h,e.entryCount))))},f)),e.readEntry(),
e.on("entry",u=>{if(c.isCancellationRequested)return;if(!a.sourcePathRegex.test(u.fileName))return void m(c);const h=u.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(h)){const e=i.join(t,h);return void(l=s.createCancelablePromise(t=>o.mkdirp(e).then(()=>m(t)).then(void 0,f)))}const d=p(e,u),v=function(e){const t=e.externalFileAttributes>>16||33188;return[448,56,7].map(e=>t&e).reduce((e,t)=>e+t,61440&t)}(u);l=s.createCancelablePromise(e=>g.queue(()=>d.then(s=>(function(e,t,s,a,c,l){const u=i.dirname(t),h=i.join(a,u);if(0!==h.indexOf(a))return Promise.reject(new Error(n.localize(0,null,t)));const d=i.join(a,t);let f;return l.onCancellationRequested(()=>{f&&f.destroy()}),Promise.resolve(o.mkdirp(h)).then(()=>new Promise((t,n)=>{if(!l.isCancellationRequested)try{(f=r.createWriteStream(d,{mode:s})).once("close",()=>t()),f.once("error",n),e.once("error",n),e.pipe(f)}catch(e){n(e)}}))})(s,h,v,t,0,e).then(()=>m(e)))).then(null,f))})})}function f(e,t=!1){return new Promise((n,i)=>{a.open(e,t?{lazyEntries:!0
}:void 0,(e,t)=>{e?i(h(e)):n(l.assertIsDefined(t))})})}function p(e,t){return new Promise((n,i)=>{e.openReadStream(t,(e,t)=>{e?i(h(e)):n(l.assertIsDefined(t))})})}t.ExtractError=u,t.zip=function(e,t){return new Promise((n,i)=>{const s=new c.ZipFile;t.forEach(e=>{e.contents?s.addBuffer("string"==typeof e.contents?Buffer.from(e.contents,"utf8"):e.contents,e.path):e.localPath&&s.addFile(e.localPath,e.path)}),s.end();const o=r.createWriteStream(e);s.outputStream.pipe(o),s.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>n(e))})},t.extract=function(e,t,n={},i){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let s=f(e,!0);return n.overwrite&&(s=s.then(e=>o.rimraf(t).then(()=>e))),s.then(e=>d(e,t,{sourcePathRegex:r},i))},t.buffer=function(e,t){return function(e,t){return f(e).then(e=>new Promise((i,r)=>{e.on("entry",n=>{n.fileName===t&&p(e,n).then(e=>i(e),e=>r(e))}),e.once("close",()=>r(new Error(n.localize(2,null,t))))}))}(e,t).then(e=>new Promise((t,n)=>{const i=[];e.once("error",n),
e.on("data",e=>i.push(e)),e.on("end",()=>t(Buffer.concat(i)))}))}})),define(t[86],n([0,1,62,115]),(function(e,t,n,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0,t.getManifest=function(e){return n.buffer(e,"extension/package.json").then(e=>{try{return JSON.parse(e.toString("utf8"))}catch(e){throw new Error(i.localize(0,null))}})}})),define(t[165],n([0,1,56,3,14,2,13,28,31,15,7,23,131,116,38,62,6,21,4]),(function(e,t,n,i,r,a,c,l,u,h,d,f,p,g,m,v,y,w,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;let _=class extends i.Disposable{constructor(e,t,n,i){super(),this.beforeRemovingExtension=e,this.logService=t,this.environmentService=n,this.productService=i,this._devSystemExtensionsPath=null,this.systemExtensionsPath=n.builtinExtensionsPath,this.extensionsPath=n.extensionsPath,this.uninstalledPath=a.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new h.Queue}async cleanUp(){await this.removeUninstalledExtensions(),
await this.removeOutdatedExtensions()}async scanExtensions(e){const t=[];null!==e&&0!==e||t.push(this.scanSystemExtensions().then(null,e=>Promise.reject(new l.ExtensionManagementError(this.joinErrors(e).message,"scanningSystem")))),null!==e&&1!==e||t.push(this.scanUserExtensions(!0).then(null,e=>Promise.reject(new l.ExtensionManagementError(this.joinErrors(e).message,"scanningUser"))));try{const e=await Promise.all(t);return w.flatten(e)}catch(e){throw this.joinErrors(e)}}async scanUserExtensions(e){this.logService.trace("Started scanning user extensions");let[t,i]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);if(i=i.filter(e=>!t[new u.ExtensionIdentifierWithVersion(e.identifier,e.manifest.version).key()]),e){i=u.groupByExtension(i,e=>e.identifier).map(e=>e.sort((e,t)=>n.rcompare(e.manifest.version,t.manifest.version))[0])}return this.logService.trace("Scanned user extensions:",i.length),i}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}
async extractUserExtension(e,t,n){const{identifier:i}=e,s=e.key(),o=a.join(this.extensionsPath,`.${s}`),c=a.join(this.extensionsPath,s);try{await r.rimraf(c)}catch(e){try{await r.rimraf(c)}catch(e){}throw new l.ExtensionManagementError(g.localize(0,null,c,i.id),"deleting")}await this.extractAtLocation(i,t,o,n);try{await this.rename(i,o,c,Date.now()+12e4),this.logService.info("Renamed to",c)}catch(e){this.logService.info("Rename failed. Deleting from extracted location",o);try{r.rimraf(o)}catch(e){}throw e}let u=null;try{u=await this.scanExtension(s,this.extensionsPath,1)}catch(e){}if(u)return u;throw new Error(g.localize(1,null,this.extensionsPath))}async saveMetadataForLocalExtension(e,t){this.setMetadata(e,t),t.isMachineScoped=t.isMachineScoped||void 0;const n=a.join(e.location.fsPath,"package.json"),i=await r.readFile(n,"utf8"),{manifest:s}=await this.parseManifest(i);return s.__metadata=t,await r.writeFile(n,JSON.stringify(s,null,"\t")),e}getUninstalledExtensions(){
return this.withUninstalledExtensions(e=>e)}async withUninstalledExtensions(e){return this.uninstalledFileLimiter.queue(async()=>{let t;try{t=await r.readFile(this.uninstalledPath,"utf8")}catch(e){if("ENOENT"!==e.code)throw e}let n={};if(t)try{n=JSON.parse(t)}catch(e){}const i=e(n);return Object.keys(n).length?await r.writeFile(this.uninstalledPath,JSON.stringify(n)):await r.rimraf(this.uninstalledPath),i})}async removeExtension(e,t){this.logService.trace(`Deleting ${t} extension from disk`,e.identifier.id,e.location.fsPath),await r.rimraf(e.location.fsPath),this.logService.info("Deleted from disk",e.identifier.id,e.location.fsPath)}async removeUninstalledExtension(e){await this.removeExtension(e,"uninstalled"),await this.withUninstalledExtensions(t=>delete t[new u.ExtensionIdentifierWithVersion(e.identifier,e.manifest.version).key()])}async extractAtLocation(e,t,n,i){this.logService.trace(`Started extracting the extension from ${t} to ${n}`);try{await r.rimraf(n)}catch(e){
throw new l.ExtensionManagementError(this.joinErrors(e).message,"deleting")}try{await v.extract(t,n,{sourcePath:"extension",overwrite:!0},i),this.logService.info(`Extracted extension to ${n}:`,e.id)}catch(e){try{await r.rimraf(n)}catch(e){}throw new l.ExtensionManagementError(e.message,e instanceof v.ExtractError&&e.type?e.type:"extracting")}}async rename(e,t,n,i){try{await r.rename(t,n)}catch(r){if(y.isWindows&&r&&"EPERM"===r.code&&Date.now()<i)return this.logService.info(`Failed renaming ${t} to ${n} with 'EPERM' error. Trying again...`,e.id),this.rename(e,t,n,i);throw new l.ExtensionManagementError(r.message||g.localize(2,null,t,n),r.code||"renaming")}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const e=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return e;const t=this.scanDevSystemExtensions(),[n,i]=await Promise.all([e,t]);return[...n,...i]}async scanExtensionsInDir(e,t){const n=new h.Limiter(10),i=await r.readdir(e)
;return(await Promise.all(i.map(i=>n.queue(()=>this.scanExtension(i,e,t))))).filter(e=>e&&e.identifier)}async scanExtension(e,t,n){if(1===n&&0===e.indexOf("."))return null;const i=a.join(t,e);try{const e=await r.readdir(i),{manifest:t,metadata:s}=await this.readManifest(i),o=e.filter(e=>/^readme(\.txt|\.md|)$/i.test(e))[0],c=o?d.URI.file(a.join(i,o)):void 0,l=e.filter(e=>/^changelog(\.txt|\.md|)$/i.test(e))[0],h=l?d.URI.file(a.join(i,l)):void 0,f={type:n,identifier:{id:u.getGalleryExtensionId(t.publisher,t.name)},manifest:t,location:d.URI.file(i),readmeUrl:c,changelogUrl:h,publisherDisplayName:null,publisherId:null,isMachineScoped:!1};return s&&this.setMetadata(f,s),f}catch(e){return this.logService.trace(e),null}}async scanDefaultSystemExtensions(){const e=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",e.length),e}async scanDevSystemExtensions(){const e=this.getDevSystemExtensionsList();if(e.length){
const t=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",t.length),t.filter(t=>e.some(e=>u.areSameExtensions(t.identifier,{id:e})))}return[]}setMetadata(e,t){e.publisherDisplayName=t.publisherDisplayName||null,e.publisherId=t.publisherId||null,e.identifier.uuid=t.id,e.isMachineScoped=!!t.isMachineScoped}async removeUninstalledExtensions(){const e=await this.getUninstalledExtensions(),t=await this.scanAllUserExtensions(),i=new Set;for(const n of t)e[new u.ExtensionIdentifierWithVersion(n.identifier,n.manifest.version).key()]||i.add(n.identifier.id.toLowerCase());const r=u.groupByExtension(t,e=>e.identifier);await Promise.all(r.map(async e=>{const t=e.sort((e,t)=>n.rcompare(e.manifest.version,t.manifest.version))[0];i.has(t.identifier.id.toLowerCase())||await this.beforeRemovingExtension(t)}));const s=t.filter(t=>e[new u.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])
;await Promise.all(s.map(e=>this.removeUninstalledExtension(e)))}async removeOutdatedExtensions(){const e=await this.scanAllUserExtensions(),t=[],i=u.groupByExtension(e,e=>e.identifier);t.push(...w.flatten(i.map(e=>e.sort((e,t)=>n.rcompare(e.manifest.version,t.manifest.version)).slice(1)))),await Promise.all(t.map(e=>this.removeExtension(e,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(e=>e.name)}joinErrors(e){const t=Array.isArray(e)?e:[e];return 1===t.length?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((e,t)=>new Error(`${e.message}${e.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=a.normalize(a.join(E.FileAccess.asFileUri("",e).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(e){
const t=[r.readFile(a.join(e,"package.json"),"utf8").then(e=>this.parseManifest(e)),r.readFile(a.join(e,"package.nls.json"),"utf8").then(void 0,e=>"ENOENT"!==e.code?Promise.reject(e):"{}").then(e=>JSON.parse(e))],[{manifest:n,metadata:i},s]=await Promise.all(t);return{manifest:p.localizeManifest(n,s),metadata:i}}parseManifest(e){return new Promise((t,n)=>{try{const n=JSON.parse(e),i=n.__metadata||null;delete n.__metadata,t({manifest:n,metadata:i})}catch(e){n(new Error(g.localize(3,null)))}})}};_=s([o(1,c.ILogService),o(2,f.INativeEnvironmentService),o(3,m.IProductService)],_),t.ExtensionsScanner=_})),define(t[63],n([0,1,114,2,14,3,21,62,28,31,23,15,5,56,7,26,6,13,138,43,36,54,22,20,75,8,4,24,86,140,165,141]),(function(e,t,n,i,r,a,c,l,u,h,d,f,p,g,m,v,y,w,E,_,S,b,C,x,P,I,k,O,D,L,T,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;let R=class extends a.Disposable{constructor(e,t,n,i,r,s){super(),this.environmentService=e,this.galleryService=t,this.logService=n,
this.downloadService=i,this.telemetryService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new p.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new p.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new p.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new p.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const o=this._register(s.createInstance(A.ExtensionsLifecycle));this.extensionsScanner=this._register(s.createInstance(T.ExtensionsScanner,e=>o.postUninstall(e))),this.manifestCache=this._register(new E.ExtensionsManifestCache(e,this)),this.extensionsDownloader=this._register(s.createInstance(L.ExtensionsDownloader)),this._register(a.toDisposable(()=>{this.installingExtensions.forEach(e=>e.cancel()),
this.uninstallingExtensions.forEach(e=>e.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(e){this.logService.trace("ExtensionManagementService#zip",e.identifier.id);const t=await this.collectFiles(e),n=await l.zip(C.joinPath(this.environmentService.tmpDir,x.generateUuid()).fsPath,t);return m.URI.file(n)}async unzip(e){return this.logService.trace("ExtensionManagementService#unzip",e.toString()),(await this.install(e)).identifier}async getManifest(e){const t=await this.downloadVsix(e),n=i.resolve(t.fsPath);return D.getManifest(n)}async collectFiles(e){const t=async e=>{let n=await r.readdir(e);n=n.map(t=>i.join(e,t));const s=await Promise.all(n.map(e=>r.stat(e)));let o=Promise.resolve([]);return s.forEach((e,i)=>{const r=n[i];e.isFile()&&(o=o.then(e=>[...e,r])),e.isDirectory()&&(o=o.then(e=>t(r).then(t=>[...e,...t])))}),o};return(await t(e.location.fsPath)).map(t=>({path:`extension/${i.relative(e.location.fsPath,t)}`,localPath:t}))}async install(e,t){
return this.logService.trace("ExtensionManagementService#install",e.toString()),f.createCancelablePromise(async r=>{const s=await this.downloadVsix(e),o=i.resolve(s.fsPath),a=await D.getManifest(o),c={id:h.getGalleryExtensionId(a.publisher,a.name)};let l=1;if(a.engines&&a.engines.vscode&&!b.isEngineValid(a.engines.vscode,v.default.version))throw new Error(n.localize(0,null,c.id,v.default.version));const u=new h.ExtensionIdentifierWithVersion(c,a.version),d=(await this.getInstalled(1)).find(e=>h.areSameExtensions(c,e.identifier));if(d)if(t=t||d.isMachineScoped,l=2,u.equals(new h.ExtensionIdentifierWithVersion(d.identifier,d.manifest.version)))try{await this.extensionsScanner.removeExtension(d,"existing")}catch(e){throw new Error(n.localize(1,null,a.displayName||a.name))}else g.gt(d.manifest.version,a.version)&&await this.uninstallExtension(d);else{const e=await this.unsetUninstalledAndGetLocal(u);if(e)try{await this.extensionsScanner.removeExtension(e,"existing")}catch(e){
throw new Error(n.localize(2,null,a.displayName||a.name))}}let f;this.logService.info("Installing the extension:",c.id),this._onInstallExtension.fire({identifier:c,zipPath:o});try{f=await this.getGalleryMetadata(h.getGalleryExtensionId(a.publisher,a.name))}catch(e){}try{const e=await this.installFromZipPath(u,o,t?Object.assign(Object.assign({},f||{}),{isMachineScoped:t}):f,l,r);return this.logService.info("Successfully installed the extension:",c.id),e}catch(e){throw this.logService.error("Failed to install the extension:",c.id,e.message),e}})}async downloadVsix(e){if(e.scheme===k.Schemas.file)return e;if(!this.downloadService)throw new Error("Download service is not available");const t=C.joinPath(this.environmentService.tmpDir,x.generateUuid());return await this.downloadService.download(e,t),t}async installFromZipPath(e,t,n,i,r){try{const s=await this.installExtension({zipPath:t,identifierWithVersion:e,metadata:n},r);try{await this.installDependenciesAndPackExtensions(s,void 0)}catch(e){
c.isNonEmptyArray(s.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",s.identifier.id,e.message),c.isNonEmptyArray(s.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",s.identifier.id,e.message)}return this._onDidInstallExtension.fire({identifier:e.identifier,zipPath:t,local:s,operation:i}),s}catch(n){throw this._onDidInstallExtension.fire({identifier:e.identifier,zipPath:t,operation:i,error:n}),n}}async canInstall(e){return!0}async installFromGallery(e,t){if(!this.galleryService.isEnabled())throw new Error(n.localize(3,null));try{e=await this.checkAndGetCompatibleVersion(e)}catch(t){const n=t&&t.code?t.code:"unknown";throw this.logService.error("Failed to install extension:",e.identifier.id,t?t.message:n),this.reportTelemetry(this.getTelemetryEvent(1),h.getGalleryExtensionTelemetryData(e),void 0,t),t instanceof Error&&(t.name=n),t}const i=new h.ExtensionIdentifierWithVersion(e.identifier,e.version).key()
;let r=this.installingExtensions.get(i);return r||(r=f.createCancelablePromise(n=>this.doInstallFromGallery(e,!!t,n)),this.installingExtensions.set(i,r),r.finally(()=>this.installingExtensions.delete(i))),r}async doInstallFromGallery(e,t,n){const i=(new Date).getTime();let r=1;this.logService.info("Installing extension:",e.identifier.id),this._onInstallExtension.fire({identifier:e.identifier,gallery:e});try{const s=(await this.getInstalled(1)).find(t=>h.areSameExtensions(t.identifier,e.identifier));s&&(r=2);const o=await this.downloadInstallableExtension(e,r);o.metadata.isMachineScoped=t||(null==s?void 0:s.isMachineScoped);const a=await this.installExtension(o,n);try{await this.extensionsDownloader.delete(m.URI.file(o.zipPath))}catch(e){}try{await this.installDependenciesAndPackExtensions(a,s)}catch(e){try{await this.uninstall(a)}catch(e){}throw e}return s&&g.neq(s.manifest.version,e.version)&&await this.setUninstalled(s),this.logService.info("Extensions installed successfully:",e.identifier.id),
this._onDidInstallExtension.fire({identifier:e.identifier,gallery:e,local:a,operation:r}),this.reportTelemetry(this.getTelemetryEvent(r),h.getGalleryExtensionTelemetryData(e),(new Date).getTime()-i,void 0),a}catch(t){const n=t&&t.code?t.code:"unknown";throw this.logService.error("Failed to install extension:",e.identifier.id,t?t.message:n),this._onDidInstallExtension.fire({identifier:e.identifier,gallery:e,operation:r,error:n}),this.reportTelemetry(this.getTelemetryEvent(r),h.getGalleryExtensionTelemetryData(e),(new Date).getTime()-i,t),t instanceof Error&&(t.name=n),t}}async checkAndGetCompatibleVersion(e){if(await this.isMalicious(e))throw new u.ExtensionManagementError(n.localize(4,null),u.INSTALL_ERROR_MALICIOUS);const t=await this.galleryService.getCompatibleExtension(e);if(!t)throw new u.ExtensionManagementError(n.localize(5,null,e.identifier.id,v.default.version),u.INSTALL_ERROR_INCOMPATIBLE);return t}async reinstallFromGallery(e){
if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",e.identifier.id),!this.galleryService.isEnabled())throw new Error(n.localize(6,null));const t=await this.findGalleryExtension(e);if(!t)throw new Error(n.localize(7,null));await this.setUninstalled(e);try{await this.extensionsScanner.removeUninstalledExtension(e)}catch(e){throw new Error(n.localize(8,null,_.toErrorMessage(e)))}await this.installFromGallery(t)}getTelemetryEvent(e){return 2===e?"extensionGallery:update":"extensionGallery:install"}async isMalicious(e){const t=await this.getExtensionsReport();return h.getMaliciousExtensionsSet(t).has(e.identifier.id)}async downloadInstallableExtension(e,t){const n={id:e.identifier.uuid,publisherId:e.publisherId,publisherDisplayName:e.publisherDisplayName};let i;try{this.logService.trace("Started downloading extension:",e.identifier.id);const n=await this.extensionsDownloader.downloadExtension(e,t);this.logService.info("Downloaded extension:",e.identifier.id,i),i=n.fsPath}catch(e){
throw new u.ExtensionManagementError(this.joinErrors(e).message,"downloading")}try{const t=await D.getManifest(i);return{zipPath:i,identifierWithVersion:new h.ExtensionIdentifierWithVersion(e.identifier,t.version),metadata:n}}catch(e){throw new u.ExtensionManagementError(this.joinErrors(e).message,"validating")}}async installExtension(e,t){try{const t=await this.unsetUninstalledAndGetLocal(e.identifierWithVersion);if(t)return t}catch(e){throw y.isMacintosh?new u.ExtensionManagementError(n.localize(9,null),"unsetUninstalled"):new u.ExtensionManagementError(n.localize(10,null),"unsetUninstalled")}return this.extractAndInstall(e,t)}async unsetUninstalledAndGetLocal(e){return await this.isUninstalled(e)?(this.logService.trace("Removing the extension from uninstalled list:",e.identifier.id),await this.unsetUninstalled(e),this.logService.info("Removed the extension from uninstalled list:",e.identifier.id),
(await this.getInstalled(1)).find(t=>new h.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).equals(e))||null):null}async extractAndInstall({zipPath:e,identifierWithVersion:t,metadata:n},i){const{identifier:r}=t;let s=await this.extensionsScanner.extractUserExtension(t,e,i);return this.logService.info("Installation completed.",r.id),n&&(s=await this.extensionsScanner.saveMetadataForLocalExtension(s,n)),s}async installDependenciesAndPackExtensions(e,t){if(!this.galleryService.isEnabled())return;const n=e.manifest.extensionDependencies||[];if(e.manifest.extensionPack)for(const i of e.manifest.extensionPack)t&&t.manifest.extensionPack&&t.manifest.extensionPack.some(e=>h.areSameExtensions({id:e},{id:i}))||n.every(e=>!h.areSameExtensions({id:e},{id:i}))&&n.push(i);if(n.length){const e=await this.getInstalled(),t=n.filter(t=>e.every(({identifier:e})=>!h.areSameExtensions(e,{id:t})));if(t.length){const e=(await this.galleryService.query({names:t,pageSize:n.length},O.CancellationToken.None)).firstPage
;try{await Promise.all(e.map(e=>this.installFromGallery(e)))}catch(t){try{await this.rollback(e)}catch(e){}throw t}}}}async rollback(e){const t=(await this.getInstalled(1)).filter(t=>e.some(e=>new h.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).equals(new h.ExtensionIdentifierWithVersion(e.identifier,e.version))));await Promise.all(t.map(e=>this.uninstall(e)))}async uninstall(e){this.logService.trace("ExtensionManagementService#uninstall",e.identifier.id);const t=await this.getInstalled(1),i=t.find(t=>h.areSameExtensions(t.identifier,e.identifier));if(!i)throw new Error(n.localize(11,null,e.manifest.displayName||e.manifest.name));try{await this.checkForDependenciesAndUninstall(i,t)}catch(e){throw this.joinErrors(e)}}async updateMetadata(e,t){return this.logService.trace("ExtensionManagementService#updateMetadata",e.identifier.id),e=await this.extensionsScanner.saveMetadataForLocalExtension(e,Object.assign(Object.assign({},t),{isMachineScoped:e.isMachineScoped})),
this.manifestCache.invalidate(),e}async getGalleryMetadata(e){const t=await this.findGalleryExtensionByName(e);return t?{id:t.identifier.uuid,publisherDisplayName:t.publisherDisplayName,publisherId:t.publisherId}:void 0}async findGalleryExtension(e){if(e.identifier.uuid){const t=await this.findGalleryExtensionById(e.identifier.uuid);return t||this.findGalleryExtensionByName(e.identifier.id)}return this.findGalleryExtensionByName(e.identifier.id)}async findGalleryExtensionById(e){return(await this.galleryService.query({ids:[e],pageSize:1},O.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(e){return(await this.galleryService.query({names:[e],pageSize:1},O.CancellationToken.None)).firstPage[0]}joinErrors(e){const t=Array.isArray(e)?e:[e];return 1===t.length?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((e,t)=>new Error(`${e.message}${e.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}async checkForDependenciesAndUninstall(e,t){try{await this.preUninstallExtension(e)
;const n=this.getAllPackExtensionsToUninstall(e,t);n.length?await this.uninstallExtensions(e,n,t):await this.uninstallExtensions(e,[],t)}catch(t){throw await this.postUninstallExtension(e,new u.ExtensionManagementError(t instanceof Error?t.message:t,"local")),t}await this.postUninstallExtension(e)}async uninstallExtensions(e,t,n){const i=[e,...t];for(const t of i)this.checkForDependents(t,i,n,e);await Promise.all([this.uninstallExtension(e),...t.map(e=>this.doUninstall(e))])}checkForDependents(e,t,n,i){const r=this.getDependents(e,n);if(r.length){const n=r.filter(e=>-1===t.indexOf(e));if(n.length)throw new Error(this.getDependentsErrorMessage(e,n,i))}}getDependentsErrorMessage(e,t,i){
return i===e?1===t.length?n.localize(12,null,i.manifest.displayName||i.manifest.name,t[0].manifest.displayName||t[0].manifest.name):2===t.length?n.localize(13,null,i.manifest.displayName||i.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):n.localize(14,null,i.manifest.displayName||i.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):1===t.length?n.localize(15,null,i.manifest.displayName||i.manifest.name,e.manifest.displayName||e.manifest.name,t[0].manifest.displayName||t[0].manifest.name):2===t.length?n.localize(16,null,i.manifest.displayName||i.manifest.name,e.manifest.displayName||e.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):n.localize(17,null,i.manifest.displayName||i.manifest.name,e.manifest.displayName||e.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}
getAllPackExtensionsToUninstall(e,t,n=[]){if(-1!==n.indexOf(e))return[];n.push(e);const i=e.manifest.extensionPack?e.manifest.extensionPack:[];if(i.length){const e=t.filter(e=>i.some(t=>h.areSameExtensions({id:t},e.identifier))),r=[];for(const i of e)r.push(...this.getAllPackExtensionsToUninstall(i,t,n));return[...e,...r]}return[]}getDependents(e,t){return t.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(t=>h.areSameExtensions({id:t},e.identifier)))}async doUninstall(e){try{await this.preUninstallExtension(e),await this.uninstallExtension(e)}catch(t){throw await this.postUninstallExtension(e,new u.ExtensionManagementError(t instanceof Error?t.message:t,"local")),t}await this.postUninstallExtension(e)}async preUninstallExtension(e){if(!await r.exists(e.location.fsPath))throw new Error(n.localize(18,null));this.logService.info("Uninstalling extension:",e.identifier.id),this._onUninstallExtension.fire(e.identifier)}async uninstallExtension(e){
let t=this.uninstallingExtensions.get(e.identifier.id);return t||(t=f.createCancelablePromise(async()=>{const t=await this.extensionsScanner.scanUserExtensions(!1);await this.setUninstalled(...t.filter(t=>h.areSameExtensions(t.identifier,e.identifier)))}),this.uninstallingExtensions.set(e.identifier.id,t),t.finally(()=>this.uninstallingExtensions.delete(e.identifier.id))),t}async postUninstallExtension(e,t){if(t)this.logService.error("Failed to uninstall extension:",e.identifier.id,t.message);else if(this.logService.info("Successfully uninstalled extension:",e.identifier.id),e.identifier.uuid)try{await this.galleryService.reportStatistic(e.manifest.publisher,e.manifest.name,e.manifest.version,"uninstall")}catch(t){}this.reportTelemetry("extensionGallery:uninstall",h.getLocalExtensionTelemetryData(e),void 0,t);const n=t?t instanceof u.ExtensionManagementError?t.code:"unknown":void 0;this._onDidUninstallExtension.fire({identifier:e.identifier,error:n})}getInstalled(e=null){
return this.extensionsScanner.scanExtensions(e)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(e){return 1===(await this.filterUninstalled(e)).length}filterUninstalled(...e){return this.extensionsScanner.withUninstalledExtensions(t=>{const n=[];for(const i of e)t[i.key()]&&n.push(i.key());return n})}setUninstalled(...e){const t=e.map(e=>new h.ExtensionIdentifierWithVersion(e.identifier,e.manifest.version));return this.extensionsScanner.withUninstalledExtensions(e=>(t.forEach(t=>e[t.key()]=!0),e))}unsetUninstalled(e){return this.extensionsScanner.withUninstalledExtensions(t=>delete t[e.key()])}getExtensionsReport(){const e=(new Date).getTime();return(!this.reportedExtensions||e-this.lastReportTimestamp>3e5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=e),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const e=await this.galleryService.getExtensionsReport()
;return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${e.length} reported extensions from service`),e}catch(e){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(e,t,n,i){const r=i?i instanceof u.ExtensionManagementError?i.code:"unknown":void 0;this.telemetryService.publicLogError(e,Object.assign(Object.assign({},t),{success:!i,duration:n,errorcode:r}))}};R=s([o(0,d.INativeEnvironmentService),o(1,u.IExtensionGalleryService),o(2,w.ILogService),o(3,I.optional(P.IDownloadService)),o(4,S.ITelemetryService),o(5,I.IInstantiationService)],R),t.ExtensionManagementService=R})),define(t[64],n([0,1,176,60,3,12,16,147,29,13,17]),(function(e,t,n,i,r,a,c,l,u,h,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let f=class extends r.Disposable{constructor(e,t){super(),this.logService=t,this.configure(e.getValue()),
this._register(e.onDidChangeConfiguration(()=>this.configure(e.getValue()),this))}configure(e){this.proxyUrl=e.http&&e.http.proxy,this.strictSSL=!(!e.http||!e.http.proxyStrictSSL),this.authorization=e.http&&e.http.proxyAuthorization}async request(e,t){this.logService.trace("RequestService#request",e.url);const{proxyUrl:n,strictSSL:i}=this,r=e.agent?e.agent:await l.getProxyAgent(e.url||"",{proxyUrl:n,strictSSL:i});return e.agent=r,e.strictSSL=i,this.authorization&&(e.headers=Object.assign(Object.assign({},e.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(e,t)}async getNodeRequest(t){return("https:"===i.parse(t.url).protocol?await new Promise((t,n)=>{e(["https"],t,n)}):await new Promise((t,n)=>{e(["http"],t,n)})).request}_request(e,t){return new Promise(async(r,s)=>{let o;const l=i.parse(e.url),u=e.getRawRequest?e.getRawRequest(e):await this.getNodeRequest(e),h={hostname:l.hostname,port:l.port?parseInt(l.port):"https:"===l.protocol?443:80,protocol:l.protocol,path:l.path,
method:e.type||"GET",headers:e.headers,agent:e.agent,rejectUnauthorized:!a.isBoolean(e.strictSSL)||e.strictSSL};e.user&&e.password&&(h.auth=e.user+":"+e.password),(o=u(h,i=>{const o=a.isNumber(e.followRedirects)?e.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&o>0&&i.headers.location)this._request(Object.assign(Object.assign({},e),{url:i.headers.location,followRedirects:o-1}),t).then(r,s);else{let e=i;"gzip"===i.headers["content-encoding"]&&(e=i.pipe(n.createGunzip())),r({res:i,stream:d.streamToBufferReadableStream(e)})}})).on("error",s),e.timeout&&o.setTimeout(e.timeout),e.data&&"string"==typeof e.data&&o.write(e.data),o.end(),t.onCancellationRequested(()=>{o.abort(),s(c.canceled())})})}async resolveProxy(e){}};f=s([o(0,u.IConfigurationService),o(1,h.ILogService)],f),t.RequestService=f})),
define(t[166],n([0,1,110,15,26,2,45,44,8,55,23,81,28,63,61,36,48,82,84,47,64,29,59,83,14,67,149,150,13,16,31,7,86,37,24,79,4,80,155,57,25,46,3,38]),(function(e,t,n,i,r,a,c,l,u,h,d,f,p,g,m,v,y,w,E,_,S,b,C,x,P,I,k,O,D,L,T,A,R,F,M,N,U,j,z,$,B,W,V,q){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=t.Main=t.getIdAndVersion=void 0;const H=e=>n.localize(1,null,e),G=n.localize(2,null,"ms-dotnettools.csharp");function K(e,t){return t?`${e.publisher}.${e.name}@${e.version}`:`${e.publisher}.${e.name}`}const J=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function Q(e){const t=J.exec(e);return t&&t[1]?[T.adoptToGalleryExtensionId(t[1]),t[2]]:[T.adoptToGalleryExtensionId(e),void 0]}t.getIdAndVersion=Q;let X=class{constructor(e,t,n,i){this.instantiationService=e,this.environmentService=t,this.extensionManagementService=n,this.extensionGalleryService=i}async run(e){
e["install-source"]?await this.setInstallSource(e["install-source"]):e["list-extensions"]?await this.listExtensions(!!e["show-versions"],e.category):e["install-extension"]?await this.installExtensions(e["install-extension"],!!e.force):e["uninstall-extension"]?await this.uninstallExtension(e["uninstall-extension"]):e["locate-extension"]?await this.locateExtension(e["locate-extension"]):e.telemetry&&console.log(z.buildTelemetryMessage(this.environmentService.appRoot,this.environmentService.extensionsPath?this.environmentService.extensionsPath:void 0))}setInstallSource(e){return P.writeFile(this.environmentService.installSourcePath,e.slice(0,30))}async listExtensions(e,t){let n=await this.extensionManagementService.getInstalled(1);const i=F.EXTENSION_CATEGORIES.map(e=>e.toLowerCase());if(t&&""!==t){if(i.indexOf(t.toLowerCase())<0)return void console.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");n=n.filter(e=>{if(e.manifest.categories){
return e.manifest.categories.map(e=>e.toLowerCase()).indexOf(t.toLowerCase())>-1}return!1})}else if(""===t)return console.log("Possible Categories: "),void i.forEach(e=>{console.log(e)});n.forEach(t=>console.log(K(t.manifest,e)))}async installExtensions(e,t){const i=[],r=[];e.length&&console.log(n.localize(3,null));for(const n of e)try{const e=await this.installExtension(n,t);e&&r.push(e)}catch(e){console.error(e.message||e.stack||e),i.push(n)}return r.some(e=>F.isLanguagePackExtension(e))&&await this.updateLocalizationsCache(),i.length?Promise.reject(n.localize(4,null,i.join(", "))):Promise.resolve()}async installExtension(e,t){if(/\.vsix$/i.test(e)){e=a.isAbsolute(e)?e:a.join(process.cwd(),e);const i=await R.getManifest(e);return await this.validate(i,t)?this.extensionManagementService.install(A.URI.file(e)).then(t=>(console.log(n.localize(5,null,I.getBaseLabel(e))),i),t=>L.isPromiseCanceledError(t)?(console.log(n.localize(6,null,I.getBaseLabel(e))),null):Promise.reject(t)):null}const[i,r]=Q(e)
;return this.extensionManagementService.getInstalled(1).then(e=>this.extensionGalleryService.getCompatibleExtension({id:i},r).then(null,e=>{if(e.responseText)try{const t=JSON.parse(e.responseText);return Promise.reject(t.message)}catch(e){}return Promise.reject(e)}).then(async s=>{if(!s)return Promise.reject(new Error(`${(e=>n.localize(0,null,e))(r?`${i}@${r}`:i)}\n${G}`));const o=await this.extensionGalleryService.getManifest(s,M.CancellationToken.None),[a]=e.filter(e=>T.areSameExtensions(e.identifier,{id:i}));if(a){if(s.version===a.manifest.version)return console.log(n.localize(7,null,r?`${i}@${r}`:i)),Promise.resolve(null);if(!r&&!t)return console.log(n.localize(8,null,i,a.manifest.version,s.version)),Promise.resolve(null);console.log(n.localize(9,null,i,s.version))}return await this.installFromGallery(i,s),o}))}async validate(t,i){if(!t)throw new Error("Invalid vsix");const r=await new Promise((t,n)=>{e(["semver-umd"],t,n)}),s={id:T.getGalleryExtensionId(t.publisher,t.name)
},o=(await this.extensionManagementService.getInstalled(1)).find(e=>T.areSameExtensions(s,e.identifier)&&r.gt(e.manifest.version,t.version));return!(o&&!i)||(console.log(n.localize(10,null,o.identifier.id,o.manifest.version,t.version)),!1)}async installFromGallery(e,t){console.log(n.localize(11,null,e,t.version));try{await this.extensionManagementService.installFromGallery(t),console.log(n.localize(12,null,e,t.version))}catch(t){if(!L.isPromiseCanceledError(t))throw t;console.log(n.localize(13,null,e))}}async uninstallExtension(e){async function t(e){if(!/\.vsix$/i.test(e))return e;const t=a.isAbsolute(e)?e:a.join(process.cwd(),e);return K(await R.getManifest(t))}const i=[];for(const r of e){const e=await t(r),s=await this.extensionManagementService.getInstalled(1),[o]=s.filter(t=>T.areSameExtensions(t.identifier,{id:e}));if(!o)return Promise.reject(new Error(`${H(e)}\n${G}`));console.log(n.localize(14,null,e)),await this.extensionManagementService.uninstall(o,!0),i.push(o),console.log(n.localize(15,null,e))}
i.some(e=>F.isLanguagePackExtension(e.manifest))&&await this.updateLocalizationsCache()}async locateExtension(e){const t=await this.extensionManagementService.getInstalled();e.forEach(e=>{t.forEach(t=>{t.identifier.id!==e||t.location.scheme!==U.Schemas.file||console.log(t.location.fsPath)})})}async updateLocalizationsCache(){const e=this.instantiationService.createInstance(N.LocalizationsService);await e.update(),e.dispose()}};X=s([o(0,u.IInstantiationService),o(1,d.INativeEnvironmentService),o(2,p.IExtensionManagementService),o(3,p.IExtensionGalleryService)],X),t.Main=X;const Y="monacoworkbench";t.main=async function(e){const t=new c.ServiceCollection,n=new V.DisposableStore,s=new f.NativeEnvironmentService(e),o=new j.SpdLogService("cli",s.logsPath,D.getLogLevel(s));process.once("exit",()=>o.dispose()),o.info("main",e),await Promise.all([s.appSettingsHome.fsPath,s.extensionsPath].map(e=>e?P.mkdirp(e):void 0));const a=new $.FileService(o);n.add(a),t.set(B.IFileService,a)
;const u=new W.DiskFileSystemProvider(o);n.add(u),a.registerProvider(U.Schemas.file,u);const I=new C.ConfigurationService(s.settingsResource,a);n.add(I),await I.initialize(),t.set(d.IEnvironmentService,s),t.set(d.INativeEnvironmentService,s),t.set(D.ILogService,o),t.set(b.IConfigurationService,I),t.set(k.IStateService,new l.SyncDescriptor(O.StateService)),t.set(q.IProductService,Object.assign({_serviceBrand:void 0},r.default));const L=new h.InstantiationService(t);return L.invokeFunction(async t=>{const a=t.get(k.IStateService),{appRoot:u,extensionsPath:h,extensionDevelopmentLocationURI:d,isBuilt:f,installSourcePath:b}=s,C=new c.ServiceCollection;C.set(_.IRequestService,new l.SyncDescriptor(S.RequestService)),C.set(p.IExtensionManagementService,new l.SyncDescriptor(g.ExtensionManagementService)),C.set(p.IExtensionGalleryService,new l.SyncDescriptor(m.ExtensionGalleryService));const P=[];if(f&&!d&&!s.disableTelemetry&&r.default.enableTelemetry){
r.default.aiConfig&&r.default.aiConfig.asimovKey&&P.push(new x.AppInsightsAppender(Y,null,r.default.aiConfig.asimovKey,o));const e={appender:y.combinedAppender(...P),sendErrorTelemetry:!1,commonProperties:E.resolveCommonProperties(r.default.commit,r.default.version,a.getItem("telemetry.machineId"),r.default.msftInternalDomains,b),piiPaths:h?[u,h]:[u]};C.set(v.ITelemetryService,new l.SyncDescriptor(w.TelemetryService,[e]))}else C.set(v.ITelemetryService,y.NullTelemetryService);const I=L.createChild(C).createInstance(X);try{await I.run(e),await i.raceTimeout(y.combinedAppender(...P).flush(),1e3)}finally{n.dispose()}})}})),define(t[87],n([0,1,23,45,13,44,59,29,47,64,48,36,28,61,63,55,5,166,26,3,57,46,4,25,38,15]),(function(e,t,n,i,r,s,o,a,c,l,u,h,d,f,p,g,m,v,y,w,E,_,S,b,C,x){"use strict";function P(e){let t=0,n=0,i=0;return e>=1e3&&(e-=1e3*(i=Math.floor(e/1e3))),i>=60&&(i-=60*(n=Math.floor(i/60))),n>=60&&(n-=60*(t=Math.floor(n/60))),`${t?`${t}h`:""}${n?`${n}m`:""}${i?`${i}s`:""}${e?`${e}ms`:""}`}
Object.defineProperty(t,"__esModule",{value:!0}),t.run=t.shouldSpawnCli=t.ManagementConnection=void 0;function I(e){return!!(e["list-extensions"]||e["install-extension"]||e["uninstall-extension"]||e["locate-extension"])}t.ManagementConnection=class{constructor(e,t,n,i){this._logService=e,this._reconnectionToken=t,this._onClose=new m.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=n,this.protocol=i,this._disposed=!1,this._disconnectRunner1=new x.RunOnceScheduler(()=>{this._log(`The reconnection grace time of ${P(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new x.RunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${P(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onClose(()=>{
this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${P(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(e){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${e}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${P(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const e=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),e.end(),this._onClose.fire(void 0)}
acceptReconnection(e,t,n){this._remoteAddress=e,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(t,n),this.protocol.endAcceptReconnection()}},t.shouldSpawnCli=I,t.run=async function(e,t,m){if(!I(e))return!1;const x=new w.DisposableStore,P=new i.ServiceCollection;P.set(n.IEnvironmentService,t),P.set(n.INativeEnvironmentService,t),P.set(r.ILogService,m),P.set(C.IProductService,Object.assign({_serviceBrand:void 0},y.default));const k=new E.FileService(m);x.add(k),P.set(b.IFileService,k);const O=new _.DiskFileSystemProvider(m);x.add(O),k.registerProvider(S.Schemas.file,O);const D=new o.ConfigurationService(t.settingsResource,k);x.add(D),await D.initialize(),P.set(a.IConfigurationService,D);const L=new g.InstantiationService(P);P.set(c.IRequestService,new s.SyncDescriptor(l.RequestService)),P.set(h.ITelemetryService,u.NullTelemetryService),
P.set(d.IExtensionGalleryService,new s.SyncDescriptor(f.ExtensionGalleryService)),P.set(d.IExtensionManagementService,new s.SyncDescriptor(p.ExtensionManagementService));try{await L.createInstance(v.Main).run(e)}finally{x.dispose()}return!0}})),define(t[167],n([0,1,58,18,177,70,27,60,17,3,20,14,99,6,72,73,156,87,40,13,4,26,23,45,44,59,29,47,64,48,36,28,61,63,55,75,128,78,79,83,82,84,69,57,46,25,38,35,5,162,157,163,146,130,154,126,142,160,7,30,2,12]),(function(e,t,n,i,r,s,o,a,c,l,u,h,d,f,p,g,m,v,y,w,E,_,S,b,C,x,P,I,k,O,D,L,T,A,R,F,M,N,U,j,z,$,B,W,V,q,H,G,K,J,Q,X,Y,Z,ee,te,ne,ie,re,se,oe,ae){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteExtensionHostAgentServer=void 0;const ce=3e5,le="monacoworkbench";class ue extends G.IPCServer{constructor(){const e=new K.Emitter;super(e.event),this._onDidConnectEmitter=e}acceptConnection(e,t){this._onDidConnectEmitter.fire({protocol:e,onDidClientDisconnect:t})}}function he(e){return e<10?`0${e}`:String(e)}function de(){const e=new Date
;return`${he(e.getHours())}:${he(e.getMinutes())}:${he(e.getSeconds())}`}class fe extends w.AbstractLogService{constructor(e=w.DEFAULT_LOG_LEVEL){super(),this.setLevel(e),this.useColors=Boolean(process.stdout.isTTY)}trace(e,...t){this.getLevel()<=w.LogLevel.Trace&&(this.useColors?console.log(`[90m[${de()}][0m`,e,...t):console.log(`[${de()}]`,e,...t))}debug(e,...t){this.getLevel()<=w.LogLevel.Debug&&(this.useColors?console.log(`[90m[${de()}][0m`,e,...t):console.log(`[${de()}]`,e,...t))}info(e,...t){this.getLevel()<=w.LogLevel.Info&&(this.useColors?console.log(`[90m[${de()}][0m`,e,...t):console.log(`[${de()}]`,e,...t))}warn(e,...t){this.getLevel()<=w.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${de()}][0m`,e,...t):console.warn(`[${de()}]`,e,...t))}error(e,...t){this.getLevel()<=w.LogLevel.Error&&(this.useColors?console.error(`[91m[${de()}][0m`,e,...t):console.error(`[${de()}]`,e,...t))}critical(e,...t){
this.getLevel()<=w.LogLevel.Critical&&(this.useColors?console.error(`[90m[${de()}][0m`,e,...t):console.error(`[${de()}]`,e,...t))}dispose(){}flush(){}}class pe extends l.Disposable{constructor(t,n,r){super(),this._connectionToken=t,this._environmentService=n,this._logService=new w.MultiplexLogService([new fe(w.getLogLevel(this._environmentService)),r]),this._socketServer=new ue,this._uriTransformerCache=Object.create(null),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null);const s=E.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",e).fsPath;i.existsSync(s)?this._webClientServer=new ie.WebClientServer(this._connectionToken,this._environmentService,this._logService):this._webClientServer=null}async start(e){return await this._createServices(),this._start(e)}async _createServices(){const e=new b.ServiceCollection;this._socketServer.registerChannel(te.ExtensionHostDebugBroadcastChannel.ChannelName,new te.ExtensionHostDebugBroadcastChannel)
;const t=new G.StaticRouter(e=>"renderer"===e.clientId);this._socketServer.registerChannel("logger",new ne.LoggerChannel(this._logService)),e.set(S.IEnvironmentService,this._environmentService),e.set(S.INativeEnvironmentService,this._environmentService),e.set(w.ILogService,this._logService),e.set(H.IProductService,Object.assign({_serviceBrand:void 0},_.default));const n=this._register(new W.FileService(this._logService));e.set(q.IFileService,n),n.registerProvider(E.Schemas.file,this._register(new V.DiskFileSystemProvider(this._logService))),e.set(P.IConfigurationService,new C.SyncDescriptor(x.ConfigurationService,[this._environmentService.machineSettingsResource,n])),e.set(I.IRequestService,new C.SyncDescriptor(k.RequestService));let i=O.NullAppender;if(!this._environmentService.args["disable-telemetry"]&&_.default.enableTelemetry){_.default.aiConfig&&_.default.aiConfig.asimovKey&&(i=new j.AppInsightsAppender(le,null,_.default.aiConfig.asimovKey,this._logService),this._register(l.toDisposable(()=>i.flush())))
;const t=await B.getMachineId(),n={appender:O.combinedAppender(i,new O.LogAppender(this._logService)),commonProperties:$.resolveCommonProperties(_.default.commit,_.default.version+"-remote",t,_.default.msftInternalDomains,this._environmentService.installSourcePath,"remoteAgent"),piiPaths:[this._environmentService.appRoot]};e.set(D.ITelemetryService,new C.SyncDescriptor(z.TelemetryService,[n]))}else e.set(D.ITelemetryService,O.NullTelemetryService);e.set(L.IExtensionGalleryService,new C.SyncDescriptor(T.ExtensionGalleryService));const r=this._socketServer.getChannel("download",t);e.set(F.IDownloadService,new M.DownloadServiceChannelClient(r,()=>this._getUriTransformer("renderer"))),e.set(L.IExtensionManagementService,new C.SyncDescriptor(A.ExtensionManagementService));const s=new R.InstantiationService(e);e.set(N.ILocalizationsService,s.createInstance(U.LocalizationsService)),s.invokeFunction(e=>{
const t=new J.RemoteAgentEnvironmentChannel(this._connectionToken,this._environmentService,this._logService,e.get(D.ITelemetryService),i);this._socketServer.registerChannel("remoteextensionsenvironment",t);const n=new Q.RemoteAgentFileSystemChannel(this._logService,this._environmentService);this._socketServer.registerChannel(X.REMOTE_FILE_SYSTEM_CHANNEL_NAME,n),this._socketServer.registerChannel("request",new Y.RequestChannel(e.get(I.IRequestService)));const r=e.get(L.IExtensionManagementService),s=new Z.ExtensionManagementChannel(r,e=>this._getUriTransformer(e.remoteAuthority));this._socketServer.registerChannel("extensions",s),r.removeDeprecatedExtensions(),this._register(new ee.default(e.get(D.ITelemetryService)))})}_getUriTransformer(e){return this._uriTransformerCache[e]||(this._uriTransformerCache[e]=y.createRemoteURITransformer(e)),this._uriTransformerCache[e]}async _start(e){if("number"==typeof e.port){const e=o.networkInterfaces(),t=this._logService;Object.keys(e).forEach((function(n){
e[n].forEach((function(e){e.internal||"IPv4"!==e.family||(console.log(`IP Address: ${e.address}`),t.trace(`IP Address: ${e.address}`))}))}))}setTimeout(()=>this._cleanupOlderLogs(this._environmentService.logsPath).then(null,e=>this._logService.error(e)),1e4);const t=r.createServer(async(e,t)=>{if("GET"!==e.method)return ie.serveError(e,t,405,`Unsupported method ${e.method}`);if(!e.url)return ie.serveError(e,t,400,"Bad request.");const n=a.parse(e.url,!0),i=n.pathname;if(!i)return ie.serveError(e,t,400,"Bad request.");if("/version"===i)return t.writeHead(200,{"Content-Type":"text/plain"}),t.end(_.default.commit||"");if("/delay-shutdown"===i)return this._delayShutdown(),t.writeHead(200),t.end("OK");if("/vscode-remote-resource"===i){if(n.query.tkn!==this._connectionToken)return ie.serveError(e,t,403,"Forbidden.");const i=n.query.path;if("string"!=typeof i)return ie.serveError(e,t,400,"Bad request.");let r;try{r=re.URI.from({scheme:E.Schemas.file,path:i}).fsPath}catch(n){
return ie.serveError(e,t,400,"Bad request.")}const s=Object.create(null);return this._environmentService.isBuilt&&(se.isEqualOrParent(r,this._environmentService.builtinExtensionsPath,!f.isLinux)||se.isEqualOrParent(r,this._environmentService.extensionsPath,!f.isLinux))&&(s["Cache-Control"]="public, max-age=31536000"),ie.serveFile(this._logService,e,t,r,s)}if(!this._webClientServer)return t.writeHead(404,{"Content-Type":"text/plain"}),t.end("Not found");this._webClientServer.handle(e,t,n)});t.on("upgrade",(e,t)=>{if("websocket"!==e.headers.upgrade)return void t.end("HTTP/1.1 400 Bad Request");const i=e.headers["sec-websocket-key"],r=n.createHash("sha1");r.update(i+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const s=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${r.digest("base64")}`];t.write(s.join("\r\n")+"\r\n\r\n"),t.setTimeout(0);let o=u.generateUuid(),c=!1,l=!1;if(e.url){const t=a.parse(e.url,!0).query
;"string"==typeof t.reconnectionToken&&(o=t.reconnectionToken),"true"===t.reconnection&&(c=!0),"true"===t.skipWebSocketFrames&&(l=!0)}l?this._handleWebSocketConnection(new g.NodeSocket(t),c,o):this._handleWebSocketConnection(new g.WebSocketNodeSocket(new g.NodeSocket(t)),c,o)}),t.on("error",e=>{this._logService.error("Error occurred in server"),this._logService.error(e)});const i=e.socketPath?{path:e.socketPath}:{host:e.host,port:e.port};t.listen(i,()=>{const e=ae.assertIsDefined(t.address());console.log(`Extension host agent listening on ${"string"==typeof e?e:e.port}`),this._webClientServer&&"string"!=typeof e&&console.log(`Web UI available at http://localhost${80===e.port?"":`:${e.port}`}/?tkn=${this._connectionToken}`),console.log(),console.log(),this._logService.info("Extension host agent started.")}),this._register({dispose:()=>t.close()})}async _cleanupOlderLogs(e){
const t=oe.basename(e),n=oe.dirname(e),i=(await h.readdir(n)).filter(e=>/^\d{8}T\d{6}$/.test(e)).sort().filter(e=>e!==t),r=i.slice(0,Math.max(0,i.length-9));await Promise.all(r.map(e=>h.rimraf(oe.join(n,e))))}_getRemoteAddress(e){let t;return(t=e instanceof g.NodeSocket?e.socket:e.socket.socket).remoteAddress||"<unknown>"}_handleWebSocketConnection(t,n,i){const r=this._getRemoteAddress(t),s=`[${r}][${i.substr(0,8)}]`,o=new p.PersistentProtocol(t);let a;try{const t=e.__$__nodeRequire("vsda");a=new t.validator}catch(e){}const l=o.onControlMessage(e=>{const u=JSON.parse(e.toString());if("auth"===u.type){if("string"!=typeof u.auth||"00000000000000000000"!==u.auth)return this._logService.error(`${s} Unauthorized client refused.`),o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"error",reason:"Unauthorized client refused."}))),o.dispose(),void t.dispose();let e="VS Code Headless is cool";if(a)try{e=a.createNewMessage(e)}catch(e){}const n={type:"sign",data:e}
;o.sendControl(c.VSBuffer.fromString(JSON.stringify(n)))}else if("connectionType"===u.type){l.dispose();const e=u.commit,h=_.default.commit;if(e&&h&&e!==h)return this._logService.error(`${s} Version mismatch, client refused.`),o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"error",reason:"Version mismatch, client refused."}))),o.dispose(),void t.dispose();let d=!1;if(u.signedData===this._connectionToken&&(d=!0),!d&&a&&"string"==typeof u.signedData)try{d="ok"===a.validate(u.signedData)}catch(e){}if(d)this._environmentService.isBuilt||this._logService.trace(`${s} Client handshake succeded.`);else{if(this._environmentService.isBuilt)return this._logService.error(`${s} Unauthorized client refused.`),o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"error",reason:"Unauthorized client refused."}))),o.dispose(),void t.dispose();this._logService.error(`${s} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let e in this._managementConnections){
this._managementConnections[e].shortenReconnectionGraceTimeIfNecessary()}for(let e in this._extHostConnections){this._extHostConnections[e].shortenReconnectionGraceTimeIfNecessary()}switch(u.desiredConnectionType){case 1:if(n)if(this._managementConnections[i]){o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"ok"})));const e=o.readEntireBuffer();o.dispose(),this._managementConnections[i].acceptReconnection(r,t,e)}else this._logService.error(`${s}[ManagementConnection] Unknown reconnection token.`),o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"error",reason:"Unknown reconnection token."}))),o.dispose(),t.dispose();else if(this._managementConnections[i])this._logService.error(`${s}[ManagementConnection] Duplicate reconnection token.`),o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"error",reason:"Duplicate reconnection token."}))),o.dispose(),t.dispose();else{o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"ok"})));const e=new v.ManagementConnection(this._logService,i,r,o)
;this._socketServer.acceptConnection(e.protocol,e.onClose),this._managementConnections[i]=e,e.onClose(()=>{delete this._managementConnections[i]})}break;case 2:const e=u.args||{language:"en"};this._updateWithFreeDebugPort(e).then(e=>{if(e.port&&this._logService.trace(`${s}[ExtensionHostConnection] - startParams debug port ${e.port}`),u.args?(this._logService.trace(`${s}[ExtensionHostConnection] - startParams language: ${e.language}`),this._logService.trace(`${s}[ExtensionHostConnection] - startParams env: ${JSON.stringify(e.env)}`)):this._logService.trace(`${s}[ExtensionHostConnection] - no UI language provided by renderer. Falling back to English`),n)if(this._extHostConnections[i]){o.sendControl(c.VSBuffer.fromString(JSON.stringify(e.port?{debugPort:e.port}:{})));const n=o.readEntireBuffer();o.dispose(),this._extHostConnections[i].acceptReconnection(r,t,n)}else this._logService.error(`${s}[ExtensionHostConnection] Unknown reconnection token.`),o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"error",
reason:"Unknown reconnection token."}))),o.dispose(),t.dispose();else if(this._extHostConnections[i])this._logService.error(`${s}[ExtensionHostConnection] Duplicate reconnection token.`),o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"error",reason:"Duplicate reconnection token."}))),o.dispose(),t.dispose();else{o.sendControl(c.VSBuffer.fromString(JSON.stringify(e.port?{debugPort:e.port}:{})));const n=o.readEntireBuffer();o.dispose();const s=new m.ExtensionHostConnection(this._environmentService,this._logService,i,r,t,n);this._extHostConnections[i]=s,s.onClose(()=>{delete this._extHostConnections[i],this._onDidCloseExtHostConnection()}),s.start(e)}});break;case 3:const a=u.args;this._createTunnel(o,a);break;default:console.error("Unknown initial data received."),this._logService.error("Unknown initial data received."),o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"error",reason:"Unknown initial data received."}))),o.dispose(),t.dispose()}}})}async _createTunnel(e,t){
const n=e.getSocket().socket,i=e.readEntireBuffer();e.dispose(),n.pause();const r=await this._connectTunnelSocket(t.port);i.byteLength>0&&r.write(i.buffer),r.on("end",()=>n.end()),r.on("close",()=>n.end()),r.on("error",()=>n.destroy()),n.on("end",()=>r.end()),n.on("close",()=>r.end()),n.on("error",()=>r.destroy()),r.pipe(n),n.pipe(r)}_connectTunnelSocket(e){return new Promise((t,n)=>{const i=s.createConnection({port:e},()=>{i.removeListener("error",n),i.pause(),t(i)});i.once("error",n)})}_updateWithFreeDebugPort(e){return"number"==typeof e.port?d.findFreePort(e.port,10,5e3).then(t=>(e.port=t,e)):(e.debugId=void 0,e.port=void 0,e.break=void 0,Promise.resolve(e))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}
_waitThenShutdown(){this._environmentService.args["enable-remote-auto-shutdown"]&&(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},ce))}_shutdown(){if(!!Object.keys(this._extHostConnections).length)return console.log("New EH opened, aborting shutdown"),void this._logService.info("New EH opened, aborting shutdown");console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),
this.shutdownTimer=void 0)}}t.RemoteExtensionHostAgentServer=pe})),define(t[178],n([0,1,27,18,4,87,81,167,13,164,80,20,129,2]),(function(e,t,n,i,r,s,o,a,c,l,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServerEnvironmentService=void 0;const p={port:{type:"string"},connectionToken:{type:"string"},host:{type:"string"},"socket-path":{type:"string"},driver:{type:"string"},fileWatcherPolling:{type:"string"},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"disable-telemetry":d.OPTIONS["disable-telemetry"],"extensions-dir":d.OPTIONS["extensions-dir"],"extensions-download-dir":d.OPTIONS["extensions-download-dir"],"install-extension":d.OPTIONS["install-extension"],"uninstall-extension":d.OPTIONS["uninstall-extension"],"locate-extension":d.OPTIONS["locate-extension"],"list-extensions":d.OPTIONS["list-extensions"],force:d.OPTIONS.force,"do-not-sync":d.OPTIONS["do-not-sync"],"disable-user-env-probe":d.OPTIONS["disable-user-env-probe"],
folder:{type:"string"},workspace:{type:"string"},"web-user-data-dir":{type:"string"},"use-host-proxy":{type:"string"},_:d.OPTIONS._};class g extends o.NativeEnvironmentService{get args(){return super.args}}t.ServerEnvironmentService=g;const m={onMultipleValues:(e,t)=>{console.error(`Option ${e} can only be defined once. Using value ${t}.`)},onUnknownOption:e=>{console.error(`Ignoring option ${e}: not supported for server.`)}},v=d.parseArgs(process.argv.slice(2),p,m),y=process.env.VSCODE_AGENT_FOLDER||f.join(n.homedir(),".vscode-remote"),w=f.join(y,"data"),E=f.join(w,"User"),_=f.join(E,"globalStorage"),S=f.join(w,"Machine");v["user-data-dir"]=w;const b=f.dirname(r.FileAccess.asFileUri("",e).fsPath),C=f.join(b,"extensions");v["builtin-extensions-dir"]=C;const x=v.connectionToken||h.generateUuid(),P=v.host;let I=8e3;try{v.port&&(I=parseInt(v.port))}catch(e){console.log("Port is not a number, using 8000 instead.")}const k=v["socket-path"];v["extensions-dir"]=v["extensions-dir"]||f.join(y,"extensions"),
[y,v["extensions-dir"],w,E,S,_].forEach(e=>{try{i.existsSync(e)||i.mkdirSync(e)}catch(e){console.error(e)}});const O=new g(v),D=new u.SpdLogService(l.RemoteExtensionLogFileName,O.logsPath,c.getLogLevel(O));function L(e){setTimeout(()=>process.exit(e),0)}if(D.trace(`Remote configuration data at ${y}`),D.trace("process arguments:",v),s.shouldSpawnCli(v))s.run(v,O,D).then(()=>L(0)).then(null,e=>{D.error(e.message||e.stack||e),L(1)});else{const e="\n\n*\n* Visual Studio Code Server\n*\n* Reminder: You may only use this software with Visual Studio family products,\n* as described in the license https://aka.ms/vscode-remote/license\n*\n\n";if(D.info(e),console.log(e),"win32"===process.platform&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const e=f.join(process.env.HOMEDRIVE,"node_modules"),t=f.dirname(f.join(process.env.HOMEDRIVE,process.env.HOMEPATH)),n=f.join(t,"node_modules");if(i.existsSync(e)||i.existsSync(n)){
const t=`\n\n*\n* !!!! Server terminated due to presence of CVE-2020-1416 !!!!\n*\n* Please remove the following directories and re-try\n* ${e}\n* ${n}\n*\n* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416\n*\n\n`;D.warn(t),console.warn(t),process.exit(0)}}const t=new a.RemoteExtensionHostAgentServer(x,O,D);k?t.start({socketPath:k}):t.start({host:P,port:I}),process.on("exit",()=>{t.dispose()})}}))}).call(this);
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/93c2f0fbf16c5a4b10e4d5f89737d9c2c25488a3/core/vs/server/remoteExtensionHostAgent.js.map
